"Main interface for ec2 service type defs"
from __future__ import annotations

from datetime import datetime
from typing import Any, List
from mypy_boto3.type_defs import Literal, TypedDict


__all__ = (
    "BundleTaskCompleteWaitFiltersTypeDef",
    "BundleTaskCompleteWaitWaiterConfigTypeDef",
    "ClassicAddressAssociateResponseTypeDef",
    "ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef",
    "ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    "ClientAcceptVpcEndpointConnectionsResponseTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    "ClientAcceptVpcPeeringConnectionResponseTypeDef",
    "ClientAdvertiseByoipCidrResponseByoipCidrTypeDef",
    "ClientAdvertiseByoipCidrResponseTypeDef",
    "ClientAllocateAddressResponseTypeDef",
    "ClientAllocateHostsResponseTypeDef",
    "ClientAllocateHostsTagSpecificationsTagsTypeDef",
    "ClientAllocateHostsTagSpecificationsTypeDef",
    "ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef",
    "ClientAssignIpv6AddressesResponseTypeDef",
    "ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    "ClientAssignPrivateIpAddressesResponseTypeDef",
    "ClientAssociateAddressResponseTypeDef",
    "ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef",
    "ClientAssociateClientVpnTargetNetworkResponseTypeDef",
    "ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef",
    "ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    "ClientAssociateIamInstanceProfileResponseTypeDef",
    "ClientAssociateRouteTableResponseTypeDef",
    "ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientAssociateSubnetCidrBlockResponseTypeDef",
    "ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef",
    "ClientAssociateTransitGatewayRouteTableResponseTypeDef",
    "ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    "ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    "ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientAssociateVpcCidrBlockResponseTypeDef",
    "ClientAttachClassicLinkVpcResponseTypeDef",
    "ClientAttachNetworkInterfaceResponseTypeDef",
    "ClientAttachVolumeResponseTypeDef",
    "ClientAttachVpnGatewayResponseVpcAttachmentTypeDef",
    "ClientAttachVpnGatewayResponseTypeDef",
    "ClientAuthorizeClientVpnIngressResponseStatusTypeDef",
    "ClientAuthorizeClientVpnIngressResponseTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef",
    "ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef",
    "ClientBundleInstanceResponseBundleTaskStorageS3TypeDef",
    "ClientBundleInstanceResponseBundleTaskStorageTypeDef",
    "ClientBundleInstanceResponseBundleTaskTypeDef",
    "ClientBundleInstanceResponseTypeDef",
    "ClientBundleInstanceStorageS3TypeDef",
    "ClientBundleInstanceStorageTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef",
    "ClientCancelBundleTaskResponseBundleTaskStorageTypeDef",
    "ClientCancelBundleTaskResponseBundleTaskTypeDef",
    "ClientCancelBundleTaskResponseTypeDef",
    "ClientCancelCapacityReservationResponseTypeDef",
    "ClientCancelImportTaskResponseTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    "ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    "ClientCancelReservedInstancesListingResponseTypeDef",
    "ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef",
    "ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef",
    "ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef",
    "ClientCancelSpotFleetRequestsResponseTypeDef",
    "ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef",
    "ClientCancelSpotInstanceRequestsResponseTypeDef",
    "ClientConfirmProductInstanceResponseTypeDef",
    "ClientCopyFpgaImageResponseTypeDef",
    "ClientCopyImageResponseTypeDef",
    "ClientCopySnapshotResponseTagsTypeDef",
    "ClientCopySnapshotResponseTypeDef",
    "ClientCopySnapshotTagSpecificationsTagsTypeDef",
    "ClientCopySnapshotTagSpecificationsTypeDef",
    "ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef",
    "ClientCreateCapacityReservationResponseCapacityReservationTypeDef",
    "ClientCreateCapacityReservationResponseTypeDef",
    "ClientCreateCapacityReservationTagSpecificationsTagsTypeDef",
    "ClientCreateCapacityReservationTagSpecificationsTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef",
    "ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef",
    "ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef",
    "ClientCreateClientVpnEndpointResponseStatusTypeDef",
    "ClientCreateClientVpnEndpointResponseTypeDef",
    "ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef",
    "ClientCreateClientVpnEndpointTagSpecificationsTypeDef",
    "ClientCreateClientVpnRouteResponseStatusTypeDef",
    "ClientCreateClientVpnRouteResponseTypeDef",
    "ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef",
    "ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef",
    "ClientCreateCustomerGatewayResponseTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetTagsTypeDef",
    "ClientCreateDefaultSubnetResponseSubnetTypeDef",
    "ClientCreateDefaultSubnetResponseTypeDef",
    "ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateDefaultVpcResponseVpcTagsTypeDef",
    "ClientCreateDefaultVpcResponseVpcTypeDef",
    "ClientCreateDefaultVpcResponseTypeDef",
    "ClientCreateDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    "ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef",
    "ClientCreateDhcpOptionsResponseTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef",
    "ClientCreateEgressOnlyInternetGatewayResponseTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef",
    "ClientCreateFleetLaunchTemplateConfigsTypeDef",
    "ClientCreateFleetOnDemandOptionsTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef",
    "ClientCreateFleetResponseErrorsTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef",
    "ClientCreateFleetResponseInstancesTypeDef",
    "ClientCreateFleetResponseTypeDef",
    "ClientCreateFleetSpotOptionsTypeDef",
    "ClientCreateFleetTagSpecificationsTagsTypeDef",
    "ClientCreateFleetTagSpecificationsTypeDef",
    "ClientCreateFleetTargetCapacitySpecificationTypeDef",
    "ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef",
    "ClientCreateFlowLogsResponseUnsuccessfulTypeDef",
    "ClientCreateFlowLogsResponseTypeDef",
    "ClientCreateFpgaImageInputStorageLocationTypeDef",
    "ClientCreateFpgaImageLogsStorageLocationTypeDef",
    "ClientCreateFpgaImageResponseTypeDef",
    "ClientCreateFpgaImageTagSpecificationsTagsTypeDef",
    "ClientCreateFpgaImageTagSpecificationsTypeDef",
    "ClientCreateImageBlockDeviceMappingsEbsTypeDef",
    "ClientCreateImageBlockDeviceMappingsTypeDef",
    "ClientCreateImageResponseTypeDef",
    "ClientCreateInstanceExportTaskExportToS3TaskTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef",
    "ClientCreateInstanceExportTaskResponseExportTaskTypeDef",
    "ClientCreateInstanceExportTaskResponseTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef",
    "ClientCreateInternetGatewayResponseInternetGatewayTypeDef",
    "ClientCreateInternetGatewayResponseTypeDef",
    "ClientCreateKeyPairResponseTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientCreateLaunchTemplateResponseTypeDef",
    "ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef",
    "ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef",
    "ClientCreateLaunchTemplateVersionResponseTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayTagsTypeDef",
    "ClientCreateNatGatewayResponseNatGatewayTypeDef",
    "ClientCreateNatGatewayResponseTypeDef",
    "ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef",
    "ClientCreateNetworkAclEntryPortRangeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclTagsTypeDef",
    "ClientCreateNetworkAclResponseNetworkAclTypeDef",
    "ClientCreateNetworkAclResponseTypeDef",
    "ClientCreateNetworkInterfaceIpv6AddressesTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef",
    "ClientCreateNetworkInterfacePermissionResponseTypeDef",
    "ClientCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef",
    "ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef",
    "ClientCreateNetworkInterfaceResponseTypeDef",
    "ClientCreateReservedInstancesListingPriceSchedulesTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    "ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    "ClientCreateReservedInstancesListingResponseTypeDef",
    "ClientCreateRouteResponseTypeDef",
    "ClientCreateRouteTableResponseRouteTableAssociationsTypeDef",
    "ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef",
    "ClientCreateRouteTableResponseRouteTableRoutesTypeDef",
    "ClientCreateRouteTableResponseRouteTableTagsTypeDef",
    "ClientCreateRouteTableResponseRouteTableTypeDef",
    "ClientCreateRouteTableResponseTypeDef",
    "ClientCreateSecurityGroupResponseTypeDef",
    "ClientCreateSnapshotResponseTagsTypeDef",
    "ClientCreateSnapshotResponseTypeDef",
    "ClientCreateSnapshotTagSpecificationsTagsTypeDef",
    "ClientCreateSnapshotTagSpecificationsTypeDef",
    "ClientCreateSnapshotsInstanceSpecificationTypeDef",
    "ClientCreateSnapshotsResponseSnapshotsTagsTypeDef",
    "ClientCreateSnapshotsResponseSnapshotsTypeDef",
    "ClientCreateSnapshotsResponseTypeDef",
    "ClientCreateSnapshotsTagSpecificationsTagsTypeDef",
    "ClientCreateSnapshotsTagSpecificationsTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    "ClientCreateSpotDatafeedSubscriptionResponseTypeDef",
    "ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateSubnetResponseSubnetTagsTypeDef",
    "ClientCreateSubnetResponseSubnetTypeDef",
    "ClientCreateSubnetResponseTypeDef",
    "ClientCreateTagsTagsTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef",
    "ClientCreateTrafficMirrorFilterResponseTypeDef",
    "ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    "ClientCreateTrafficMirrorFilterRuleResponseTypeDef",
    "ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    "ClientCreateTrafficMirrorSessionResponseTypeDef",
    "ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef",
    "ClientCreateTrafficMirrorTargetResponseTypeDef",
    "ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef",
    "ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayOptionsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef",
    "ClientCreateTransitGatewayResponseTransitGatewayTypeDef",
    "ClientCreateTransitGatewayResponseTypeDef",
    "ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientCreateTransitGatewayRouteResponseRouteTypeDef",
    "ClientCreateTransitGatewayRouteResponseTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    "ClientCreateTransitGatewayRouteTableResponseTypeDef",
    "ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayTagSpecificationsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef",
    "ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef",
    "ClientCreateVolumeResponseAttachmentsTypeDef",
    "ClientCreateVolumeResponseTagsTypeDef",
    "ClientCreateVolumeResponseTypeDef",
    "ClientCreateVolumeTagSpecificationsTagsTypeDef",
    "ClientCreateVolumeTagSpecificationsTypeDef",
    "ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef",
    "ClientCreateVpcEndpointConnectionNotificationResponseTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef",
    "ClientCreateVpcEndpointResponseVpcEndpointTypeDef",
    "ClientCreateVpcEndpointResponseTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef",
    "ClientCreateVpcEndpointServiceConfigurationResponseTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    "ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    "ClientCreateVpcPeeringConnectionResponseTypeDef",
    "ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef",
    "ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    "ClientCreateVpcResponseVpcTagsTypeDef",
    "ClientCreateVpcResponseVpcTypeDef",
    "ClientCreateVpcResponseTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientCreateVpnConnectionOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientCreateVpnConnectionResponseVpnConnectionTypeDef",
    "ClientCreateVpnConnectionResponseTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef",
    "ClientCreateVpnGatewayResponseVpnGatewayTypeDef",
    "ClientCreateVpnGatewayResponseTypeDef",
    "ClientDeleteClientVpnEndpointResponseStatusTypeDef",
    "ClientDeleteClientVpnEndpointResponseTypeDef",
    "ClientDeleteClientVpnRouteResponseStatusTypeDef",
    "ClientDeleteClientVpnRouteResponseTypeDef",
    "ClientDeleteEgressOnlyInternetGatewayResponseTypeDef",
    "ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef",
    "ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef",
    "ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef",
    "ClientDeleteFleetsResponseTypeDef",
    "ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteFlowLogsResponseUnsuccessfulTypeDef",
    "ClientDeleteFlowLogsResponseTypeDef",
    "ClientDeleteFpgaImageResponseTypeDef",
    "ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientDeleteLaunchTemplateResponseTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    "ClientDeleteLaunchTemplateVersionsResponseTypeDef",
    "ClientDeleteNatGatewayResponseTypeDef",
    "ClientDeleteNetworkInterfacePermissionResponseTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef",
    "ClientDeleteQueuedReservedInstancesResponseTypeDef",
    "ClientDeleteTagsTagsTypeDef",
    "ClientDeleteTrafficMirrorFilterResponseTypeDef",
    "ClientDeleteTrafficMirrorFilterRuleResponseTypeDef",
    "ClientDeleteTrafficMirrorSessionResponseTypeDef",
    "ClientDeleteTrafficMirrorTargetResponseTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef",
    "ClientDeleteTransitGatewayResponseTransitGatewayTypeDef",
    "ClientDeleteTransitGatewayResponseTypeDef",
    "ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientDeleteTransitGatewayRouteResponseRouteTypeDef",
    "ClientDeleteTransitGatewayRouteResponseTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    "ClientDeleteTransitGatewayRouteTableResponseTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef",
    "ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef",
    "ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef",
    "ClientDeleteVpcEndpointsResponseTypeDef",
    "ClientDeleteVpcPeeringConnectionResponseTypeDef",
    "ClientDeprovisionByoipCidrResponseByoipCidrTypeDef",
    "ClientDeprovisionByoipCidrResponseTypeDef",
    "ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef",
    "ClientDescribeAccountAttributesResponseAccountAttributesTypeDef",
    "ClientDescribeAccountAttributesResponseTypeDef",
    "ClientDescribeAddressesFiltersTypeDef",
    "ClientDescribeAddressesResponseAddressesTagsTypeDef",
    "ClientDescribeAddressesResponseAddressesTypeDef",
    "ClientDescribeAddressesResponseTypeDef",
    "ClientDescribeAggregateIdFormatResponseStatusesTypeDef",
    "ClientDescribeAggregateIdFormatResponseTypeDef",
    "ClientDescribeAvailabilityZonesFiltersTypeDef",
    "ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef",
    "ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef",
    "ClientDescribeAvailabilityZonesResponseTypeDef",
    "ClientDescribeBundleTasksFiltersTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef",
    "ClientDescribeBundleTasksResponseBundleTasksTypeDef",
    "ClientDescribeBundleTasksResponseTypeDef",
    "ClientDescribeByoipCidrsResponseByoipCidrsTypeDef",
    "ClientDescribeByoipCidrsResponseTypeDef",
    "ClientDescribeCapacityReservationsFiltersTypeDef",
    "ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef",
    "ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef",
    "ClientDescribeCapacityReservationsResponseTypeDef",
    "ClientDescribeClassicLinkInstancesFiltersTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef",
    "ClientDescribeClassicLinkInstancesResponseInstancesTypeDef",
    "ClientDescribeClassicLinkInstancesResponseTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef",
    "ClientDescribeClientVpnAuthorizationRulesResponseTypeDef",
    "ClientDescribeClientVpnConnectionsFiltersTypeDef",
    "ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef",
    "ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef",
    "ClientDescribeClientVpnConnectionsResponseTypeDef",
    "ClientDescribeClientVpnEndpointsFiltersTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef",
    "ClientDescribeClientVpnEndpointsResponseTypeDef",
    "ClientDescribeClientVpnRoutesFiltersTypeDef",
    "ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef",
    "ClientDescribeClientVpnRoutesResponseRoutesTypeDef",
    "ClientDescribeClientVpnRoutesResponseTypeDef",
    "ClientDescribeClientVpnTargetNetworksFiltersTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef",
    "ClientDescribeClientVpnTargetNetworksResponseTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef",
    "ClientDescribeConversionTasksResponseConversionTasksTypeDef",
    "ClientDescribeConversionTasksResponseTypeDef",
    "ClientDescribeCustomerGatewaysFiltersTypeDef",
    "ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef",
    "ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef",
    "ClientDescribeCustomerGatewaysResponseTypeDef",
    "ClientDescribeDhcpOptionsFiltersTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    "ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef",
    "ClientDescribeDhcpOptionsResponseTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef",
    "ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef",
    "ClientDescribeElasticGpusFiltersTypeDef",
    "ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef",
    "ClientDescribeElasticGpusResponseElasticGpuSetTypeDef",
    "ClientDescribeElasticGpusResponseTypeDef",
    "ClientDescribeExportImageTasksFiltersTypeDef",
    "ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef",
    "ClientDescribeExportImageTasksResponseExportImageTasksTypeDef",
    "ClientDescribeExportImageTasksResponseTypeDef",
    "ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef",
    "ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef",
    "ClientDescribeExportTasksResponseExportTasksTypeDef",
    "ClientDescribeExportTasksResponseTypeDef",
    "ClientDescribeFastSnapshotRestoresFiltersTypeDef",
    "ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef",
    "ClientDescribeFastSnapshotRestoresResponseTypeDef",
    "ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef",
    "ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef",
    "ClientDescribeFleetHistoryResponseTypeDef",
    "ClientDescribeFleetInstancesFiltersTypeDef",
    "ClientDescribeFleetInstancesResponseActiveInstancesTypeDef",
    "ClientDescribeFleetInstancesResponseTypeDef",
    "ClientDescribeFleetsFiltersTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsErrorsTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsInstancesTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    "ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef",
    "ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef",
    "ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef",
    "ClientDescribeFleetsResponseFleetsTagsTypeDef",
    "ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef",
    "ClientDescribeFleetsResponseFleetsTypeDef",
    "ClientDescribeFleetsResponseTypeDef",
    "ClientDescribeFlowLogsFiltersTypeDef",
    "ClientDescribeFlowLogsResponseFlowLogsTypeDef",
    "ClientDescribeFlowLogsResponseTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    "ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    "ClientDescribeFpgaImageAttributeResponseTypeDef",
    "ClientDescribeFpgaImagesFiltersTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef",
    "ClientDescribeFpgaImagesResponseFpgaImagesTypeDef",
    "ClientDescribeFpgaImagesResponseTypeDef",
    "ClientDescribeHostReservationOfferingsFiltersTypeDef",
    "ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef",
    "ClientDescribeHostReservationOfferingsResponseTypeDef",
    "ClientDescribeHostReservationsFiltersTypeDef",
    "ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef",
    "ClientDescribeHostReservationsResponseHostReservationSetTypeDef",
    "ClientDescribeHostReservationsResponseTypeDef",
    "ClientDescribeHostsFiltersTypeDef",
    "ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    "ClientDescribeHostsResponseHostsAvailableCapacityTypeDef",
    "ClientDescribeHostsResponseHostsHostPropertiesTypeDef",
    "ClientDescribeHostsResponseHostsInstancesTypeDef",
    "ClientDescribeHostsResponseHostsTagsTypeDef",
    "ClientDescribeHostsResponseHostsTypeDef",
    "ClientDescribeHostsResponseTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef",
    "ClientDescribeIamInstanceProfileAssociationsResponseTypeDef",
    "ClientDescribeIdFormatResponseStatusesTypeDef",
    "ClientDescribeIdFormatResponseTypeDef",
    "ClientDescribeIdentityIdFormatResponseStatusesTypeDef",
    "ClientDescribeIdentityIdFormatResponseTypeDef",
    "ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef",
    "ClientDescribeImageAttributeResponseDescriptionTypeDef",
    "ClientDescribeImageAttributeResponseKernelIdTypeDef",
    "ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef",
    "ClientDescribeImageAttributeResponseProductCodesTypeDef",
    "ClientDescribeImageAttributeResponseRamdiskIdTypeDef",
    "ClientDescribeImageAttributeResponseSriovNetSupportTypeDef",
    "ClientDescribeImageAttributeResponseTypeDef",
    "ClientDescribeImagesFiltersTypeDef",
    "ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef",
    "ClientDescribeImagesResponseImagesProductCodesTypeDef",
    "ClientDescribeImagesResponseImagesStateReasonTypeDef",
    "ClientDescribeImagesResponseImagesTagsTypeDef",
    "ClientDescribeImagesResponseImagesTypeDef",
    "ClientDescribeImagesResponseTypeDef",
    "ClientDescribeImportImageTasksFiltersTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef",
    "ClientDescribeImportImageTasksResponseImportImageTasksTypeDef",
    "ClientDescribeImportImageTasksResponseTypeDef",
    "ClientDescribeImportSnapshotTasksFiltersTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    "ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef",
    "ClientDescribeImportSnapshotTasksResponseTypeDef",
    "ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef",
    "ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef",
    "ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef",
    "ClientDescribeInstanceAttributeResponseEnaSupportTypeDef",
    "ClientDescribeInstanceAttributeResponseGroupsTypeDef",
    "ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    "ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef",
    "ClientDescribeInstanceAttributeResponseKernelIdTypeDef",
    "ClientDescribeInstanceAttributeResponseProductCodesTypeDef",
    "ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef",
    "ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef",
    "ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef",
    "ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef",
    "ClientDescribeInstanceAttributeResponseUserDataTypeDef",
    "ClientDescribeInstanceAttributeResponseTypeDef",
    "ClientDescribeInstanceCreditSpecificationsFiltersTypeDef",
    "ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef",
    "ClientDescribeInstanceCreditSpecificationsResponseTypeDef",
    "ClientDescribeInstanceStatusFiltersTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef",
    "ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef",
    "ClientDescribeInstanceStatusResponseTypeDef",
    "ClientDescribeInstanceTypeOfferingsFiltersTypeDef",
    "ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef",
    "ClientDescribeInstanceTypeOfferingsResponseTypeDef",
    "ClientDescribeInstanceTypesFiltersTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef",
    "ClientDescribeInstanceTypesResponseInstanceTypesTypeDef",
    "ClientDescribeInstanceTypesResponseTypeDef",
    "ClientDescribeInstancesFiltersTypeDef",
    "ClientDescribeInstancesResponseReservationsGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesStateTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef",
    "ClientDescribeInstancesResponseReservationsInstancesTypeDef",
    "ClientDescribeInstancesResponseReservationsTypeDef",
    "ClientDescribeInstancesResponseTypeDef",
    "ClientDescribeInternetGatewaysFiltersTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef",
    "ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef",
    "ClientDescribeInternetGatewaysResponseTypeDef",
    "ClientDescribeKeyPairsFiltersTypeDef",
    "ClientDescribeKeyPairsResponseKeyPairsTypeDef",
    "ClientDescribeKeyPairsResponseTypeDef",
    "ClientDescribeLaunchTemplateVersionsFiltersTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef",
    "ClientDescribeLaunchTemplateVersionsResponseTypeDef",
    "ClientDescribeLaunchTemplatesFiltersTypeDef",
    "ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef",
    "ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef",
    "ClientDescribeLaunchTemplatesResponseTypeDef",
    "ClientDescribeMovingAddressesFiltersTypeDef",
    "ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef",
    "ClientDescribeMovingAddressesResponseTypeDef",
    "ClientDescribeNatGatewaysFiltersTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef",
    "ClientDescribeNatGatewaysResponseNatGatewaysTypeDef",
    "ClientDescribeNatGatewaysResponseTypeDef",
    "ClientDescribeNetworkAclsFiltersTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef",
    "ClientDescribeNetworkAclsResponseNetworkAclsTypeDef",
    "ClientDescribeNetworkAclsResponseTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef",
    "ClientDescribeNetworkInterfaceAttributeResponseTypeDef",
    "ClientDescribeNetworkInterfacePermissionsFiltersTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef",
    "ClientDescribeNetworkInterfacePermissionsResponseTypeDef",
    "ClientDescribeNetworkInterfacesFiltersTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef",
    "ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef",
    "ClientDescribeNetworkInterfacesResponseTypeDef",
    "ClientDescribePlacementGroupsFiltersTypeDef",
    "ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef",
    "ClientDescribePlacementGroupsResponseTypeDef",
    "ClientDescribePrefixListsFiltersTypeDef",
    "ClientDescribePrefixListsResponsePrefixListsTypeDef",
    "ClientDescribePrefixListsResponseTypeDef",
    "ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef",
    "ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef",
    "ClientDescribePrincipalIdFormatResponseTypeDef",
    "ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    "ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef",
    "ClientDescribePublicIpv4PoolsResponseTypeDef",
    "ClientDescribeRegionsFiltersTypeDef",
    "ClientDescribeRegionsResponseRegionsTypeDef",
    "ClientDescribeRegionsResponseTypeDef",
    "ClientDescribeReservedInstancesFiltersTypeDef",
    "ClientDescribeReservedInstancesListingsFiltersTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef",
    "ClientDescribeReservedInstancesListingsResponseTypeDef",
    "ClientDescribeReservedInstancesModificationsFiltersTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef",
    "ClientDescribeReservedInstancesModificationsResponseTypeDef",
    "ClientDescribeReservedInstancesOfferingsFiltersTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef",
    "ClientDescribeReservedInstancesOfferingsResponseTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef",
    "ClientDescribeReservedInstancesResponseReservedInstancesTypeDef",
    "ClientDescribeReservedInstancesResponseTypeDef",
    "ClientDescribeRouteTablesFiltersTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef",
    "ClientDescribeRouteTablesResponseRouteTablesTypeDef",
    "ClientDescribeRouteTablesResponseTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef",
    "ClientDescribeScheduledInstanceAvailabilityResponseTypeDef",
    "ClientDescribeScheduledInstancesFiltersTypeDef",
    "ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    "ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef",
    "ClientDescribeScheduledInstancesResponseTypeDef",
    "ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef",
    "ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef",
    "ClientDescribeSecurityGroupReferencesResponseTypeDef",
    "ClientDescribeSecurityGroupsFiltersTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef",
    "ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef",
    "ClientDescribeSecurityGroupsResponseTypeDef",
    "ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef",
    "ClientDescribeSnapshotAttributeResponseProductCodesTypeDef",
    "ClientDescribeSnapshotAttributeResponseTypeDef",
    "ClientDescribeSnapshotsFiltersTypeDef",
    "ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef",
    "ClientDescribeSnapshotsResponseSnapshotsTypeDef",
    "ClientDescribeSnapshotsResponseTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    "ClientDescribeSpotDatafeedSubscriptionResponseTypeDef",
    "ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef",
    "ClientDescribeSpotFleetInstancesResponseTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef",
    "ClientDescribeSpotFleetRequestHistoryResponseTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    "ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef",
    "ClientDescribeSpotFleetRequestsResponseTypeDef",
    "ClientDescribeSpotInstanceRequestsFiltersTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef",
    "ClientDescribeSpotInstanceRequestsResponseTypeDef",
    "ClientDescribeSpotPriceHistoryFiltersTypeDef",
    "ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef",
    "ClientDescribeSpotPriceHistoryResponseTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef",
    "ClientDescribeStaleSecurityGroupsResponseTypeDef",
    "ClientDescribeSubnetsFiltersTypeDef",
    "ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    "ClientDescribeSubnetsResponseSubnetsTagsTypeDef",
    "ClientDescribeSubnetsResponseSubnetsTypeDef",
    "ClientDescribeSubnetsResponseTypeDef",
    "ClientDescribeTagsFiltersTypeDef",
    "ClientDescribeTagsResponseTagsTypeDef",
    "ClientDescribeTagsResponseTypeDef",
    "ClientDescribeTrafficMirrorFiltersFiltersTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef",
    "ClientDescribeTrafficMirrorFiltersResponseTypeDef",
    "ClientDescribeTrafficMirrorSessionsFiltersTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef",
    "ClientDescribeTrafficMirrorSessionsResponseTypeDef",
    "ClientDescribeTrafficMirrorTargetsFiltersTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef",
    "ClientDescribeTrafficMirrorTargetsResponseTypeDef",
    "ClientDescribeTransitGatewayAttachmentsFiltersTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef",
    "ClientDescribeTransitGatewayAttachmentsResponseTypeDef",
    "ClientDescribeTransitGatewayRouteTablesFiltersTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef",
    "ClientDescribeTransitGatewayRouteTablesResponseTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef",
    "ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef",
    "ClientDescribeTransitGatewaysFiltersTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef",
    "ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef",
    "ClientDescribeTransitGatewaysResponseTypeDef",
    "ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef",
    "ClientDescribeVolumeAttributeResponseProductCodesTypeDef",
    "ClientDescribeVolumeAttributeResponseTypeDef",
    "ClientDescribeVolumeStatusFiltersTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    "ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef",
    "ClientDescribeVolumeStatusResponseTypeDef",
    "ClientDescribeVolumesFiltersTypeDef",
    "ClientDescribeVolumesModificationsFiltersTypeDef",
    "ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef",
    "ClientDescribeVolumesModificationsResponseTypeDef",
    "ClientDescribeVolumesResponseVolumesAttachmentsTypeDef",
    "ClientDescribeVolumesResponseVolumesTagsTypeDef",
    "ClientDescribeVolumesResponseVolumesTypeDef",
    "ClientDescribeVolumesResponseTypeDef",
    "ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef",
    "ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef",
    "ClientDescribeVpcAttributeResponseTypeDef",
    "ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef",
    "ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientDescribeVpcClassicLinkFiltersTypeDef",
    "ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef",
    "ClientDescribeVpcClassicLinkResponseVpcsTypeDef",
    "ClientDescribeVpcClassicLinkResponseTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef",
    "ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef",
    "ClientDescribeVpcEndpointConnectionsFiltersTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef",
    "ClientDescribeVpcEndpointConnectionsResponseTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef",
    "ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef",
    "ClientDescribeVpcEndpointServicePermissionsResponseTypeDef",
    "ClientDescribeVpcEndpointServicesFiltersTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef",
    "ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef",
    "ClientDescribeVpcEndpointServicesResponseTypeDef",
    "ClientDescribeVpcEndpointsFiltersTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef",
    "ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef",
    "ClientDescribeVpcEndpointsResponseTypeDef",
    "ClientDescribeVpcPeeringConnectionsFiltersTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef",
    "ClientDescribeVpcPeeringConnectionsResponseTypeDef",
    "ClientDescribeVpcsFiltersTypeDef",
    "ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    "ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef",
    "ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    "ClientDescribeVpcsResponseVpcsTagsTypeDef",
    "ClientDescribeVpcsResponseVpcsTypeDef",
    "ClientDescribeVpcsResponseTypeDef",
    "ClientDescribeVpnConnectionsFiltersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef",
    "ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef",
    "ClientDescribeVpnConnectionsResponseTypeDef",
    "ClientDescribeVpnGatewaysFiltersTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef",
    "ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef",
    "ClientDescribeVpnGatewaysResponseTypeDef",
    "ClientDetachClassicLinkVpcResponseTypeDef",
    "ClientDetachVolumeResponseTypeDef",
    "ClientDisableEbsEncryptionByDefaultResponseTypeDef",
    "ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef",
    "ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef",
    "ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef",
    "ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef",
    "ClientDisableFastSnapshotRestoresResponseTypeDef",
    "ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    "ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef",
    "ClientDisableVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientDisableVpcClassicLinkResponseTypeDef",
    "ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef",
    "ClientDisassociateClientVpnTargetNetworkResponseTypeDef",
    "ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    "ClientDisassociateIamInstanceProfileResponseTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientDisassociateSubnetCidrBlockResponseTypeDef",
    "ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef",
    "ClientDisassociateTransitGatewayRouteTableResponseTypeDef",
    "ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    "ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    "ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    "ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    "ClientDisassociateVpcCidrBlockResponseTypeDef",
    "ClientEnableEbsEncryptionByDefaultResponseTypeDef",
    "ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef",
    "ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef",
    "ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef",
    "ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef",
    "ClientEnableFastSnapshotRestoresResponseTypeDef",
    "ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    "ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef",
    "ClientEnableVpcClassicLinkDnsSupportResponseTypeDef",
    "ClientEnableVpcClassicLinkResponseTypeDef",
    "ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef",
    "ClientExportClientVpnClientCertificateRevocationListResponseTypeDef",
    "ClientExportClientVpnClientConfigurationResponseTypeDef",
    "ClientExportImageResponseS3ExportLocationTypeDef",
    "ClientExportImageResponseTypeDef",
    "ClientExportImageS3ExportLocationTypeDef",
    "ClientExportTransitGatewayRoutesFiltersTypeDef",
    "ClientExportTransitGatewayRoutesResponseTypeDef",
    "ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef",
    "ClientGetCapacityReservationUsageResponseTypeDef",
    "ClientGetConsoleOutputResponseTypeDef",
    "ClientGetConsoleScreenshotResponseTypeDef",
    "ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef",
    "ClientGetDefaultCreditSpecificationResponseTypeDef",
    "ClientGetEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientGetEbsEncryptionByDefaultResponseTypeDef",
    "ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef",
    "ClientGetHostReservationPurchasePreviewResponseTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef",
    "ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef",
    "ClientGetLaunchTemplateDataResponseTypeDef",
    "ClientGetPasswordDataResponseTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef",
    "ClientGetReservedInstancesExchangeQuoteResponseTypeDef",
    "ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef",
    "ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef",
    "ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef",
    "ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef",
    "ClientImportClientVpnClientCertificateRevocationListResponseTypeDef",
    "ClientImportImageClientDataTypeDef",
    "ClientImportImageDiskContainersUserBucketTypeDef",
    "ClientImportImageDiskContainersTypeDef",
    "ClientImportImageLicenseSpecificationsTypeDef",
    "ClientImportImageResponseLicenseSpecificationsTypeDef",
    "ClientImportImageResponseSnapshotDetailsUserBucketTypeDef",
    "ClientImportImageResponseSnapshotDetailsTypeDef",
    "ClientImportImageResponseTypeDef",
    "ClientImportInstanceDiskImagesImageTypeDef",
    "ClientImportInstanceDiskImagesVolumeTypeDef",
    "ClientImportInstanceDiskImagesTypeDef",
    "ClientImportInstanceLaunchSpecificationPlacementTypeDef",
    "ClientImportInstanceLaunchSpecificationUserDataTypeDef",
    "ClientImportInstanceLaunchSpecificationTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef",
    "ClientImportInstanceResponseConversionTaskImportInstanceTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskImportVolumeTypeDef",
    "ClientImportInstanceResponseConversionTaskTagsTypeDef",
    "ClientImportInstanceResponseConversionTaskTypeDef",
    "ClientImportInstanceResponseTypeDef",
    "ClientImportKeyPairResponseTypeDef",
    "ClientImportSnapshotClientDataTypeDef",
    "ClientImportSnapshotDiskContainerUserBucketTypeDef",
    "ClientImportSnapshotDiskContainerTypeDef",
    "ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef",
    "ClientImportSnapshotResponseSnapshotTaskDetailTypeDef",
    "ClientImportSnapshotResponseTypeDef",
    "ClientImportVolumeImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef",
    "ClientImportVolumeResponseConversionTaskImportInstanceTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskImportVolumeTypeDef",
    "ClientImportVolumeResponseConversionTaskTagsTypeDef",
    "ClientImportVolumeResponseConversionTaskTypeDef",
    "ClientImportVolumeResponseTypeDef",
    "ClientImportVolumeVolumeTypeDef",
    "ClientModifyCapacityReservationResponseTypeDef",
    "ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef",
    "ClientModifyClientVpnEndpointDnsServersTypeDef",
    "ClientModifyClientVpnEndpointResponseTypeDef",
    "ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef",
    "ClientModifyDefaultCreditSpecificationResponseTypeDef",
    "ClientModifyEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientModifyFleetResponseTypeDef",
    "ClientModifyFleetTargetCapacitySpecificationTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef",
    "ClientModifyFpgaImageAttributeLoadPermissionTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    "ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    "ClientModifyFpgaImageAttributeResponseTypeDef",
    "ClientModifyHostsResponseUnsuccessfulErrorTypeDef",
    "ClientModifyHostsResponseUnsuccessfulTypeDef",
    "ClientModifyHostsResponseTypeDef",
    "ClientModifyImageAttributeDescriptionTypeDef",
    "ClientModifyImageAttributeLaunchPermissionAddTypeDef",
    "ClientModifyImageAttributeLaunchPermissionRemoveTypeDef",
    "ClientModifyImageAttributeLaunchPermissionTypeDef",
    "ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef",
    "ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef",
    "ClientModifyInstanceAttributeDisableApiTerminationTypeDef",
    "ClientModifyInstanceAttributeEbsOptimizedTypeDef",
    "ClientModifyInstanceAttributeEnaSupportTypeDef",
    "ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    "ClientModifyInstanceAttributeInstanceTypeTypeDef",
    "ClientModifyInstanceAttributeKernelTypeDef",
    "ClientModifyInstanceAttributeRamdiskTypeDef",
    "ClientModifyInstanceAttributeSourceDestCheckTypeDef",
    "ClientModifyInstanceAttributeSriovNetSupportTypeDef",
    "ClientModifyInstanceAttributeUserDataTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef",
    "ClientModifyInstanceCapacityReservationAttributesResponseTypeDef",
    "ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef",
    "ClientModifyInstanceCreditSpecificationResponseTypeDef",
    "ClientModifyInstanceEventStartTimeResponseEventTypeDef",
    "ClientModifyInstanceEventStartTimeResponseTypeDef",
    "ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef",
    "ClientModifyInstanceMetadataOptionsResponseTypeDef",
    "ClientModifyInstancePlacementResponseTypeDef",
    "ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    "ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef",
    "ClientModifyLaunchTemplateResponseTypeDef",
    "ClientModifyNetworkInterfaceAttributeAttachmentTypeDef",
    "ClientModifyNetworkInterfaceAttributeDescriptionTypeDef",
    "ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef",
    "ClientModifyReservedInstancesResponseTypeDef",
    "ClientModifyReservedInstancesTargetConfigurationsTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef",
    "ClientModifySnapshotAttributeCreateVolumePermissionTypeDef",
    "ClientModifySpotFleetRequestResponseTypeDef",
    "ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef",
    "ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef",
    "ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef",
    "ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    "ClientModifyTrafficMirrorFilterRuleResponseTypeDef",
    "ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    "ClientModifyTrafficMirrorSessionResponseTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientModifyTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientModifyVolumeAttributeAutoEnableIOTypeDef",
    "ClientModifyVolumeResponseVolumeModificationTypeDef",
    "ClientModifyVolumeResponseTypeDef",
    "ClientModifyVpcAttributeEnableDnsHostnamesTypeDef",
    "ClientModifyVpcAttributeEnableDnsSupportTypeDef",
    "ClientModifyVpcEndpointConnectionNotificationResponseTypeDef",
    "ClientModifyVpcEndpointResponseTypeDef",
    "ClientModifyVpcEndpointServiceConfigurationResponseTypeDef",
    "ClientModifyVpcEndpointServicePermissionsResponseTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef",
    "ClientModifyVpcPeeringConnectionOptionsResponseTypeDef",
    "ClientModifyVpcTenancyResponseTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnConnectionResponseVpnConnectionTypeDef",
    "ClientModifyVpnConnectionResponseTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef",
    "ClientModifyVpnTunnelCertificateResponseTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef",
    "ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef",
    "ClientModifyVpnTunnelOptionsResponseTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    "ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef",
    "ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    "ClientMonitorInstancesResponseInstanceMonitoringsTypeDef",
    "ClientMonitorInstancesResponseTypeDef",
    "ClientMoveAddressToVpcResponseTypeDef",
    "ClientProvisionByoipCidrCidrAuthorizationContextTypeDef",
    "ClientProvisionByoipCidrResponseByoipCidrTypeDef",
    "ClientProvisionByoipCidrResponseTypeDef",
    "ClientPurchaseHostReservationResponsePurchaseTypeDef",
    "ClientPurchaseHostReservationResponseTypeDef",
    "ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef",
    "ClientPurchaseReservedInstancesOfferingResponseTypeDef",
    "ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef",
    "ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    "ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef",
    "ClientPurchaseScheduledInstancesResponseTypeDef",
    "ClientRegisterImageBlockDeviceMappingsEbsTypeDef",
    "ClientRegisterImageBlockDeviceMappingsTypeDef",
    "ClientRegisterImageResponseTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    "ClientRejectTransitGatewayVpcAttachmentResponseTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    "ClientRejectVpcEndpointConnectionsResponseTypeDef",
    "ClientRejectVpcPeeringConnectionResponseTypeDef",
    "ClientReleaseHostsResponseUnsuccessfulErrorTypeDef",
    "ClientReleaseHostsResponseUnsuccessfulTypeDef",
    "ClientReleaseHostsResponseTypeDef",
    "ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef",
    "ClientReplaceIamInstanceProfileAssociationResponseTypeDef",
    "ClientReplaceNetworkAclAssociationResponseTypeDef",
    "ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef",
    "ClientReplaceNetworkAclEntryPortRangeTypeDef",
    "ClientReplaceRouteTableAssociationResponseTypeDef",
    "ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    "ClientReplaceTransitGatewayRouteResponseRouteTypeDef",
    "ClientReplaceTransitGatewayRouteResponseTypeDef",
    "ClientRequestSpotFleetResponseTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "ClientRequestSpotFleetSpotFleetRequestConfigTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef",
    "ClientRequestSpotInstancesLaunchSpecificationTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef",
    "ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef",
    "ClientRequestSpotInstancesResponseTypeDef",
    "ClientResetEbsDefaultKmsKeyIdResponseTypeDef",
    "ClientResetFpgaImageAttributeResponseTypeDef",
    "ClientRestoreAddressToClassicResponseTypeDef",
    "ClientRevokeClientVpnIngressResponseStatusTypeDef",
    "ClientRevokeClientVpnIngressResponseTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientRevokeSecurityGroupEgressIpPermissionsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientRevokeSecurityGroupIngressIpPermissionsTypeDef",
    "ClientRunInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientRunInstancesBlockDeviceMappingsTypeDef",
    "ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientRunInstancesCapacityReservationSpecificationTypeDef",
    "ClientRunInstancesCpuOptionsTypeDef",
    "ClientRunInstancesCreditSpecificationTypeDef",
    "ClientRunInstancesElasticGpuSpecificationTypeDef",
    "ClientRunInstancesElasticInferenceAcceleratorsTypeDef",
    "ClientRunInstancesHibernationOptionsTypeDef",
    "ClientRunInstancesIamInstanceProfileTypeDef",
    "ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "ClientRunInstancesInstanceMarketOptionsTypeDef",
    "ClientRunInstancesIpv6AddressesTypeDef",
    "ClientRunInstancesLaunchTemplateTypeDef",
    "ClientRunInstancesLicenseSpecificationsTypeDef",
    "ClientRunInstancesMetadataOptionsTypeDef",
    "ClientRunInstancesMonitoringTypeDef",
    "ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRunInstancesNetworkInterfacesTypeDef",
    "ClientRunInstancesPlacementTypeDef",
    "ClientRunInstancesResponseGroupsTypeDef",
    "ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef",
    "ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef",
    "ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef",
    "ClientRunInstancesResponseInstancesCpuOptionsTypeDef",
    "ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef",
    "ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "ClientRunInstancesResponseInstancesHibernationOptionsTypeDef",
    "ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef",
    "ClientRunInstancesResponseInstancesLicensesTypeDef",
    "ClientRunInstancesResponseInstancesMetadataOptionsTypeDef",
    "ClientRunInstancesResponseInstancesMonitoringTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef",
    "ClientRunInstancesResponseInstancesPlacementTypeDef",
    "ClientRunInstancesResponseInstancesProductCodesTypeDef",
    "ClientRunInstancesResponseInstancesSecurityGroupsTypeDef",
    "ClientRunInstancesResponseInstancesStateReasonTypeDef",
    "ClientRunInstancesResponseInstancesStateTypeDef",
    "ClientRunInstancesResponseInstancesTagsTypeDef",
    "ClientRunInstancesResponseInstancesTypeDef",
    "ClientRunInstancesResponseTypeDef",
    "ClientRunInstancesTagSpecificationsTagsTypeDef",
    "ClientRunInstancesTagSpecificationsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef",
    "ClientRunScheduledInstancesLaunchSpecificationTypeDef",
    "ClientRunScheduledInstancesResponseTypeDef",
    "ClientSearchTransitGatewayRoutesFiltersTypeDef",
    "ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef",
    "ClientSearchTransitGatewayRoutesResponseRoutesTypeDef",
    "ClientSearchTransitGatewayRoutesResponseTypeDef",
    "ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef",
    "ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef",
    "ClientStartInstancesResponseStartingInstancesTypeDef",
    "ClientStartInstancesResponseTypeDef",
    "ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef",
    "ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef",
    "ClientStopInstancesResponseStoppingInstancesTypeDef",
    "ClientStopInstancesResponseTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef",
    "ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef",
    "ClientTerminateClientVpnConnectionsResponseTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef",
    "ClientTerminateInstancesResponseTerminatingInstancesTypeDef",
    "ClientTerminateInstancesResponseTypeDef",
    "ClientUnassignIpv6AddressesResponseTypeDef",
    "ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    "ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef",
    "ClientUnmonitorInstancesResponseTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef",
    "ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef",
    "ClientWithdrawByoipCidrResponseByoipCidrTypeDef",
    "ClientWithdrawByoipCidrResponseTypeDef",
    "ConversionTaskCancelledWaitWaiterConfigTypeDef",
    "ConversionTaskCompletedWaitWaiterConfigTypeDef",
    "ConversionTaskDeletedWaitWaiterConfigTypeDef",
    "CustomerGatewayAvailableWaitFiltersTypeDef",
    "CustomerGatewayAvailableWaitWaiterConfigTypeDef",
    "DescribeByoipCidrsPaginatePaginationConfigTypeDef",
    "DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef",
    "DescribeByoipCidrsPaginateResponseTypeDef",
    "DescribeCapacityReservationsPaginateFiltersTypeDef",
    "DescribeCapacityReservationsPaginatePaginationConfigTypeDef",
    "DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef",
    "DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef",
    "DescribeCapacityReservationsPaginateResponseTypeDef",
    "DescribeClassicLinkInstancesPaginateFiltersTypeDef",
    "DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef",
    "DescribeClassicLinkInstancesPaginateResponseTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef",
    "DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef",
    "DescribeClientVpnConnectionsPaginateFiltersTypeDef",
    "DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef",
    "DescribeClientVpnConnectionsPaginateResponseTypeDef",
    "DescribeClientVpnEndpointsPaginateFiltersTypeDef",
    "DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef",
    "DescribeClientVpnEndpointsPaginateResponseTypeDef",
    "DescribeClientVpnRoutesPaginateFiltersTypeDef",
    "DescribeClientVpnRoutesPaginatePaginationConfigTypeDef",
    "DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef",
    "DescribeClientVpnRoutesPaginateResponseRoutesTypeDef",
    "DescribeClientVpnRoutesPaginateResponseTypeDef",
    "DescribeClientVpnTargetNetworksPaginateFiltersTypeDef",
    "DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef",
    "DescribeClientVpnTargetNetworksPaginateResponseTypeDef",
    "DescribeDhcpOptionsPaginateFiltersTypeDef",
    "DescribeDhcpOptionsPaginatePaginationConfigTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef",
    "DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef",
    "DescribeDhcpOptionsPaginateResponseTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef",
    "DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef",
    "DescribeExportImageTasksPaginateFiltersTypeDef",
    "DescribeExportImageTasksPaginatePaginationConfigTypeDef",
    "DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef",
    "DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef",
    "DescribeExportImageTasksPaginateResponseTypeDef",
    "DescribeFastSnapshotRestoresPaginateFiltersTypeDef",
    "DescribeFastSnapshotRestoresPaginatePaginationConfigTypeDef",
    "DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef",
    "DescribeFastSnapshotRestoresPaginateResponseTypeDef",
    "DescribeFleetsPaginateFiltersTypeDef",
    "DescribeFleetsPaginatePaginationConfigTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsErrorsTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsInstancesTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    "DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef",
    "DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef",
    "DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef",
    "DescribeFleetsPaginateResponseFleetsTagsTypeDef",
    "DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef",
    "DescribeFleetsPaginateResponseFleetsTypeDef",
    "DescribeFleetsPaginateResponseTypeDef",
    "DescribeFlowLogsPaginateFiltersTypeDef",
    "DescribeFlowLogsPaginatePaginationConfigTypeDef",
    "DescribeFlowLogsPaginateResponseFlowLogsTypeDef",
    "DescribeFlowLogsPaginateResponseTypeDef",
    "DescribeFpgaImagesPaginateFiltersTypeDef",
    "DescribeFpgaImagesPaginatePaginationConfigTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef",
    "DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef",
    "DescribeFpgaImagesPaginateResponseTypeDef",
    "DescribeHostReservationOfferingsPaginateFiltersTypeDef",
    "DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef",
    "DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef",
    "DescribeHostReservationOfferingsPaginateResponseTypeDef",
    "DescribeHostReservationsPaginateFiltersTypeDef",
    "DescribeHostReservationsPaginatePaginationConfigTypeDef",
    "DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef",
    "DescribeHostReservationsPaginateResponseHostReservationSetTypeDef",
    "DescribeHostReservationsPaginateResponseTypeDef",
    "DescribeHostsPaginateFiltersTypeDef",
    "DescribeHostsPaginatePaginationConfigTypeDef",
    "DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    "DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef",
    "DescribeHostsPaginateResponseHostsHostPropertiesTypeDef",
    "DescribeHostsPaginateResponseHostsInstancesTypeDef",
    "DescribeHostsPaginateResponseHostsTagsTypeDef",
    "DescribeHostsPaginateResponseHostsTypeDef",
    "DescribeHostsPaginateResponseTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef",
    "DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef",
    "DescribeImportImageTasksPaginateFiltersTypeDef",
    "DescribeImportImageTasksPaginatePaginationConfigTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef",
    "DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef",
    "DescribeImportImageTasksPaginateResponseTypeDef",
    "DescribeImportSnapshotTasksPaginateFiltersTypeDef",
    "DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef",
    "DescribeImportSnapshotTasksPaginateResponseTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef",
    "DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef",
    "DescribeInstanceCreditSpecificationsPaginateResponseTypeDef",
    "DescribeInstanceStatusPaginateFiltersTypeDef",
    "DescribeInstanceStatusPaginatePaginationConfigTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef",
    "DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef",
    "DescribeInstanceStatusPaginateResponseTypeDef",
    "DescribeInstancesPaginateFiltersTypeDef",
    "DescribeInstancesPaginatePaginationConfigTypeDef",
    "DescribeInstancesPaginateResponseReservationsGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef",
    "DescribeInstancesPaginateResponseReservationsInstancesTypeDef",
    "DescribeInstancesPaginateResponseReservationsTypeDef",
    "DescribeInstancesPaginateResponseTypeDef",
    "DescribeInternetGatewaysPaginateFiltersTypeDef",
    "DescribeInternetGatewaysPaginatePaginationConfigTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef",
    "DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef",
    "DescribeInternetGatewaysPaginateResponseTypeDef",
    "DescribeLaunchTemplateVersionsPaginateFiltersTypeDef",
    "DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef",
    "DescribeLaunchTemplateVersionsPaginateResponseTypeDef",
    "DescribeLaunchTemplatesPaginateFiltersTypeDef",
    "DescribeLaunchTemplatesPaginatePaginationConfigTypeDef",
    "DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef",
    "DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef",
    "DescribeLaunchTemplatesPaginateResponseTypeDef",
    "DescribeMovingAddressesPaginateFiltersTypeDef",
    "DescribeMovingAddressesPaginatePaginationConfigTypeDef",
    "DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef",
    "DescribeMovingAddressesPaginateResponseTypeDef",
    "DescribeNatGatewaysPaginateFiltersTypeDef",
    "DescribeNatGatewaysPaginatePaginationConfigTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef",
    "DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef",
    "DescribeNatGatewaysPaginateResponseTypeDef",
    "DescribeNetworkAclsPaginateFiltersTypeDef",
    "DescribeNetworkAclsPaginatePaginationConfigTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef",
    "DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef",
    "DescribeNetworkAclsPaginateResponseTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef",
    "DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef",
    "DescribeNetworkInterfacePermissionsPaginateResponseTypeDef",
    "DescribeNetworkInterfacesPaginateFiltersTypeDef",
    "DescribeNetworkInterfacesPaginatePaginationConfigTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef",
    "DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef",
    "DescribeNetworkInterfacesPaginateResponseTypeDef",
    "DescribePrefixListsPaginateFiltersTypeDef",
    "DescribePrefixListsPaginatePaginationConfigTypeDef",
    "DescribePrefixListsPaginateResponsePrefixListsTypeDef",
    "DescribePrefixListsPaginateResponseTypeDef",
    "DescribePrincipalIdFormatPaginatePaginationConfigTypeDef",
    "DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef",
    "DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef",
    "DescribePrincipalIdFormatPaginateResponseTypeDef",
    "DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef",
    "DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    "DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef",
    "DescribePublicIpv4PoolsPaginateResponseTypeDef",
    "DescribeReservedInstancesModificationsPaginateFiltersTypeDef",
    "DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef",
    "DescribeReservedInstancesModificationsPaginateResponseTypeDef",
    "DescribeReservedInstancesOfferingsPaginateFiltersTypeDef",
    "DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef",
    "DescribeReservedInstancesOfferingsPaginateResponseTypeDef",
    "DescribeRouteTablesPaginateFiltersTypeDef",
    "DescribeRouteTablesPaginatePaginationConfigTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef",
    "DescribeRouteTablesPaginateResponseRouteTablesTypeDef",
    "DescribeRouteTablesPaginateResponseTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef",
    "DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef",
    "DescribeScheduledInstancesPaginateFiltersTypeDef",
    "DescribeScheduledInstancesPaginatePaginationConfigTypeDef",
    "DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef",
    "DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef",
    "DescribeScheduledInstancesPaginateResponseTypeDef",
    "DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef",
    "DescribeSecurityGroupsPaginateFiltersTypeDef",
    "DescribeSecurityGroupsPaginatePaginationConfigTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef",
    "DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef",
    "DescribeSecurityGroupsPaginateResponseTypeDef",
    "DescribeSnapshotsPaginateFiltersTypeDef",
    "DescribeSnapshotsPaginatePaginationConfigTypeDef",
    "DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef",
    "DescribeSnapshotsPaginateResponseSnapshotsTypeDef",
    "DescribeSnapshotsPaginateResponseTypeDef",
    "DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef",
    "DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef",
    "DescribeSpotFleetInstancesPaginateResponseTypeDef",
    "DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef",
    "DescribeSpotFleetRequestsPaginateResponseTypeDef",
    "DescribeSpotInstanceRequestsPaginateFiltersTypeDef",
    "DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef",
    "DescribeSpotInstanceRequestsPaginateResponseTypeDef",
    "DescribeSpotPriceHistoryPaginateFiltersTypeDef",
    "DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef",
    "DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef",
    "DescribeSpotPriceHistoryPaginateResponseTypeDef",
    "DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef",
    "DescribeStaleSecurityGroupsPaginateResponseTypeDef",
    "DescribeSubnetsPaginateFiltersTypeDef",
    "DescribeSubnetsPaginatePaginationConfigTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsTagsTypeDef",
    "DescribeSubnetsPaginateResponseSubnetsTypeDef",
    "DescribeSubnetsPaginateResponseTypeDef",
    "DescribeTagsPaginateFiltersTypeDef",
    "DescribeTagsPaginatePaginationConfigTypeDef",
    "DescribeTagsPaginateResponseTagsTypeDef",
    "DescribeTagsPaginateResponseTypeDef",
    "DescribeTrafficMirrorFiltersPaginateFiltersTypeDef",
    "DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef",
    "DescribeTrafficMirrorFiltersPaginateResponseTypeDef",
    "DescribeTrafficMirrorSessionsPaginateFiltersTypeDef",
    "DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef",
    "DescribeTrafficMirrorSessionsPaginateResponseTypeDef",
    "DescribeTrafficMirrorTargetsPaginateFiltersTypeDef",
    "DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef",
    "DescribeTrafficMirrorTargetsPaginateResponseTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef",
    "DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef",
    "DescribeTransitGatewayAttachmentsPaginateResponseTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef",
    "DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef",
    "DescribeTransitGatewayRouteTablesPaginateResponseTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef",
    "DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef",
    "DescribeTransitGatewaysPaginateFiltersTypeDef",
    "DescribeTransitGatewaysPaginatePaginationConfigTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef",
    "DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef",
    "DescribeTransitGatewaysPaginateResponseTypeDef",
    "DescribeVolumeStatusPaginateFiltersTypeDef",
    "DescribeVolumeStatusPaginatePaginationConfigTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef",
    "DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef",
    "DescribeVolumeStatusPaginateResponseTypeDef",
    "DescribeVolumesModificationsPaginateFiltersTypeDef",
    "DescribeVolumesModificationsPaginatePaginationConfigTypeDef",
    "DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef",
    "DescribeVolumesModificationsPaginateResponseTypeDef",
    "DescribeVolumesPaginateFiltersTypeDef",
    "DescribeVolumesPaginatePaginationConfigTypeDef",
    "DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef",
    "DescribeVolumesPaginateResponseVolumesTagsTypeDef",
    "DescribeVolumesPaginateResponseVolumesTypeDef",
    "DescribeVolumesPaginateResponseTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef",
    "DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef",
    "DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef",
    "DescribeVpcEndpointConnectionsPaginateFiltersTypeDef",
    "DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef",
    "DescribeVpcEndpointConnectionsPaginateResponseTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef",
    "DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef",
    "DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef",
    "DescribeVpcEndpointServicesPaginateFiltersTypeDef",
    "DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef",
    "DescribeVpcEndpointServicesPaginateResponseTypeDef",
    "DescribeVpcEndpointsPaginateFiltersTypeDef",
    "DescribeVpcEndpointsPaginatePaginationConfigTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef",
    "DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef",
    "DescribeVpcEndpointsPaginateResponseTypeDef",
    "DescribeVpcPeeringConnectionsPaginateFiltersTypeDef",
    "DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef",
    "DescribeVpcPeeringConnectionsPaginateResponseTypeDef",
    "DescribeVpcsPaginateFiltersTypeDef",
    "DescribeVpcsPaginatePaginationConfigTypeDef",
    "DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    "DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef",
    "DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    "DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    "DescribeVpcsPaginateResponseVpcsTagsTypeDef",
    "DescribeVpcsPaginateResponseVpcsTypeDef",
    "DescribeVpcsPaginateResponseTypeDef",
    "DhcpOptionsCreateTagsTagsTypeDef",
    "DhcpOptionsSetsFilterFiltersTypeDef",
    "ExportTaskCancelledWaitWaiterConfigTypeDef",
    "ExportTaskCompletedWaitWaiterConfigTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef",
    "GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef",
    "GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef",
    "GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef",
    "ImageAvailableWaitFiltersTypeDef",
    "ImageAvailableWaitWaiterConfigTypeDef",
    "ImageCreateTagsTagsTypeDef",
    "ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    "ImageDescribeAttributeResponseDescriptionTypeDef",
    "ImageDescribeAttributeResponseKernelIdTypeDef",
    "ImageDescribeAttributeResponseLaunchPermissionsTypeDef",
    "ImageDescribeAttributeResponseProductCodesTypeDef",
    "ImageDescribeAttributeResponseRamdiskIdTypeDef",
    "ImageDescribeAttributeResponseSriovNetSupportTypeDef",
    "ImageDescribeAttributeResponseTypeDef",
    "ImageExistsWaitFiltersTypeDef",
    "ImageExistsWaitWaiterConfigTypeDef",
    "ImageModifyAttributeDescriptionTypeDef",
    "ImageModifyAttributeLaunchPermissionAddTypeDef",
    "ImageModifyAttributeLaunchPermissionRemoveTypeDef",
    "ImageModifyAttributeLaunchPermissionTypeDef",
    "ImageWaitUntilExistsFiltersTypeDef",
    "ImagesFilterFiltersTypeDef",
    "InstanceAttachClassicLinkVpcResponseTypeDef",
    "InstanceAttachVolumeResponseTypeDef",
    "InstanceConsoleOutputResponseTypeDef",
    "InstanceCreateImageBlockDeviceMappingsEbsTypeDef",
    "InstanceCreateImageBlockDeviceMappingsTypeDef",
    "InstanceCreateTagsTagsTypeDef",
    "InstanceDeleteTagsTagsTypeDef",
    "InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    "InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    "InstanceDescribeAttributeResponseDisableApiTerminationTypeDef",
    "InstanceDescribeAttributeResponseEbsOptimizedTypeDef",
    "InstanceDescribeAttributeResponseEnaSupportTypeDef",
    "InstanceDescribeAttributeResponseGroupsTypeDef",
    "InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    "InstanceDescribeAttributeResponseInstanceTypeTypeDef",
    "InstanceDescribeAttributeResponseKernelIdTypeDef",
    "InstanceDescribeAttributeResponseProductCodesTypeDef",
    "InstanceDescribeAttributeResponseRamdiskIdTypeDef",
    "InstanceDescribeAttributeResponseRootDeviceNameTypeDef",
    "InstanceDescribeAttributeResponseSourceDestCheckTypeDef",
    "InstanceDescribeAttributeResponseSriovNetSupportTypeDef",
    "InstanceDescribeAttributeResponseUserDataTypeDef",
    "InstanceDescribeAttributeResponseTypeDef",
    "InstanceDetachClassicLinkVpcResponseTypeDef",
    "InstanceDetachVolumeResponseTypeDef",
    "InstanceExistsWaitFiltersTypeDef",
    "InstanceExistsWaitWaiterConfigTypeDef",
    "InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef",
    "InstanceModifyAttributeBlockDeviceMappingsTypeDef",
    "InstanceModifyAttributeDisableApiTerminationTypeDef",
    "InstanceModifyAttributeEbsOptimizedTypeDef",
    "InstanceModifyAttributeEnaSupportTypeDef",
    "InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    "InstanceModifyAttributeInstanceTypeTypeDef",
    "InstanceModifyAttributeKernelTypeDef",
    "InstanceModifyAttributeRamdiskTypeDef",
    "InstanceModifyAttributeSourceDestCheckTypeDef",
    "InstanceModifyAttributeSriovNetSupportTypeDef",
    "InstanceModifyAttributeUserDataTypeDef",
    "InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstanceMonitorResponseInstanceMonitoringsTypeDef",
    "InstanceMonitorResponseTypeDef",
    "InstancePasswordDataResponseTypeDef",
    "InstanceRunningWaitFiltersTypeDef",
    "InstanceRunningWaitWaiterConfigTypeDef",
    "InstanceStartResponseStartingInstancesCurrentStateTypeDef",
    "InstanceStartResponseStartingInstancesPreviousStateTypeDef",
    "InstanceStartResponseStartingInstancesTypeDef",
    "InstanceStartResponseTypeDef",
    "InstanceStatusOkWaitFiltersTypeDef",
    "InstanceStatusOkWaitWaiterConfigTypeDef",
    "InstanceStopResponseStoppingInstancesCurrentStateTypeDef",
    "InstanceStopResponseStoppingInstancesPreviousStateTypeDef",
    "InstanceStopResponseStoppingInstancesTypeDef",
    "InstanceStopResponseTypeDef",
    "InstanceStoppedWaitFiltersTypeDef",
    "InstanceStoppedWaitWaiterConfigTypeDef",
    "InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    "InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    "InstanceTerminateResponseTerminatingInstancesTypeDef",
    "InstanceTerminateResponseTypeDef",
    "InstanceTerminatedWaitFiltersTypeDef",
    "InstanceTerminatedWaitWaiterConfigTypeDef",
    "InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstanceUnmonitorResponseInstanceMonitoringsTypeDef",
    "InstanceUnmonitorResponseTypeDef",
    "InstanceWaitUntilExistsFiltersTypeDef",
    "InstanceWaitUntilRunningFiltersTypeDef",
    "InstanceWaitUntilStoppedFiltersTypeDef",
    "InstanceWaitUntilTerminatedFiltersTypeDef",
    "InstancesCreateTagsTagsTypeDef",
    "InstancesFilterFiltersTypeDef",
    "InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstancesMonitorResponseInstanceMonitoringsTypeDef",
    "InstancesMonitorResponseTypeDef",
    "InstancesStartResponseStartingInstancesCurrentStateTypeDef",
    "InstancesStartResponseStartingInstancesPreviousStateTypeDef",
    "InstancesStartResponseStartingInstancesTypeDef",
    "InstancesStartResponseTypeDef",
    "InstancesStopResponseStoppingInstancesCurrentStateTypeDef",
    "InstancesStopResponseStoppingInstancesPreviousStateTypeDef",
    "InstancesStopResponseStoppingInstancesTypeDef",
    "InstancesStopResponseTypeDef",
    "InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    "InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    "InstancesTerminateResponseTerminatingInstancesTypeDef",
    "InstancesTerminateResponseTypeDef",
    "InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    "InstancesUnmonitorResponseInstanceMonitoringsTypeDef",
    "InstancesUnmonitorResponseTypeDef",
    "InternetGatewayCreateTagsTagsTypeDef",
    "InternetGatewaysFilterFiltersTypeDef",
    "KeyPairExistsWaitFiltersTypeDef",
    "KeyPairExistsWaitWaiterConfigTypeDef",
    "KeyPairsFilterFiltersTypeDef",
    "NatGatewayAvailableWaitFiltersTypeDef",
    "NatGatewayAvailableWaitWaiterConfigTypeDef",
    "NetworkAclCreateEntryIcmpTypeCodeTypeDef",
    "NetworkAclCreateEntryPortRangeTypeDef",
    "NetworkAclCreateTagsTagsTypeDef",
    "NetworkAclReplaceAssociationResponseTypeDef",
    "NetworkAclReplaceEntryIcmpTypeCodeTypeDef",
    "NetworkAclReplaceEntryPortRangeTypeDef",
    "NetworkAclsFilterFiltersTypeDef",
    "NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    "NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef",
    "NetworkInterfaceAttachResponseTypeDef",
    "NetworkInterfaceAvailableWaitFiltersTypeDef",
    "NetworkInterfaceAvailableWaitWaiterConfigTypeDef",
    "NetworkInterfaceCreateTagsTagsTypeDef",
    "NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef",
    "NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef",
    "NetworkInterfaceDescribeAttributeResponseGroupsTypeDef",
    "NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef",
    "NetworkInterfaceDescribeAttributeResponseTypeDef",
    "NetworkInterfaceModifyAttributeAttachmentTypeDef",
    "NetworkInterfaceModifyAttributeDescriptionTypeDef",
    "NetworkInterfaceModifyAttributeSourceDestCheckTypeDef",
    "NetworkInterfacesFilterFiltersTypeDef",
    "PasswordDataAvailableWaitWaiterConfigTypeDef",
    "PlacementGroupsFilterFiltersTypeDef",
    "RouteTableCreateTagsTagsTypeDef",
    "RouteTablesFilterFiltersTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupAuthorizeEgressIpPermissionsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupAuthorizeIngressIpPermissionsTypeDef",
    "SecurityGroupCreateTagsTagsTypeDef",
    "SecurityGroupExistsWaitFiltersTypeDef",
    "SecurityGroupExistsWaitWaiterConfigTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupRevokeEgressIpPermissionsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef",
    "SecurityGroupRevokeIngressIpPermissionsTypeDef",
    "SecurityGroupsFilterFiltersTypeDef",
    "ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef",
    "ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef",
    "ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef",
    "ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef",
    "ServiceResourceCreateInstancesCpuOptionsTypeDef",
    "ServiceResourceCreateInstancesCreditSpecificationTypeDef",
    "ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef",
    "ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef",
    "ServiceResourceCreateInstancesHibernationOptionsTypeDef",
    "ServiceResourceCreateInstancesIamInstanceProfileTypeDef",
    "ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef",
    "ServiceResourceCreateInstancesIpv6AddressesTypeDef",
    "ServiceResourceCreateInstancesLaunchTemplateTypeDef",
    "ServiceResourceCreateInstancesLicenseSpecificationsTypeDef",
    "ServiceResourceCreateInstancesMetadataOptionsTypeDef",
    "ServiceResourceCreateInstancesMonitoringTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "ServiceResourceCreateInstancesNetworkInterfacesTypeDef",
    "ServiceResourceCreateInstancesPlacementTypeDef",
    "ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateInstancesTagSpecificationsTypeDef",
    "ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef",
    "ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateSnapshotTagSpecificationsTypeDef",
    "ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef",
    "ServiceResourceCreateVolumeTagSpecificationsTypeDef",
    "ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef",
    "ServiceResourceRegisterImageBlockDeviceMappingsTypeDef",
    "SnapshotCompletedWaitFiltersTypeDef",
    "SnapshotCompletedWaitWaiterConfigTypeDef",
    "SnapshotCopyResponseTagsTypeDef",
    "SnapshotCopyResponseTypeDef",
    "SnapshotCopyTagSpecificationsTagsTypeDef",
    "SnapshotCopyTagSpecificationsTypeDef",
    "SnapshotCreateTagsTagsTypeDef",
    "SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef",
    "SnapshotDescribeAttributeResponseProductCodesTypeDef",
    "SnapshotDescribeAttributeResponseTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionAddTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef",
    "SnapshotModifyAttributeCreateVolumePermissionTypeDef",
    "SnapshotWaitUntilCompletedFiltersTypeDef",
    "SnapshotsFilterFiltersTypeDef",
    "SpotInstanceRequestFulfilledWaitFiltersTypeDef",
    "SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef",
    "SubnetAvailableWaitFiltersTypeDef",
    "SubnetAvailableWaitWaiterConfigTypeDef",
    "SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef",
    "SubnetCreateInstancesBlockDeviceMappingsTypeDef",
    "SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    "SubnetCreateInstancesCapacityReservationSpecificationTypeDef",
    "SubnetCreateInstancesCpuOptionsTypeDef",
    "SubnetCreateInstancesCreditSpecificationTypeDef",
    "SubnetCreateInstancesElasticGpuSpecificationTypeDef",
    "SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef",
    "SubnetCreateInstancesHibernationOptionsTypeDef",
    "SubnetCreateInstancesIamInstanceProfileTypeDef",
    "SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    "SubnetCreateInstancesInstanceMarketOptionsTypeDef",
    "SubnetCreateInstancesIpv6AddressesTypeDef",
    "SubnetCreateInstancesLaunchTemplateTypeDef",
    "SubnetCreateInstancesLicenseSpecificationsTypeDef",
    "SubnetCreateInstancesMetadataOptionsTypeDef",
    "SubnetCreateInstancesMonitoringTypeDef",
    "SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    "SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    "SubnetCreateInstancesNetworkInterfacesTypeDef",
    "SubnetCreateInstancesPlacementTypeDef",
    "SubnetCreateInstancesTagSpecificationsTagsTypeDef",
    "SubnetCreateInstancesTagSpecificationsTypeDef",
    "SubnetCreateNetworkInterfaceIpv6AddressesTypeDef",
    "SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef",
    "SubnetCreateTagsTagsTypeDef",
    "SubnetsFilterFiltersTypeDef",
    "SystemStatusOkWaitFiltersTypeDef",
    "SystemStatusOkWaitWaiterConfigTypeDef",
    "VolumeAttachToInstanceResponseTypeDef",
    "VolumeAvailableWaitFiltersTypeDef",
    "VolumeAvailableWaitWaiterConfigTypeDef",
    "VolumeCreateSnapshotTagSpecificationsTagsTypeDef",
    "VolumeCreateSnapshotTagSpecificationsTypeDef",
    "VolumeCreateTagsTagsTypeDef",
    "VolumeDeletedWaitFiltersTypeDef",
    "VolumeDeletedWaitWaiterConfigTypeDef",
    "VolumeDescribeAttributeResponseAutoEnableIOTypeDef",
    "VolumeDescribeAttributeResponseProductCodesTypeDef",
    "VolumeDescribeAttributeResponseTypeDef",
    "VolumeDescribeStatusFiltersTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    "VolumeDescribeStatusResponseVolumeStatusesTypeDef",
    "VolumeDescribeStatusResponseTypeDef",
    "VolumeDetachFromInstanceResponseTypeDef",
    "VolumeInUseWaitFiltersTypeDef",
    "VolumeInUseWaitWaiterConfigTypeDef",
    "VolumeModifyAttributeAutoEnableIOTypeDef",
    "VolumesFilterFiltersTypeDef",
    "VpcAddressAssociateResponseTypeDef",
    "VpcAttachClassicLinkInstanceResponseTypeDef",
    "VpcAvailableWaitFiltersTypeDef",
    "VpcAvailableWaitWaiterConfigTypeDef",
    "VpcCreateTagsTagsTypeDef",
    "VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef",
    "VpcDescribeAttributeResponseEnableDnsSupportTypeDef",
    "VpcDescribeAttributeResponseTypeDef",
    "VpcDetachClassicLinkInstanceResponseTypeDef",
    "VpcDisableClassicLinkResponseTypeDef",
    "VpcEnableClassicLinkResponseTypeDef",
    "VpcExistsWaitFiltersTypeDef",
    "VpcExistsWaitWaiterConfigTypeDef",
    "VpcModifyAttributeEnableDnsHostnamesTypeDef",
    "VpcModifyAttributeEnableDnsSupportTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef",
    "VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef",
    "VpcPeeringConnectionAcceptResponseTypeDef",
    "VpcPeeringConnectionDeleteResponseTypeDef",
    "VpcPeeringConnectionDeletedWaitFiltersTypeDef",
    "VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef",
    "VpcPeeringConnectionExistsWaitFiltersTypeDef",
    "VpcPeeringConnectionExistsWaitWaiterConfigTypeDef",
    "VpcPeeringConnectionRejectResponseTypeDef",
    "VpcPeeringConnectionWaitUntilExistsFiltersTypeDef",
    "VpcPeeringConnectionsFilterFiltersTypeDef",
    "VpcWaitUntilAvailableFiltersTypeDef",
    "VpcWaitUntilExistsFiltersTypeDef",
    "VpcsFilterFiltersTypeDef",
    "VpnConnectionAvailableWaitFiltersTypeDef",
    "VpnConnectionAvailableWaitWaiterConfigTypeDef",
    "VpnConnectionDeletedWaitFiltersTypeDef",
    "VpnConnectionDeletedWaitWaiterConfigTypeDef",
)


_BundleTaskCompleteWaitFiltersTypeDef = TypedDict(
    "_BundleTaskCompleteWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class BundleTaskCompleteWaitFiltersTypeDef(_BundleTaskCompleteWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_BundleTaskCompleteWaitWaiterConfigTypeDef = TypedDict(
    "_BundleTaskCompleteWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class BundleTaskCompleteWaitWaiterConfigTypeDef(_BundleTaskCompleteWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ClassicAddressAssociateResponseTypeDef = TypedDict(
    "_ClassicAddressAssociateResponseTypeDef", {"AssociationId": str}, total=False
)


class ClassicAddressAssociateResponseTypeDef(_ClassicAddressAssociateResponseTypeDef):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef = TypedDict(
    "_ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef", {"ExchangeId": str}, total=False
)


class ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef(
    _ClientAcceptReservedInstancesExchangeQuoteResponseTypeDef
):
    """
    - *(dict) --*

      The result of the exchange and whether it was ``successful`` .
      - **ExchangeId** *(string) --*

        The ID of the successful exchange.
    """


_ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"InstanceCount": int, "OfferingId": str},
    total=False,
)


class ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef(
    _ClientAcceptReservedInstancesExchangeQuoteTargetConfigurationsTypeDef
):
    """
    - *(dict) --*

      Details about the target configuration.
      - **InstanceCount** *(integer) --*

        The number of instances the Covertible Reserved Instance offering can be applied to. This
        parameter is reserved and cannot be specified in a request
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    pass


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    pass


_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    - **TransitGatewayVpcAttachment** *(dict) --*

      The VPC attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientAcceptTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientAcceptTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachment** *(dict) --*

        The VPC attachment.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientAcceptVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientAcceptVpcEndpointConnectionsResponseTypeDef",
    {"Unsuccessful": List[ClientAcceptVpcEndpointConnectionsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientAcceptVpcEndpointConnectionsResponseTypeDef(
    _ClientAcceptVpcEndpointConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **Unsuccessful** *(list) --*

        Information about the interface endpoints that were not accepted, if applicable.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing an
      active VPC peering connection.
      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.
    """


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    {
        "Code": Literal[
            "initiating-request",
            "pending-acceptance",
            "active",
            "deleted",
            "rejected",
            "failed",
            "expired",
            "provisioning",
            "deleting",
        ],
        "Message": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
):
    pass


_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
):
    """
    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.
      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.
        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.
    """


_ClientAcceptVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientAcceptVpcPeeringConnectionResponseTypeDef",
    {"VpcPeeringConnection": ClientAcceptVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef},
    total=False,
)


class ClientAcceptVpcPeeringConnectionResponseTypeDef(
    _ClientAcceptVpcPeeringConnectionResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcPeeringConnection** *(dict) --*

        Information about the VPC peering connection.
        - **AccepterVpcInfo** *(dict) --*

          Information about the accepter VPC. CIDR block information is only returned when
          describing an active VPC peering connection.
          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.
    """


_ClientAdvertiseByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientAdvertiseByoipCidrResponseByoipCidrTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class ClientAdvertiseByoipCidrResponseByoipCidrTypeDef(
    _ClientAdvertiseByoipCidrResponseByoipCidrTypeDef
):
    """
    - **ByoipCidr** *(dict) --*

      Information about the address range.
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_ClientAdvertiseByoipCidrResponseTypeDef = TypedDict(
    "_ClientAdvertiseByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientAdvertiseByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientAdvertiseByoipCidrResponseTypeDef(_ClientAdvertiseByoipCidrResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidr** *(dict) --*

        Information about the address range.
        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.
    """


_ClientAllocateAddressResponseTypeDef = TypedDict(
    "_ClientAllocateAddressResponseTypeDef",
    {
        "PublicIp": str,
        "AllocationId": str,
        "PublicIpv4Pool": str,
        "Domain": Literal["vpc", "standard"],
    },
    total=False,
)


class ClientAllocateAddressResponseTypeDef(_ClientAllocateAddressResponseTypeDef):
    """
    - *(dict) --*

      - **PublicIp** *(string) --*

        The Elastic IP address.
    """


_ClientAllocateHostsResponseTypeDef = TypedDict(
    "_ClientAllocateHostsResponseTypeDef", {"HostIds": List[str]}, total=False
)


class ClientAllocateHostsResponseTypeDef(_ClientAllocateHostsResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of AllocateHosts.
      - **HostIds** *(list) --*

        The ID of the allocated Dedicated Host. This is used to launch an instance onto a specific
        host.
        - *(string) --*
    """


_ClientAllocateHostsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientAllocateHostsTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientAllocateHostsTagSpecificationsTagsTypeDef(
    _ClientAllocateHostsTagSpecificationsTagsTypeDef
):
    pass


_ClientAllocateHostsTagSpecificationsTypeDef = TypedDict(
    "_ClientAllocateHostsTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientAllocateHostsTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientAllocateHostsTagSpecificationsTypeDef(_ClientAllocateHostsTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef",
    {"SecurityGroupIds": List[str]},
    total=False,
)


class ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef(
    _ClientApplySecurityGroupsToClientVpnTargetNetworkResponseTypeDef
):
    """
    - *(dict) --*

      - **SecurityGroupIds** *(list) --*

        The IDs of the applied security groups.
        - *(string) --*
    """


_ClientAssignIpv6AddressesResponseTypeDef = TypedDict(
    "_ClientAssignIpv6AddressesResponseTypeDef",
    {"AssignedIpv6Addresses": List[str], "NetworkInterfaceId": str},
    total=False,
)


class ClientAssignIpv6AddressesResponseTypeDef(_ClientAssignIpv6AddressesResponseTypeDef):
    """
    - *(dict) --*

      - **AssignedIpv6Addresses** *(list) --*

        The IPv6 addresses assigned to the network interface.
        - *(string) --*
    """


_ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef = TypedDict(
    "_ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    {"PrivateIpAddress": str},
    total=False,
)


class ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef(
    _ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
):
    pass


_ClientAssignPrivateIpAddressesResponseTypeDef = TypedDict(
    "_ClientAssignPrivateIpAddressesResponseTypeDef",
    {
        "NetworkInterfaceId": str,
        "AssignedPrivateIpAddresses": List[
            ClientAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
        ],
    },
    total=False,
)


class ClientAssignPrivateIpAddressesResponseTypeDef(_ClientAssignPrivateIpAddressesResponseTypeDef):
    """
    - *(dict) --*

      - **NetworkInterfaceId** *(string) --*

        The ID of the network interface.
    """


_ClientAssociateAddressResponseTypeDef = TypedDict(
    "_ClientAssociateAddressResponseTypeDef", {"AssociationId": str}, total=False
)


class ClientAssociateAddressResponseTypeDef(_ClientAssociateAddressResponseTypeDef):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef = TypedDict(
    "_ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef",
    {
        "Code": Literal[
            "associating", "associated", "association-failed", "disassociating", "disassociated"
        ],
        "Message": str,
    },
    total=False,
)


class ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef(
    _ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef
):
    pass


_ClientAssociateClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientAssociateClientVpnTargetNetworkResponseTypeDef",
    {"AssociationId": str, "Status": ClientAssociateClientVpnTargetNetworkResponseStatusTypeDef},
    total=False,
)


class ClientAssociateClientVpnTargetNetworkResponseTypeDef(
    _ClientAssociateClientVpnTargetNetworkResponseTypeDef
):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        The unique ID of the target network association.
    """


_ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef(
    _ClientAssociateIamInstanceProfileIamInstanceProfileTypeDef
):
    """
    The IAM instance profile.
    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.
    """


_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    pass


_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef(
    _ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
):
    """
    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_ClientAssociateIamInstanceProfileResponseTypeDef = TypedDict(
    "_ClientAssociateIamInstanceProfileResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientAssociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientAssociateIamInstanceProfileResponseTypeDef(
    _ClientAssociateIamInstanceProfileResponseTypeDef
):
    """
    - *(dict) --*

      - **IamInstanceProfileAssociation** *(dict) --*

        Information about the IAM instance profile association.
        - **AssociationId** *(string) --*

          The ID of the association.
    """


_ClientAssociateRouteTableResponseTypeDef = TypedDict(
    "_ClientAssociateRouteTableResponseTypeDef", {"AssociationId": str}, total=False
)


class ClientAssociateRouteTableResponseTypeDef(_ClientAssociateRouteTableResponseTypeDef):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        The route table association ID. This ID is required for disassociating the route table.
    """


_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    pass


_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.
      - **AssociationId** *(string) --*

        The association ID for the CIDR block.
    """


_ClientAssociateSubnetCidrBlockResponseTypeDef = TypedDict(
    "_ClientAssociateSubnetCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientAssociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "SubnetId": str,
    },
    total=False,
)


class ClientAssociateSubnetCidrBlockResponseTypeDef(_ClientAssociateSubnetCidrBlockResponseTypeDef):
    """
    - *(dict) --*

      - **Ipv6CidrBlockAssociation** *(dict) --*

        Information about the IPv6 CIDR block association.
        - **AssociationId** *(string) --*

          The association ID for the CIDR block.
    """


_ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef = TypedDict(
    "_ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef(
    _ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef
):
    """
    - **Association** *(dict) --*

      The ID of the association.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_ClientAssociateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientAssociateTransitGatewayRouteTableResponseTypeDef",
    {"Association": ClientAssociateTransitGatewayRouteTableResponseAssociationTypeDef},
    total=False,
)


class ClientAssociateTransitGatewayRouteTableResponseTypeDef(
    _ClientAssociateTransitGatewayRouteTableResponseTypeDef
):
    """
    - *(dict) --*

      - **Association** *(dict) --*

        The ID of the association.
        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.
    """


_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef(
    _ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef
):
    pass


_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientAssociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef(
    _ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef
):
    pass


_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    pass


_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.
      - **AssociationId** *(string) --*

        The association ID for the IPv6 CIDR block.
    """


_ClientAssociateVpcCidrBlockResponseTypeDef = TypedDict(
    "_ClientAssociateVpcCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientAssociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "CidrBlockAssociation": ClientAssociateVpcCidrBlockResponseCidrBlockAssociationTypeDef,
        "VpcId": str,
    },
    total=False,
)


class ClientAssociateVpcCidrBlockResponseTypeDef(_ClientAssociateVpcCidrBlockResponseTypeDef):
    """
    - *(dict) --*

      - **Ipv6CidrBlockAssociation** *(dict) --*

        Information about the IPv6 CIDR block association.
        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.
    """


_ClientAttachClassicLinkVpcResponseTypeDef = TypedDict(
    "_ClientAttachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class ClientAttachClassicLinkVpcResponseTypeDef(_ClientAttachClassicLinkVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientAttachNetworkInterfaceResponseTypeDef = TypedDict(
    "_ClientAttachNetworkInterfaceResponseTypeDef", {"AttachmentId": str}, total=False
)


class ClientAttachNetworkInterfaceResponseTypeDef(_ClientAttachNetworkInterfaceResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of AttachNetworkInterface.
      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.
    """


_ClientAttachVolumeResponseTypeDef = TypedDict(
    "_ClientAttachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientAttachVolumeResponseTypeDef(_ClientAttachVolumeResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_ClientAttachVpnGatewayResponseVpcAttachmentTypeDef = TypedDict(
    "_ClientAttachVpnGatewayResponseVpcAttachmentTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientAttachVpnGatewayResponseVpcAttachmentTypeDef(
    _ClientAttachVpnGatewayResponseVpcAttachmentTypeDef
):
    """
    - **VpcAttachment** *(dict) --*

      Information about the attachment.
      - **State** *(string) --*

        The current state of the attachment.
    """


_ClientAttachVpnGatewayResponseTypeDef = TypedDict(
    "_ClientAttachVpnGatewayResponseTypeDef",
    {"VpcAttachment": ClientAttachVpnGatewayResponseVpcAttachmentTypeDef},
    total=False,
)


class ClientAttachVpnGatewayResponseTypeDef(_ClientAttachVpnGatewayResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of AttachVpnGateway.
      - **VpcAttachment** *(dict) --*

        Information about the attachment.
        - **State** *(string) --*

          The current state of the attachment.
    """


_ClientAuthorizeClientVpnIngressResponseStatusTypeDef = TypedDict(
    "_ClientAuthorizeClientVpnIngressResponseStatusTypeDef",
    {"Code": Literal["authorizing", "active", "failed", "revoking"], "Message": str},
    total=False,
)


class ClientAuthorizeClientVpnIngressResponseStatusTypeDef(
    _ClientAuthorizeClientVpnIngressResponseStatusTypeDef
):
    """
    - **Status** *(dict) --*

      The current state of the authorization rule.
      - **Code** *(string) --*

        The state of the authorization rule.
    """


_ClientAuthorizeClientVpnIngressResponseTypeDef = TypedDict(
    "_ClientAuthorizeClientVpnIngressResponseTypeDef",
    {"Status": ClientAuthorizeClientVpnIngressResponseStatusTypeDef},
    total=False,
)


class ClientAuthorizeClientVpnIngressResponseTypeDef(
    _ClientAuthorizeClientVpnIngressResponseTypeDef
):
    """
    - *(dict) --*

      - **Status** *(dict) --*

        The current state of the authorization rule.
        - **Code** *(string) --*

          The state of the authorization rule.
    """


_ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef
):
    pass


_ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientAuthorizeSecurityGroupEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[ClientAuthorizeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[ClientAuthorizeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientAuthorizeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef(
    _ClientAuthorizeSecurityGroupEgressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef
):
    pass


_ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef = TypedDict(
    "_ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientAuthorizeSecurityGroupIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[ClientAuthorizeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[ClientAuthorizeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientAuthorizeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef(
    _ClientAuthorizeSecurityGroupIngressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef(
    _ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef
):
    pass


_ClientBundleInstanceResponseBundleTaskStorageS3TypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientBundleInstanceResponseBundleTaskStorageS3TypeDef(
    _ClientBundleInstanceResponseBundleTaskStorageS3TypeDef
):
    pass


_ClientBundleInstanceResponseBundleTaskStorageTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskStorageTypeDef",
    {"S3": ClientBundleInstanceResponseBundleTaskStorageS3TypeDef},
    total=False,
)


class ClientBundleInstanceResponseBundleTaskStorageTypeDef(
    _ClientBundleInstanceResponseBundleTaskStorageTypeDef
):
    pass


_ClientBundleInstanceResponseBundleTaskTypeDef = TypedDict(
    "_ClientBundleInstanceResponseBundleTaskTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientBundleInstanceResponseBundleTaskBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": Literal[
            "pending",
            "waiting-for-shutdown",
            "bundling",
            "storing",
            "cancelling",
            "complete",
            "failed",
        ],
        "Storage": ClientBundleInstanceResponseBundleTaskStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientBundleInstanceResponseBundleTaskTypeDef(_ClientBundleInstanceResponseBundleTaskTypeDef):
    """
    - **BundleTask** *(dict) --*

      Information about the bundle task.
      - **BundleId** *(string) --*

        The ID of the bundle task.
    """


_ClientBundleInstanceResponseTypeDef = TypedDict(
    "_ClientBundleInstanceResponseTypeDef",
    {"BundleTask": ClientBundleInstanceResponseBundleTaskTypeDef},
    total=False,
)


class ClientBundleInstanceResponseTypeDef(_ClientBundleInstanceResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of BundleInstance.
      - **BundleTask** *(dict) --*

        Information about the bundle task.
        - **BundleId** *(string) --*

          The ID of the bundle task.
    """


_ClientBundleInstanceStorageS3TypeDef = TypedDict(
    "_ClientBundleInstanceStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientBundleInstanceStorageS3TypeDef(_ClientBundleInstanceStorageS3TypeDef):
    """
    - **S3** *(dict) --*

      An Amazon S3 storage location.
      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your access key
        ID, review and follow the guidance in `Best Practices for Managing AWS Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .
    """


_ClientBundleInstanceStorageTypeDef = TypedDict(
    "_ClientBundleInstanceStorageTypeDef", {"S3": ClientBundleInstanceStorageS3TypeDef}, total=False
)


class ClientBundleInstanceStorageTypeDef(_ClientBundleInstanceStorageTypeDef):
    """
    The bucket in which to store the AMI. You can specify a bucket that you already own or a new
    bucket that Amazon EC2 creates on your behalf. If you specify a bucket that belongs to someone
    else, Amazon EC2 returns an error.
    - **S3** *(dict) --*

      An Amazon S3 storage location.
      - **AWSAccessKeyId** *(string) --*

        The access key ID of the owner of the bucket. Before you specify a value for your access key
        ID, review and follow the guidance in `Best Practices for Managing AWS Access Keys
        <https://docs.aws.amazon.com/general/latest/gr/aws-access-keys-best-practices.html>`__ .
    """


_ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef
):
    pass


_ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef(
    _ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef
):
    pass


_ClientCancelBundleTaskResponseBundleTaskStorageTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskStorageTypeDef",
    {"S3": ClientCancelBundleTaskResponseBundleTaskStorageS3TypeDef},
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskStorageTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskStorageTypeDef
):
    pass


_ClientCancelBundleTaskResponseBundleTaskTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseBundleTaskTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientCancelBundleTaskResponseBundleTaskBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": Literal[
            "pending",
            "waiting-for-shutdown",
            "bundling",
            "storing",
            "cancelling",
            "complete",
            "failed",
        ],
        "Storage": ClientCancelBundleTaskResponseBundleTaskStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientCancelBundleTaskResponseBundleTaskTypeDef(
    _ClientCancelBundleTaskResponseBundleTaskTypeDef
):
    """
    - **BundleTask** *(dict) --*

      Information about the bundle task.
      - **BundleId** *(string) --*

        The ID of the bundle task.
    """


_ClientCancelBundleTaskResponseTypeDef = TypedDict(
    "_ClientCancelBundleTaskResponseTypeDef",
    {"BundleTask": ClientCancelBundleTaskResponseBundleTaskTypeDef},
    total=False,
)


class ClientCancelBundleTaskResponseTypeDef(_ClientCancelBundleTaskResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CancelBundleTask.
      - **BundleTask** *(dict) --*

        Information about the bundle task.
        - **BundleId** *(string) --*

          The ID of the bundle task.
    """


_ClientCancelCapacityReservationResponseTypeDef = TypedDict(
    "_ClientCancelCapacityReservationResponseTypeDef", {"Return": bool}, total=False
)


class ClientCancelCapacityReservationResponseTypeDef(
    _ClientCancelCapacityReservationResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientCancelImportTaskResponseTypeDef = TypedDict(
    "_ClientCancelImportTaskResponseTypeDef",
    {"ImportTaskId": str, "PreviousState": str, "State": str},
    total=False,
)


class ClientCancelImportTaskResponseTypeDef(_ClientCancelImportTaskResponseTypeDef):
    """
    - *(dict) --*

      - **ImportTaskId** *(string) --*

        The ID of the task being canceled.
    """


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": Literal["available", "sold", "cancelled", "pending"]},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
):
    pass


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    pass


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
):
    pass


_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": Literal["active", "pending", "cancelled", "closed"],
        "StatusMessage": str,
        "Tags": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef(
    _ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance listing.
      - **ClientToken** *(string) --*

        A unique, case-sensitive key supplied by the client to ensure that the request is
        idempotent. For more information, see `Ensuring Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCancelReservedInstancesListingResponseTypeDef = TypedDict(
    "_ClientCancelReservedInstancesListingResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientCancelReservedInstancesListingResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientCancelReservedInstancesListingResponseTypeDef(
    _ClientCancelReservedInstancesListingResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of CancelReservedInstancesListing.
      - **ReservedInstancesListings** *(list) --*

        The Reserved Instance listing.
        - *(dict) --*

          Describes a Reserved Instance listing.
          - **ClientToken** *(string) --*

            A unique, case-sensitive key supplied by the client to ensure that the request is
            idempotent. For more information, see `Ensuring Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .
    """


_ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef",
    {
        "CurrentSpotFleetRequestState": Literal[
            "submitted",
            "active",
            "cancelled",
            "failed",
            "cancelled_running",
            "cancelled_terminating",
            "modifying",
        ],
        "PreviousSpotFleetRequestState": Literal[
            "submitted",
            "active",
            "cancelled",
            "failed",
            "cancelled_running",
            "cancelled_terminating",
            "modifying",
        ],
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef(
    _ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef
):
    """
    - *(dict) --*

      Describes a Spot Fleet request that was successfully canceled.
      - **CurrentSpotFleetRequestState** *(string) --*

        The current state of the Spot Fleet request.
    """


_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef",
    {
        "Code": Literal[
            "fleetRequestIdDoesNotExist",
            "fleetRequestIdMalformed",
            "fleetRequestNotInCancellableState",
            "unexpectedError",
        ],
        "Message": str,
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef(
    _ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef
):
    pass


_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef",
    {
        "Error": ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsErrorTypeDef,
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef(
    _ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef
):
    pass


_ClientCancelSpotFleetRequestsResponseTypeDef = TypedDict(
    "_ClientCancelSpotFleetRequestsResponseTypeDef",
    {
        "SuccessfulFleetRequests": List[
            ClientCancelSpotFleetRequestsResponseSuccessfulFleetRequestsTypeDef
        ],
        "UnsuccessfulFleetRequests": List[
            ClientCancelSpotFleetRequestsResponseUnsuccessfulFleetRequestsTypeDef
        ],
    },
    total=False,
)


class ClientCancelSpotFleetRequestsResponseTypeDef(_ClientCancelSpotFleetRequestsResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CancelSpotFleetRequests.
      - **SuccessfulFleetRequests** *(list) --*

        Information about the Spot Fleet requests that are successfully canceled.
        - *(dict) --*

          Describes a Spot Fleet request that was successfully canceled.
          - **CurrentSpotFleetRequestState** *(string) --*

            The current state of the Spot Fleet request.
    """


_ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef",
    {
        "SpotInstanceRequestId": str,
        "State": Literal["active", "open", "closed", "cancelled", "completed"],
    },
    total=False,
)


class ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef(
    _ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef
):
    """
    - *(dict) --*

      Describes a request to cancel a Spot Instance.
      - **SpotInstanceRequestId** *(string) --*

        The ID of the Spot Instance request.
    """


_ClientCancelSpotInstanceRequestsResponseTypeDef = TypedDict(
    "_ClientCancelSpotInstanceRequestsResponseTypeDef",
    {
        "CancelledSpotInstanceRequests": List[
            ClientCancelSpotInstanceRequestsResponseCancelledSpotInstanceRequestsTypeDef
        ]
    },
    total=False,
)


class ClientCancelSpotInstanceRequestsResponseTypeDef(
    _ClientCancelSpotInstanceRequestsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of CancelSpotInstanceRequests.
      - **CancelledSpotInstanceRequests** *(list) --*

        One or more Spot Instance requests.
        - *(dict) --*

          Describes a request to cancel a Spot Instance.
          - **SpotInstanceRequestId** *(string) --*

            The ID of the Spot Instance request.
    """


_ClientConfirmProductInstanceResponseTypeDef = TypedDict(
    "_ClientConfirmProductInstanceResponseTypeDef", {"OwnerId": str, "Return": bool}, total=False
)


class ClientConfirmProductInstanceResponseTypeDef(_ClientConfirmProductInstanceResponseTypeDef):
    """
    - *(dict) --*

      - **OwnerId** *(string) --*

        The AWS account ID of the instance owner. This is only present if the product code is
        attached to the instance.
    """


_ClientCopyFpgaImageResponseTypeDef = TypedDict(
    "_ClientCopyFpgaImageResponseTypeDef", {"FpgaImageId": str}, total=False
)


class ClientCopyFpgaImageResponseTypeDef(_ClientCopyFpgaImageResponseTypeDef):
    """
    - *(dict) --*

      - **FpgaImageId** *(string) --*

        The ID of the new AFI.
    """


_ClientCopyImageResponseTypeDef = TypedDict(
    "_ClientCopyImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientCopyImageResponseTypeDef(_ClientCopyImageResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CopyImage.
      - **ImageId** *(string) --*

        The ID of the new AMI.
    """


_ClientCopySnapshotResponseTagsTypeDef = TypedDict(
    "_ClientCopySnapshotResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCopySnapshotResponseTagsTypeDef(_ClientCopySnapshotResponseTagsTypeDef):
    pass


_ClientCopySnapshotResponseTypeDef = TypedDict(
    "_ClientCopySnapshotResponseTypeDef",
    {"SnapshotId": str, "Tags": List[ClientCopySnapshotResponseTagsTypeDef]},
    total=False,
)


class ClientCopySnapshotResponseTypeDef(_ClientCopySnapshotResponseTypeDef):
    """
    - *(dict) --*

      - **SnapshotId** *(string) --*

        The ID of the new snapshot.
    """


_ClientCopySnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCopySnapshotTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCopySnapshotTagSpecificationsTagsTypeDef(
    _ClientCopySnapshotTagSpecificationsTagsTypeDef
):
    pass


_ClientCopySnapshotTagSpecificationsTypeDef = TypedDict(
    "_ClientCopySnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCopySnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCopySnapshotTagSpecificationsTypeDef(_ClientCopySnapshotTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef(
    _ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef
):
    pass


_ClientCreateCapacityReservationResponseCapacityReservationTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseCapacityReservationTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": Literal[
            "Linux/UNIX",
            "Red Hat Enterprise Linux",
            "SUSE Linux",
            "Windows",
            "Windows with SQL Server",
            "Windows with SQL Server Enterprise",
            "Windows with SQL Server Standard",
            "Windows with SQL Server Web",
            "Linux with SQL Server Standard",
            "Linux with SQL Server Web",
            "Linux with SQL Server Enterprise",
        ],
        "AvailabilityZone": str,
        "Tenancy": Literal["default", "dedicated"],
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": Literal["active", "expired", "cancelled", "pending", "failed"],
        "EndDate": datetime,
        "EndDateType": Literal["unlimited", "limited"],
        "InstanceMatchCriteria": Literal["open", "targeted"],
        "CreateDate": datetime,
        "Tags": List[ClientCreateCapacityReservationResponseCapacityReservationTagsTypeDef],
    },
    total=False,
)


class ClientCreateCapacityReservationResponseCapacityReservationTypeDef(
    _ClientCreateCapacityReservationResponseCapacityReservationTypeDef
):
    """
    - **CapacityReservation** *(dict) --*

      Information about the Capacity Reservation.
      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_ClientCreateCapacityReservationResponseTypeDef = TypedDict(
    "_ClientCreateCapacityReservationResponseTypeDef",
    {"CapacityReservation": ClientCreateCapacityReservationResponseCapacityReservationTypeDef},
    total=False,
)


class ClientCreateCapacityReservationResponseTypeDef(
    _ClientCreateCapacityReservationResponseTypeDef
):
    """
    - *(dict) --*

      - **CapacityReservation** *(dict) --*

        Information about the Capacity Reservation.
        - **CapacityReservationId** *(string) --*

          The ID of the Capacity Reservation.
    """


_ClientCreateCapacityReservationTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCapacityReservationTagSpecificationsTagsTypeDef(
    _ClientCreateCapacityReservationTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateCapacityReservationTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateCapacityReservationTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateCapacityReservationTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateCapacityReservationTagSpecificationsTypeDef(
    _ClientCreateCapacityReservationTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef
):
    pass


_ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChainArn": str},
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef
):
    pass


_ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef",
    {
        "Type": Literal["certificate-authentication", "directory-service-authentication"],
        "ActiveDirectory": ClientCreateClientVpnEndpointAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": ClientCreateClientVpnEndpointAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef(
    _ClientCreateClientVpnEndpointAuthenticationOptionsTypeDef
):
    """
    - *(dict) --*

      Describes the authentication method to be used by a Client VPN endpoint. Client VPN supports
      Active Directory and mutual authentication. For more information, see `Authentication
      <https://docs.aws.amazon.com/vpn/latest/clientvpn-admin/authentication-authrization.html#client-authentication>`__
      in the *AWS Client VPN Administrator Guide* .
      - **Type** *(string) --*

        The type of client authentication to be used. Specify ``certificate-authentication`` to use
        certificate-based authentication, or ``directory-service-authentication`` to use Active
        Directory authentication.
    """


_ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef(
    _ClientCreateClientVpnEndpointConnectionLogOptionsTypeDef
):
    """
    Information about the client connection logging options.
    If you enable client connection logging, data about client connections is sent to a Cloudwatch
    Logs log stream. The following information is logged:
    * Client connection requests
    * Client connection results (successful and unsuccessful)
    * Reasons for unsuccessful client connection requests
    * Client connection termination time
    - **Enabled** *(boolean) --*

      Indicates whether connection logging is enabled.
    """


_ClientCreateClientVpnEndpointResponseStatusTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointResponseStatusTypeDef",
    {"Code": Literal["pending-associate", "available", "deleting", "deleted"], "Message": str},
    total=False,
)


class ClientCreateClientVpnEndpointResponseStatusTypeDef(
    _ClientCreateClientVpnEndpointResponseStatusTypeDef
):
    pass


_ClientCreateClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointResponseTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Status": ClientCreateClientVpnEndpointResponseStatusTypeDef,
        "DnsName": str,
    },
    total=False,
)


class ClientCreateClientVpnEndpointResponseTypeDef(_ClientCreateClientVpnEndpointResponseTypeDef):
    """
    - *(dict) --*

      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint.
    """


_ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef(
    _ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateClientVpnEndpointTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateClientVpnEndpointTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateClientVpnEndpointTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateClientVpnEndpointTagSpecificationsTypeDef(
    _ClientCreateClientVpnEndpointTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateClientVpnRouteResponseStatusTypeDef = TypedDict(
    "_ClientCreateClientVpnRouteResponseStatusTypeDef",
    {"Code": Literal["creating", "active", "failed", "deleting"], "Message": str},
    total=False,
)


class ClientCreateClientVpnRouteResponseStatusTypeDef(
    _ClientCreateClientVpnRouteResponseStatusTypeDef
):
    """
    - **Status** *(dict) --*

      The current state of the route.
      - **Code** *(string) --*

        The state of the Client VPN endpoint route.
    """


_ClientCreateClientVpnRouteResponseTypeDef = TypedDict(
    "_ClientCreateClientVpnRouteResponseTypeDef",
    {"Status": ClientCreateClientVpnRouteResponseStatusTypeDef},
    total=False,
)


class ClientCreateClientVpnRouteResponseTypeDef(_ClientCreateClientVpnRouteResponseTypeDef):
    """
    - *(dict) --*

      - **Status** *(dict) --*

        The current state of the route.
        - **Code** *(string) --*

          The state of the Client VPN endpoint route.
    """


_ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef(
    _ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef
):
    pass


_ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef",
    {
        "BgpAsn": str,
        "CustomerGatewayId": str,
        "IpAddress": str,
        "CertificateArn": str,
        "State": str,
        "Type": str,
        "DeviceName": str,
        "Tags": List[ClientCreateCustomerGatewayResponseCustomerGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef(
    _ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef
):
    """
    - **CustomerGateway** *(dict) --*

      Information about the customer gateway.
      - **BgpAsn** *(string) --*

        The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).
    """


_ClientCreateCustomerGatewayResponseTypeDef = TypedDict(
    "_ClientCreateCustomerGatewayResponseTypeDef",
    {"CustomerGateway": ClientCreateCustomerGatewayResponseCustomerGatewayTypeDef},
    total=False,
)


class ClientCreateCustomerGatewayResponseTypeDef(_ClientCreateCustomerGatewayResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CreateCustomerGateway.
      - **CustomerGateway** *(dict) --*

        Information about the customer gateway.
        - **BgpAsn** *(string) --*

          The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).
    """


_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateDefaultSubnetResponseSubnetTagsTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateDefaultSubnetResponseSubnetTagsTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetTagsTypeDef
):
    pass


_ClientCreateDefaultSubnetResponseSubnetTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseSubnetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": Literal["pending", "available"],
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateDefaultSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientCreateDefaultSubnetResponseSubnetTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientCreateDefaultSubnetResponseSubnetTypeDef(
    _ClientCreateDefaultSubnetResponseSubnetTypeDef
):
    """
    - **Subnet** *(dict) --*

      Information about the subnet.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.
    """


_ClientCreateDefaultSubnetResponseTypeDef = TypedDict(
    "_ClientCreateDefaultSubnetResponseTypeDef",
    {"Subnet": ClientCreateDefaultSubnetResponseSubnetTypeDef},
    total=False,
)


class ClientCreateDefaultSubnetResponseTypeDef(_ClientCreateDefaultSubnetResponseTypeDef):
    """
    - *(dict) --*

      - **Subnet** *(dict) --*

        Information about the subnet.
        - **AvailabilityZone** *(string) --*

          The Availability Zone of the subnet.
    """


_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef
):
    pass


_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateDefaultVpcResponseVpcTagsTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateDefaultVpcResponseVpcTagsTypeDef(_ClientCreateDefaultVpcResponseVpcTagsTypeDef):
    pass


_ClientCreateDefaultVpcResponseVpcTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseVpcTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": Literal["pending", "available"],
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateDefaultVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            ClientCreateDefaultVpcResponseVpcCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[ClientCreateDefaultVpcResponseVpcTagsTypeDef],
    },
    total=False,
)


class ClientCreateDefaultVpcResponseVpcTypeDef(_ClientCreateDefaultVpcResponseVpcTypeDef):
    """
    - **Vpc** *(dict) --*

      Information about the VPC.
      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.
    """


_ClientCreateDefaultVpcResponseTypeDef = TypedDict(
    "_ClientCreateDefaultVpcResponseTypeDef",
    {"Vpc": ClientCreateDefaultVpcResponseVpcTypeDef},
    total=False,
)


class ClientCreateDefaultVpcResponseTypeDef(_ClientCreateDefaultVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Vpc** *(dict) --*

        Information about the VPC.
        - **CidrBlock** *(string) --*

          The primary IPv4 CIDR block for the VPC.
    """


_ClientCreateDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsDhcpConfigurationsTypeDef",
    {"Key": str, "Values": List[str]},
    total=False,
)


class ClientCreateDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientCreateDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    - *(dict) --*

      - **Key** *(string) --*
      - **Values** *(list) --*

        - *(string) --*
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    pass


_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef],
    },
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes a DHCP configuration option.
      - **Key** *(string) --*

        The name of a DHCP option.
    """


_ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef
):
    pass


_ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            ClientCreateDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[ClientCreateDhcpOptionsResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef(
    _ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef
):
    """
    - **DhcpOptions** *(dict) --*

      A set of DHCP options.
      - **DhcpConfigurations** *(list) --*

        One or more DHCP options in the set.
        - *(dict) --*

          Describes a DHCP configuration option.
          - **Key** *(string) --*

            The name of a DHCP option.
    """


_ClientCreateDhcpOptionsResponseTypeDef = TypedDict(
    "_ClientCreateDhcpOptionsResponseTypeDef",
    {"DhcpOptions": ClientCreateDhcpOptionsResponseDhcpOptionsTypeDef},
    total=False,
)


class ClientCreateDhcpOptionsResponseTypeDef(_ClientCreateDhcpOptionsResponseTypeDef):
    """
    - *(dict) --*

      - **DhcpOptions** *(dict) --*

        A set of DHCP options.
        - **DhcpConfigurations** *(list) --*

          One or more DHCP options in the set.
          - *(dict) --*

            Describes a DHCP configuration option.
            - **Key** *(string) --*

              The name of a DHCP option.
    """


_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef
):
    pass


_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef",
    {
        "Attachments": List[
            ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef
):
    pass


_ClientCreateEgressOnlyInternetGatewayResponseTypeDef = TypedDict(
    "_ClientCreateEgressOnlyInternetGatewayResponseTypeDef",
    {
        "ClientToken": str,
        "EgressOnlyInternetGateway": ClientCreateEgressOnlyInternetGatewayResponseEgressOnlyInternetGatewayTypeDef,
    },
    total=False,
)


class ClientCreateEgressOnlyInternetGatewayResponseTypeDef(
    _ClientCreateEgressOnlyInternetGatewayResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientToken** *(string) --*

        Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
    """


_ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    """
    - **LaunchTemplateSpecification** *(dict) --*

      The launch template to use. You must specify either the launch template ID or launch template
      name in the request.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef
):
    pass


_ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef(
    _ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef
):
    pass


_ClientCreateFleetLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientCreateFleetLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[ClientCreateFleetLaunchTemplateConfigsOverridesTypeDef],
    },
    total=False,
)


class ClientCreateFleetLaunchTemplateConfigsTypeDef(_ClientCreateFleetLaunchTemplateConfigsTypeDef):
    """
    - *(dict) --*

      Describes a launch template and overrides.
      - **LaunchTemplateSpecification** *(dict) --*

        The launch template to use. You must specify either the launch template ID or launch
        template name in the request.
        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.
    """


_ClientCreateFleetOnDemandOptionsTypeDef = TypedDict(
    "_ClientCreateFleetOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "prioritized"],
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientCreateFleetOnDemandOptionsTypeDef(_ClientCreateFleetOnDemandOptionsTypeDef):
    """
    Describes the configuration of On-Demand Instances in an EC2 Fleet.
    - **AllocationStrategy** *(string) --*

      The order of the launch template overrides to use in fulfilling On-Demand capacity. If you
      specify ``lowest-price`` , EC2 Fleet uses price to determine the order, launching the lowest
      price first. If you specify ``prioritized`` , EC2 Fleet uses the priority that you assigned to
      each launch template override, launching the highest priority first. If you do not specify a
      value, EC2 Fleet defaults to ``lowest-price`` .
    """


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef(
    _ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef
):
    pass


_ClientCreateFleetResponseErrorsTypeDef = TypedDict(
    "_ClientCreateFleetResponseErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientCreateFleetResponseErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class ClientCreateFleetResponseErrorsTypeDef(_ClientCreateFleetResponseErrorsTypeDef):
    pass


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef(
    _ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef
):
    pass


_ClientCreateFleetResponseInstancesTypeDef = TypedDict(
    "_ClientCreateFleetResponseInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientCreateFleetResponseInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "InstanceIds": List[str],
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
    },
    total=False,
)


class ClientCreateFleetResponseInstancesTypeDef(_ClientCreateFleetResponseInstancesTypeDef):
    pass


_ClientCreateFleetResponseTypeDef = TypedDict(
    "_ClientCreateFleetResponseTypeDef",
    {
        "FleetId": str,
        "Errors": List[ClientCreateFleetResponseErrorsTypeDef],
        "Instances": List[ClientCreateFleetResponseInstancesTypeDef],
    },
    total=False,
)


class ClientCreateFleetResponseTypeDef(_ClientCreateFleetResponseTypeDef):
    """
    - *(dict) --*

      - **FleetId** *(string) --*

        The ID of the EC2 Fleet.
    """


_ClientCreateFleetSpotOptionsTypeDef = TypedDict(
    "_ClientCreateFleetSpotOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "diversified", "capacity-optimized"],
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientCreateFleetSpotOptionsTypeDef(_ClientCreateFleetSpotOptionsTypeDef):
    """
    Describes the configuration of Spot Instances in an EC2 Fleet.
    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance pools
      specified by the EC2 Fleet.
      If the allocation strategy is ``lowest-price`` , EC2 Fleet launches instances from the Spot
      Instance pools with the lowest price. This is the default allocation strategy.
      If the allocation strategy is ``diversified`` , EC2 Fleet launches instances from all the Spot
      Instance pools that you specify.
      If the allocation strategy is ``capacity-optimized`` , EC2 Fleet launches instances from Spot
      Instance pools with optimal capacity for the number of instances that are launching.
    """


_ClientCreateFleetTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateFleetTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateFleetTagSpecificationsTagsTypeDef(_ClientCreateFleetTagSpecificationsTagsTypeDef):
    pass


_ClientCreateFleetTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateFleetTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateFleetTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateFleetTagSpecificationsTypeDef(_ClientCreateFleetTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_RequiredClientCreateFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_RequiredClientCreateFleetTargetCapacitySpecificationTypeDef", {"TotalTargetCapacity": int}
)
_OptionalClientCreateFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_OptionalClientCreateFleetTargetCapacitySpecificationTypeDef",
    {
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": Literal["spot", "on-demand"],
    },
    total=False,
)


class ClientCreateFleetTargetCapacitySpecificationTypeDef(
    _RequiredClientCreateFleetTargetCapacitySpecificationTypeDef,
    _OptionalClientCreateFleetTargetCapacitySpecificationTypeDef,
):
    """
    The number of units to request.
    - **TotalTargetCapacity** *(integer) --***[REQUIRED]**

      The number of units to request, filled using ``DefaultTargetCapacityType`` .
    """


_ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef(
    _ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef
):
    pass


_ClientCreateFlowLogsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseUnsuccessfulTypeDef",
    {"Error": ClientCreateFlowLogsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientCreateFlowLogsResponseUnsuccessfulTypeDef(
    _ClientCreateFlowLogsResponseUnsuccessfulTypeDef
):
    pass


_ClientCreateFlowLogsResponseTypeDef = TypedDict(
    "_ClientCreateFlowLogsResponseTypeDef",
    {
        "ClientToken": str,
        "FlowLogIds": List[str],
        "Unsuccessful": List[ClientCreateFlowLogsResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientCreateFlowLogsResponseTypeDef(_ClientCreateFlowLogsResponseTypeDef):
    """
    - *(dict) --*

      - **ClientToken** *(string) --*

        Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
    """


_ClientCreateFpgaImageInputStorageLocationTypeDef = TypedDict(
    "_ClientCreateFpgaImageInputStorageLocationTypeDef", {"Bucket": str, "Key": str}, total=False
)


class ClientCreateFpgaImageInputStorageLocationTypeDef(
    _ClientCreateFpgaImageInputStorageLocationTypeDef
):
    """
    The location of the encrypted design checkpoint in Amazon S3. The input must be a tarball.
    - **Bucket** *(string) --*

      The name of the S3 bucket.
    """


_ClientCreateFpgaImageLogsStorageLocationTypeDef = TypedDict(
    "_ClientCreateFpgaImageLogsStorageLocationTypeDef", {"Bucket": str, "Key": str}, total=False
)


class ClientCreateFpgaImageLogsStorageLocationTypeDef(
    _ClientCreateFpgaImageLogsStorageLocationTypeDef
):
    """
    The location in Amazon S3 for the output logs.
    - **Bucket** *(string) --*

      The name of the S3 bucket.
    """


_ClientCreateFpgaImageResponseTypeDef = TypedDict(
    "_ClientCreateFpgaImageResponseTypeDef",
    {"FpgaImageId": str, "FpgaImageGlobalId": str},
    total=False,
)


class ClientCreateFpgaImageResponseTypeDef(_ClientCreateFpgaImageResponseTypeDef):
    """
    - *(dict) --*

      - **FpgaImageId** *(string) --*

        The FPGA image identifier (AFI ID).
    """


_ClientCreateFpgaImageTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateFpgaImageTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateFpgaImageTagSpecificationsTagsTypeDef(
    _ClientCreateFpgaImageTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateFpgaImageTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateFpgaImageTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateFpgaImageTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateFpgaImageTagSpecificationsTypeDef(_ClientCreateFpgaImageTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientCreateImageBlockDeviceMappingsEbsTypeDef(
    _ClientCreateImageBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientCreateImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateImageBlockDeviceMappingsTypeDef(_ClientCreateImageBlockDeviceMappingsTypeDef):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientCreateImageResponseTypeDef = TypedDict(
    "_ClientCreateImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientCreateImageResponseTypeDef(_ClientCreateImageResponseTypeDef):
    """
    - *(dict) --*

      - **ImageId** *(string) --*

        The ID of the new AMI.
    """


_ClientCreateInstanceExportTaskExportToS3TaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskExportToS3TaskTypeDef",
    {
        "ContainerFormat": str,
        "DiskImageFormat": Literal["VMDK", "RAW", "VHD"],
        "S3Bucket": str,
        "S3Prefix": str,
    },
    total=False,
)


class ClientCreateInstanceExportTaskExportToS3TaskTypeDef(
    _ClientCreateInstanceExportTaskExportToS3TaskTypeDef
):
    """
    The format and location for an instance export task.
    - **ContainerFormat** *(string) --*

      The container format used to combine disk images with metadata (such as OVF). If absent, only
      the disk image is exported.
    """


_ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef",
    {
        "ContainerFormat": str,
        "DiskImageFormat": Literal["VMDK", "RAW", "VHD"],
        "S3Bucket": str,
        "S3Key": str,
    },
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef
):
    pass


_ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef",
    {"InstanceId": str, "TargetEnvironment": Literal["citrix", "vmware", "microsoft"]},
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef
):
    pass


_ClientCreateInstanceExportTaskResponseExportTaskTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseExportTaskTypeDef",
    {
        "Description": str,
        "ExportTaskId": str,
        "ExportToS3Task": ClientCreateInstanceExportTaskResponseExportTaskExportToS3TaskTypeDef,
        "InstanceExportDetails": ClientCreateInstanceExportTaskResponseExportTaskInstanceExportDetailsTypeDef,
        "State": Literal["active", "cancelling", "cancelled", "completed"],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateInstanceExportTaskResponseExportTaskTypeDef(
    _ClientCreateInstanceExportTaskResponseExportTaskTypeDef
):
    """
    - **ExportTask** *(dict) --*

      Information about the instance export task.
      - **Description** *(string) --*

        A description of the resource being exported.
    """


_ClientCreateInstanceExportTaskResponseTypeDef = TypedDict(
    "_ClientCreateInstanceExportTaskResponseTypeDef",
    {"ExportTask": ClientCreateInstanceExportTaskResponseExportTaskTypeDef},
    total=False,
)


class ClientCreateInstanceExportTaskResponseTypeDef(_ClientCreateInstanceExportTaskResponseTypeDef):
    """
    - *(dict) --*

      - **ExportTask** *(dict) --*

        Information about the instance export task.
        - **Description** *(string) --*

          A description of the resource being exported.
    """


_ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes the attachment of a VPC to an internet gateway or an egress-only internet gateway.
      - **State** *(string) --*

        The current state of the attachment. For an internet gateway, the state is ``available``
        when attached to a VPC; otherwise, this value is not returned.
    """


_ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef
):
    pass


_ClientCreateInternetGatewayResponseInternetGatewayTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseInternetGatewayTypeDef",
    {
        "Attachments": List[ClientCreateInternetGatewayResponseInternetGatewayAttachmentsTypeDef],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[ClientCreateInternetGatewayResponseInternetGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateInternetGatewayResponseInternetGatewayTypeDef(
    _ClientCreateInternetGatewayResponseInternetGatewayTypeDef
):
    """
    - **InternetGateway** *(dict) --*

      Information about the internet gateway.
      - **Attachments** *(list) --*

        Any VPCs attached to the internet gateway.
        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.
          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is ``available``
            when attached to a VPC; otherwise, this value is not returned.
    """


_ClientCreateInternetGatewayResponseTypeDef = TypedDict(
    "_ClientCreateInternetGatewayResponseTypeDef",
    {"InternetGateway": ClientCreateInternetGatewayResponseInternetGatewayTypeDef},
    total=False,
)


class ClientCreateInternetGatewayResponseTypeDef(_ClientCreateInternetGatewayResponseTypeDef):
    """
    - *(dict) --*

      - **InternetGateway** *(dict) --*

        Information about the internet gateway.
        - **Attachments** *(list) --*

          Any VPCs attached to the internet gateway.
          - *(dict) --*

            Describes the attachment of a VPC to an internet gateway or an egress-only internet
            gateway.
            - **State** *(string) --*

              The current state of the attachment. For an internet gateway, the state is
              ``available`` when attached to a VPC; otherwise, this value is not returned.
    """


_ClientCreateKeyPairResponseTypeDef = TypedDict(
    "_ClientCreateKeyPairResponseTypeDef",
    {"KeyFingerprint": str, "KeyMaterial": str, "KeyName": str},
    total=False,
)


class ClientCreateKeyPairResponseTypeDef(_ClientCreateKeyPairResponseTypeDef):
    """
    - *(dict) --*

      Describes a key pair.
      - **KeyFingerprint** *(string) --*

        The SHA-1 digest of the DER encoded private key.
    """


_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef", {"Enabled": bool}, total=False
)


class ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateLaunchTemplateDataTypeDef
):
    """
    The information for the launch template.
    - **KernelId** *(string) --*

      The ID of the kernel.
      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information,
        see `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .
    """


_ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    pass


_ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientCreateLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    - **LaunchTemplate** *(dict) --*

      Information about the launch template.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientCreateLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientCreateLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientCreateLaunchTemplateResponseTypeDef(_ClientCreateLaunchTemplateResponseTypeDef):
    """
    - *(dict) --*

      - **LaunchTemplate** *(dict) --*

        Information about the launch template.
        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.
    """


_ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateLaunchTemplateTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateLaunchTemplateTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateLaunchTemplateTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateVersionLaunchTemplateDataTypeDef
):
    """
    The information for the launch template.
    - **KernelId** *(string) --*

      The ID of the kernel.
      .. warning::

        We recommend that you use PV-GRUB instead of kernels and RAM disks. For more information,
        see `User Provided Kernels
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedkernels.html>`__ in the
        *Amazon Elastic Compute Cloud User Guide* .
    """


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef
):
    pass


_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionLaunchTemplateDataTypeDef,
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef(
    _ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef
):
    """
    - **LaunchTemplateVersion** *(dict) --*

      Information about the launch template version.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientCreateLaunchTemplateVersionResponseTypeDef = TypedDict(
    "_ClientCreateLaunchTemplateVersionResponseTypeDef",
    {
        "LaunchTemplateVersion": ClientCreateLaunchTemplateVersionResponseLaunchTemplateVersionTypeDef
    },
    total=False,
)


class ClientCreateLaunchTemplateVersionResponseTypeDef(
    _ClientCreateLaunchTemplateVersionResponseTypeDef
):
    """
    - *(dict) --*

      - **LaunchTemplateVersion** *(dict) --*

        Information about the launch template version.
        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.
    """


_ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef
):
    pass


_ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef
):
    pass


_ClientCreateNatGatewayResponseNatGatewayTagsTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateNatGatewayResponseNatGatewayTagsTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayTagsTypeDef
):
    pass


_ClientCreateNatGatewayResponseNatGatewayTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseNatGatewayTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            ClientCreateNatGatewayResponseNatGatewayNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": ClientCreateNatGatewayResponseNatGatewayProvisionedBandwidthTypeDef,
        "State": Literal["pending", "failed", "available", "deleting", "deleted"],
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[ClientCreateNatGatewayResponseNatGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateNatGatewayResponseNatGatewayTypeDef(
    _ClientCreateNatGatewayResponseNatGatewayTypeDef
):
    pass


_ClientCreateNatGatewayResponseTypeDef = TypedDict(
    "_ClientCreateNatGatewayResponseTypeDef",
    {"ClientToken": str, "NatGateway": ClientCreateNatGatewayResponseNatGatewayTypeDef},
    total=False,
)


class ClientCreateNatGatewayResponseTypeDef(_ClientCreateNatGatewayResponseTypeDef):
    """
    - *(dict) --*

      - **ClientToken** *(string) --*

        Unique, case-sensitive identifier to ensure the idempotency of the request. Only returned if
        a client token was provided in the request.
    """


_ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef = TypedDict(
    "_ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef", {"Code": int, "Type": int}, total=False
)


class ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef(
    _ClientCreateNetworkAclEntryIcmpTypeCodeTypeDef
):
    """
    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.
    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.
    """


_ClientCreateNetworkAclEntryPortRangeTypeDef = TypedDict(
    "_ClientCreateNetworkAclEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class ClientCreateNetworkAclEntryPortRangeTypeDef(_ClientCreateNetworkAclEntryPortRangeTypeDef):
    """
    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).
    - **From** *(integer) --*

      The first port in the range.
    """


_ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a network ACL and a subnet.
      - **NetworkAclAssociationId** *(string) --*

        The ID of the association between a network ACL and a subnet.
    """


_ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef
):
    pass


_ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef
):
    pass


_ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": ClientCreateNetworkAclResponseNetworkAclEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": ClientCreateNetworkAclResponseNetworkAclEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": Literal["allow", "deny"],
        "RuleNumber": int,
    },
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef
):
    pass


_ClientCreateNetworkAclResponseNetworkAclTagsTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateNetworkAclResponseNetworkAclTagsTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclTagsTypeDef
):
    pass


_ClientCreateNetworkAclResponseNetworkAclTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseNetworkAclTypeDef",
    {
        "Associations": List[ClientCreateNetworkAclResponseNetworkAclAssociationsTypeDef],
        "Entries": List[ClientCreateNetworkAclResponseNetworkAclEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[ClientCreateNetworkAclResponseNetworkAclTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateNetworkAclResponseNetworkAclTypeDef(
    _ClientCreateNetworkAclResponseNetworkAclTypeDef
):
    """
    - **NetworkAcl** *(dict) --*

      Information about the network ACL.
      - **Associations** *(list) --*

        Any associations between the network ACL and one or more subnets
        - *(dict) --*

          Describes an association between a network ACL and a subnet.
          - **NetworkAclAssociationId** *(string) --*

            The ID of the association between a network ACL and a subnet.
    """


_ClientCreateNetworkAclResponseTypeDef = TypedDict(
    "_ClientCreateNetworkAclResponseTypeDef",
    {"NetworkAcl": ClientCreateNetworkAclResponseNetworkAclTypeDef},
    total=False,
)


class ClientCreateNetworkAclResponseTypeDef(_ClientCreateNetworkAclResponseTypeDef):
    """
    - *(dict) --*

      - **NetworkAcl** *(dict) --*

        Information about the network ACL.
        - **Associations** *(list) --*

          Any associations between the network ACL and one or more subnets
          - *(dict) --*

            Describes an association between a network ACL and a subnet.
            - **NetworkAclAssociationId** *(string) --*

              The ID of the association between a network ACL and a subnet.
    """


_ClientCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ClientCreateNetworkInterfaceIpv6AddressesTypeDef(
    _ClientCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef",
    {"State": Literal["pending", "granted", "revoking", "revoked"], "StatusMessage": str},
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef
):
    pass


_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": Literal["INSTANCE-ATTACH", "EIP-ASSOCIATE"],
        "PermissionState": ClientCreateNetworkInterfacePermissionResponseInterfacePermissionPermissionStateTypeDef,
    },
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef
):
    """
    - **InterfacePermission** *(dict) --*

      Information about the permission for the network interface.
      - **NetworkInterfacePermissionId** *(string) --*

        The ID of the network interface permission.
    """


_ClientCreateNetworkInterfacePermissionResponseTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePermissionResponseTypeDef",
    {
        "InterfacePermission": ClientCreateNetworkInterfacePermissionResponseInterfacePermissionTypeDef
    },
    total=False,
)


class ClientCreateNetworkInterfacePermissionResponseTypeDef(
    _ClientCreateNetworkInterfacePermissionResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of CreateNetworkInterfacePermission.
      - **InterfacePermission** *(dict) --*

        Information about the permission for the network interface.
        - **NetworkInterfacePermissionId** *(string) --*

          The ID of the network interface permission.
    """


_ClientCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _ClientCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    - *(dict) --*

      Describes a secondary private IPv4 address for a network interface.
      - **Primary** *(boolean) --*

        Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
        IPv4 address can be designated as primary.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef
):
    """
    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.
      - **AllocationId** *(string) --*

        The allocation ID.
    """


_ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef",
    {
        "Association": ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef
):
    pass


_ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef",
    {
        "Association": ClientCreateNetworkInterfaceResponseNetworkInterfaceAssociationTypeDef,
        "Attachment": ClientCreateNetworkInterfaceResponseNetworkInterfaceAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[ClientCreateNetworkInterfaceResponseNetworkInterfaceGroupsTypeDef],
        "InterfaceType": Literal["interface", "natGateway", "efa"],
        "Ipv6Addresses": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfaceIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientCreateNetworkInterfaceResponseNetworkInterfacePrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "TagSet": List[ClientCreateNetworkInterfaceResponseNetworkInterfaceTagSetTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef(
    _ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef
):
    """
    - **NetworkInterface** *(dict) --*

      Information about the network interface.
      - **Association** *(dict) --*

        The association information for an Elastic IP address (IPv4) associated with the network
        interface.
        - **AllocationId** *(string) --*

          The allocation ID.
    """


_ClientCreateNetworkInterfaceResponseTypeDef = TypedDict(
    "_ClientCreateNetworkInterfaceResponseTypeDef",
    {"NetworkInterface": ClientCreateNetworkInterfaceResponseNetworkInterfaceTypeDef},
    total=False,
)


class ClientCreateNetworkInterfaceResponseTypeDef(_ClientCreateNetworkInterfaceResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CreateNetworkInterface.
      - **NetworkInterface** *(dict) --*

        Information about the network interface.
        - **Association** *(dict) --*

          The association information for an Elastic IP address (IPv4) associated with the network
          interface.
          - **AllocationId** *(string) --*

            The allocation ID.
    """


_ClientCreateReservedInstancesListingPriceSchedulesTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingPriceSchedulesTypeDef",
    {"CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCreateReservedInstancesListingPriceSchedulesTypeDef(
    _ClientCreateReservedInstancesListingPriceSchedulesTypeDef
):
    """
    - *(dict) --*

      Describes the price for a Reserved Instance.
      - **CurrencyCode** *(string) --*

        The currency for transacting the Reserved Instance resale. At this time, the only supported
        currency is ``USD`` .
    """


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": Literal["available", "sold", "cancelled", "pending"]},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
):
    pass


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    pass


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
):
    pass


_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": Literal["active", "pending", "cancelled", "closed"],
        "StatusMessage": str,
        "Tags": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef(
    _ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance listing.
      - **ClientToken** *(string) --*

        A unique, case-sensitive key supplied by the client to ensure that the request is
        idempotent. For more information, see `Ensuring Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientCreateReservedInstancesListingResponseTypeDef = TypedDict(
    "_ClientCreateReservedInstancesListingResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientCreateReservedInstancesListingResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientCreateReservedInstancesListingResponseTypeDef(
    _ClientCreateReservedInstancesListingResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of CreateReservedInstancesListing.
      - **ReservedInstancesListings** *(list) --*

        Information about the Standard Reserved Instance listing.
        - *(dict) --*

          Describes a Reserved Instance listing.
          - **ClientToken** *(string) --*

            A unique, case-sensitive key supplied by the client to ensure that the request is
            idempotent. For more information, see `Ensuring Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .
    """


_ClientCreateRouteResponseTypeDef = TypedDict(
    "_ClientCreateRouteResponseTypeDef", {"Return": bool}, total=False
)


class ClientCreateRouteResponseTypeDef(_ClientCreateRouteResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientCreateRouteTableResponseRouteTableAssociationsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableAssociationsTypeDef",
    {"Main": bool, "RouteTableAssociationId": str, "RouteTableId": str, "SubnetId": str},
    total=False,
)


class ClientCreateRouteTableResponseRouteTableAssociationsTypeDef(
    _ClientCreateRouteTableResponseRouteTableAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a route table and a subnet.
      - **Main** *(boolean) --*

        Indicates whether this is the main route table.
    """


_ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef(
    _ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef
):
    pass


_ClientCreateRouteTableResponseRouteTableRoutesTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": Literal["CreateRouteTable", "CreateRoute", "EnableVgwRoutePropagation"],
        "State": Literal["active", "blackhole"],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientCreateRouteTableResponseRouteTableRoutesTypeDef(
    _ClientCreateRouteTableResponseRouteTableRoutesTypeDef
):
    pass


_ClientCreateRouteTableResponseRouteTableTagsTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateRouteTableResponseRouteTableTagsTypeDef(
    _ClientCreateRouteTableResponseRouteTableTagsTypeDef
):
    pass


_ClientCreateRouteTableResponseRouteTableTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseRouteTableTypeDef",
    {
        "Associations": List[ClientCreateRouteTableResponseRouteTableAssociationsTypeDef],
        "PropagatingVgws": List[ClientCreateRouteTableResponseRouteTablePropagatingVgwsTypeDef],
        "RouteTableId": str,
        "Routes": List[ClientCreateRouteTableResponseRouteTableRoutesTypeDef],
        "Tags": List[ClientCreateRouteTableResponseRouteTableTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateRouteTableResponseRouteTableTypeDef(
    _ClientCreateRouteTableResponseRouteTableTypeDef
):
    """
    - **RouteTable** *(dict) --*

      Information about the route table.
      - **Associations** *(list) --*

        The associations between the route table and one or more subnets.
        - *(dict) --*

          Describes an association between a route table and a subnet.
          - **Main** *(boolean) --*

            Indicates whether this is the main route table.
    """


_ClientCreateRouteTableResponseTypeDef = TypedDict(
    "_ClientCreateRouteTableResponseTypeDef",
    {"RouteTable": ClientCreateRouteTableResponseRouteTableTypeDef},
    total=False,
)


class ClientCreateRouteTableResponseTypeDef(_ClientCreateRouteTableResponseTypeDef):
    """
    - *(dict) --*

      - **RouteTable** *(dict) --*

        Information about the route table.
        - **Associations** *(list) --*

          The associations between the route table and one or more subnets.
          - *(dict) --*

            Describes an association between a route table and a subnet.
            - **Main** *(boolean) --*

              Indicates whether this is the main route table.
    """


_ClientCreateSecurityGroupResponseTypeDef = TypedDict(
    "_ClientCreateSecurityGroupResponseTypeDef", {"GroupId": str}, total=False
)


class ClientCreateSecurityGroupResponseTypeDef(_ClientCreateSecurityGroupResponseTypeDef):
    """
    - *(dict) --*

      - **GroupId** *(string) --*

        The ID of the security group.
    """


_ClientCreateSnapshotResponseTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSnapshotResponseTagsTypeDef(_ClientCreateSnapshotResponseTagsTypeDef):
    pass


_ClientCreateSnapshotResponseTypeDef = TypedDict(
    "_ClientCreateSnapshotResponseTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": Literal["pending", "completed", "error"],
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[ClientCreateSnapshotResponseTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotResponseTypeDef(_ClientCreateSnapshotResponseTypeDef):
    """
    - *(dict) --*

      Describes a snapshot.
      - **DataEncryptionKeyId** *(string) --*

        The data encryption key identifier for the snapshot. This value is a unique identifier that
        corresponds to the data encryption key that was used to encrypt the original volume or
        snapshot copy. Because data encryption keys are inherited by volumes created from snapshots,
        and vice versa, if snapshots share the same data encryption key identifier, then they belong
        to the same volume/snapshot lineage. This parameter is only returned by  DescribeSnapshots .
    """


_ClientCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSnapshotTagSpecificationsTagsTypeDef(
    _ClientCreateSnapshotTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotTagSpecificationsTypeDef(_ClientCreateSnapshotTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateSnapshotsInstanceSpecificationTypeDef = TypedDict(
    "_ClientCreateSnapshotsInstanceSpecificationTypeDef",
    {"InstanceId": str, "ExcludeBootVolume": bool},
    total=False,
)


class ClientCreateSnapshotsInstanceSpecificationTypeDef(
    _ClientCreateSnapshotsInstanceSpecificationTypeDef
):
    """
    The instance to specify which volumes should be included in the snapshots.
    - **InstanceId** *(string) --*

      The instance to specify which volumes should be snapshotted.
    """


_ClientCreateSnapshotsResponseSnapshotsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseSnapshotsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSnapshotsResponseSnapshotsTagsTypeDef(
    _ClientCreateSnapshotsResponseSnapshotsTagsTypeDef
):
    pass


_ClientCreateSnapshotsResponseSnapshotsTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseSnapshotsTypeDef",
    {
        "Description": str,
        "Tags": List[ClientCreateSnapshotsResponseSnapshotsTagsTypeDef],
        "Encrypted": bool,
        "VolumeId": str,
        "State": Literal["pending", "completed", "error"],
        "VolumeSize": int,
        "StartTime": datetime,
        "Progress": str,
        "OwnerId": str,
        "SnapshotId": str,
    },
    total=False,
)


class ClientCreateSnapshotsResponseSnapshotsTypeDef(_ClientCreateSnapshotsResponseSnapshotsTypeDef):
    """
    - *(dict) --*

      Information about a snapshot.
      - **Description** *(string) --*

        Description specified by the CreateSnapshotRequest that has been applied to all snapshots.
    """


_ClientCreateSnapshotsResponseTypeDef = TypedDict(
    "_ClientCreateSnapshotsResponseTypeDef",
    {"Snapshots": List[ClientCreateSnapshotsResponseSnapshotsTypeDef]},
    total=False,
)


class ClientCreateSnapshotsResponseTypeDef(_ClientCreateSnapshotsResponseTypeDef):
    """
    - *(dict) --*

      - **Snapshots** *(list) --*

        List of snapshots.
        - *(dict) --*

          Information about a snapshot.
          - **Description** *(string) --*

            Description specified by the CreateSnapshotRequest that has been applied to all
            snapshots.
    """


_ClientCreateSnapshotsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateSnapshotsTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSnapshotsTagSpecificationsTagsTypeDef(
    _ClientCreateSnapshotsTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateSnapshotsTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateSnapshotsTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateSnapshotsTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateSnapshotsTagSpecificationsTypeDef(_ClientCreateSnapshotsTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef
):
    pass


_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    {
        "Bucket": str,
        "Fault": ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef,
        "OwnerId": str,
        "Prefix": str,
        "State": Literal["Active", "Inactive"],
    },
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
):
    """
    - **SpotDatafeedSubscription** *(dict) --*

      The Spot Instance data feed subscription.
      - **Bucket** *(string) --*

        The Amazon S3 bucket where the Spot Instance data feed is located.
    """


_ClientCreateSpotDatafeedSubscriptionResponseTypeDef = TypedDict(
    "_ClientCreateSpotDatafeedSubscriptionResponseTypeDef",
    {
        "SpotDatafeedSubscription": ClientCreateSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
    },
    total=False,
)


class ClientCreateSpotDatafeedSubscriptionResponseTypeDef(
    _ClientCreateSpotDatafeedSubscriptionResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of CreateSpotDatafeedSubscription.
      - **SpotDatafeedSubscription** *(dict) --*

        The Spot Instance data feed subscription.
        - **Bucket** *(string) --*

          The Amazon S3 bucket where the Spot Instance data feed is located.
    """


_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateSubnetResponseSubnetTagsTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateSubnetResponseSubnetTagsTypeDef(_ClientCreateSubnetResponseSubnetTagsTypeDef):
    pass


_ClientCreateSubnetResponseSubnetTypeDef = TypedDict(
    "_ClientCreateSubnetResponseSubnetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": Literal["pending", "available"],
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateSubnetResponseSubnetIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientCreateSubnetResponseSubnetTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientCreateSubnetResponseSubnetTypeDef(_ClientCreateSubnetResponseSubnetTypeDef):
    """
    - **Subnet** *(dict) --*

      Information about the subnet.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.
    """


_ClientCreateSubnetResponseTypeDef = TypedDict(
    "_ClientCreateSubnetResponseTypeDef",
    {"Subnet": ClientCreateSubnetResponseSubnetTypeDef},
    total=False,
)


class ClientCreateSubnetResponseTypeDef(_ClientCreateSubnetResponseTypeDef):
    """
    - *(dict) --*

      - **Subnet** *(dict) --*

        Information about the subnet.
        - **AvailabilityZone** *(string) --*

          The Availability Zone of the subnet.
    """


_ClientCreateTagsTagsTypeDef = TypedDict(
    "_ClientCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateTagsTagsTypeDef(_ClientCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef
):
    """
    - **TrafficMirrorFilter** *(dict) --*

      Information about the Traffic Mirror filter.
      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.
    """


_ClientCreateTrafficMirrorFilterResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterResponseTypeDef",
    {
        "TrafficMirrorFilter": ClientCreateTrafficMirrorFilterResponseTrafficMirrorFilterTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterResponseTypeDef(
    _ClientCreateTrafficMirrorFilterResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilter** *(dict) --*

        Information about the Traffic Mirror filter.
        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.
    """


_ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    The destination port range.
    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef,
        "SourcePortRange": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
):
    """
    - **TrafficMirrorFilterRule** *(dict) --*

      The Traffic Mirror rule.
      - **TrafficMirrorFilterRuleId** *(string) --*

        The ID of the Traffic Mirror rule.
    """


_ClientCreateTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleResponseTypeDef",
    {
        "TrafficMirrorFilterRule": ClientCreateTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleResponseTypeDef(
    _ClientCreateTrafficMirrorFilterRuleResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilterRule** *(dict) --*

        The Traffic Mirror rule.
        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.
    """


_ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientCreateTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    The source port range.
    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTrafficMirrorFilterTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorFilterTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef
):
    """
    - **TrafficMirrorSession** *(dict) --*

      Information about the Traffic Mirror session.
      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.
    """


_ClientCreateTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionResponseTypeDef",
    {
        "TrafficMirrorSession": ClientCreateTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionResponseTypeDef(
    _ClientCreateTrafficMirrorSessionResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorSession** *(dict) --*

        Information about the Traffic Mirror session.
        - **TrafficMirrorSessionId** *(string) --*

          The ID for the Traffic Mirror session.
    """


_ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTrafficMirrorSessionTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorSessionTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": Literal["network-interface", "network-load-balancer"],
        "Description": str,
        "OwnerId": str,
        "Tags": List[ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef
):
    """
    - **TrafficMirrorTarget** *(dict) --*

      Information about the Traffic Mirror target.
      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.
    """


_ClientCreateTrafficMirrorTargetResponseTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetResponseTypeDef",
    {
        "TrafficMirrorTarget": ClientCreateTrafficMirrorTargetResponseTrafficMirrorTargetTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetResponseTypeDef(
    _ClientCreateTrafficMirrorTargetResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorTarget** *(dict) --*

        Information about the Traffic Mirror target.
        - **TrafficMirrorTargetId** *(string) --*

          The ID of the Traffic Mirror target.
    """


_ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef(
    _ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTrafficMirrorTargetTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef(
    _ClientCreateTrafficMirrorTargetTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": Literal["enable", "disable"],
        "DefaultRouteTableAssociation": Literal["enable", "disable"],
        "DefaultRouteTablePropagation": Literal["enable", "disable"],
        "VpnEcmpSupport": Literal["enable", "disable"],
        "DnsSupport": Literal["enable", "disable"],
    },
    total=False,
)


class ClientCreateTransitGatewayOptionsTypeDef(_ClientCreateTransitGatewayOptionsTypeDef):
    """
    The transit gateway options.
    - **AmazonSideAsn** *(integer) --*

      A private Autonomous System Number (ASN) for the Amazon side of a BGP session. The range is
      64512 to 65534 for 16-bit ASNs and 4200000000 to 4294967294 for 32-bit ASNs.
    """


_ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": Literal["enable", "disable"],
        "DefaultRouteTableAssociation": Literal["enable", "disable"],
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": Literal["enable", "disable"],
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": Literal["enable", "disable"],
        "DnsSupport": Literal["enable", "disable"],
    },
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef
):
    pass


_ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef
):
    pass


_ClientCreateTransitGatewayResponseTransitGatewayTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTransitGatewayTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": Literal["pending", "available", "modifying", "deleting", "deleted"],
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientCreateTransitGatewayResponseTransitGatewayOptionsTypeDef,
        "Tags": List[ClientCreateTransitGatewayResponseTransitGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayResponseTransitGatewayTypeDef(
    _ClientCreateTransitGatewayResponseTransitGatewayTypeDef
):
    """
    - **TransitGateway** *(dict) --*

      Information about the transit gateway.
      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.
    """


_ClientCreateTransitGatewayResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayResponseTypeDef",
    {"TransitGateway": ClientCreateTransitGatewayResponseTransitGatewayTypeDef},
    total=False,
)


class ClientCreateTransitGatewayResponseTypeDef(_ClientCreateTransitGatewayResponseTypeDef):
    """
    - *(dict) --*

      - **TransitGateway** *(dict) --*

        Information about the transit gateway.
        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.
    """


_ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {
        "ResourceId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    pass


_ClientCreateTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientCreateTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": Literal["static", "propagated"],
        "State": Literal["pending", "active", "blackhole", "deleting", "deleted"],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteResponseRouteTypeDef(
    _ClientCreateTransitGatewayRouteResponseRouteTypeDef
):
    """
    - **Route** *(dict) --*

      Information about the route.
      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.
    """


_ClientCreateTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteResponseTypeDef",
    {"Route": ClientCreateTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientCreateTransitGatewayRouteResponseTypeDef(
    _ClientCreateTransitGatewayRouteResponseTypeDef
):
    """
    - *(dict) --*

      - **Route** *(dict) --*

        Information about the route.
        - **DestinationCidrBlock** *(string) --*

          The CIDR block used for destination matches.
    """


_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
):
    pass


_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
):
    """
    - **TransitGatewayRouteTable** *(dict) --*

      Information about the transit gateway route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_ClientCreateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableResponseTypeDef",
    {
        "TransitGatewayRouteTable": ClientCreateTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableResponseTypeDef(
    _ClientCreateTransitGatewayRouteTableResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTable** *(dict) --*

        Information about the transit gateway route table.
        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.
    """


_ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTransitGatewayRouteTableTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayRouteTableTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateTransitGatewayTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTransitGatewayTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTransitGatewayTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    The VPC attachment options.
    - **DnsSupport** *(string) --*

      Enable or disable DNS support. The default is ``enable`` .
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    pass


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    pass


_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the VPC attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientCreateTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientCreateTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachment** *(dict) --*

        Information about the VPC attachment.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef(
    _ClientCreateTransitGatewayVpcAttachmentTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateVolumeResponseAttachmentsTypeDef = TypedDict(
    "_ClientCreateVolumeResponseAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientCreateVolumeResponseAttachmentsTypeDef(_ClientCreateVolumeResponseAttachmentsTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_ClientCreateVolumeResponseTagsTypeDef = TypedDict(
    "_ClientCreateVolumeResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVolumeResponseTagsTypeDef(_ClientCreateVolumeResponseTagsTypeDef):
    pass


_ClientCreateVolumeResponseTypeDef = TypedDict(
    "_ClientCreateVolumeResponseTypeDef",
    {
        "Attachments": List[ClientCreateVolumeResponseAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": Literal["creating", "available", "in-use", "deleting", "deleted", "error"],
        "VolumeId": str,
        "Iops": int,
        "Tags": List[ClientCreateVolumeResponseTagsTypeDef],
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "FastRestored": bool,
    },
    total=False,
)


class ClientCreateVolumeResponseTypeDef(_ClientCreateVolumeResponseTypeDef):
    """
    - *(dict) --*

      Describes a volume.
      - **Attachments** *(list) --*

        Information about the volume attachments.
        - *(dict) --*

          Describes volume attachment details.
          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.
    """


_ClientCreateVolumeTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientCreateVolumeTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVolumeTagSpecificationsTagsTypeDef(
    _ClientCreateVolumeTagSpecificationsTagsTypeDef
):
    pass


_ClientCreateVolumeTagSpecificationsTypeDef = TypedDict(
    "_ClientCreateVolumeTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientCreateVolumeTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientCreateVolumeTagSpecificationsTypeDef(_ClientCreateVolumeTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef = TypedDict(
    "_ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": Literal["Enabled", "Disabled"],
    },
    total=False,
)


class ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef(
    _ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef
):
    """
    - **ConnectionNotification** *(dict) --*

      Information about the notification.
      - **ConnectionNotificationId** *(string) --*

        The ID of the notification.
    """


_ClientCreateVpcEndpointConnectionNotificationResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointConnectionNotificationResponseTypeDef",
    {
        "ConnectionNotification": ClientCreateVpcEndpointConnectionNotificationResponseConnectionNotificationTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateVpcEndpointConnectionNotificationResponseTypeDef(
    _ClientCreateVpcEndpointConnectionNotificationResponseTypeDef
):
    """
    - *(dict) --*

      - **ConnectionNotification** *(dict) --*

        Information about the notification.
        - **ConnectionNotificationId** *(string) --*

          The ID of the notification.
    """


_ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef
):
    pass


_ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef
):
    pass


_ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef
):
    pass


_ClientCreateVpcEndpointResponseVpcEndpointTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseVpcEndpointTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": Literal["Interface", "Gateway"],
        "VpcId": str,
        "ServiceName": str,
        "State": Literal[
            "PendingAcceptance",
            "Pending",
            "Available",
            "Deleting",
            "Deleted",
            "Rejected",
            "Failed",
            "Expired",
        ],
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[ClientCreateVpcEndpointResponseVpcEndpointGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[ClientCreateVpcEndpointResponseVpcEndpointDnsEntriesTypeDef],
        "CreationTimestamp": datetime,
        "Tags": List[ClientCreateVpcEndpointResponseVpcEndpointTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class ClientCreateVpcEndpointResponseVpcEndpointTypeDef(
    _ClientCreateVpcEndpointResponseVpcEndpointTypeDef
):
    """
    - **VpcEndpoint** *(dict) --*

      Information about the endpoint.
      - **VpcEndpointId** *(string) --*

        The ID of the VPC endpoint.
    """


_ClientCreateVpcEndpointResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointResponseTypeDef",
    {"VpcEndpoint": ClientCreateVpcEndpointResponseVpcEndpointTypeDef, "ClientToken": str},
    total=False,
)


class ClientCreateVpcEndpointResponseTypeDef(_ClientCreateVpcEndpointResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CreateVpcEndpoint.
      - **VpcEndpoint** *(dict) --*

        Information about the endpoint.
        - **VpcEndpointId** *(string) --*

          The ID of the VPC endpoint.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef",
    {"ServiceType": Literal["Interface", "Gateway"]},
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef
):
    """
    - *(dict) --*

      Describes the type of service for a VPC endpoint.
      - **ServiceType** *(string) --*

        The type of service.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef
):
    pass


_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef",
    {
        "ServiceType": List[
            ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": Literal["Pending", "Available", "Deleting", "Deleted", "Failed"],
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTagsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef
):
    """
    - **ServiceConfiguration** *(dict) --*

      Information about the service configuration.
      - **ServiceType** *(list) --*

        The type of service.
        - *(dict) --*

          Describes the type of service for a VPC endpoint.
          - **ServiceType** *(string) --*

            The type of service.
    """


_ClientCreateVpcEndpointServiceConfigurationResponseTypeDef = TypedDict(
    "_ClientCreateVpcEndpointServiceConfigurationResponseTypeDef",
    {
        "ServiceConfiguration": ClientCreateVpcEndpointServiceConfigurationResponseServiceConfigurationTypeDef,
        "ClientToken": str,
    },
    total=False,
)


class ClientCreateVpcEndpointServiceConfigurationResponseTypeDef(
    _ClientCreateVpcEndpointServiceConfigurationResponseTypeDef
):
    """
    - *(dict) --*

      - **ServiceConfiguration** *(dict) --*

        Information about the service configuration.
        - **ServiceType** *(list) --*

          The type of service.
          - *(dict) --*

            Describes the type of service for a VPC endpoint.
            - **ServiceType** *(string) --*

              The type of service.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing an
      active VPC peering connection.
      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.
    """


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef",
    {
        "Code": Literal[
            "initiating-request",
            "pending-acceptance",
            "active",
            "deleted",
            "rejected",
            "failed",
            "expired",
            "provisioning",
            "deleting",
        ],
        "Message": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef
):
    pass


_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef(
    _ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef
):
    """
    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.
      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.
        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.
    """


_ClientCreateVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientCreateVpcPeeringConnectionResponseTypeDef",
    {"VpcPeeringConnection": ClientCreateVpcPeeringConnectionResponseVpcPeeringConnectionTypeDef},
    total=False,
)


class ClientCreateVpcPeeringConnectionResponseTypeDef(
    _ClientCreateVpcPeeringConnectionResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcPeeringConnection** *(dict) --*

        Information about the VPC peering connection.
        - **AccepterVpcInfo** *(dict) --*

          Information about the accepter VPC. CIDR block information is only returned when
          describing an active VPC peering connection.
          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.
    """


_ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef
):
    pass


_ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientCreateVpcResponseVpcCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef(
    _ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef(
    _ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientCreateVpcResponseVpcTagsTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVpcResponseVpcTagsTypeDef(_ClientCreateVpcResponseVpcTagsTypeDef):
    pass


_ClientCreateVpcResponseVpcTypeDef = TypedDict(
    "_ClientCreateVpcResponseVpcTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": Literal["pending", "available"],
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Ipv6CidrBlockAssociationSet": List[
            ClientCreateVpcResponseVpcIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[ClientCreateVpcResponseVpcCidrBlockAssociationSetTypeDef],
        "IsDefault": bool,
        "Tags": List[ClientCreateVpcResponseVpcTagsTypeDef],
    },
    total=False,
)


class ClientCreateVpcResponseVpcTypeDef(_ClientCreateVpcResponseVpcTypeDef):
    """
    - **Vpc** *(dict) --*

      Information about the VPC.
      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.
    """


_ClientCreateVpcResponseTypeDef = TypedDict(
    "_ClientCreateVpcResponseTypeDef", {"Vpc": ClientCreateVpcResponseVpcTypeDef}, total=False
)


class ClientCreateVpcResponseTypeDef(_ClientCreateVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Vpc** *(dict) --*

        Information about the VPC.
        - **CidrBlock** *(string) --*

          The primary IPv4 CIDR block for the VPC.
    """


_ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef", {"Value": str}, total=False
)


class ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientCreateVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IKEVersions": List[ClientCreateVpnConnectionOptionsTunnelOptionsIKEVersionsTypeDef],
    },
    total=False,
)


class ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef
):
    pass


_ClientCreateVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[ClientCreateVpnConnectionOptionsTunnelOptionsTypeDef],
    },
    total=False,
)


class ClientCreateVpnConnectionOptionsTypeDef(_ClientCreateVpnConnectionOptionsTypeDef):
    """
    The options for the VPN connection.
    - **StaticRoutesOnly** *(boolean) --*

      Indicate whether the VPN connection uses static routes only. If you are creating a VPN
      connection for a device that does not support BGP, you must specify ``true`` . Use
      CreateVpnConnectionRoute to create a static route.
      Default: ``false``
    """


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientCreateVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": Literal["UP", "DOWN"],
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
):
    pass


_ClientCreateVpnConnectionResponseVpnConnectionTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientCreateVpnConnectionResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientCreateVpnConnectionResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientCreateVpnConnectionResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[ClientCreateVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef],
    },
    total=False,
)


class ClientCreateVpnConnectionResponseVpnConnectionTypeDef(
    _ClientCreateVpnConnectionResponseVpnConnectionTypeDef
):
    """
    - **VpnConnection** *(dict) --*

      Information about the VPN connection.
      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.
    """


_ClientCreateVpnConnectionResponseTypeDef = TypedDict(
    "_ClientCreateVpnConnectionResponseTypeDef",
    {"VpnConnection": ClientCreateVpnConnectionResponseVpnConnectionTypeDef},
    total=False,
)


class ClientCreateVpnConnectionResponseTypeDef(_ClientCreateVpnConnectionResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CreateVpnConnection.
      - **VpnConnection** *(dict) --*

        Information about the VPN connection.
        - **CustomerGatewayConfiguration** *(string) --*

          The configuration information for the VPN connection's customer gateway (in the native XML
          format). This element is always present in the  CreateVpnConnection response; however,
          it's present in the  DescribeVpnConnections response only if the VPN connection is in the
          ``pending`` or ``available`` state.
    """


_ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef
):
    pass


_ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef
):
    pass


_ClientCreateVpnGatewayResponseVpnGatewayTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseVpnGatewayTypeDef",
    {
        "AvailabilityZone": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpcAttachments": List[ClientCreateVpnGatewayResponseVpnGatewayVpcAttachmentsTypeDef],
        "VpnGatewayId": str,
        "AmazonSideAsn": int,
        "Tags": List[ClientCreateVpnGatewayResponseVpnGatewayTagsTypeDef],
    },
    total=False,
)


class ClientCreateVpnGatewayResponseVpnGatewayTypeDef(
    _ClientCreateVpnGatewayResponseVpnGatewayTypeDef
):
    """
    - **VpnGateway** *(dict) --*

      Information about the virtual private gateway.
      - **AvailabilityZone** *(string) --*

        The Availability Zone where the virtual private gateway was created, if applicable. This
        field may be empty or not returned.
    """


_ClientCreateVpnGatewayResponseTypeDef = TypedDict(
    "_ClientCreateVpnGatewayResponseTypeDef",
    {"VpnGateway": ClientCreateVpnGatewayResponseVpnGatewayTypeDef},
    total=False,
)


class ClientCreateVpnGatewayResponseTypeDef(_ClientCreateVpnGatewayResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of CreateVpnGateway.
      - **VpnGateway** *(dict) --*

        Information about the virtual private gateway.
        - **AvailabilityZone** *(string) --*

          The Availability Zone where the virtual private gateway was created, if applicable. This
          field may be empty or not returned.
    """


_ClientDeleteClientVpnEndpointResponseStatusTypeDef = TypedDict(
    "_ClientDeleteClientVpnEndpointResponseStatusTypeDef",
    {"Code": Literal["pending-associate", "available", "deleting", "deleted"], "Message": str},
    total=False,
)


class ClientDeleteClientVpnEndpointResponseStatusTypeDef(
    _ClientDeleteClientVpnEndpointResponseStatusTypeDef
):
    """
    - **Status** *(dict) --*

      The current state of the Client VPN endpoint.
      - **Code** *(string) --*

        The state of the Client VPN endpoint. Possible states include:
        * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
        have been associated. The Client VPN endpoint cannot accept connections.
        * ``available`` - The Client VPN endpoint has been created and a target network has been
        associated. The Client VPN endpoint can accept connections.
        * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
        accept connections.
        * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
        accept connections.
    """


_ClientDeleteClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteClientVpnEndpointResponseTypeDef",
    {"Status": ClientDeleteClientVpnEndpointResponseStatusTypeDef},
    total=False,
)


class ClientDeleteClientVpnEndpointResponseTypeDef(_ClientDeleteClientVpnEndpointResponseTypeDef):
    """
    - *(dict) --*

      - **Status** *(dict) --*

        The current state of the Client VPN endpoint.
        - **Code** *(string) --*

          The state of the Client VPN endpoint. Possible states include:
          * ``pending-associate`` - The Client VPN endpoint has been created but no target networks
          have been associated. The Client VPN endpoint cannot accept connections.
          * ``available`` - The Client VPN endpoint has been created and a target network has been
          associated. The Client VPN endpoint can accept connections.
          * ``deleting`` - The Client VPN endpoint is being deleted. The Client VPN endpoint cannot
          accept connections.
          * ``deleted`` - The Client VPN endpoint has been deleted. The Client VPN endpoint cannot
          accept connections.
    """


_ClientDeleteClientVpnRouteResponseStatusTypeDef = TypedDict(
    "_ClientDeleteClientVpnRouteResponseStatusTypeDef",
    {"Code": Literal["creating", "active", "failed", "deleting"], "Message": str},
    total=False,
)


class ClientDeleteClientVpnRouteResponseStatusTypeDef(
    _ClientDeleteClientVpnRouteResponseStatusTypeDef
):
    """
    - **Status** *(dict) --*

      The current state of the route.
      - **Code** *(string) --*

        The state of the Client VPN endpoint route.
    """


_ClientDeleteClientVpnRouteResponseTypeDef = TypedDict(
    "_ClientDeleteClientVpnRouteResponseTypeDef",
    {"Status": ClientDeleteClientVpnRouteResponseStatusTypeDef},
    total=False,
)


class ClientDeleteClientVpnRouteResponseTypeDef(_ClientDeleteClientVpnRouteResponseTypeDef):
    """
    - *(dict) --*

      - **Status** *(dict) --*

        The current state of the route.
        - **Code** *(string) --*

          The state of the Client VPN endpoint route.
    """


_ClientDeleteEgressOnlyInternetGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteEgressOnlyInternetGatewayResponseTypeDef", {"ReturnCode": bool}, total=False
)


class ClientDeleteEgressOnlyInternetGatewayResponseTypeDef(
    _ClientDeleteEgressOnlyInternetGatewayResponseTypeDef
):
    """
    - *(dict) --*

      - **ReturnCode** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef",
    {
        "CurrentFleetState": Literal[
            "submitted",
            "active",
            "deleted",
            "failed",
            "deleted_running",
            "deleted_terminating",
            "modifying",
        ],
        "PreviousFleetState": Literal[
            "submitted",
            "active",
            "deleted",
            "failed",
            "deleted_running",
            "deleted_terminating",
            "modifying",
        ],
        "FleetId": str,
    },
    total=False,
)


class ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef(
    _ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef
):
    """
    - *(dict) --*

      Describes an EC2 Fleet that was successfully deleted.
      - **CurrentFleetState** *(string) --*

        The current state of the EC2 Fleet.
    """


_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef",
    {
        "Code": Literal[
            "fleetIdDoesNotExist", "fleetIdMalformed", "fleetNotInDeletableState", "unexpectedError"
        ],
        "Message": str,
    },
    total=False,
)


class ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef(
    _ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef
):
    pass


_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef",
    {"Error": ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsErrorTypeDef, "FleetId": str},
    total=False,
)


class ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef(
    _ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef
):
    pass


_ClientDeleteFleetsResponseTypeDef = TypedDict(
    "_ClientDeleteFleetsResponseTypeDef",
    {
        "SuccessfulFleetDeletions": List[ClientDeleteFleetsResponseSuccessfulFleetDeletionsTypeDef],
        "UnsuccessfulFleetDeletions": List[
            ClientDeleteFleetsResponseUnsuccessfulFleetDeletionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteFleetsResponseTypeDef(_ClientDeleteFleetsResponseTypeDef):
    """
    - *(dict) --*

      - **SuccessfulFleetDeletions** *(list) --*

        Information about the EC2 Fleets that are successfully deleted.
        - *(dict) --*

          Describes an EC2 Fleet that was successfully deleted.
          - **CurrentFleetState** *(string) --*

            The current state of the EC2 Fleet.
    """


_ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientDeleteFlowLogsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseUnsuccessfulTypeDef",
    {"Error": ClientDeleteFlowLogsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientDeleteFlowLogsResponseUnsuccessfulTypeDef(
    _ClientDeleteFlowLogsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientDeleteFlowLogsResponseTypeDef = TypedDict(
    "_ClientDeleteFlowLogsResponseTypeDef",
    {"Unsuccessful": List[ClientDeleteFlowLogsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientDeleteFlowLogsResponseTypeDef(_ClientDeleteFlowLogsResponseTypeDef):
    """
    - *(dict) --*

      - **Unsuccessful** *(list) --*

        Information about the flow logs that could not be deleted successfully.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientDeleteFpgaImageResponseTypeDef = TypedDict(
    "_ClientDeleteFpgaImageResponseTypeDef", {"Return": bool}, total=False
)


class ClientDeleteFpgaImageResponseTypeDef(_ClientDeleteFpgaImageResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    pass


_ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientDeleteLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    - **LaunchTemplate** *(dict) --*

      Information about the launch template.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientDeleteLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientDeleteLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientDeleteLaunchTemplateResponseTypeDef(_ClientDeleteLaunchTemplateResponseTypeDef):
    """
    - *(dict) --*

      - **LaunchTemplate** *(dict) --*

        Information about the launch template.
        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.
    """


_ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "VersionNumber": int},
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef
):
    """
    - *(dict) --*

      Describes a launch template version that was successfully deleted.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef",
    {
        "Code": Literal[
            "launchTemplateIdDoesNotExist",
            "launchTemplateIdMalformed",
            "launchTemplateNameDoesNotExist",
            "launchTemplateNameMalformed",
            "launchTemplateVersionDoesNotExist",
            "unexpectedError",
        ],
        "Message": str,
    },
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef
):
    pass


_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "ResponseError": ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsResponseErrorTypeDef,
    },
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef
):
    pass


_ClientDeleteLaunchTemplateVersionsResponseTypeDef = TypedDict(
    "_ClientDeleteLaunchTemplateVersionsResponseTypeDef",
    {
        "SuccessfullyDeletedLaunchTemplateVersions": List[
            ClientDeleteLaunchTemplateVersionsResponseSuccessfullyDeletedLaunchTemplateVersionsTypeDef
        ],
        "UnsuccessfullyDeletedLaunchTemplateVersions": List[
            ClientDeleteLaunchTemplateVersionsResponseUnsuccessfullyDeletedLaunchTemplateVersionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteLaunchTemplateVersionsResponseTypeDef(
    _ClientDeleteLaunchTemplateVersionsResponseTypeDef
):
    """
    - *(dict) --*

      - **SuccessfullyDeletedLaunchTemplateVersions** *(list) --*

        Information about the launch template versions that were successfully deleted.
        - *(dict) --*

          Describes a launch template version that was successfully deleted.
          - **LaunchTemplateId** *(string) --*

            The ID of the launch template.
    """


_ClientDeleteNatGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteNatGatewayResponseTypeDef", {"NatGatewayId": str}, total=False
)


class ClientDeleteNatGatewayResponseTypeDef(_ClientDeleteNatGatewayResponseTypeDef):
    """
    - *(dict) --*

      - **NatGatewayId** *(string) --*

        The ID of the NAT gateway.
    """


_ClientDeleteNetworkInterfacePermissionResponseTypeDef = TypedDict(
    "_ClientDeleteNetworkInterfacePermissionResponseTypeDef", {"Return": bool}, total=False
)


class ClientDeleteNetworkInterfacePermissionResponseTypeDef(
    _ClientDeleteNetworkInterfacePermissionResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output for DeleteNetworkInterfacePermission.
      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds, otherwise returns an error.
    """


_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef",
    {
        "Code": Literal[
            "reserved-instances-id-invalid",
            "reserved-instances-not-in-queued-state",
            "unexpected-error",
        ],
        "Message": str,
    },
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef
):
    pass


_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef",
    {
        "Error": ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsErrorTypeDef,
        "ReservedInstancesId": str,
    },
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef
):
    pass


_ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance whose queued purchase was successfully deleted.
      - **ReservedInstancesId** *(string) --*

        The ID of the Reserved Instance.
    """


_ClientDeleteQueuedReservedInstancesResponseTypeDef = TypedDict(
    "_ClientDeleteQueuedReservedInstancesResponseTypeDef",
    {
        "SuccessfulQueuedPurchaseDeletions": List[
            ClientDeleteQueuedReservedInstancesResponseSuccessfulQueuedPurchaseDeletionsTypeDef
        ],
        "FailedQueuedPurchaseDeletions": List[
            ClientDeleteQueuedReservedInstancesResponseFailedQueuedPurchaseDeletionsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteQueuedReservedInstancesResponseTypeDef(
    _ClientDeleteQueuedReservedInstancesResponseTypeDef
):
    """
    - *(dict) --*

      - **SuccessfulQueuedPurchaseDeletions** *(list) --*

        Information about the queued purchases that were successfully deleted.
        - *(dict) --*

          Describes a Reserved Instance whose queued purchase was successfully deleted.
          - **ReservedInstancesId** *(string) --*

            The ID of the Reserved Instance.
    """


_ClientDeleteTagsTagsTypeDef = TypedDict(
    "_ClientDeleteTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDeleteTagsTagsTypeDef(_ClientDeleteTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_ClientDeleteTrafficMirrorFilterResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorFilterResponseTypeDef", {"TrafficMirrorFilterId": str}, total=False
)


class ClientDeleteTrafficMirrorFilterResponseTypeDef(
    _ClientDeleteTrafficMirrorFilterResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.
    """


_ClientDeleteTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorFilterRuleResponseTypeDef",
    {"TrafficMirrorFilterRuleId": str},
    total=False,
)


class ClientDeleteTrafficMirrorFilterRuleResponseTypeDef(
    _ClientDeleteTrafficMirrorFilterRuleResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilterRuleId** *(string) --*

        The ID of the deleted Traffic Mirror rule.
    """


_ClientDeleteTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorSessionResponseTypeDef", {"TrafficMirrorSessionId": str}, total=False
)


class ClientDeleteTrafficMirrorSessionResponseTypeDef(
    _ClientDeleteTrafficMirrorSessionResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorSessionId** *(string) --*

        The ID of the deleted Traffic Mirror session.
    """


_ClientDeleteTrafficMirrorTargetResponseTypeDef = TypedDict(
    "_ClientDeleteTrafficMirrorTargetResponseTypeDef", {"TrafficMirrorTargetId": str}, total=False
)


class ClientDeleteTrafficMirrorTargetResponseTypeDef(
    _ClientDeleteTrafficMirrorTargetResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorTargetId** *(string) --*

        The ID of the deleted Traffic Mirror target.
    """


_ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": Literal["enable", "disable"],
        "DefaultRouteTableAssociation": Literal["enable", "disable"],
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": Literal["enable", "disable"],
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": Literal["enable", "disable"],
        "DnsSupport": Literal["enable", "disable"],
    },
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef
):
    pass


_ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef
):
    pass


_ClientDeleteTransitGatewayResponseTransitGatewayTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTransitGatewayTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": Literal["pending", "available", "modifying", "deleting", "deleted"],
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientDeleteTransitGatewayResponseTransitGatewayOptionsTypeDef,
        "Tags": List[ClientDeleteTransitGatewayResponseTransitGatewayTagsTypeDef],
    },
    total=False,
)


class ClientDeleteTransitGatewayResponseTransitGatewayTypeDef(
    _ClientDeleteTransitGatewayResponseTransitGatewayTypeDef
):
    """
    - **TransitGateway** *(dict) --*

      Information about the deleted transit gateway.
      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.
    """


_ClientDeleteTransitGatewayResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayResponseTypeDef",
    {"TransitGateway": ClientDeleteTransitGatewayResponseTransitGatewayTypeDef},
    total=False,
)


class ClientDeleteTransitGatewayResponseTypeDef(_ClientDeleteTransitGatewayResponseTypeDef):
    """
    - *(dict) --*

      - **TransitGateway** *(dict) --*

        Information about the deleted transit gateway.
        - **TransitGatewayId** *(string) --*

          The ID of the transit gateway.
    """


_ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {
        "ResourceId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    pass


_ClientDeleteTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientDeleteTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": Literal["static", "propagated"],
        "State": Literal["pending", "active", "blackhole", "deleting", "deleted"],
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseRouteTypeDef(
    _ClientDeleteTransitGatewayRouteResponseRouteTypeDef
):
    """
    - **Route** *(dict) --*

      Information about the route.
      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.
    """


_ClientDeleteTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteResponseTypeDef",
    {"Route": ClientDeleteTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientDeleteTransitGatewayRouteResponseTypeDef(
    _ClientDeleteTransitGatewayRouteResponseTypeDef
):
    """
    - *(dict) --*

      - **Route** *(dict) --*

        Information about the route.
        - **DestinationCidrBlock** *(string) --*

          The CIDR block used for destination matches.
    """


_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
):
    pass


_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTagsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
):
    """
    - **TransitGatewayRouteTable** *(dict) --*

      Information about the deleted transit gateway route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_ClientDeleteTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayRouteTableResponseTypeDef",
    {
        "TransitGatewayRouteTable": ClientDeleteTransitGatewayRouteTableResponseTransitGatewayRouteTableTypeDef
    },
    total=False,
)


class ClientDeleteTransitGatewayRouteTableResponseTypeDef(
    _ClientDeleteTransitGatewayRouteTableResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTable** *(dict) --*

        Information about the deleted transit gateway route table.
        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    pass


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    pass


_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the deleted VPC attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientDeleteTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientDeleteTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachment** *(dict) --*

        Information about the deleted VPC attachment.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef",
    {
        "Unsuccessful": List[
            ClientDeleteVpcEndpointConnectionNotificationsResponseUnsuccessfulTypeDef
        ]
    },
    total=False,
)


class ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef(
    _ClientDeleteVpcEndpointConnectionNotificationsResponseTypeDef
):
    """
    - *(dict) --*

      - **Unsuccessful** *(list) --*

        Information about the notifications that could not be deleted successfully.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef",
    {"Unsuccessful": List[ClientDeleteVpcEndpointServiceConfigurationsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef(
    _ClientDeleteVpcEndpointServiceConfigurationsResponseTypeDef
):
    """
    - *(dict) --*

      - **Unsuccessful** *(list) --*

        Information about the service configurations that were not deleted, if applicable.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef(
    _ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef",
    {"Error": ClientDeleteVpcEndpointsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef(
    _ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientDeleteVpcEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteVpcEndpointsResponseTypeDef",
    {"Unsuccessful": List[ClientDeleteVpcEndpointsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientDeleteVpcEndpointsResponseTypeDef(_ClientDeleteVpcEndpointsResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DeleteVpcEndpoints.
      - **Unsuccessful** *(list) --*

        Information about the VPC endpoints that were not successfully deleted.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientDeleteVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientDeleteVpcPeeringConnectionResponseTypeDef", {"Return": bool}, total=False
)


class ClientDeleteVpcPeeringConnectionResponseTypeDef(
    _ClientDeleteVpcPeeringConnectionResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDeprovisionByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientDeprovisionByoipCidrResponseByoipCidrTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class ClientDeprovisionByoipCidrResponseByoipCidrTypeDef(
    _ClientDeprovisionByoipCidrResponseByoipCidrTypeDef
):
    """
    - **ByoipCidr** *(dict) --*

      Information about the address range.
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_ClientDeprovisionByoipCidrResponseTypeDef = TypedDict(
    "_ClientDeprovisionByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientDeprovisionByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientDeprovisionByoipCidrResponseTypeDef(_ClientDeprovisionByoipCidrResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidr** *(dict) --*

        Information about the address range.
        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.
    """


_ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef",
    {"AttributeValue": str},
    total=False,
)


class ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef(
    _ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef
):
    pass


_ClientDescribeAccountAttributesResponseAccountAttributesTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseAccountAttributesTypeDef",
    {
        "AttributeName": str,
        "AttributeValues": List[
            ClientDescribeAccountAttributesResponseAccountAttributesAttributeValuesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeAccountAttributesResponseAccountAttributesTypeDef(
    _ClientDescribeAccountAttributesResponseAccountAttributesTypeDef
):
    """
    - *(dict) --*

      Describes an account attribute.
      - **AttributeName** *(string) --*

        The name of the account attribute.
    """


_ClientDescribeAccountAttributesResponseTypeDef = TypedDict(
    "_ClientDescribeAccountAttributesResponseTypeDef",
    {"AccountAttributes": List[ClientDescribeAccountAttributesResponseAccountAttributesTypeDef]},
    total=False,
)


class ClientDescribeAccountAttributesResponseTypeDef(
    _ClientDescribeAccountAttributesResponseTypeDef
):
    """
    - *(dict) --*

      - **AccountAttributes** *(list) --*

        Information about the account attributes.
        - *(dict) --*

          Describes an account attribute.
          - **AttributeName** *(string) --*

            The name of the account attribute.
    """


_ClientDescribeAddressesFiltersTypeDef = TypedDict(
    "_ClientDescribeAddressesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeAddressesFiltersTypeDef(_ClientDescribeAddressesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeAddressesResponseAddressesTagsTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseAddressesTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeAddressesResponseAddressesTagsTypeDef(
    _ClientDescribeAddressesResponseAddressesTagsTypeDef
):
    pass


_ClientDescribeAddressesResponseAddressesTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseAddressesTypeDef",
    {
        "InstanceId": str,
        "PublicIp": str,
        "AllocationId": str,
        "AssociationId": str,
        "Domain": Literal["vpc", "standard"],
        "NetworkInterfaceId": str,
        "NetworkInterfaceOwnerId": str,
        "PrivateIpAddress": str,
        "Tags": List[ClientDescribeAddressesResponseAddressesTagsTypeDef],
        "PublicIpv4Pool": str,
    },
    total=False,
)


class ClientDescribeAddressesResponseAddressesTypeDef(
    _ClientDescribeAddressesResponseAddressesTypeDef
):
    """
    - *(dict) --*

      Describes an Elastic IP address.
      - **InstanceId** *(string) --*

        The ID of the instance that the address is associated with (if any).
    """


_ClientDescribeAddressesResponseTypeDef = TypedDict(
    "_ClientDescribeAddressesResponseTypeDef",
    {"Addresses": List[ClientDescribeAddressesResponseAddressesTypeDef]},
    total=False,
)


class ClientDescribeAddressesResponseTypeDef(_ClientDescribeAddressesResponseTypeDef):
    """
    - *(dict) --*

      - **Addresses** *(list) --*

        Information about the Elastic IP addresses.
        - *(dict) --*

          Describes an Elastic IP address.
          - **InstanceId** *(string) --*

            The ID of the instance that the address is associated with (if any).
    """


_ClientDescribeAggregateIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeAggregateIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeAggregateIdFormatResponseStatusesTypeDef(
    _ClientDescribeAggregateIdFormatResponseStatusesTypeDef
):
    pass


_ClientDescribeAggregateIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeAggregateIdFormatResponseTypeDef",
    {
        "UseLongIdsAggregated": bool,
        "Statuses": List[ClientDescribeAggregateIdFormatResponseStatusesTypeDef],
    },
    total=False,
)


class ClientDescribeAggregateIdFormatResponseTypeDef(
    _ClientDescribeAggregateIdFormatResponseTypeDef
):
    """
    - *(dict) --*

      - **UseLongIdsAggregated** *(boolean) --*

        Indicates whether all resource types in the Region are configured to use longer IDs. This
        value is only ``true`` if all users are configured to use longer IDs for all resources types
        in the Region.
    """


_ClientDescribeAvailabilityZonesFiltersTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeAvailabilityZonesFiltersTypeDef(_ClientDescribeAvailabilityZonesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef",
    {"Message": str},
    total=False,
)


class ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef(
    _ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef
):
    pass


_ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef",
    {
        "State": Literal["available", "information", "impaired", "unavailable"],
        "Messages": List[ClientDescribeAvailabilityZonesResponseAvailabilityZonesMessagesTypeDef],
        "RegionName": str,
        "ZoneName": str,
        "ZoneId": str,
    },
    total=False,
)


class ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef(
    _ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef
):
    """
    - *(dict) --*

      Describes an Availability Zone.
      - **State** *(string) --*

        The state of the Availability Zone.
    """


_ClientDescribeAvailabilityZonesResponseTypeDef = TypedDict(
    "_ClientDescribeAvailabilityZonesResponseTypeDef",
    {"AvailabilityZones": List[ClientDescribeAvailabilityZonesResponseAvailabilityZonesTypeDef]},
    total=False,
)


class ClientDescribeAvailabilityZonesResponseTypeDef(
    _ClientDescribeAvailabilityZonesResponseTypeDef
):
    """
    - *(dict) --*

      - **AvailabilityZones** *(list) --*

        Information about the Availability Zones.
        - *(dict) --*

          Describes an Availability Zone.
          - **State** *(string) --*

            The state of the Availability Zone.
    """


_ClientDescribeBundleTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeBundleTasksFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeBundleTasksFiltersTypeDef(_ClientDescribeBundleTasksFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef
):
    pass


_ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef",
    {
        "AWSAccessKeyId": str,
        "Bucket": str,
        "Prefix": str,
        "UploadPolicy": bytes,
        "UploadPolicySignature": str,
    },
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef
):
    pass


_ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef",
    {"S3": ClientDescribeBundleTasksResponseBundleTasksStorageS3TypeDef},
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef
):
    pass


_ClientDescribeBundleTasksResponseBundleTasksTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseBundleTasksTypeDef",
    {
        "BundleId": str,
        "BundleTaskError": ClientDescribeBundleTasksResponseBundleTasksBundleTaskErrorTypeDef,
        "InstanceId": str,
        "Progress": str,
        "StartTime": datetime,
        "State": Literal[
            "pending",
            "waiting-for-shutdown",
            "bundling",
            "storing",
            "cancelling",
            "complete",
            "failed",
        ],
        "Storage": ClientDescribeBundleTasksResponseBundleTasksStorageTypeDef,
        "UpdateTime": datetime,
    },
    total=False,
)


class ClientDescribeBundleTasksResponseBundleTasksTypeDef(
    _ClientDescribeBundleTasksResponseBundleTasksTypeDef
):
    """
    - *(dict) --*

      Describes a bundle task.
      - **BundleId** *(string) --*

        The ID of the bundle task.
    """


_ClientDescribeBundleTasksResponseTypeDef = TypedDict(
    "_ClientDescribeBundleTasksResponseTypeDef",
    {"BundleTasks": List[ClientDescribeBundleTasksResponseBundleTasksTypeDef]},
    total=False,
)


class ClientDescribeBundleTasksResponseTypeDef(_ClientDescribeBundleTasksResponseTypeDef):
    """
    - *(dict) --*

      - **BundleTasks** *(list) --*

        Information about the bundle tasks.
        - *(dict) --*

          Describes a bundle task.
          - **BundleId** *(string) --*

            The ID of the bundle task.
    """


_ClientDescribeByoipCidrsResponseByoipCidrsTypeDef = TypedDict(
    "_ClientDescribeByoipCidrsResponseByoipCidrsTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class ClientDescribeByoipCidrsResponseByoipCidrsTypeDef(
    _ClientDescribeByoipCidrsResponseByoipCidrsTypeDef
):
    """
    - *(dict) --*

      Information about an address range that is provisioned for use with your AWS resources through
      bring your own IP addresses (BYOIP).
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_ClientDescribeByoipCidrsResponseTypeDef = TypedDict(
    "_ClientDescribeByoipCidrsResponseTypeDef",
    {"ByoipCidrs": List[ClientDescribeByoipCidrsResponseByoipCidrsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeByoipCidrsResponseTypeDef(_ClientDescribeByoipCidrsResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidrs** *(list) --*

        Information about your address ranges.
        - *(dict) --*

          Information about an address range that is provisioned for use with your AWS resources
          through bring your own IP addresses (BYOIP).
          - **Cidr** *(string) --*

            The public IPv4 address range, in CIDR notation.
    """


_ClientDescribeCapacityReservationsFiltersTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeCapacityReservationsFiltersTypeDef(
    _ClientDescribeCapacityReservationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef(
    _ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef
):
    pass


_ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": Literal[
            "Linux/UNIX",
            "Red Hat Enterprise Linux",
            "SUSE Linux",
            "Windows",
            "Windows with SQL Server",
            "Windows with SQL Server Enterprise",
            "Windows with SQL Server Standard",
            "Windows with SQL Server Web",
            "Linux with SQL Server Standard",
            "Linux with SQL Server Web",
            "Linux with SQL Server Enterprise",
        ],
        "AvailabilityZone": str,
        "Tenancy": Literal["default", "dedicated"],
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": Literal["active", "expired", "cancelled", "pending", "failed"],
        "EndDate": datetime,
        "EndDateType": Literal["unlimited", "limited"],
        "InstanceMatchCriteria": Literal["open", "targeted"],
        "CreateDate": datetime,
        "Tags": List[ClientDescribeCapacityReservationsResponseCapacityReservationsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef(
    _ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef
):
    pass


_ClientDescribeCapacityReservationsResponseTypeDef = TypedDict(
    "_ClientDescribeCapacityReservationsResponseTypeDef",
    {
        "NextToken": str,
        "CapacityReservations": List[
            ClientDescribeCapacityReservationsResponseCapacityReservationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeCapacityReservationsResponseTypeDef(
    _ClientDescribeCapacityReservationsResponseTypeDef
):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeClassicLinkInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClassicLinkInstancesFiltersTypeDef(
    _ClientDescribeClassicLinkInstancesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef
):
    pass


_ClientDescribeClassicLinkInstancesResponseInstancesTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseInstancesTypeDef",
    {
        "Groups": List[ClientDescribeClassicLinkInstancesResponseInstancesGroupsTypeDef],
        "InstanceId": str,
        "Tags": List[ClientDescribeClassicLinkInstancesResponseInstancesTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseInstancesTypeDef(
    _ClientDescribeClassicLinkInstancesResponseInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a linked EC2-Classic instance.
      - **Groups** *(list) --*

        A list of security groups.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_ClientDescribeClassicLinkInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeClassicLinkInstancesResponseTypeDef",
    {
        "Instances": List[ClientDescribeClassicLinkInstancesResponseInstancesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClassicLinkInstancesResponseTypeDef(
    _ClientDescribeClassicLinkInstancesResponseTypeDef
):
    """
    - *(dict) --*

      - **Instances** *(list) --*

        Information about one or more linked EC2-Classic instances.
        - *(dict) --*

          Describes a linked EC2-Classic instance.
          - **Groups** *(list) --*

            A list of security groups.
            - *(dict) --*

              Describes a security group.
              - **GroupName** *(string) --*

                The name of the security group.
    """


_ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef",
    {"Code": Literal["authorizing", "active", "failed", "revoking"], "Message": str},
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef
):
    pass


_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "GroupId": str,
        "AccessAll": bool,
        "DestinationCidr": str,
        "Status": ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesStatusTypeDef,
    },
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef
):
    """
    - *(dict) --*

      Information about an authorization rule.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint with which the authorization rule is associated.
    """


_ClientDescribeClientVpnAuthorizationRulesResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnAuthorizationRulesResponseTypeDef",
    {
        "AuthorizationRules": List[
            ClientDescribeClientVpnAuthorizationRulesResponseAuthorizationRulesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnAuthorizationRulesResponseTypeDef(
    _ClientDescribeClientVpnAuthorizationRulesResponseTypeDef
):
    """
    - *(dict) --*

      - **AuthorizationRules** *(list) --*

        Information about the authorization rules.
        - *(dict) --*

          Information about an authorization rule.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint with which the authorization rule is associated.
    """


_ClientDescribeClientVpnConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnConnectionsFiltersTypeDef(
    _ClientDescribeClientVpnConnectionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef",
    {"Code": Literal["active", "failed-to-terminate", "terminating", "terminated"], "Message": str},
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef(
    _ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef
):
    pass


_ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Timestamp": str,
        "ConnectionId": str,
        "Username": str,
        "ConnectionEstablishedTime": str,
        "IngressBytes": str,
        "EgressBytes": str,
        "IngressPackets": str,
        "EgressPackets": str,
        "ClientIp": str,
        "CommonName": str,
        "Status": ClientDescribeClientVpnConnectionsResponseConnectionsStatusTypeDef,
        "ConnectionEndTime": str,
    },
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef(
    _ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a client connection.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint to which the client is connected.
    """


_ClientDescribeClientVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnConnectionsResponseTypeDef",
    {
        "Connections": List[ClientDescribeClientVpnConnectionsResponseConnectionsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnConnectionsResponseTypeDef(
    _ClientDescribeClientVpnConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **Connections** *(list) --*

        Information about the active and terminated client connections.
        - *(dict) --*

          Describes a client connection.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint to which the client is connected.
    """


_ClientDescribeClientVpnEndpointsFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnEndpointsFiltersTypeDef(
    _ClientDescribeClientVpnEndpointsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    {"NetworkId": str, "NetworkType": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChain": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    {
        "Type": Literal["certificate-authentication", "directory-service-authentication"],
        "ActiveDirectory": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef",
    {"Code": Literal["pending-associate", "available", "deleting", "deleted"], "Message": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef
):
    pass


_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "Status": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsStatusTypeDef,
        "CreationTime": str,
        "DeletionTime": str,
        "DnsName": str,
        "ClientCidrBlock": str,
        "DnsServers": List[str],
        "SplitTunnel": bool,
        "VpnProtocol": str,
        "TransportProtocol": Literal["tcp", "udp"],
        "AssociatedTargetNetworks": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
        ],
        "ServerCertificateArn": str,
        "AuthenticationOptions": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsAuthenticationOptionsTypeDef
        ],
        "ConnectionLogOptions": ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsConnectionLogOptionsTypeDef,
        "Tags": List[ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef(
    _ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef
):
    """
    - *(dict) --*

      Describes a Client VPN endpoint.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint.
    """


_ClientDescribeClientVpnEndpointsResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnEndpointsResponseTypeDef",
    {
        "ClientVpnEndpoints": List[
            ClientDescribeClientVpnEndpointsResponseClientVpnEndpointsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnEndpointsResponseTypeDef(
    _ClientDescribeClientVpnEndpointsResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientVpnEndpoints** *(list) --*

        Information about the Client VPN endpoints.
        - *(dict) --*

          Describes a Client VPN endpoint.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint.
    """


_ClientDescribeClientVpnRoutesFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeClientVpnRoutesFiltersTypeDef(_ClientDescribeClientVpnRoutesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef",
    {"Code": Literal["creating", "active", "failed", "deleting"], "Message": str},
    total=False,
)


class ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef(
    _ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef
):
    pass


_ClientDescribeClientVpnRoutesResponseRoutesTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseRoutesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidr": str,
        "TargetSubnet": str,
        "Type": str,
        "Origin": str,
        "Status": ClientDescribeClientVpnRoutesResponseRoutesStatusTypeDef,
        "Description": str,
    },
    total=False,
)


class ClientDescribeClientVpnRoutesResponseRoutesTypeDef(
    _ClientDescribeClientVpnRoutesResponseRoutesTypeDef
):
    """
    - *(dict) --*

      Information about a Client VPN endpoint route.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint with which the route is associated.
    """


_ClientDescribeClientVpnRoutesResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnRoutesResponseTypeDef",
    {"Routes": List[ClientDescribeClientVpnRoutesResponseRoutesTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeClientVpnRoutesResponseTypeDef(_ClientDescribeClientVpnRoutesResponseTypeDef):
    """
    - *(dict) --*

      - **Routes** *(list) --*

        Information about the Client VPN endpoint routes.
        - *(dict) --*

          Information about a Client VPN endpoint route.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint with which the route is associated.
    """


_ClientDescribeClientVpnTargetNetworksFiltersTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeClientVpnTargetNetworksFiltersTypeDef(
    _ClientDescribeClientVpnTargetNetworksFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef",
    {
        "Code": Literal[
            "associating", "associated", "association-failed", "disassociating", "disassociated"
        ],
        "Message": str,
    },
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef
):
    pass


_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef",
    {
        "AssociationId": str,
        "VpcId": str,
        "TargetNetworkId": str,
        "ClientVpnEndpointId": str,
        "Status": ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksStatusTypeDef,
        "SecurityGroups": List[str],
    },
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef
):
    """
    - *(dict) --*

      Describes a target network associated with a Client VPN endpoint.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_ClientDescribeClientVpnTargetNetworksResponseTypeDef = TypedDict(
    "_ClientDescribeClientVpnTargetNetworksResponseTypeDef",
    {
        "ClientVpnTargetNetworks": List[
            ClientDescribeClientVpnTargetNetworksResponseClientVpnTargetNetworksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeClientVpnTargetNetworksResponseTypeDef(
    _ClientDescribeClientVpnTargetNetworksResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientVpnTargetNetworks** *(list) --*

        Information about the associated target networks.
        - *(dict) --*

          Describes a target network associated with a Client VPN endpoint.
          - **AssociationId** *(string) --*

            The ID of the association.
    """


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[
            ClientDescribeConversionTasksResponseConversionTasksImportInstanceVolumesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientDescribeConversionTasksResponseConversionTasksImportVolumeImageTypeDef,
        "Volume": ClientDescribeConversionTasksResponseConversionTasksImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef
):
    pass


_ClientDescribeConversionTasksResponseConversionTasksTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseConversionTasksTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientDescribeConversionTasksResponseConversionTasksImportInstanceTypeDef,
        "ImportVolume": ClientDescribeConversionTasksResponseConversionTasksImportVolumeTypeDef,
        "State": Literal["active", "cancelling", "cancelled", "completed"],
        "StatusMessage": str,
        "Tags": List[ClientDescribeConversionTasksResponseConversionTasksTagsTypeDef],
    },
    total=False,
)


class ClientDescribeConversionTasksResponseConversionTasksTypeDef(
    _ClientDescribeConversionTasksResponseConversionTasksTypeDef
):
    """
    - *(dict) --*

      Describes a conversion task.
      - **ConversionTaskId** *(string) --*

        The ID of the conversion task.
    """


_ClientDescribeConversionTasksResponseTypeDef = TypedDict(
    "_ClientDescribeConversionTasksResponseTypeDef",
    {"ConversionTasks": List[ClientDescribeConversionTasksResponseConversionTasksTypeDef]},
    total=False,
)


class ClientDescribeConversionTasksResponseTypeDef(_ClientDescribeConversionTasksResponseTypeDef):
    """
    - *(dict) --*

      - **ConversionTasks** *(list) --*

        Information about the conversion tasks.
        - *(dict) --*

          Describes a conversion task.
          - **ConversionTaskId** *(string) --*

            The ID of the conversion task.
    """


_ClientDescribeCustomerGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeCustomerGatewaysFiltersTypeDef(_ClientDescribeCustomerGatewaysFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef(
    _ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef
):
    pass


_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef",
    {
        "BgpAsn": str,
        "CustomerGatewayId": str,
        "IpAddress": str,
        "CertificateArn": str,
        "State": str,
        "Type": str,
        "DeviceName": str,
        "Tags": List[ClientDescribeCustomerGatewaysResponseCustomerGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef(
    _ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a customer gateway.
      - **BgpAsn** *(string) --*

        The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).
    """


_ClientDescribeCustomerGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeCustomerGatewaysResponseTypeDef",
    {"CustomerGateways": List[ClientDescribeCustomerGatewaysResponseCustomerGatewaysTypeDef]},
    total=False,
)


class ClientDescribeCustomerGatewaysResponseTypeDef(_ClientDescribeCustomerGatewaysResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeCustomerGateways.
      - **CustomerGateways** *(list) --*

        Information about one or more customer gateways.
        - *(dict) --*

          Describes a customer gateway.
          - **BgpAsn** *(string) --*

            The customer gateway's Border Gateway Protocol (BGP) Autonomous System Number (ASN).
    """


_ClientDescribeDhcpOptionsFiltersTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeDhcpOptionsFiltersTypeDef(_ClientDescribeDhcpOptionsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    pass


_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsValuesTypeDef],
    },
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes a DHCP configuration option.
      - **Key** *(string) --*

        The name of a DHCP option.
    """


_ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef
):
    pass


_ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            ClientDescribeDhcpOptionsResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[ClientDescribeDhcpOptionsResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef(
    _ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of DHCP options.
      - **DhcpConfigurations** *(list) --*

        One or more DHCP options in the set.
        - *(dict) --*

          Describes a DHCP configuration option.
          - **Key** *(string) --*

            The name of a DHCP option.
    """


_ClientDescribeDhcpOptionsResponseTypeDef = TypedDict(
    "_ClientDescribeDhcpOptionsResponseTypeDef",
    {"DhcpOptions": List[ClientDescribeDhcpOptionsResponseDhcpOptionsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeDhcpOptionsResponseTypeDef(_ClientDescribeDhcpOptionsResponseTypeDef):
    """
    - *(dict) --*

      - **DhcpOptions** *(list) --*

        Information about one or more DHCP options sets.
        - *(dict) --*

          Describes a set of DHCP options.
          - **DhcpConfigurations** *(list) --*

            One or more DHCP options in the set.
            - *(dict) --*

              Describes a DHCP configuration option.
              - **Key** *(string) --*

                The name of a DHCP option.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes the attachment of a VPC to an internet gateway or an egress-only internet gateway.
      - **State** *(string) --*

        The current state of the attachment. For an internet gateway, the state is ``available``
        when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef",
    {
        "Attachments": List[
            ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes an egress-only internet gateway.
      - **Attachments** *(list) --*

        Information about the attachment of the egress-only internet gateway.
        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.
          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is ``available``
            when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef",
    {
        "EgressOnlyInternetGateways": List[
            ClientDescribeEgressOnlyInternetGatewaysResponseEgressOnlyInternetGatewaysTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef(
    _ClientDescribeEgressOnlyInternetGatewaysResponseTypeDef
):
    """
    - *(dict) --*

      - **EgressOnlyInternetGateways** *(list) --*

        Information about the egress-only internet gateways.
        - *(dict) --*

          Describes an egress-only internet gateway.
          - **Attachments** *(list) --*

            Information about the attachment of the egress-only internet gateway.
            - *(dict) --*

              Describes the attachment of a VPC to an internet gateway or an egress-only internet
              gateway.
              - **State** *(string) --*

                The current state of the attachment. For an internet gateway, the state is
                ``available`` when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeElasticGpusFiltersTypeDef = TypedDict(
    "_ClientDescribeElasticGpusFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeElasticGpusFiltersTypeDef(_ClientDescribeElasticGpusFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef",
    {"Status": Literal["OK", "IMPAIRED"]},
    total=False,
)


class ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef(
    _ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef
):
    pass


_ClientDescribeElasticGpusResponseElasticGpuSetTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseElasticGpuSetTypeDef",
    {
        "ElasticGpuId": str,
        "AvailabilityZone": str,
        "ElasticGpuType": str,
        "ElasticGpuHealth": ClientDescribeElasticGpusResponseElasticGpuSetElasticGpuHealthTypeDef,
        "ElasticGpuState": str,
        "InstanceId": str,
    },
    total=False,
)


class ClientDescribeElasticGpusResponseElasticGpuSetTypeDef(
    _ClientDescribeElasticGpusResponseElasticGpuSetTypeDef
):
    """
    - *(dict) --*

      Describes an Elastic Graphics accelerator.
      - **ElasticGpuId** *(string) --*

        The ID of the Elastic Graphics accelerator.
    """


_ClientDescribeElasticGpusResponseTypeDef = TypedDict(
    "_ClientDescribeElasticGpusResponseTypeDef",
    {
        "ElasticGpuSet": List[ClientDescribeElasticGpusResponseElasticGpuSetTypeDef],
        "MaxResults": int,
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeElasticGpusResponseTypeDef(_ClientDescribeElasticGpusResponseTypeDef):
    """
    - *(dict) --*

      - **ElasticGpuSet** *(list) --*

        Information about the Elastic Graphics accelerators.
        - *(dict) --*

          Describes an Elastic Graphics accelerator.
          - **ElasticGpuId** *(string) --*

            The ID of the Elastic Graphics accelerator.
    """


_ClientDescribeExportImageTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeExportImageTasksFiltersTypeDef(_ClientDescribeExportImageTasksFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef",
    {"S3Bucket": str, "S3Prefix": str},
    total=False,
)


class ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef(
    _ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef
):
    pass


_ClientDescribeExportImageTasksResponseExportImageTasksTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseExportImageTasksTypeDef",
    {
        "Description": str,
        "ExportImageTaskId": str,
        "ImageId": str,
        "Progress": str,
        "S3ExportLocation": ClientDescribeExportImageTasksResponseExportImageTasksS3ExportLocationTypeDef,
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeExportImageTasksResponseExportImageTasksTypeDef(
    _ClientDescribeExportImageTasksResponseExportImageTasksTypeDef
):
    """
    - *(dict) --*

      Describes an export image task.
      - **Description** *(string) --*

        A description of the image being exported.
    """


_ClientDescribeExportImageTasksResponseTypeDef = TypedDict(
    "_ClientDescribeExportImageTasksResponseTypeDef",
    {
        "ExportImageTasks": List[ClientDescribeExportImageTasksResponseExportImageTasksTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeExportImageTasksResponseTypeDef(_ClientDescribeExportImageTasksResponseTypeDef):
    """
    - *(dict) --*

      - **ExportImageTasks** *(list) --*

        Information about the export image tasks.
        - *(dict) --*

          Describes an export image task.
          - **Description** *(string) --*

            A description of the image being exported.
    """


_ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef",
    {
        "ContainerFormat": str,
        "DiskImageFormat": Literal["VMDK", "RAW", "VHD"],
        "S3Bucket": str,
        "S3Key": str,
    },
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef(
    _ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef
):
    pass


_ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef",
    {"InstanceId": str, "TargetEnvironment": Literal["citrix", "vmware", "microsoft"]},
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef(
    _ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef
):
    pass


_ClientDescribeExportTasksResponseExportTasksTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseExportTasksTypeDef",
    {
        "Description": str,
        "ExportTaskId": str,
        "ExportToS3Task": ClientDescribeExportTasksResponseExportTasksExportToS3TaskTypeDef,
        "InstanceExportDetails": ClientDescribeExportTasksResponseExportTasksInstanceExportDetailsTypeDef,
        "State": Literal["active", "cancelling", "cancelled", "completed"],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeExportTasksResponseExportTasksTypeDef(
    _ClientDescribeExportTasksResponseExportTasksTypeDef
):
    """
    - *(dict) --*

      Describes an instance export task.
      - **Description** *(string) --*

        A description of the resource being exported.
    """


_ClientDescribeExportTasksResponseTypeDef = TypedDict(
    "_ClientDescribeExportTasksResponseTypeDef",
    {"ExportTasks": List[ClientDescribeExportTasksResponseExportTasksTypeDef]},
    total=False,
)


class ClientDescribeExportTasksResponseTypeDef(_ClientDescribeExportTasksResponseTypeDef):
    """
    - *(dict) --*

      - **ExportTasks** *(list) --*

        Information about the export tasks.
        - *(dict) --*

          Describes an instance export task.
          - **Description** *(string) --*

            A description of the resource being exported.
    """


_ClientDescribeFastSnapshotRestoresFiltersTypeDef = TypedDict(
    "_ClientDescribeFastSnapshotRestoresFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeFastSnapshotRestoresFiltersTypeDef(
    _ClientDescribeFastSnapshotRestoresFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef = TypedDict(
    "_ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": Literal["enabling", "optimizing", "enabled", "disabling", "disabled"],
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
    total=False,
)


class ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef(
    _ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef
):
    """
    - *(dict) --*

      Describes fast snapshot restores for a snapshot.
      - **SnapshotId** *(string) --*

        The ID of the snapshot.
    """


_ClientDescribeFastSnapshotRestoresResponseTypeDef = TypedDict(
    "_ClientDescribeFastSnapshotRestoresResponseTypeDef",
    {
        "FastSnapshotRestores": List[
            ClientDescribeFastSnapshotRestoresResponseFastSnapshotRestoresTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeFastSnapshotRestoresResponseTypeDef(
    _ClientDescribeFastSnapshotRestoresResponseTypeDef
):
    """
    - *(dict) --*

      - **FastSnapshotRestores** *(list) --*

        Information about the state of fast snapshot restores.
        - *(dict) --*

          Describes fast snapshot restores for a snapshot.
          - **SnapshotId** *(string) --*

            The ID of the snapshot.
    """


_ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef",
    {"EventDescription": str, "EventSubType": str, "InstanceId": str},
    total=False,
)


class ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef(
    _ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef
):
    """
    - **EventInformation** *(dict) --*

      Information about the event.
      - **EventDescription** *(string) --*

        The description of the event.
    """


_ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef",
    {
        "EventInformation": ClientDescribeFleetHistoryResponseHistoryRecordsEventInformationTypeDef,
        "EventType": Literal["instance-change", "fleet-change", "service-error"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef(
    _ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef
):
    """
    - *(dict) --*

      Describes an event in the history of an EC2 Fleet.
      - **EventInformation** *(dict) --*

        Information about the event.
        - **EventDescription** *(string) --*

          The description of the event.
    """


_ClientDescribeFleetHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeFleetHistoryResponseTypeDef",
    {
        "HistoryRecords": List[ClientDescribeFleetHistoryResponseHistoryRecordsTypeDef],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "FleetId": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientDescribeFleetHistoryResponseTypeDef(_ClientDescribeFleetHistoryResponseTypeDef):
    """
    - *(dict) --*

      - **HistoryRecords** *(list) --*

        Information about the events in the history of the EC2 Fleet.
        - *(dict) --*

          Describes an event in the history of an EC2 Fleet.
          - **EventInformation** *(dict) --*

            Information about the event.
            - **EventDescription** *(string) --*

              The description of the event.
    """


_ClientDescribeFleetInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeFleetInstancesFiltersTypeDef(_ClientDescribeFleetInstancesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeFleetInstancesResponseActiveInstancesTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": Literal["healthy", "unhealthy"],
    },
    total=False,
)


class ClientDescribeFleetInstancesResponseActiveInstancesTypeDef(
    _ClientDescribeFleetInstancesResponseActiveInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a running instance in a Spot Fleet.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientDescribeFleetInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeFleetInstancesResponseTypeDef",
    {
        "ActiveInstances": List[ClientDescribeFleetInstancesResponseActiveInstancesTypeDef],
        "NextToken": str,
        "FleetId": str,
    },
    total=False,
)


class ClientDescribeFleetInstancesResponseTypeDef(_ClientDescribeFleetInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **ActiveInstances** *(list) --*

        The running instances. This list is refreshed periodically and might be out of date.
        - *(dict) --*

          Describes a running instance in a Spot Fleet.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientDescribeFleetsFiltersTypeDef = TypedDict(
    "_ClientDescribeFleetsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeFleetsFiltersTypeDef(_ClientDescribeFleetsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsErrorsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientDescribeFleetsResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsErrorsTypeDef(
    _ClientDescribeFleetsResponseFleetsErrorsTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsInstancesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": ClientDescribeFleetsResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "InstanceIds": List[str],
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsInstancesTypeDef(
    _ClientDescribeFleetsResponseFleetsInstancesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsOverridesTypeDef],
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef(
    _ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "prioritized"],
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef(
    _ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "diversified", "capacity-optimized"],
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef(
    _ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsTagsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeFleetsResponseFleetsTagsTypeDef(_ClientDescribeFleetsResponseFleetsTagsTypeDef):
    pass


_ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef",
    {
        "TotalTargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": Literal["spot", "on-demand"],
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef(
    _ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef
):
    pass


_ClientDescribeFleetsResponseFleetsTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseFleetsTypeDef",
    {
        "ActivityStatus": Literal[
            "error", "pending_fulfillment", "pending_termination", "fulfilled"
        ],
        "CreateTime": datetime,
        "FleetId": str,
        "FleetState": Literal[
            "submitted",
            "active",
            "deleted",
            "failed",
            "deleted_running",
            "deleted_terminating",
            "modifying",
        ],
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": Literal["no-termination", "termination"],
        "FulfilledCapacity": float,
        "FulfilledOnDemandCapacity": float,
        "LaunchTemplateConfigs": List[
            ClientDescribeFleetsResponseFleetsLaunchTemplateConfigsTypeDef
        ],
        "TargetCapacitySpecification": ClientDescribeFleetsResponseFleetsTargetCapacitySpecificationTypeDef,
        "TerminateInstancesWithExpiration": bool,
        "Type": Literal["request", "maintain", "instant"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "SpotOptions": ClientDescribeFleetsResponseFleetsSpotOptionsTypeDef,
        "OnDemandOptions": ClientDescribeFleetsResponseFleetsOnDemandOptionsTypeDef,
        "Tags": List[ClientDescribeFleetsResponseFleetsTagsTypeDef],
        "Errors": List[ClientDescribeFleetsResponseFleetsErrorsTypeDef],
        "Instances": List[ClientDescribeFleetsResponseFleetsInstancesTypeDef],
    },
    total=False,
)


class ClientDescribeFleetsResponseFleetsTypeDef(_ClientDescribeFleetsResponseFleetsTypeDef):
    pass


_ClientDescribeFleetsResponseTypeDef = TypedDict(
    "_ClientDescribeFleetsResponseTypeDef",
    {"NextToken": str, "Fleets": List[ClientDescribeFleetsResponseFleetsTypeDef]},
    total=False,
)


class ClientDescribeFleetsResponseTypeDef(_ClientDescribeFleetsResponseTypeDef):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token for the next set of results.
    """


_ClientDescribeFlowLogsFiltersTypeDef = TypedDict(
    "_ClientDescribeFlowLogsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeFlowLogsFiltersTypeDef(_ClientDescribeFlowLogsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeFlowLogsResponseFlowLogsTypeDef = TypedDict(
    "_ClientDescribeFlowLogsResponseFlowLogsTypeDef",
    {
        "CreationTime": datetime,
        "DeliverLogsErrorMessage": str,
        "DeliverLogsPermissionArn": str,
        "DeliverLogsStatus": str,
        "FlowLogId": str,
        "FlowLogStatus": str,
        "LogGroupName": str,
        "ResourceId": str,
        "TrafficType": Literal["ACCEPT", "REJECT", "ALL"],
        "LogDestinationType": Literal["cloud-watch-logs", "s3"],
        "LogDestination": str,
        "LogFormat": str,
    },
    total=False,
)


class ClientDescribeFlowLogsResponseFlowLogsTypeDef(_ClientDescribeFlowLogsResponseFlowLogsTypeDef):
    """
    - *(dict) --*

      Describes a flow log.
      - **CreationTime** *(datetime) --*

        The date and time the flow log was created.
    """


_ClientDescribeFlowLogsResponseTypeDef = TypedDict(
    "_ClientDescribeFlowLogsResponseTypeDef",
    {"FlowLogs": List[ClientDescribeFlowLogsResponseFlowLogsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeFlowLogsResponseTypeDef(_ClientDescribeFlowLogsResponseTypeDef):
    """
    - *(dict) --*

      - **FlowLogs** *(list) --*

        Information about the flow logs.
        - *(dict) --*

          Describes a flow log.
          - **CreationTime** *(datetime) --*

            The date and time the flow log was created.
    """


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    {"UserId": str, "Group": str},
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
):
    pass


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
):
    pass


_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    {
        "FpgaImageId": str,
        "Name": str,
        "Description": str,
        "LoadPermissions": List[
            ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
        ],
        "ProductCodes": List[
            ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef(
    _ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef
):
    """
    - **FpgaImageAttribute** *(dict) --*

      Information about the attribute.
      - **FpgaImageId** *(string) --*

        The ID of the AFI.
    """


_ClientDescribeFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeFpgaImageAttributeResponseTypeDef",
    {"FpgaImageAttribute": ClientDescribeFpgaImageAttributeResponseFpgaImageAttributeTypeDef},
    total=False,
)


class ClientDescribeFpgaImageAttributeResponseTypeDef(
    _ClientDescribeFpgaImageAttributeResponseTypeDef
):
    """
    - *(dict) --*

      - **FpgaImageAttribute** *(dict) --*

        Information about the attribute.
        - **FpgaImageId** *(string) --*

          The ID of the AFI.
    """


_ClientDescribeFpgaImagesFiltersTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeFpgaImagesFiltersTypeDef(_ClientDescribeFpgaImagesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef",
    {"DeviceId": str, "VendorId": str, "SubsystemId": str, "SubsystemVendorId": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef
):
    pass


_ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef
):
    pass


_ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef",
    {"Code": Literal["pending", "failed", "available", "unavailable"], "Message": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef
):
    pass


_ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef
):
    pass


_ClientDescribeFpgaImagesResponseFpgaImagesTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseFpgaImagesTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "Name": str,
        "Description": str,
        "ShellVersion": str,
        "PciId": ClientDescribeFpgaImagesResponseFpgaImagesPciIdTypeDef,
        "State": ClientDescribeFpgaImagesResponseFpgaImagesStateTypeDef,
        "CreateTime": datetime,
        "UpdateTime": datetime,
        "OwnerId": str,
        "OwnerAlias": str,
        "ProductCodes": List[ClientDescribeFpgaImagesResponseFpgaImagesProductCodesTypeDef],
        "Tags": List[ClientDescribeFpgaImagesResponseFpgaImagesTagsTypeDef],
        "Public": bool,
        "DataRetentionSupport": bool,
    },
    total=False,
)


class ClientDescribeFpgaImagesResponseFpgaImagesTypeDef(
    _ClientDescribeFpgaImagesResponseFpgaImagesTypeDef
):
    """
    - *(dict) --*

      Describes an Amazon FPGA image (AFI).
      - **FpgaImageId** *(string) --*

        The FPGA image identifier (AFI ID).
    """


_ClientDescribeFpgaImagesResponseTypeDef = TypedDict(
    "_ClientDescribeFpgaImagesResponseTypeDef",
    {"FpgaImages": List[ClientDescribeFpgaImagesResponseFpgaImagesTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeFpgaImagesResponseTypeDef(_ClientDescribeFpgaImagesResponseTypeDef):
    """
    - *(dict) --*

      - **FpgaImages** *(list) --*

        Information about the FPGA images.
        - *(dict) --*

          Describes an Amazon FPGA image (AFI).
          - **FpgaImageId** *(string) --*

            The FPGA image identifier (AFI ID).
    """


_ClientDescribeHostReservationOfferingsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeHostReservationOfferingsFiltersTypeDef(
    _ClientDescribeHostReservationOfferingsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef(
    _ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef
):
    pass


_ClientDescribeHostReservationOfferingsResponseTypeDef = TypedDict(
    "_ClientDescribeHostReservationOfferingsResponseTypeDef",
    {
        "NextToken": str,
        "OfferingSet": List[ClientDescribeHostReservationOfferingsResponseOfferingSetTypeDef],
    },
    total=False,
)


class ClientDescribeHostReservationOfferingsResponseTypeDef(
    _ClientDescribeHostReservationOfferingsResponseTypeDef
):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeHostReservationsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostReservationsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeHostReservationsFiltersTypeDef(_ClientDescribeHostReservationsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef(
    _ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef
):
    pass


_ClientDescribeHostReservationsResponseHostReservationSetTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseHostReservationSetTypeDef",
    {
        "Count": int,
        "CurrencyCode": str,
        "Duration": int,
        "End": datetime,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "Start": datetime,
        "State": Literal["payment-pending", "payment-failed", "active", "retired"],
        "UpfrontPrice": str,
        "Tags": List[ClientDescribeHostReservationsResponseHostReservationSetTagsTypeDef],
    },
    total=False,
)


class ClientDescribeHostReservationsResponseHostReservationSetTypeDef(
    _ClientDescribeHostReservationsResponseHostReservationSetTypeDef
):
    """
    - *(dict) --*

      Details about the Dedicated Host Reservation and associated Dedicated Hosts.
      - **Count** *(integer) --*

        The number of Dedicated Hosts the reservation is associated with.
    """


_ClientDescribeHostReservationsResponseTypeDef = TypedDict(
    "_ClientDescribeHostReservationsResponseTypeDef",
    {
        "HostReservationSet": List[ClientDescribeHostReservationsResponseHostReservationSetTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeHostReservationsResponseTypeDef(_ClientDescribeHostReservationsResponseTypeDef):
    """
    - *(dict) --*

      - **HostReservationSet** *(list) --*

        Details about the reservation's configuration.
        - *(dict) --*

          Details about the Dedicated Host Reservation and associated Dedicated Hosts.
          - **Count** *(integer) --*

            The number of Dedicated Hosts the reservation is associated with.
    """


_ClientDescribeHostsFiltersTypeDef = TypedDict(
    "_ClientDescribeHostsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeHostsFiltersTypeDef(_ClientDescribeHostsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    {"AvailableCapacity": int, "InstanceType": str, "TotalCapacity": int},
    total=False,
)


class ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef(
    _ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
):
    pass


_ClientDescribeHostsResponseHostsAvailableCapacityTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsAvailableCapacityTypeDef",
    {
        "AvailableInstanceCapacity": List[
            ClientDescribeHostsResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
        ],
        "AvailableVCpus": int,
    },
    total=False,
)


class ClientDescribeHostsResponseHostsAvailableCapacityTypeDef(
    _ClientDescribeHostsResponseHostsAvailableCapacityTypeDef
):
    pass


_ClientDescribeHostsResponseHostsHostPropertiesTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsHostPropertiesTypeDef",
    {"Cores": int, "InstanceType": str, "InstanceFamily": str, "Sockets": int, "TotalVCpus": int},
    total=False,
)


class ClientDescribeHostsResponseHostsHostPropertiesTypeDef(
    _ClientDescribeHostsResponseHostsHostPropertiesTypeDef
):
    pass


_ClientDescribeHostsResponseHostsInstancesTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsInstancesTypeDef",
    {"InstanceId": str, "InstanceType": str, "OwnerId": str},
    total=False,
)


class ClientDescribeHostsResponseHostsInstancesTypeDef(
    _ClientDescribeHostsResponseHostsInstancesTypeDef
):
    pass


_ClientDescribeHostsResponseHostsTagsTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeHostsResponseHostsTagsTypeDef(_ClientDescribeHostsResponseHostsTagsTypeDef):
    pass


_ClientDescribeHostsResponseHostsTypeDef = TypedDict(
    "_ClientDescribeHostsResponseHostsTypeDef",
    {
        "AutoPlacement": Literal["on", "off"],
        "AvailabilityZone": str,
        "AvailableCapacity": ClientDescribeHostsResponseHostsAvailableCapacityTypeDef,
        "ClientToken": str,
        "HostId": str,
        "HostProperties": ClientDescribeHostsResponseHostsHostPropertiesTypeDef,
        "HostReservationId": str,
        "Instances": List[ClientDescribeHostsResponseHostsInstancesTypeDef],
        "State": Literal[
            "available",
            "under-assessment",
            "permanent-failure",
            "released",
            "released-permanent-failure",
            "pending",
        ],
        "AllocationTime": datetime,
        "ReleaseTime": datetime,
        "Tags": List[ClientDescribeHostsResponseHostsTagsTypeDef],
        "HostRecovery": Literal["on", "off"],
        "AllowsMultipleInstanceTypes": Literal["on", "off"],
        "OwnerId": str,
        "AvailabilityZoneId": str,
        "MemberOfServiceLinkedResourceGroup": bool,
    },
    total=False,
)


class ClientDescribeHostsResponseHostsTypeDef(_ClientDescribeHostsResponseHostsTypeDef):
    """
    - *(dict) --*

      Describes the properties of the Dedicated Host.
      - **AutoPlacement** *(string) --*

        Whether auto-placement is on or off.
    """


_ClientDescribeHostsResponseTypeDef = TypedDict(
    "_ClientDescribeHostsResponseTypeDef",
    {"Hosts": List[ClientDescribeHostsResponseHostsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeHostsResponseTypeDef(_ClientDescribeHostsResponseTypeDef):
    """
    - *(dict) --*

      - **Hosts** *(list) --*

        Information about the Dedicated Hosts.
        - *(dict) --*

          Describes the properties of the Dedicated Host.
          - **AutoPlacement** *(string) --*

            Whether auto-placement is on or off.
    """


_ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef
):
    pass


_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between an IAM instance profile and an instance.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_ClientDescribeIamInstanceProfileAssociationsResponseTypeDef = TypedDict(
    "_ClientDescribeIamInstanceProfileAssociationsResponseTypeDef",
    {
        "IamInstanceProfileAssociations": List[
            ClientDescribeIamInstanceProfileAssociationsResponseIamInstanceProfileAssociationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeIamInstanceProfileAssociationsResponseTypeDef(
    _ClientDescribeIamInstanceProfileAssociationsResponseTypeDef
):
    """
    - *(dict) --*

      - **IamInstanceProfileAssociations** *(list) --*

        Information about the IAM instance profile associations.
        - *(dict) --*

          Describes an association between an IAM instance profile and an instance.
          - **AssociationId** *(string) --*

            The ID of the association.
    """


_ClientDescribeIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeIdFormatResponseStatusesTypeDef(_ClientDescribeIdFormatResponseStatusesTypeDef):
    """
    - *(dict) --*

      Describes the ID format for a resource.
      - **Deadline** *(datetime) --*

        The date in UTC at which you are permanently switched over to using longer IDs. If a
        deadline is not yet available for this resource type, this field is not returned.
    """


_ClientDescribeIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeIdFormatResponseTypeDef",
    {"Statuses": List[ClientDescribeIdFormatResponseStatusesTypeDef]},
    total=False,
)


class ClientDescribeIdFormatResponseTypeDef(_ClientDescribeIdFormatResponseTypeDef):
    """
    - *(dict) --*

      - **Statuses** *(list) --*

        Information about the ID format for the resource.
        - *(dict) --*

          Describes the ID format for a resource.
          - **Deadline** *(datetime) --*

            The date in UTC at which you are permanently switched over to using longer IDs. If a
            deadline is not yet available for this resource type, this field is not returned.
    """


_ClientDescribeIdentityIdFormatResponseStatusesTypeDef = TypedDict(
    "_ClientDescribeIdentityIdFormatResponseStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribeIdentityIdFormatResponseStatusesTypeDef(
    _ClientDescribeIdentityIdFormatResponseStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the ID format for a resource.
      - **Deadline** *(datetime) --*

        The date in UTC at which you are permanently switched over to using longer IDs. If a
        deadline is not yet available for this resource type, this field is not returned.
    """


_ClientDescribeIdentityIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribeIdentityIdFormatResponseTypeDef",
    {"Statuses": List[ClientDescribeIdentityIdFormatResponseStatusesTypeDef]},
    total=False,
)


class ClientDescribeIdentityIdFormatResponseTypeDef(_ClientDescribeIdentityIdFormatResponseTypeDef):
    """
    - *(dict) --*

      - **Statuses** *(list) --*

        Information about the ID format for the resources.
        - *(dict) --*

          Describes the ID format for a resource.
          - **Deadline** *(datetime) --*

            The date in UTC at which you are permanently switched over to using longer IDs. If a
            deadline is not yet available for this resource type, this field is not returned.
    """


_ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeImageAttributeResponseBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef(
    _ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientDescribeImageAttributeResponseDescriptionTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseDescriptionTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseDescriptionTypeDef(
    _ClientDescribeImageAttributeResponseDescriptionTypeDef
):
    pass


_ClientDescribeImageAttributeResponseKernelIdTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseKernelIdTypeDef(
    _ClientDescribeImageAttributeResponseKernelIdTypeDef
):
    pass


_ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef(
    _ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef
):
    pass


_ClientDescribeImageAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeImageAttributeResponseProductCodesTypeDef(
    _ClientDescribeImageAttributeResponseProductCodesTypeDef
):
    pass


_ClientDescribeImageAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseRamdiskIdTypeDef(
    _ClientDescribeImageAttributeResponseRamdiskIdTypeDef
):
    pass


_ClientDescribeImageAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ClientDescribeImageAttributeResponseSriovNetSupportTypeDef(
    _ClientDescribeImageAttributeResponseSriovNetSupportTypeDef
):
    pass


_ClientDescribeImageAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeImageAttributeResponseTypeDef",
    {
        "BlockDeviceMappings": List[ClientDescribeImageAttributeResponseBlockDeviceMappingsTypeDef],
        "ImageId": str,
        "LaunchPermissions": List[ClientDescribeImageAttributeResponseLaunchPermissionsTypeDef],
        "ProductCodes": List[ClientDescribeImageAttributeResponseProductCodesTypeDef],
        "Description": ClientDescribeImageAttributeResponseDescriptionTypeDef,
        "KernelId": ClientDescribeImageAttributeResponseKernelIdTypeDef,
        "RamdiskId": ClientDescribeImageAttributeResponseRamdiskIdTypeDef,
        "SriovNetSupport": ClientDescribeImageAttributeResponseSriovNetSupportTypeDef,
    },
    total=False,
)


class ClientDescribeImageAttributeResponseTypeDef(_ClientDescribeImageAttributeResponseTypeDef):
    """
    - *(dict) --*

      Describes an image attribute.
      - **BlockDeviceMappings** *(list) --*

        The block device mapping entries.
        - *(dict) --*

          Describes a block device mapping.
          - **DeviceName** *(string) --*

            The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientDescribeImagesFiltersTypeDef = TypedDict(
    "_ClientDescribeImagesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeImagesFiltersTypeDef(_ClientDescribeImagesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeImagesResponseImagesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef(
    _ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeImagesResponseImagesProductCodesTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeImagesResponseImagesProductCodesTypeDef(
    _ClientDescribeImagesResponseImagesProductCodesTypeDef
):
    pass


_ClientDescribeImagesResponseImagesStateReasonTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeImagesResponseImagesStateReasonTypeDef(
    _ClientDescribeImagesResponseImagesStateReasonTypeDef
):
    pass


_ClientDescribeImagesResponseImagesTagsTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeImagesResponseImagesTagsTypeDef(_ClientDescribeImagesResponseImagesTagsTypeDef):
    pass


_ClientDescribeImagesResponseImagesTypeDef = TypedDict(
    "_ClientDescribeImagesResponseImagesTypeDef",
    {
        "Architecture": Literal["i386", "x86_64", "arm64"],
        "CreationDate": str,
        "ImageId": str,
        "ImageLocation": str,
        "ImageType": Literal["machine", "kernel", "ramdisk"],
        "Public": bool,
        "KernelId": str,
        "OwnerId": str,
        "Platform": str,
        "ProductCodes": List[ClientDescribeImagesResponseImagesProductCodesTypeDef],
        "RamdiskId": str,
        "State": Literal[
            "pending", "available", "invalid", "deregistered", "transient", "failed", "error"
        ],
        "BlockDeviceMappings": List[ClientDescribeImagesResponseImagesBlockDeviceMappingsTypeDef],
        "Description": str,
        "EnaSupport": bool,
        "Hypervisor": Literal["ovm", "xen"],
        "ImageOwnerAlias": str,
        "Name": str,
        "RootDeviceName": str,
        "RootDeviceType": Literal["ebs", "instance-store"],
        "SriovNetSupport": str,
        "StateReason": ClientDescribeImagesResponseImagesStateReasonTypeDef,
        "Tags": List[ClientDescribeImagesResponseImagesTagsTypeDef],
        "VirtualizationType": Literal["hvm", "paravirtual"],
    },
    total=False,
)


class ClientDescribeImagesResponseImagesTypeDef(_ClientDescribeImagesResponseImagesTypeDef):
    """
    - *(dict) --*

      Describes an image.
      - **Architecture** *(string) --*

        The architecture of the image.
    """


_ClientDescribeImagesResponseTypeDef = TypedDict(
    "_ClientDescribeImagesResponseTypeDef",
    {"Images": List[ClientDescribeImagesResponseImagesTypeDef]},
    total=False,
)


class ClientDescribeImagesResponseTypeDef(_ClientDescribeImagesResponseTypeDef):
    """
    - *(dict) --*

      - **Images** *(list) --*

        Information about the images.
        - *(dict) --*

          Describes an image.
          - **Architecture** *(string) --*

            The architecture of the image.
    """


_ClientDescribeImportImageTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeImportImageTasksFiltersTypeDef(_ClientDescribeImportImageTasksFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef
):
    pass


_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef
):
    pass


_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef
):
    pass


_ClientDescribeImportImageTasksResponseImportImageTasksTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseImportImageTasksTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[
            ClientDescribeImportImageTasksResponseImportImageTasksSnapshotDetailsTypeDef
        ],
        "Status": str,
        "StatusMessage": str,
        "LicenseSpecifications": List[
            ClientDescribeImportImageTasksResponseImportImageTasksLicenseSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseImportImageTasksTypeDef(
    _ClientDescribeImportImageTasksResponseImportImageTasksTypeDef
):
    """
    - *(dict) --*

      Describes an import image task.
      - **Architecture** *(string) --*

        The architecture of the virtual machine.
        Valid values: ``i386`` | ``x86_64`` | ``arm64``
    """


_ClientDescribeImportImageTasksResponseTypeDef = TypedDict(
    "_ClientDescribeImportImageTasksResponseTypeDef",
    {
        "ImportImageTasks": List[ClientDescribeImportImageTasksResponseImportImageTasksTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeImportImageTasksResponseTypeDef(_ClientDescribeImportImageTasksResponseTypeDef):
    """
    - *(dict) --*

      - **ImportImageTasks** *(list) --*

        A list of zero or more import image tasks that are currently active or were completed or
        canceled in the previous 7 days.
        - *(dict) --*

          Describes an import image task.
          - **Architecture** *(string) --*

            The architecture of the virtual machine.
            Valid values: ``i386`` | ``x86_64`` | ``arm64``
    """


_ClientDescribeImportSnapshotTasksFiltersTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeImportSnapshotTasksFiltersTypeDef(
    _ClientDescribeImportSnapshotTasksFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef
):
    pass


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef
):
    pass


_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef(
    _ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef
):
    """
    - *(dict) --*

      Describes an import snapshot task.
      - **Description** *(string) --*

        A description of the import snapshot task.
    """


_ClientDescribeImportSnapshotTasksResponseTypeDef = TypedDict(
    "_ClientDescribeImportSnapshotTasksResponseTypeDef",
    {
        "ImportSnapshotTasks": List[
            ClientDescribeImportSnapshotTasksResponseImportSnapshotTasksTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeImportSnapshotTasksResponseTypeDef(
    _ClientDescribeImportSnapshotTasksResponseTypeDef
):
    """
    - *(dict) --*

      - **ImportSnapshotTasks** *(list) --*

        A list of zero or more import snapshot tasks that are currently active or were completed or
        canceled in the previous 7 days.
        - *(dict) --*

          Describes an import snapshot task.
          - **Description** *(string) --*

            A description of the import snapshot task.
    """


_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientDescribeInstanceAttributeResponseBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef(
    _ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef(
    _ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef(
    _ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseEnaSupportTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseEnaSupportTypeDef", {"Value": bool}, total=False
)


class ClientDescribeInstanceAttributeResponseEnaSupportTypeDef(
    _ClientDescribeInstanceAttributeResponseEnaSupportTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseGroupsTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseGroupsTypeDef(
    _ClientDescribeInstanceAttributeResponseGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef(
    _ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef(
    _ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseKernelIdTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseKernelIdTypeDef(
    _ClientDescribeInstanceAttributeResponseKernelIdTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeInstanceAttributeResponseProductCodesTypeDef(
    _ClientDescribeInstanceAttributeResponseProductCodesTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef(
    _ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef(
    _ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef(
    _ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef(
    _ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseUserDataTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseUserDataTypeDef", {"Value": str}, total=False
)


class ClientDescribeInstanceAttributeResponseUserDataTypeDef(
    _ClientDescribeInstanceAttributeResponseUserDataTypeDef
):
    pass


_ClientDescribeInstanceAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceAttributeResponseTypeDef",
    {
        "Groups": List[ClientDescribeInstanceAttributeResponseGroupsTypeDef],
        "BlockDeviceMappings": List[
            ClientDescribeInstanceAttributeResponseBlockDeviceMappingsTypeDef
        ],
        "DisableApiTermination": ClientDescribeInstanceAttributeResponseDisableApiTerminationTypeDef,
        "EnaSupport": ClientDescribeInstanceAttributeResponseEnaSupportTypeDef,
        "EbsOptimized": ClientDescribeInstanceAttributeResponseEbsOptimizedTypeDef,
        "InstanceId": str,
        "InstanceInitiatedShutdownBehavior": ClientDescribeInstanceAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef,
        "InstanceType": ClientDescribeInstanceAttributeResponseInstanceTypeTypeDef,
        "KernelId": ClientDescribeInstanceAttributeResponseKernelIdTypeDef,
        "ProductCodes": List[ClientDescribeInstanceAttributeResponseProductCodesTypeDef],
        "RamdiskId": ClientDescribeInstanceAttributeResponseRamdiskIdTypeDef,
        "RootDeviceName": ClientDescribeInstanceAttributeResponseRootDeviceNameTypeDef,
        "SourceDestCheck": ClientDescribeInstanceAttributeResponseSourceDestCheckTypeDef,
        "SriovNetSupport": ClientDescribeInstanceAttributeResponseSriovNetSupportTypeDef,
        "UserData": ClientDescribeInstanceAttributeResponseUserDataTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceAttributeResponseTypeDef(
    _ClientDescribeInstanceAttributeResponseTypeDef
):
    """
    - *(dict) --*

      Describes an instance attribute.
      - **Groups** *(list) --*

        The security groups associated with the instance.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_ClientDescribeInstanceCreditSpecificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsFiltersTypeDef(
    _ClientDescribeInstanceCreditSpecificationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef(
    _ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes the credit option for CPU usage of a burstable performance instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientDescribeInstanceCreditSpecificationsResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceCreditSpecificationsResponseTypeDef",
    {
        "InstanceCreditSpecifications": List[
            ClientDescribeInstanceCreditSpecificationsResponseInstanceCreditSpecificationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceCreditSpecificationsResponseTypeDef(
    _ClientDescribeInstanceCreditSpecificationsResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceCreditSpecifications** *(list) --*

        Information about the credit option for CPU usage of an instance.
        - *(dict) --*

          Describes the credit option for CPU usage of a burstable performance instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientDescribeInstanceStatusFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeInstanceStatusFiltersTypeDef(_ClientDescribeInstanceStatusFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef",
    {
        "InstanceEventId": str,
        "Code": Literal[
            "instance-reboot",
            "system-reboot",
            "system-maintenance",
            "instance-retirement",
            "instance-stop",
        ],
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    {
        "ImpairedSince": datetime,
        "Name": str,
        "Status": Literal["passed", "failed", "insufficient-data", "initializing"],
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef",
    {
        "Details": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusDetailsTypeDef
        ],
        "Status": Literal["ok", "impaired", "insufficient-data", "not-applicable", "initializing"],
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef",
    {
        "ImpairedSince": datetime,
        "Name": str,
        "Status": Literal["passed", "failed", "insufficient-data", "initializing"],
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef",
    {
        "Details": List[
            ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusDetailsTypeDef
        ],
        "Status": Literal["ok", "impaired", "insufficient-data", "not-applicable", "initializing"],
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef
):
    pass


_ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef",
    {
        "AvailabilityZone": str,
        "Events": List[ClientDescribeInstanceStatusResponseInstanceStatusesEventsTypeDef],
        "InstanceId": str,
        "InstanceState": ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStateTypeDef,
        "InstanceStatus": ClientDescribeInstanceStatusResponseInstanceStatusesInstanceStatusTypeDef,
        "SystemStatus": ClientDescribeInstanceStatusResponseInstanceStatusesSystemStatusTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef(
    _ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the status of an instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.
    """


_ClientDescribeInstanceStatusResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceStatusResponseTypeDef",
    {
        "InstanceStatuses": List[ClientDescribeInstanceStatusResponseInstanceStatusesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceStatusResponseTypeDef(_ClientDescribeInstanceStatusResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceStatuses** *(list) --*

        Information about the status of the instances.
        - *(dict) --*

          Describes the status of an instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.
    """


_ClientDescribeInstanceTypeOfferingsFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceTypeOfferingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeInstanceTypeOfferingsFiltersTypeDef(
    _ClientDescribeInstanceTypeOfferingsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef = TypedDict(
    "_ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "LocationType": Literal["region", "availability-zone", "availability-zone-id"],
        "Location": str,
    },
    total=False,
)


class ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef(
    _ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef
):
    """
    - *(dict) --*

      The instance types offered.
      - **InstanceType** *(string) --*

        The instance type. For more information, see `Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .
    """


_ClientDescribeInstanceTypeOfferingsResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceTypeOfferingsResponseTypeDef",
    {
        "InstanceTypeOfferings": List[
            ClientDescribeInstanceTypeOfferingsResponseInstanceTypeOfferingsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceTypeOfferingsResponseTypeDef(
    _ClientDescribeInstanceTypeOfferingsResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceTypeOfferings** *(list) --*

        The instance types offered.
        - *(dict) --*

          The instance types offered.
          - **InstanceType** *(string) --*

            The instance type. For more information, see `Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .
    """


_ClientDescribeInstanceTypesFiltersTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeInstanceTypesFiltersTypeDef(_ClientDescribeInstanceTypesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef",
    {
        "EbsOptimizedSupport": Literal["unsupported", "supported", "default"],
        "EncryptionSupport": Literal["unsupported", "supported"],
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef",
    {"SizeInMiB": int},
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef",
    {
        "Name": str,
        "Manufacturer": str,
        "Count": int,
        "MemoryInfo": ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasMemoryInfoTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef",
    {
        "Fpgas": List[ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoFpgasTypeDef],
        "TotalFpgaMemoryInMiB": int,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef",
    {"SizeInMiB": int},
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef",
    {
        "Name": str,
        "Manufacturer": str,
        "Count": int,
        "MemoryInfo": ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusMemoryInfoTypeDef,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef",
    {
        "Gpus": List[ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoGpusTypeDef],
        "TotalGpuMemoryInMiB": int,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef",
    {"SizeInGB": int, "Count": int, "Type": Literal["hdd", "ssd"]},
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef",
    {
        "TotalSizeInGB": int,
        "Disks": List[
            ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoDisksTypeDef
        ],
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef",
    {"SizeInMiB": int},
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef",
    {
        "NetworkPerformance": str,
        "MaximumNetworkInterfaces": int,
        "Ipv4AddressesPerInterface": int,
        "Ipv6AddressesPerInterface": int,
        "Ipv6Supported": bool,
        "EnaSupport": Literal["unsupported", "supported", "required"],
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef",
    {"SupportedStrategies": List[Literal["cluster", "partition", "spread"]]},
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef",
    {
        "SupportedArchitectures": List[Literal["i386", "x86_64", "arm64"]],
        "SustainedClockSpeedInGhz": float,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef",
    {
        "DefaultVCpus": int,
        "DefaultCores": int,
        "DefaultThreadsPerCore": int,
        "ValidCores": List[int],
        "ValidThreadsPerCore": List[int],
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef
):
    pass


_ClientDescribeInstanceTypesResponseInstanceTypesTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseInstanceTypesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "CurrentGeneration": bool,
        "FreeTierEligible": bool,
        "SupportedUsageClasses": List[Literal["spot", "on-demand"]],
        "SupportedRootDevices": List[Literal["ebs", "instance-store"]],
        "BareMetal": bool,
        "Hypervisor": Literal["nitro", "xen"],
        "ProcessorInfo": ClientDescribeInstanceTypesResponseInstanceTypesProcessorInfoTypeDef,
        "VCpuInfo": ClientDescribeInstanceTypesResponseInstanceTypesVCpuInfoTypeDef,
        "MemoryInfo": ClientDescribeInstanceTypesResponseInstanceTypesMemoryInfoTypeDef,
        "InstanceStorageSupported": bool,
        "InstanceStorageInfo": ClientDescribeInstanceTypesResponseInstanceTypesInstanceStorageInfoTypeDef,
        "EbsInfo": ClientDescribeInstanceTypesResponseInstanceTypesEbsInfoTypeDef,
        "NetworkInfo": ClientDescribeInstanceTypesResponseInstanceTypesNetworkInfoTypeDef,
        "GpuInfo": ClientDescribeInstanceTypesResponseInstanceTypesGpuInfoTypeDef,
        "FpgaInfo": ClientDescribeInstanceTypesResponseInstanceTypesFpgaInfoTypeDef,
        "PlacementGroupInfo": ClientDescribeInstanceTypesResponseInstanceTypesPlacementGroupInfoTypeDef,
        "HibernationSupported": bool,
        "BurstablePerformanceSupported": bool,
        "DedicatedHostsSupported": bool,
        "AutoRecoverySupported": bool,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseInstanceTypesTypeDef(
    _ClientDescribeInstanceTypesResponseInstanceTypesTypeDef
):
    """
    - *(dict) --*

      Describes the instance type.
      - **InstanceType** *(string) --*

        The instance type. For more information, see `Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .
    """


_ClientDescribeInstanceTypesResponseTypeDef = TypedDict(
    "_ClientDescribeInstanceTypesResponseTypeDef",
    {
        "InstanceTypes": List[ClientDescribeInstanceTypesResponseInstanceTypesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInstanceTypesResponseTypeDef(_ClientDescribeInstanceTypesResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceTypes** *(list) --*

        The instance type. For more information, see `Instance Types
        <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the *Amazon
        Elastic Compute Cloud User Guide* .
        - *(dict) --*

          Describes the instance type.
          - **InstanceType** *(string) --*

            The instance type. For more information, see `Instance Types
            <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ in the
            *Amazon Elastic Compute Cloud User Guide* .
    """


_ClientDescribeInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeInstancesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeInstancesFiltersTypeDef(_ClientDescribeInstancesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInstancesResponseReservationsGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef",
    {
        "State": Literal["pending", "applied"],
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef",
    {
        "Association": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
        ],
        "Ipv6Addresses": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesStateTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesStateTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesStateTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsInstancesTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": ClientDescribeInstancesResponseReservationsInstancesMonitoringTypeDef,
        "Placement": ClientDescribeInstancesResponseReservationsInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[
            ClientDescribeInstancesResponseReservationsInstancesProductCodesTypeDef
        ],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": ClientDescribeInstancesResponseReservationsInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": Literal["i386", "x86_64", "arm64"],
        "BlockDeviceMappings": List[
            ClientDescribeInstancesResponseReservationsInstancesBlockDeviceMappingsTypeDef
        ],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": Literal["ovm", "xen"],
        "IamInstanceProfile": ClientDescribeInstancesResponseReservationsInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": Literal["spot", "scheduled"],
        "ElasticGpuAssociations": List[
            ClientDescribeInstancesResponseReservationsInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            ClientDescribeInstancesResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientDescribeInstancesResponseReservationsInstancesNetworkInterfacesTypeDef
        ],
        "RootDeviceName": str,
        "RootDeviceType": Literal["ebs", "instance-store"],
        "SecurityGroups": List[
            ClientDescribeInstancesResponseReservationsInstancesSecurityGroupsTypeDef
        ],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": ClientDescribeInstancesResponseReservationsInstancesStateReasonTypeDef,
        "Tags": List[ClientDescribeInstancesResponseReservationsInstancesTagsTypeDef],
        "VirtualizationType": Literal["hvm", "paravirtual"],
        "CpuOptions": ClientDescribeInstancesResponseReservationsInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": ClientDescribeInstancesResponseReservationsInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": ClientDescribeInstancesResponseReservationsInstancesHibernationOptionsTypeDef,
        "Licenses": List[ClientDescribeInstancesResponseReservationsInstancesLicensesTypeDef],
        "MetadataOptions": ClientDescribeInstancesResponseReservationsInstancesMetadataOptionsTypeDef,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsInstancesTypeDef(
    _ClientDescribeInstancesResponseReservationsInstancesTypeDef
):
    pass


_ClientDescribeInstancesResponseReservationsTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseReservationsTypeDef",
    {
        "Groups": List[ClientDescribeInstancesResponseReservationsGroupsTypeDef],
        "Instances": List[ClientDescribeInstancesResponseReservationsInstancesTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class ClientDescribeInstancesResponseReservationsTypeDef(
    _ClientDescribeInstancesResponseReservationsTypeDef
):
    """
    - *(dict) --*

      Describes a reservation.
      - **Groups** *(list) --*

        [EC2-Classic only] The security groups.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_ClientDescribeInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeInstancesResponseTypeDef",
    {"Reservations": List[ClientDescribeInstancesResponseReservationsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeInstancesResponseTypeDef(_ClientDescribeInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **Reservations** *(list) --*

        Information about the reservations.
        - *(dict) --*

          Describes a reservation.
          - **Groups** *(list) --*

            [EC2-Classic only] The security groups.
            - *(dict) --*

              Describes a security group.
              - **GroupName** *(string) --*

                The name of the security group.
    """


_ClientDescribeInternetGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeInternetGatewaysFiltersTypeDef(_ClientDescribeInternetGatewaysFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes the attachment of a VPC to an internet gateway or an egress-only internet gateway.
      - **State** *(string) --*

        The current state of the attachment. For an internet gateway, the state is ``available``
        when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef
):
    pass


_ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef",
    {
        "Attachments": List[
            ClientDescribeInternetGatewaysResponseInternetGatewaysAttachmentsTypeDef
        ],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[ClientDescribeInternetGatewaysResponseInternetGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef(
    _ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes an internet gateway.
      - **Attachments** *(list) --*

        Any VPCs attached to the internet gateway.
        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.
          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is ``available``
            when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeInternetGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeInternetGatewaysResponseTypeDef",
    {
        "InternetGateways": List[ClientDescribeInternetGatewaysResponseInternetGatewaysTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeInternetGatewaysResponseTypeDef(_ClientDescribeInternetGatewaysResponseTypeDef):
    """
    - *(dict) --*

      - **InternetGateways** *(list) --*

        Information about one or more internet gateways.
        - *(dict) --*

          Describes an internet gateway.
          - **Attachments** *(list) --*

            Any VPCs attached to the internet gateway.
            - *(dict) --*

              Describes the attachment of a VPC to an internet gateway or an egress-only internet
              gateway.
              - **State** *(string) --*

                The current state of the attachment. For an internet gateway, the state is
                ``available`` when attached to a VPC; otherwise, this value is not returned.
    """


_ClientDescribeKeyPairsFiltersTypeDef = TypedDict(
    "_ClientDescribeKeyPairsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeKeyPairsFiltersTypeDef(_ClientDescribeKeyPairsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeKeyPairsResponseKeyPairsTypeDef = TypedDict(
    "_ClientDescribeKeyPairsResponseKeyPairsTypeDef",
    {"KeyFingerprint": str, "KeyName": str},
    total=False,
)


class ClientDescribeKeyPairsResponseKeyPairsTypeDef(_ClientDescribeKeyPairsResponseKeyPairsTypeDef):
    """
    - *(dict) --*

      Describes a key pair.
      - **KeyFingerprint** *(string) --*

        If you used  CreateKeyPair to create the key pair, this is the SHA-1 digest of the DER
        encoded private key. If you used  ImportKeyPair to provide AWS the public key, this is the
        MD5 public key fingerprint as specified in section 4 of RFC4716.
    """


_ClientDescribeKeyPairsResponseTypeDef = TypedDict(
    "_ClientDescribeKeyPairsResponseTypeDef",
    {"KeyPairs": List[ClientDescribeKeyPairsResponseKeyPairsTypeDef]},
    total=False,
)


class ClientDescribeKeyPairsResponseTypeDef(_ClientDescribeKeyPairsResponseTypeDef):
    """
    - *(dict) --*

      - **KeyPairs** *(list) --*

        Information about the key pairs.
        - *(dict) --*

          Describes a key pair.
          - **KeyFingerprint** *(string) --*

            If you used  CreateKeyPair to create the key pair, this is the SHA-1 digest of the DER
            encoded private key. If you used  ImportKeyPair to provide AWS the public key, this is
            the MD5 public key fingerprint as specified in section 4 of RFC4716.
    """


_ClientDescribeLaunchTemplateVersionsFiltersTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsFiltersTypeDef(
    _ClientDescribeLaunchTemplateVersionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef
):
    pass


_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef
):
    """
    - *(dict) --*

      Describes a launch template version.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientDescribeLaunchTemplateVersionsResponseTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplateVersionsResponseTypeDef",
    {
        "LaunchTemplateVersions": List[
            ClientDescribeLaunchTemplateVersionsResponseLaunchTemplateVersionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplateVersionsResponseTypeDef(
    _ClientDescribeLaunchTemplateVersionsResponseTypeDef
):
    """
    - *(dict) --*

      - **LaunchTemplateVersions** *(list) --*

        Information about the launch template versions.
        - *(dict) --*

          Describes a launch template version.
          - **LaunchTemplateId** *(string) --*

            The ID of the launch template.
    """


_ClientDescribeLaunchTemplatesFiltersTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeLaunchTemplatesFiltersTypeDef(_ClientDescribeLaunchTemplatesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef(
    _ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef
):
    pass


_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientDescribeLaunchTemplatesResponseLaunchTemplatesTagsTypeDef],
    },
    total=False,
)


class ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef(
    _ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef
):
    """
    - *(dict) --*

      Describes a launch template.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientDescribeLaunchTemplatesResponseTypeDef = TypedDict(
    "_ClientDescribeLaunchTemplatesResponseTypeDef",
    {
        "LaunchTemplates": List[ClientDescribeLaunchTemplatesResponseLaunchTemplatesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeLaunchTemplatesResponseTypeDef(_ClientDescribeLaunchTemplatesResponseTypeDef):
    """
    - *(dict) --*

      - **LaunchTemplates** *(list) --*

        Information about the launch templates.
        - *(dict) --*

          Describes a launch template.
          - **LaunchTemplateId** *(string) --*

            The ID of the launch template.
    """


_ClientDescribeMovingAddressesFiltersTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeMovingAddressesFiltersTypeDef(_ClientDescribeMovingAddressesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef",
    {"MoveStatus": Literal["movingToVpc", "restoringToClassic"], "PublicIp": str},
    total=False,
)


class ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef(
    _ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the status of a moving Elastic IP address.
      - **MoveStatus** *(string) --*

        The status of the Elastic IP address that's being moved to the EC2-VPC platform, or restored
        to the EC2-Classic platform.
    """


_ClientDescribeMovingAddressesResponseTypeDef = TypedDict(
    "_ClientDescribeMovingAddressesResponseTypeDef",
    {
        "MovingAddressStatuses": List[
            ClientDescribeMovingAddressesResponseMovingAddressStatusesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeMovingAddressesResponseTypeDef(_ClientDescribeMovingAddressesResponseTypeDef):
    """
    - *(dict) --*

      - **MovingAddressStatuses** *(list) --*

        The status for each Elastic IP address.
        - *(dict) --*

          Describes the status of a moving Elastic IP address.
          - **MoveStatus** *(string) --*

            The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
            restored to the EC2-Classic platform.
    """


_ClientDescribeNatGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeNatGatewaysFiltersTypeDef(_ClientDescribeNatGatewaysFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef
):
    pass


_ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef
):
    pass


_ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef
):
    pass


_ClientDescribeNatGatewaysResponseNatGatewaysTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseNatGatewaysTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            ClientDescribeNatGatewaysResponseNatGatewaysNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": ClientDescribeNatGatewaysResponseNatGatewaysProvisionedBandwidthTypeDef,
        "State": Literal["pending", "failed", "available", "deleting", "deleted"],
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[ClientDescribeNatGatewaysResponseNatGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeNatGatewaysResponseNatGatewaysTypeDef(
    _ClientDescribeNatGatewaysResponseNatGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a NAT gateway.
      - **CreateTime** *(datetime) --*

        The date and time the NAT gateway was created.
    """


_ClientDescribeNatGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeNatGatewaysResponseTypeDef",
    {"NatGateways": List[ClientDescribeNatGatewaysResponseNatGatewaysTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeNatGatewaysResponseTypeDef(_ClientDescribeNatGatewaysResponseTypeDef):
    """
    - *(dict) --*

      - **NatGateways** *(list) --*

        Information about the NAT gateways.
        - *(dict) --*

          Describes a NAT gateway.
          - **CreateTime** *(datetime) --*

            The date and time the NAT gateway was created.
    """


_ClientDescribeNetworkAclsFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeNetworkAclsFiltersTypeDef(_ClientDescribeNetworkAclsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a network ACL and a subnet.
      - **NetworkAclAssociationId** *(string) --*

        The ID of the association between a network ACL and a subnet.
    """


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef
):
    pass


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef
):
    pass


_ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": ClientDescribeNetworkAclsResponseNetworkAclsEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": ClientDescribeNetworkAclsResponseNetworkAclsEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": Literal["allow", "deny"],
        "RuleNumber": int,
    },
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef
):
    pass


_ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef
):
    pass


_ClientDescribeNetworkAclsResponseNetworkAclsTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseNetworkAclsTypeDef",
    {
        "Associations": List[ClientDescribeNetworkAclsResponseNetworkAclsAssociationsTypeDef],
        "Entries": List[ClientDescribeNetworkAclsResponseNetworkAclsEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[ClientDescribeNetworkAclsResponseNetworkAclsTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeNetworkAclsResponseNetworkAclsTypeDef(
    _ClientDescribeNetworkAclsResponseNetworkAclsTypeDef
):
    """
    - *(dict) --*

      Describes a network ACL.
      - **Associations** *(list) --*

        Any associations between the network ACL and one or more subnets
        - *(dict) --*

          Describes an association between a network ACL and a subnet.
          - **NetworkAclAssociationId** *(string) --*

            The ID of the association between a network ACL and a subnet.
    """


_ClientDescribeNetworkAclsResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkAclsResponseTypeDef",
    {"NetworkAcls": List[ClientDescribeNetworkAclsResponseNetworkAclsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeNetworkAclsResponseTypeDef(_ClientDescribeNetworkAclsResponseTypeDef):
    """
    - *(dict) --*

      - **NetworkAcls** *(list) --*

        Information about one or more network ACLs.
        - *(dict) --*

          Describes a network ACL.
          - **Associations** *(list) --*

            Any associations between the network ACL and one or more subnets
            - *(dict) --*

              Describes an association between a network ACL and a subnet.
              - **NetworkAclAssociationId** *(string) --*

                The ID of the association between a network ACL and a subnet.
    """


_ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef
):
    """
    - **Attachment** *(dict) --*

      The attachment (if any) of the network interface.
      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.
    """


_ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef
):
    pass


_ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef
):
    pass


_ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef",
    {"Value": bool},
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef
):
    pass


_ClientDescribeNetworkInterfaceAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfaceAttributeResponseTypeDef",
    {
        "Attachment": ClientDescribeNetworkInterfaceAttributeResponseAttachmentTypeDef,
        "Description": ClientDescribeNetworkInterfaceAttributeResponseDescriptionTypeDef,
        "Groups": List[ClientDescribeNetworkInterfaceAttributeResponseGroupsTypeDef],
        "NetworkInterfaceId": str,
        "SourceDestCheck": ClientDescribeNetworkInterfaceAttributeResponseSourceDestCheckTypeDef,
    },
    total=False,
)


class ClientDescribeNetworkInterfaceAttributeResponseTypeDef(
    _ClientDescribeNetworkInterfaceAttributeResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeNetworkInterfaceAttribute.
      - **Attachment** *(dict) --*

        The attachment (if any) of the network interface.
        - **AttachTime** *(datetime) --*

          The timestamp indicating when the attachment initiated.
    """


_ClientDescribeNetworkInterfacePermissionsFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsFiltersTypeDef(
    _ClientDescribeNetworkInterfacePermissionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    {"State": Literal["pending", "granted", "revoking", "revoked"], "StatusMessage": str},
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef
):
    pass


_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": Literal["INSTANCE-ATTACH", "EIP-ASSOCIATE"],
        "PermissionState": ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsPermissionStateTypeDef,
    },
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a permission for a network interface.
      - **NetworkInterfacePermissionId** *(string) --*

        The ID of the network interface permission.
    """


_ClientDescribeNetworkInterfacePermissionsResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacePermissionsResponseTypeDef",
    {
        "NetworkInterfacePermissions": List[
            ClientDescribeNetworkInterfacePermissionsResponseNetworkInterfacePermissionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacePermissionsResponseTypeDef(
    _ClientDescribeNetworkInterfacePermissionsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output for DescribeNetworkInterfacePermissions.
      - **NetworkInterfacePermissions** *(list) --*

        The network interface permissions.
        - *(dict) --*

          Describes a permission for a network interface.
          - **NetworkInterfacePermissionId** *(string) --*

            The ID of the network interface permission.
    """


_ClientDescribeNetworkInterfacesFiltersTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeNetworkInterfacesFiltersTypeDef(_ClientDescribeNetworkInterfacesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef
):
    """
    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.
      - **AllocationId** *(string) --*

        The allocation ID.
    """


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef
):
    pass


_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef",
    {
        "Association": ClientDescribeNetworkInterfacesResponseNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientDescribeNetworkInterfacesResponseNetworkInterfacesAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[ClientDescribeNetworkInterfacesResponseNetworkInterfacesGroupsTypeDef],
        "InterfaceType": Literal["interface", "natGateway", "efa"],
        "Ipv6Addresses": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeNetworkInterfacesResponseNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "TagSet": List[ClientDescribeNetworkInterfacesResponseNetworkInterfacesTagSetTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef(
    _ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef
):
    """
    - *(dict) --*

      Describes a network interface.
      - **Association** *(dict) --*

        The association information for an Elastic IP address (IPv4) associated with the network
        interface.
        - **AllocationId** *(string) --*

          The allocation ID.
    """


_ClientDescribeNetworkInterfacesResponseTypeDef = TypedDict(
    "_ClientDescribeNetworkInterfacesResponseTypeDef",
    {
        "NetworkInterfaces": List[ClientDescribeNetworkInterfacesResponseNetworkInterfacesTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeNetworkInterfacesResponseTypeDef(
    _ClientDescribeNetworkInterfacesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeNetworkInterfaces.
      - **NetworkInterfaces** *(list) --*

        Information about one or more network interfaces.
        - *(dict) --*

          Describes a network interface.
          - **Association** *(dict) --*

            The association information for an Elastic IP address (IPv4) associated with the network
            interface.
            - **AllocationId** *(string) --*

              The allocation ID.
    """


_ClientDescribePlacementGroupsFiltersTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribePlacementGroupsFiltersTypeDef(_ClientDescribePlacementGroupsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef",
    {
        "GroupName": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Strategy": Literal["cluster", "spread", "partition"],
        "PartitionCount": int,
    },
    total=False,
)


class ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef(
    _ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a placement group.
      - **GroupName** *(string) --*

        The name of the placement group.
    """


_ClientDescribePlacementGroupsResponseTypeDef = TypedDict(
    "_ClientDescribePlacementGroupsResponseTypeDef",
    {"PlacementGroups": List[ClientDescribePlacementGroupsResponsePlacementGroupsTypeDef]},
    total=False,
)


class ClientDescribePlacementGroupsResponseTypeDef(_ClientDescribePlacementGroupsResponseTypeDef):
    """
    - *(dict) --*

      - **PlacementGroups** *(list) --*

        Information about the placement groups.
        - *(dict) --*

          Describes a placement group.
          - **GroupName** *(string) --*

            The name of the placement group.
    """


_ClientDescribePrefixListsFiltersTypeDef = TypedDict(
    "_ClientDescribePrefixListsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribePrefixListsFiltersTypeDef(_ClientDescribePrefixListsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribePrefixListsResponsePrefixListsTypeDef = TypedDict(
    "_ClientDescribePrefixListsResponsePrefixListsTypeDef",
    {"Cidrs": List[str], "PrefixListId": str, "PrefixListName": str},
    total=False,
)


class ClientDescribePrefixListsResponsePrefixListsTypeDef(
    _ClientDescribePrefixListsResponsePrefixListsTypeDef
):
    pass


_ClientDescribePrefixListsResponseTypeDef = TypedDict(
    "_ClientDescribePrefixListsResponseTypeDef",
    {"NextToken": str, "PrefixLists": List[ClientDescribePrefixListsResponsePrefixListsTypeDef]},
    total=False,
)


class ClientDescribePrefixListsResponseTypeDef(_ClientDescribePrefixListsResponseTypeDef):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef(
    _ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef
):
    pass


_ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef",
    {
        "Arn": str,
        "Statuses": List[ClientDescribePrincipalIdFormatResponsePrincipalsStatusesTypeDef],
    },
    total=False,
)


class ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef(
    _ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef
):
    """
    - *(dict) --*

      PrincipalIdFormat description
      - **Arn** *(string) --*

        PrincipalIdFormatARN description
    """


_ClientDescribePrincipalIdFormatResponseTypeDef = TypedDict(
    "_ClientDescribePrincipalIdFormatResponseTypeDef",
    {
        "Principals": List[ClientDescribePrincipalIdFormatResponsePrincipalsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribePrincipalIdFormatResponseTypeDef(
    _ClientDescribePrincipalIdFormatResponseTypeDef
):
    """
    - *(dict) --*

      - **Principals** *(list) --*

        Information about the ID format settings for the ARN.
        - *(dict) --*

          PrincipalIdFormat description
          - **Arn** *(string) --*

            PrincipalIdFormatARN description
    """


_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    {"FirstAddress": str, "LastAddress": str, "AddressCount": int, "AvailableAddressCount": int},
    total=False,
)


class ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef(
    _ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef
):
    pass


_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolAddressRanges": List[
            ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsPoolAddressRangesTypeDef
        ],
        "TotalAddressCount": int,
        "TotalAvailableAddressCount": int,
    },
    total=False,
)


class ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef(
    _ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef
):
    """
    - *(dict) --*

      Describes an address pool.
      - **PoolId** *(string) --*

        The ID of the IPv4 address pool.
    """


_ClientDescribePublicIpv4PoolsResponseTypeDef = TypedDict(
    "_ClientDescribePublicIpv4PoolsResponseTypeDef",
    {
        "PublicIpv4Pools": List[ClientDescribePublicIpv4PoolsResponsePublicIpv4PoolsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribePublicIpv4PoolsResponseTypeDef(_ClientDescribePublicIpv4PoolsResponseTypeDef):
    """
    - *(dict) --*

      - **PublicIpv4Pools** *(list) --*

        Information about the address pools.
        - *(dict) --*

          Describes an address pool.
          - **PoolId** *(string) --*

            The ID of the IPv4 address pool.
    """


_ClientDescribeRegionsFiltersTypeDef = TypedDict(
    "_ClientDescribeRegionsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeRegionsFiltersTypeDef(_ClientDescribeRegionsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeRegionsResponseRegionsTypeDef = TypedDict(
    "_ClientDescribeRegionsResponseRegionsTypeDef",
    {"Endpoint": str, "RegionName": str, "OptInStatus": str},
    total=False,
)


class ClientDescribeRegionsResponseRegionsTypeDef(_ClientDescribeRegionsResponseRegionsTypeDef):
    """
    - *(dict) --*

      Describes a Region.
      - **Endpoint** *(string) --*

        The Region service endpoint.
    """


_ClientDescribeRegionsResponseTypeDef = TypedDict(
    "_ClientDescribeRegionsResponseTypeDef",
    {"Regions": List[ClientDescribeRegionsResponseRegionsTypeDef]},
    total=False,
)


class ClientDescribeRegionsResponseTypeDef(_ClientDescribeRegionsResponseTypeDef):
    """
    - *(dict) --*

      - **Regions** *(list) --*

        Information about the Regions.
        - *(dict) --*

          Describes a Region.
          - **Endpoint** *(string) --*

            The Region service endpoint.
    """


_ClientDescribeReservedInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesFiltersTypeDef(_ClientDescribeReservedInstancesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeReservedInstancesListingsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesListingsFiltersTypeDef(
    _ClientDescribeReservedInstancesListingsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef",
    {"InstanceCount": int, "State": Literal["available", "sold", "cancelled", "pending"]},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef
):
    pass


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef",
    {"Active": bool, "CurrencyCode": str, "Price": float, "Term": int},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef
):
    pass


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef
):
    pass


_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "InstanceCounts": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsInstanceCountsTypeDef
        ],
        "PriceSchedules": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsPriceSchedulesTypeDef
        ],
        "ReservedInstancesId": str,
        "ReservedInstancesListingId": str,
        "Status": Literal["active", "pending", "cancelled", "closed"],
        "StatusMessage": str,
        "Tags": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTagsTypeDef
        ],
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef(
    _ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance listing.
      - **ClientToken** *(string) --*

        A unique, case-sensitive key supplied by the client to ensure that the request is
        idempotent. For more information, see `Ensuring Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientDescribeReservedInstancesListingsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesListingsResponseTypeDef",
    {
        "ReservedInstancesListings": List[
            ClientDescribeReservedInstancesListingsResponseReservedInstancesListingsTypeDef
        ]
    },
    total=False,
)


class ClientDescribeReservedInstancesListingsResponseTypeDef(
    _ClientDescribeReservedInstancesListingsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeReservedInstancesListings.
      - **ReservedInstancesListings** *(list) --*

        Information about the Reserved Instance listing.
        - *(dict) --*

          Describes a Reserved Instance listing.
          - **ClientToken** *(string) --*

            A unique, case-sensitive key supplied by the client to ensure that the request is
            idempotent. For more information, see `Ensuring Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .
    """


_ClientDescribeReservedInstancesModificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesModificationsFiltersTypeDef(
    _ClientDescribeReservedInstancesModificationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
        "Scope": Literal["Availability Zone", "Region"],
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef
):
    pass


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef",
    {
        "ReservedInstancesId": str,
        "TargetConfiguration": ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef,
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef
):
    pass


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
):
    pass


_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "EffectiveDate": datetime,
        "ModificationResults": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsModificationResultsTypeDef
        ],
        "ReservedInstancesIds": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
        ],
        "ReservedInstancesModificationId": str,
        "Status": str,
        "StatusMessage": str,
        "UpdateDate": datetime,
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef
):
    pass


_ClientDescribeReservedInstancesModificationsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesModificationsResponseTypeDef",
    {
        "NextToken": str,
        "ReservedInstancesModifications": List[
            ClientDescribeReservedInstancesModificationsResponseReservedInstancesModificationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeReservedInstancesModificationsResponseTypeDef(
    _ClientDescribeReservedInstancesModificationsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeReservedInstancesModifications.
      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeReservedInstancesOfferingsFiltersTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsFiltersTypeDef(
    _ClientDescribeReservedInstancesOfferingsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    {"Count": int, "Price": float},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef
):
    pass


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef
):
    pass


_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "FixedPrice": Any,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "ReservedInstancesOfferingId": str,
        "UsagePrice": Any,
        "CurrencyCode": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Marketplace": bool,
        "OfferingClass": Literal["standard", "convertible"],
        "OfferingType": Literal[
            "Heavy Utilization",
            "Medium Utilization",
            "Light Utilization",
            "No Upfront",
            "Partial Upfront",
            "All Upfront",
        ],
        "PricingDetails": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsPricingDetailsTypeDef
        ],
        "RecurringCharges": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsRecurringChargesTypeDef
        ],
        "Scope": Literal["Availability Zone", "Region"],
    },
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance offering.
      - **AvailabilityZone** *(string) --*

        The Availability Zone in which the Reserved Instance can be used.
    """


_ClientDescribeReservedInstancesOfferingsResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesOfferingsResponseTypeDef",
    {
        "ReservedInstancesOfferings": List[
            ClientDescribeReservedInstancesOfferingsResponseReservedInstancesOfferingsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeReservedInstancesOfferingsResponseTypeDef(
    _ClientDescribeReservedInstancesOfferingsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeReservedInstancesOfferings.
      - **ReservedInstancesOfferings** *(list) --*

        A list of Reserved Instances offerings.
        - *(dict) --*

          Describes a Reserved Instance offering.
          - **AvailabilityZone** *(string) --*

            The Availability Zone in which the Reserved Instance can be used.
    """


_ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef
):
    pass


_ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef
):
    pass


_ClientDescribeReservedInstancesResponseReservedInstancesTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseReservedInstancesTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "End": datetime,
        "FixedPrice": Any,
        "InstanceCount": int,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "ReservedInstancesId": str,
        "Start": datetime,
        "State": Literal[
            "payment-pending", "active", "payment-failed", "retired", "queued", "queued-deleted"
        ],
        "UsagePrice": Any,
        "CurrencyCode": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "OfferingClass": Literal["standard", "convertible"],
        "OfferingType": Literal[
            "Heavy Utilization",
            "Medium Utilization",
            "Light Utilization",
            "No Upfront",
            "Partial Upfront",
            "All Upfront",
        ],
        "RecurringCharges": List[
            ClientDescribeReservedInstancesResponseReservedInstancesRecurringChargesTypeDef
        ],
        "Scope": Literal["Availability Zone", "Region"],
        "Tags": List[ClientDescribeReservedInstancesResponseReservedInstancesTagsTypeDef],
    },
    total=False,
)


class ClientDescribeReservedInstancesResponseReservedInstancesTypeDef(
    _ClientDescribeReservedInstancesResponseReservedInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone in which the Reserved Instance can be used.
    """


_ClientDescribeReservedInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeReservedInstancesResponseTypeDef",
    {"ReservedInstances": List[ClientDescribeReservedInstancesResponseReservedInstancesTypeDef]},
    total=False,
)


class ClientDescribeReservedInstancesResponseTypeDef(
    _ClientDescribeReservedInstancesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output for DescribeReservedInstances.
      - **ReservedInstances** *(list) --*

        A list of Reserved Instances.
        - *(dict) --*

          Describes a Reserved Instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone in which the Reserved Instance can be used.
    """


_ClientDescribeRouteTablesFiltersTypeDef = TypedDict(
    "_ClientDescribeRouteTablesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeRouteTablesFiltersTypeDef(_ClientDescribeRouteTablesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef",
    {"Main": bool, "RouteTableAssociationId": str, "RouteTableId": str, "SubnetId": str},
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a route table and a subnet.
      - **Main** *(boolean) --*

        Indicates whether this is the main route table.
    """


_ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef
):
    pass


_ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": Literal["CreateRouteTable", "CreateRoute", "EnableVgwRoutePropagation"],
        "State": Literal["active", "blackhole"],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef
):
    pass


_ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef
):
    pass


_ClientDescribeRouteTablesResponseRouteTablesTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseRouteTablesTypeDef",
    {
        "Associations": List[ClientDescribeRouteTablesResponseRouteTablesAssociationsTypeDef],
        "PropagatingVgws": List[ClientDescribeRouteTablesResponseRouteTablesPropagatingVgwsTypeDef],
        "RouteTableId": str,
        "Routes": List[ClientDescribeRouteTablesResponseRouteTablesRoutesTypeDef],
        "Tags": List[ClientDescribeRouteTablesResponseRouteTablesTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeRouteTablesResponseRouteTablesTypeDef(
    _ClientDescribeRouteTablesResponseRouteTablesTypeDef
):
    """
    - *(dict) --*

      Describes a route table.
      - **Associations** *(list) --*

        The associations between the route table and one or more subnets.
        - *(dict) --*

          Describes an association between a route table and a subnet.
          - **Main** *(boolean) --*

            Indicates whether this is the main route table.
    """


_ClientDescribeRouteTablesResponseTypeDef = TypedDict(
    "_ClientDescribeRouteTablesResponseTypeDef",
    {"RouteTables": List[ClientDescribeRouteTablesResponseRouteTablesTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeRouteTablesResponseTypeDef(_ClientDescribeRouteTablesResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeRouteTables.
      - **RouteTables** *(list) --*

        Information about one or more route tables.
        - *(dict) --*

          Describes a route table.
          - **Associations** *(list) --*

            The associations between the route table and one or more subnets.
            - *(dict) --*

              Describes an association between a route table and a subnet.
              - **Main** *(boolean) --*

                Indicates whether this is the main route table.
    """


_ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_RequiredClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_RequiredClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime},
)
_OptionalClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_OptionalClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef",
    {"LatestTime": datetime},
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef(
    _RequiredClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef,
    _OptionalClientDescribeScheduledInstanceAvailabilityFirstSlotStartTimeRangeTypeDef,
):
    """
    The time period for the first schedule to start.
    - **EarliestTime** *(datetime) --***[REQUIRED]**

      The earliest date and time, in UTC, for the Scheduled Instance to start.
    """


_ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDays": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityRecurrenceTypeDef
):
    """
    The schedule recurrence.
    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).
    """


_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef
):
    pass


_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailableInstanceCount": int,
        "FirstSlotStartTime": datetime,
        "HourlyPrice": str,
        "InstanceType": str,
        "MaxTermDurationInDays": int,
        "MinTermDurationInDays": int,
        "NetworkPlatform": str,
        "Platform": str,
        "PurchaseToken": str,
        "Recurrence": ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef,
        "SlotDurationInHours": int,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef
):
    pass


_ClientDescribeScheduledInstanceAvailabilityResponseTypeDef = TypedDict(
    "_ClientDescribeScheduledInstanceAvailabilityResponseTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceAvailabilitySet": List[
            ClientDescribeScheduledInstanceAvailabilityResponseScheduledInstanceAvailabilitySetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeScheduledInstanceAvailabilityResponseTypeDef(
    _ClientDescribeScheduledInstanceAvailabilityResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeScheduledInstanceAvailability.
      - **NextToken** *(string) --*

        The token required to retrieve the next set of results. This value is ``null`` when there
        are no more results to return.
    """


_ClientDescribeScheduledInstancesFiltersTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeScheduledInstancesFiltersTypeDef(
    _ClientDescribeScheduledInstancesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef(
    _ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef
):
    pass


_ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": ClientDescribeScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef(
    _ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef
):
    pass


_ClientDescribeScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesResponseTypeDef",
    {
        "NextToken": str,
        "ScheduledInstanceSet": List[
            ClientDescribeScheduledInstancesResponseScheduledInstanceSetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeScheduledInstancesResponseTypeDef(
    _ClientDescribeScheduledInstancesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeScheduledInstances.
      - **NextToken** *(string) --*

        The token required to retrieve the next set of results. This value is ``null`` when there
        are no more results to return.
    """


_ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef = TypedDict(
    "_ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
    total=False,
)


class ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef(
    _ClientDescribeScheduledInstancesSlotStartTimeRangeTypeDef
):
    """
    The time period for the first schedule to start.
    - **EarliestTime** *(datetime) --*

      The earliest date and time, in UTC, for the Scheduled Instance to start.
    """


_ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef",
    {"GroupId": str, "ReferencingVpcId": str, "VpcPeeringConnectionId": str},
    total=False,
)


class ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef(
    _ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef
):
    """
    - *(dict) --*

      Describes a VPC with a security group that references your security group.
      - **GroupId** *(string) --*

        The ID of your security group.
    """


_ClientDescribeSecurityGroupReferencesResponseTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupReferencesResponseTypeDef",
    {
        "SecurityGroupReferenceSet": List[
            ClientDescribeSecurityGroupReferencesResponseSecurityGroupReferenceSetTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSecurityGroupReferencesResponseTypeDef(
    _ClientDescribeSecurityGroupReferencesResponseTypeDef
):
    """
    - *(dict) --*

      - **SecurityGroupReferenceSet** *(list) --*

        Information about the VPCs with the referencing security groups.
        - *(dict) --*

          Describes a VPC with a security group that references your security group.
          - **GroupId** *(string) --*

            The ID of your security group.
    """


_ClientDescribeSecurityGroupsFiltersTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeSecurityGroupsFiltersTypeDef(_ClientDescribeSecurityGroupsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef
):
    pass


_ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef",
    {
        "Description": str,
        "GroupName": str,
        "IpPermissions": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsTypeDef
        ],
        "OwnerId": str,
        "GroupId": str,
        "IpPermissionsEgress": List[
            ClientDescribeSecurityGroupsResponseSecurityGroupsIpPermissionsEgressTypeDef
        ],
        "Tags": List[ClientDescribeSecurityGroupsResponseSecurityGroupsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef(
    _ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group
      - **Description** *(string) --*

        A description of the security group.
    """


_ClientDescribeSecurityGroupsResponseTypeDef = TypedDict(
    "_ClientDescribeSecurityGroupsResponseTypeDef",
    {
        "SecurityGroups": List[ClientDescribeSecurityGroupsResponseSecurityGroupsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeSecurityGroupsResponseTypeDef(_ClientDescribeSecurityGroupsResponseTypeDef):
    """
    - *(dict) --*

      - **SecurityGroups** *(list) --*

        Information about the security groups.
        - *(dict) --*

          Describes a security group
          - **Description** *(string) --*

            A description of the security group.
    """


_ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef(
    _ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef
):
    """
    - *(dict) --*

      Describes the user or group to be added or removed from the list of create volume permissions
      for a volume.
      - **Group** *(string) --*

        The group to be added or removed. The possible value is ``all`` .
    """


_ClientDescribeSnapshotAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeSnapshotAttributeResponseProductCodesTypeDef(
    _ClientDescribeSnapshotAttributeResponseProductCodesTypeDef
):
    pass


_ClientDescribeSnapshotAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeSnapshotAttributeResponseTypeDef",
    {
        "CreateVolumePermissions": List[
            ClientDescribeSnapshotAttributeResponseCreateVolumePermissionsTypeDef
        ],
        "ProductCodes": List[ClientDescribeSnapshotAttributeResponseProductCodesTypeDef],
        "SnapshotId": str,
    },
    total=False,
)


class ClientDescribeSnapshotAttributeResponseTypeDef(
    _ClientDescribeSnapshotAttributeResponseTypeDef
):
    """
    - *(dict) --*

      - **CreateVolumePermissions** *(list) --*

        The users and groups that have the permissions for creating volumes from the snapshot.
        - *(dict) --*

          Describes the user or group to be added or removed from the list of create volume
          permissions for a volume.
          - **Group** *(string) --*

            The group to be added or removed. The possible value is ``all`` .
    """


_ClientDescribeSnapshotsFiltersTypeDef = TypedDict(
    "_ClientDescribeSnapshotsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeSnapshotsFiltersTypeDef(_ClientDescribeSnapshotsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef(
    _ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef
):
    pass


_ClientDescribeSnapshotsResponseSnapshotsTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseSnapshotsTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": Literal["pending", "completed", "error"],
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[ClientDescribeSnapshotsResponseSnapshotsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeSnapshotsResponseSnapshotsTypeDef(
    _ClientDescribeSnapshotsResponseSnapshotsTypeDef
):
    """
    - *(dict) --*

      Describes a snapshot.
      - **DataEncryptionKeyId** *(string) --*

        The data encryption key identifier for the snapshot. This value is a unique identifier that
        corresponds to the data encryption key that was used to encrypt the original volume or
        snapshot copy. Because data encryption keys are inherited by volumes created from snapshots,
        and vice versa, if snapshots share the same data encryption key identifier, then they belong
        to the same volume/snapshot lineage. This parameter is only returned by  DescribeSnapshots .
    """


_ClientDescribeSnapshotsResponseTypeDef = TypedDict(
    "_ClientDescribeSnapshotsResponseTypeDef",
    {"Snapshots": List[ClientDescribeSnapshotsResponseSnapshotsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeSnapshotsResponseTypeDef(_ClientDescribeSnapshotsResponseTypeDef):
    """
    - *(dict) --*

      - **Snapshots** *(list) --*

        Information about the snapshots.
        - *(dict) --*

          Describes a snapshot.
          - **DataEncryptionKeyId** *(string) --*

            The data encryption key identifier for the snapshot. This value is a unique identifier
            that corresponds to the data encryption key that was used to encrypt the original volume
            or snapshot copy. Because data encryption keys are inherited by volumes created from
            snapshots, and vice versa, if snapshots share the same data encryption key identifier,
            then they belong to the same volume/snapshot lineage. This parameter is only returned by
            DescribeSnapshots .
    """


_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef
):
    pass


_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef",
    {
        "Bucket": str,
        "Fault": ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionFaultTypeDef,
        "OwnerId": str,
        "Prefix": str,
        "State": Literal["Active", "Inactive"],
    },
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
):
    """
    - **SpotDatafeedSubscription** *(dict) --*

      The Spot Instance data feed subscription.
      - **Bucket** *(string) --*

        The Amazon S3 bucket where the Spot Instance data feed is located.
    """


_ClientDescribeSpotDatafeedSubscriptionResponseTypeDef = TypedDict(
    "_ClientDescribeSpotDatafeedSubscriptionResponseTypeDef",
    {
        "SpotDatafeedSubscription": ClientDescribeSpotDatafeedSubscriptionResponseSpotDatafeedSubscriptionTypeDef
    },
    total=False,
)


class ClientDescribeSpotDatafeedSubscriptionResponseTypeDef(
    _ClientDescribeSpotDatafeedSubscriptionResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotDatafeedSubscription.
      - **SpotDatafeedSubscription** *(dict) --*

        The Spot Instance data feed subscription.
        - **Bucket** *(string) --*

          The Amazon S3 bucket where the Spot Instance data feed is located.
    """


_ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": Literal["healthy", "unhealthy"],
    },
    total=False,
)


class ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef(
    _ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a running instance in a Spot Fleet.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientDescribeSpotFleetInstancesResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetInstancesResponseTypeDef",
    {
        "ActiveInstances": List[ClientDescribeSpotFleetInstancesResponseActiveInstancesTypeDef],
        "NextToken": str,
        "SpotFleetRequestId": str,
    },
    total=False,
)


class ClientDescribeSpotFleetInstancesResponseTypeDef(
    _ClientDescribeSpotFleetInstancesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotFleetInstances.
      - **ActiveInstances** *(list) --*

        The running instances. This list is refreshed periodically and might be out of date.
        - *(dict) --*

          Describes a running instance in a Spot Fleet.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef",
    {"EventDescription": str, "EventSubType": str, "InstanceId": str},
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef
):
    """
    - **EventInformation** *(dict) --*

      Information about the event.
      - **EventDescription** *(string) --*

        The description of the event.
    """


_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef",
    {
        "EventInformation": ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsEventInformationTypeDef,
        "EventType": Literal["instanceChange", "fleetRequestChange", "error", "information"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef
):
    """
    - *(dict) --*

      Describes an event in the history of the Spot Fleet request.
      - **EventInformation** *(dict) --*

        Information about the event.
        - **EventDescription** *(string) --*

          The description of the event.
    """


_ClientDescribeSpotFleetRequestHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestHistoryResponseTypeDef",
    {
        "HistoryRecords": List[ClientDescribeSpotFleetRequestHistoryResponseHistoryRecordsTypeDef],
        "LastEvaluatedTime": datetime,
        "NextToken": str,
        "SpotFleetRequestId": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestHistoryResponseTypeDef(
    _ClientDescribeSpotFleetRequestHistoryResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotFleetRequestHistory.
      - **HistoryRecords** *(list) --*

        Information about the events in the history of the Spot Fleet request.
        - *(dict) --*

          Describes an event in the history of the Spot Fleet request.
          - **EventInformation** *(dict) --*

            Information about the event.
            - **EventDescription** *(string) --*

              The description of the event.
    """


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": Literal["lowestPrice", "diversified", "capacityOptimized"],
        "OnDemandAllocationStrategy": Literal["lowestPrice", "prioritized"],
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": Literal["noTermination", "default"],
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": Literal["request", "maintain", "instant"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "LoadBalancersConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef",
    {
        "ActivityStatus": Literal[
            "error", "pending_fulfillment", "pending_termination", "fulfilled"
        ],
        "CreateTime": datetime,
        "SpotFleetRequestConfig": ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef,
        "SpotFleetRequestId": str,
        "SpotFleetRequestState": Literal[
            "submitted",
            "active",
            "cancelled",
            "failed",
            "cancelled_running",
            "cancelled_terminating",
            "modifying",
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef(
    _ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef
):
    pass


_ClientDescribeSpotFleetRequestsResponseTypeDef = TypedDict(
    "_ClientDescribeSpotFleetRequestsResponseTypeDef",
    {
        "NextToken": str,
        "SpotFleetRequestConfigs": List[
            ClientDescribeSpotFleetRequestsResponseSpotFleetRequestConfigsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeSpotFleetRequestsResponseTypeDef(
    _ClientDescribeSpotFleetRequestsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotFleetRequests.
      - **NextToken** *(string) --*

        The token required to retrieve the next set of results. This value is ``null`` when there
        are no more results to return.
    """


_ClientDescribeSpotInstanceRequestsFiltersTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeSpotInstanceRequestsFiltersTypeDef(
    _ClientDescribeSpotInstanceRequestsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef
):
    pass


_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": Literal["open", "active", "closed", "cancelled", "failed"],
        "Status": ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTagsTypeDef],
        "Type": Literal["one-time", "persistent"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef
):
    """
    - *(dict) --*

      Describes a Spot Instance request.
      - **ActualBlockHourlyPrice** *(string) --*

        If you specified a duration and your Spot Instance request was fulfilled, this is the fixed
        hourly price in effect for the Spot Instance while it runs.
    """


_ClientDescribeSpotInstanceRequestsResponseTypeDef = TypedDict(
    "_ClientDescribeSpotInstanceRequestsResponseTypeDef",
    {
        "SpotInstanceRequests": List[
            ClientDescribeSpotInstanceRequestsResponseSpotInstanceRequestsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeSpotInstanceRequestsResponseTypeDef(
    _ClientDescribeSpotInstanceRequestsResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotInstanceRequests.
      - **SpotInstanceRequests** *(list) --*

        One or more Spot Instance requests.
        - *(dict) --*

          Describes a Spot Instance request.
          - **ActualBlockHourlyPrice** *(string) --*

            If you specified a duration and your Spot Instance request was fulfilled, this is the
            fixed hourly price in effect for the Spot Instance while it runs.
    """


_ClientDescribeSpotPriceHistoryFiltersTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeSpotPriceHistoryFiltersTypeDef(_ClientDescribeSpotPriceHistoryFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "SpotPrice": str,
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef(
    _ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef
):
    pass


_ClientDescribeSpotPriceHistoryResponseTypeDef = TypedDict(
    "_ClientDescribeSpotPriceHistoryResponseTypeDef",
    {
        "NextToken": str,
        "SpotPriceHistory": List[ClientDescribeSpotPriceHistoryResponseSpotPriceHistoryTypeDef],
    },
    total=False,
)


class ClientDescribeSpotPriceHistoryResponseTypeDef(_ClientDescribeSpotPriceHistoryResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeSpotPriceHistory.
      - **NextToken** *(string) --*

        The token required to retrieve the next set of results. This value is null or an empty
        string when there are no more results to return.
    """


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
):
    pass


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
):
    pass


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
):
    pass


_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "StaleIpPermissions": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
        ],
        "StaleIpPermissionsEgress": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef
):
    pass


_ClientDescribeStaleSecurityGroupsResponseTypeDef = TypedDict(
    "_ClientDescribeStaleSecurityGroupsResponseTypeDef",
    {
        "NextToken": str,
        "StaleSecurityGroupSet": List[
            ClientDescribeStaleSecurityGroupsResponseStaleSecurityGroupSetTypeDef
        ],
    },
    total=False,
)


class ClientDescribeStaleSecurityGroupsResponseTypeDef(
    _ClientDescribeStaleSecurityGroupsResponseTypeDef
):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use when requesting the next set of items. If there are no additional items to
        return, the string is empty.
    """


_ClientDescribeSubnetsFiltersTypeDef = TypedDict(
    "_ClientDescribeSubnetsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeSubnetsFiltersTypeDef(_ClientDescribeSubnetsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef(
    _ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientDescribeSubnetsResponseSubnetsTagsTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeSubnetsResponseSubnetsTagsTypeDef(
    _ClientDescribeSubnetsResponseSubnetsTagsTypeDef
):
    pass


_ClientDescribeSubnetsResponseSubnetsTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseSubnetsTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": Literal["pending", "available"],
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            ClientDescribeSubnetsResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[ClientDescribeSubnetsResponseSubnetsTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class ClientDescribeSubnetsResponseSubnetsTypeDef(_ClientDescribeSubnetsResponseSubnetsTypeDef):
    """
    - *(dict) --*

      Describes a subnet.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.
    """


_ClientDescribeSubnetsResponseTypeDef = TypedDict(
    "_ClientDescribeSubnetsResponseTypeDef",
    {"Subnets": List[ClientDescribeSubnetsResponseSubnetsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeSubnetsResponseTypeDef(_ClientDescribeSubnetsResponseTypeDef):
    """
    - *(dict) --*

      - **Subnets** *(list) --*

        Information about one or more subnets.
        - *(dict) --*

          Describes a subnet.
          - **AvailabilityZone** *(string) --*

            The Availability Zone of the subnet.
    """


_ClientDescribeTagsFiltersTypeDef = TypedDict(
    "_ClientDescribeTagsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeTagsFiltersTypeDef(_ClientDescribeTagsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTagsResponseTagsTypeDef = TypedDict(
    "_ClientDescribeTagsResponseTagsTypeDef",
    {
        "Key": str,
        "ResourceId": str,
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Value": str,
    },
    total=False,
)


class ClientDescribeTagsResponseTagsTypeDef(_ClientDescribeTagsResponseTagsTypeDef):
    pass


_ClientDescribeTagsResponseTypeDef = TypedDict(
    "_ClientDescribeTagsResponseTypeDef",
    {"NextToken": str, "Tags": List[ClientDescribeTagsResponseTagsTypeDef]},
    total=False,
)


class ClientDescribeTagsResponseTypeDef(_ClientDescribeTagsResponseTypeDef):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeTrafficMirrorFiltersFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersFiltersTypeDef(
    _ClientDescribeTrafficMirrorFiltersFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef
):
    pass


_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTagsTypeDef],
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef
):
    """
    - *(dict) --*

      Describes the Traffic Mirror filter.
      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.
    """


_ClientDescribeTrafficMirrorFiltersResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorFiltersResponseTypeDef",
    {
        "TrafficMirrorFilters": List[
            ClientDescribeTrafficMirrorFiltersResponseTrafficMirrorFiltersTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorFiltersResponseTypeDef(
    _ClientDescribeTrafficMirrorFiltersResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilters** *(list) --*

        Information about one or more Traffic Mirror filters.
        - *(dict) --*

          Describes the Traffic Mirror filter.
          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter.
    """


_ClientDescribeTrafficMirrorSessionsFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorSessionsFiltersTypeDef(
    _ClientDescribeTrafficMirrorSessionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef
):
    pass


_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef
):
    """
    - *(dict) --*

      Describes a Traffic Mirror session.
      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.
    """


_ClientDescribeTrafficMirrorSessionsResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorSessionsResponseTypeDef",
    {
        "TrafficMirrorSessions": List[
            ClientDescribeTrafficMirrorSessionsResponseTrafficMirrorSessionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorSessionsResponseTypeDef(
    _ClientDescribeTrafficMirrorSessionsResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorSessions** *(list) --*

        Describes one or more Traffic Mirror sessions. By default, all Traffic Mirror sessions are
        described. Alternatively, you can filter the results.
        - *(dict) --*

          Describes a Traffic Mirror session.
          - **TrafficMirrorSessionId** *(string) --*

            The ID for the Traffic Mirror session.
    """


_ClientDescribeTrafficMirrorTargetsFiltersTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTrafficMirrorTargetsFiltersTypeDef(
    _ClientDescribeTrafficMirrorTargetsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef
):
    pass


_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": Literal["network-interface", "network-load-balancer"],
        "Description": str,
        "OwnerId": str,
        "Tags": List[ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef
):
    """
    - *(dict) --*

      Describes a Traffic Mirror target.
      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.
    """


_ClientDescribeTrafficMirrorTargetsResponseTypeDef = TypedDict(
    "_ClientDescribeTrafficMirrorTargetsResponseTypeDef",
    {
        "TrafficMirrorTargets": List[
            ClientDescribeTrafficMirrorTargetsResponseTrafficMirrorTargetsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTrafficMirrorTargetsResponseTypeDef(
    _ClientDescribeTrafficMirrorTargetsResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorTargets** *(list) --*

        Information about one or more Traffic Mirror targets.
        - *(dict) --*

          Describes a Traffic Mirror target.
          - **TrafficMirrorTargetId** *(string) --*

            The ID of the Traffic Mirror target.
    """


_ClientDescribeTransitGatewayAttachmentsFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsFiltersTypeDef(
    _ClientDescribeTransitGatewayAttachmentsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef
):
    pass


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef
):
    pass


_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "TransitGatewayOwnerId": str,
        "ResourceOwnerId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "ResourceId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "Association": ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsAssociationTypeDef,
        "CreationTime": datetime,
        "Tags": List[
            ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes an attachment between a resource and a transit gateway.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientDescribeTransitGatewayAttachmentsResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayAttachmentsResponseTypeDef",
    {
        "TransitGatewayAttachments": List[
            ClientDescribeTransitGatewayAttachmentsResponseTransitGatewayAttachmentsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayAttachmentsResponseTypeDef(
    _ClientDescribeTransitGatewayAttachmentsResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayAttachments** *(list) --*

        Information about the attachments.
        - *(dict) --*

          Describes an attachment between a resource and a transit gateway.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_ClientDescribeTransitGatewayRouteTablesFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesFiltersTypeDef(
    _ClientDescribeTransitGatewayRouteTablesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef
):
    pass


_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef
):
    """
    - *(dict) --*

      Describes a transit gateway route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_ClientDescribeTransitGatewayRouteTablesResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayRouteTablesResponseTypeDef",
    {
        "TransitGatewayRouteTables": List[
            ClientDescribeTransitGatewayRouteTablesResponseTransitGatewayRouteTablesTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayRouteTablesResponseTypeDef(
    _ClientDescribeTransitGatewayRouteTablesResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTables** *(list) --*

        Information about the transit gateway route tables.
        - *(dict) --*

          Describes a transit gateway route table.
          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the transit gateway route table.
    """


_ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef
):
    pass


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef
):
    pass


_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsOptionsTypeDef,
        "Tags": List[
            ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef",
    {
        "TransitGatewayVpcAttachments": List[
            ClientDescribeTransitGatewayVpcAttachmentsResponseTransitGatewayVpcAttachmentsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef(
    _ClientDescribeTransitGatewayVpcAttachmentsResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachments** *(list) --*

        Information about the VPC attachments.
        - *(dict) --*

          Describes a VPC attachment.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_ClientDescribeTransitGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeTransitGatewaysFiltersTypeDef(_ClientDescribeTransitGatewaysFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": Literal["enable", "disable"],
        "DefaultRouteTableAssociation": Literal["enable", "disable"],
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": Literal["enable", "disable"],
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": Literal["enable", "disable"],
        "DnsSupport": Literal["enable", "disable"],
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef
):
    pass


_ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef
):
    pass


_ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": Literal["pending", "available", "modifying", "deleting", "deleted"],
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": ClientDescribeTransitGatewaysResponseTransitGatewaysOptionsTypeDef,
        "Tags": List[ClientDescribeTransitGatewaysResponseTransitGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef(
    _ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a transit gateway.
      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.
    """


_ClientDescribeTransitGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeTransitGatewaysResponseTypeDef",
    {
        "TransitGateways": List[ClientDescribeTransitGatewaysResponseTransitGatewaysTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeTransitGatewaysResponseTypeDef(_ClientDescribeTransitGatewaysResponseTypeDef):
    """
    - *(dict) --*

      - **TransitGateways** *(list) --*

        Information about the transit gateways.
        - *(dict) --*

          Describes a transit gateway.
          - **TransitGatewayId** *(string) --*

            The ID of the transit gateway.
    """


_ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef(
    _ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef
):
    """
    - **AutoEnableIO** *(dict) --*

      The state of ``autoEnableIO`` attribute.
      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVolumeAttributeResponseProductCodesTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientDescribeVolumeAttributeResponseProductCodesTypeDef(
    _ClientDescribeVolumeAttributeResponseProductCodesTypeDef
):
    pass


_ClientDescribeVolumeAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeVolumeAttributeResponseTypeDef",
    {
        "AutoEnableIO": ClientDescribeVolumeAttributeResponseAutoEnableIOTypeDef,
        "ProductCodes": List[ClientDescribeVolumeAttributeResponseProductCodesTypeDef],
        "VolumeId": str,
    },
    total=False,
)


class ClientDescribeVolumeAttributeResponseTypeDef(_ClientDescribeVolumeAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **AutoEnableIO** *(dict) --*

        The state of ``autoEnableIO`` attribute.
        - **Value** *(boolean) --*

          The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientDescribeVolumeStatusFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVolumeStatusFiltersTypeDef(_ClientDescribeVolumeStatusFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef
):
    pass


_ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef
):
    pass


_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": Literal["io-enabled", "io-performance"], "Status": str},
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    pass


_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef],
        "Status": Literal["ok", "impaired", "insufficient-data"],
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef
):
    pass


_ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef",
    {
        "Actions": List[ClientDescribeVolumeStatusResponseVolumeStatusesActionsTypeDef],
        "AvailabilityZone": str,
        "Events": List[ClientDescribeVolumeStatusResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": ClientDescribeVolumeStatusResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef(
    _ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef
):
    pass


_ClientDescribeVolumeStatusResponseTypeDef = TypedDict(
    "_ClientDescribeVolumeStatusResponseTypeDef",
    {
        "NextToken": str,
        "VolumeStatuses": List[ClientDescribeVolumeStatusResponseVolumeStatusesTypeDef],
    },
    total=False,
)


class ClientDescribeVolumeStatusResponseTypeDef(_ClientDescribeVolumeStatusResponseTypeDef):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeVolumesFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumesFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVolumesFiltersTypeDef(_ClientDescribeVolumesFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVolumesModificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVolumesModificationsFiltersTypeDef(
    _ClientDescribeVolumesModificationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef",
    {
        "VolumeId": str,
        "ModificationState": Literal["modifying", "optimizing", "completed", "failed"],
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef(
    _ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef
):
    """
    - *(dict) --*

      Describes the modification status of an EBS volume.
      If the volume has never been modified, some element values will be null.
      - **VolumeId** *(string) --*

        The ID of the volume.
    """


_ClientDescribeVolumesModificationsResponseTypeDef = TypedDict(
    "_ClientDescribeVolumesModificationsResponseTypeDef",
    {
        "VolumesModifications": List[
            ClientDescribeVolumesModificationsResponseVolumesModificationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVolumesModificationsResponseTypeDef(
    _ClientDescribeVolumesModificationsResponseTypeDef
):
    """
    - *(dict) --*

      - **VolumesModifications** *(list) --*

        Information about the volume modifications.
        - *(dict) --*

          Describes the modification status of an EBS volume.
          If the volume has never been modified, some element values will be null.
          - **VolumeId** *(string) --*

            The ID of the volume.
    """


_ClientDescribeVolumesResponseVolumesAttachmentsTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientDescribeVolumesResponseVolumesAttachmentsTypeDef(
    _ClientDescribeVolumesResponseVolumesAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_ClientDescribeVolumesResponseVolumesTagsTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeVolumesResponseVolumesTagsTypeDef(
    _ClientDescribeVolumesResponseVolumesTagsTypeDef
):
    pass


_ClientDescribeVolumesResponseVolumesTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseVolumesTypeDef",
    {
        "Attachments": List[ClientDescribeVolumesResponseVolumesAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": Literal["creating", "available", "in-use", "deleting", "deleted", "error"],
        "VolumeId": str,
        "Iops": int,
        "Tags": List[ClientDescribeVolumesResponseVolumesTagsTypeDef],
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "FastRestored": bool,
    },
    total=False,
)


class ClientDescribeVolumesResponseVolumesTypeDef(_ClientDescribeVolumesResponseVolumesTypeDef):
    """
    - *(dict) --*

      Describes a volume.
      - **Attachments** *(list) --*

        Information about the volume attachments.
        - *(dict) --*

          Describes volume attachment details.
          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.
    """


_ClientDescribeVolumesResponseTypeDef = TypedDict(
    "_ClientDescribeVolumesResponseTypeDef",
    {"Volumes": List[ClientDescribeVolumesResponseVolumesTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeVolumesResponseTypeDef(_ClientDescribeVolumesResponseTypeDef):
    """
    - *(dict) --*

      - **Volumes** *(list) --*

        Information about the volumes.
        - *(dict) --*

          Describes a volume.
          - **Attachments** *(list) --*

            Information about the volume attachments.
            - *(dict) --*

              Describes volume attachment details.
              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.
    """


_ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef(
    _ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef
):
    pass


_ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef(
    _ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef
):
    pass


_ClientDescribeVpcAttributeResponseTypeDef = TypedDict(
    "_ClientDescribeVpcAttributeResponseTypeDef",
    {
        "VpcId": str,
        "EnableDnsHostnames": ClientDescribeVpcAttributeResponseEnableDnsHostnamesTypeDef,
        "EnableDnsSupport": ClientDescribeVpcAttributeResponseEnableDnsSupportTypeDef,
    },
    total=False,
)


class ClientDescribeVpcAttributeResponseTypeDef(_ClientDescribeVpcAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **VpcId** *(string) --*

        The ID of the VPC.
    """


_ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef",
    {"ClassicLinkDnsSupported": bool, "VpcId": str},
    total=False,
)


class ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef(
    _ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef
):
    pass


_ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef",
    {"NextToken": str, "Vpcs": List[ClientDescribeVpcClassicLinkDnsSupportResponseVpcsTypeDef]},
    total=False,
)


class ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientDescribeVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientDescribeVpcClassicLinkFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpcClassicLinkFiltersTypeDef(_ClientDescribeVpcClassicLinkFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef(
    _ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef
):
    pass


_ClientDescribeVpcClassicLinkResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseVpcsTypeDef",
    {
        "ClassicLinkEnabled": bool,
        "Tags": List[ClientDescribeVpcClassicLinkResponseVpcsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class ClientDescribeVpcClassicLinkResponseVpcsTypeDef(
    _ClientDescribeVpcClassicLinkResponseVpcsTypeDef
):
    """
    - *(dict) --*

      Describes whether a VPC is enabled for ClassicLink.
      - **ClassicLinkEnabled** *(boolean) --*

        Indicates whether the VPC is enabled for ClassicLink.
    """


_ClientDescribeVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientDescribeVpcClassicLinkResponseTypeDef",
    {"Vpcs": List[ClientDescribeVpcClassicLinkResponseVpcsTypeDef]},
    total=False,
)


class ClientDescribeVpcClassicLinkResponseTypeDef(_ClientDescribeVpcClassicLinkResponseTypeDef):
    """
    - *(dict) --*

      - **Vpcs** *(list) --*

        The ClassicLink status of one or more VPCs.
        - *(dict) --*

          Describes whether a VPC is enabled for ClassicLink.
          - **ClassicLinkEnabled** *(boolean) --*

            Indicates whether the VPC is enabled for ClassicLink.
    """


_ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": Literal["Enabled", "Disabled"],
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef
):
    """
    - *(dict) --*

      Describes a connection notification for a VPC endpoint or VPC endpoint service.
      - **ConnectionNotificationId** *(string) --*

        The ID of the notification.
    """


_ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef",
    {
        "ConnectionNotificationSet": List[
            ClientDescribeVpcEndpointConnectionNotificationsResponseConnectionNotificationSetTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef(
    _ClientDescribeVpcEndpointConnectionNotificationsResponseTypeDef
):
    """
    - *(dict) --*

      - **ConnectionNotificationSet** *(list) --*

        One or more notifications.
        - *(dict) --*

          Describes a connection notification for a VPC endpoint or VPC endpoint service.
          - **ConnectionNotificationId** *(string) --*

            The ID of the notification.
    """


_ClientDescribeVpcEndpointConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointConnectionsFiltersTypeDef(
    _ClientDescribeVpcEndpointConnectionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef
):
    pass


_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointId": str,
        "VpcEndpointOwner": str,
        "VpcEndpointState": Literal[
            "PendingAcceptance",
            "Pending",
            "Available",
            "Deleting",
            "Deleted",
            "Rejected",
            "Failed",
            "Expired",
        ],
        "CreationTimestamp": datetime,
        "DnsEntries": List[
            ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsDnsEntriesTypeDef
        ],
        "NetworkLoadBalancerArns": List[str],
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC endpoint connection to a service.
      - **ServiceId** *(string) --*

        The ID of the service to which the endpoint is connected.
    """


_ClientDescribeVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointConnectionsResponseTypeDef",
    {
        "VpcEndpointConnections": List[
            ClientDescribeVpcEndpointConnectionsResponseVpcEndpointConnectionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointConnectionsResponseTypeDef(
    _ClientDescribeVpcEndpointConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcEndpointConnections** *(list) --*

        Information about one or more VPC endpoint connections.
        - *(dict) --*

          Describes a VPC endpoint connection to a service.
          - **ServiceId** *(string) --*

            The ID of the service to which the endpoint is connected.
    """


_ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef",
    {"ServiceType": Literal["Interface", "Gateway"]},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef
):
    """
    - *(dict) --*

      Describes the type of service for a VPC endpoint.
      - **ServiceType** *(string) --*

        The type of service.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef
):
    pass


_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef",
    {
        "ServiceType": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": Literal["Pending", "Available", "Deleting", "Deleted", "Failed"],
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes a service configuration for a VPC endpoint service.
      - **ServiceType** *(list) --*

        The type of service.
        - *(dict) --*

          Describes the type of service for a VPC endpoint.
          - **ServiceType** *(string) --*

            The type of service.
    """


_ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef",
    {
        "ServiceConfigurations": List[
            ClientDescribeVpcEndpointServiceConfigurationsResponseServiceConfigurationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef(
    _ClientDescribeVpcEndpointServiceConfigurationsResponseTypeDef
):
    """
    - *(dict) --*

      - **ServiceConfigurations** *(list) --*

        Information about one or more services.
        - *(dict) --*

          Describes a service configuration for a VPC endpoint service.
          - **ServiceType** *(list) --*

            The type of service.
            - *(dict) --*

              Describes the type of service for a VPC endpoint.
              - **ServiceType** *(string) --*

                The type of service.
    """


_ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef",
    {
        "PrincipalType": Literal["All", "Service", "OrganizationUnit", "Account", "User", "Role"],
        "Principal": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef
):
    """
    - *(dict) --*

      Describes a principal.
      - **PrincipalType** *(string) --*

        The type of principal.
    """


_ClientDescribeVpcEndpointServicePermissionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicePermissionsResponseTypeDef",
    {
        "AllowedPrincipals": List[
            ClientDescribeVpcEndpointServicePermissionsResponseAllowedPrincipalsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServicePermissionsResponseTypeDef(
    _ClientDescribeVpcEndpointServicePermissionsResponseTypeDef
):
    """
    - *(dict) --*

      - **AllowedPrincipals** *(list) --*

        Information about one or more allowed principals.
        - *(dict) --*

          Describes a principal.
          - **PrincipalType** *(string) --*

            The type of principal.
    """


_ClientDescribeVpcEndpointServicesFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcEndpointServicesFiltersTypeDef(
    _ClientDescribeVpcEndpointServicesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef",
    {"ServiceType": Literal["Interface", "Gateway"]},
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef
):
    pass


_ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef
):
    pass


_ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef",
    {
        "ServiceName": str,
        "ServiceId": str,
        "ServiceType": List[
            ClientDescribeVpcEndpointServicesResponseServiceDetailsServiceTypeTypeDef
        ],
        "AvailabilityZones": List[str],
        "Owner": str,
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "VpcEndpointPolicySupported": bool,
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "Tags": List[ClientDescribeVpcEndpointServicesResponseServiceDetailsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef(
    _ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef
):
    pass


_ClientDescribeVpcEndpointServicesResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointServicesResponseTypeDef",
    {
        "ServiceNames": List[str],
        "ServiceDetails": List[ClientDescribeVpcEndpointServicesResponseServiceDetailsTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointServicesResponseTypeDef(
    _ClientDescribeVpcEndpointServicesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeVpcEndpointServices.
      - **ServiceNames** *(list) --*

        A list of supported services.
        - *(string) --*
    """


_ClientDescribeVpcEndpointsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpcEndpointsFiltersTypeDef(_ClientDescribeVpcEndpointsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef
):
    pass


_ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef
):
    pass


_ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef
):
    pass


_ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": Literal["Interface", "Gateway"],
        "VpcId": str,
        "ServiceName": str,
        "State": Literal[
            "PendingAcceptance",
            "Pending",
            "Available",
            "Deleting",
            "Deleted",
            "Rejected",
            "Failed",
            "Expired",
        ],
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[ClientDescribeVpcEndpointsResponseVpcEndpointsGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[ClientDescribeVpcEndpointsResponseVpcEndpointsDnsEntriesTypeDef],
        "CreationTimestamp": datetime,
        "Tags": List[ClientDescribeVpcEndpointsResponseVpcEndpointsTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef(
    _ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC endpoint.
      - **VpcEndpointId** *(string) --*

        The ID of the VPC endpoint.
    """


_ClientDescribeVpcEndpointsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcEndpointsResponseTypeDef",
    {"VpcEndpoints": List[ClientDescribeVpcEndpointsResponseVpcEndpointsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeVpcEndpointsResponseTypeDef(_ClientDescribeVpcEndpointsResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeVpcEndpoints.
      - **VpcEndpoints** *(list) --*

        Information about the endpoints.
        - *(dict) --*

          Describes a VPC endpoint.
          - **VpcEndpointId** *(string) --*

            The ID of the VPC endpoint.
    """


_ClientDescribeVpcPeeringConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsFiltersTypeDef(
    _ClientDescribeVpcPeeringConnectionsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef
):
    """
    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing an
      active VPC peering connection.
      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.
    """


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef",
    {
        "Code": Literal[
            "initiating-request",
            "pending-acceptance",
            "active",
            "deleted",
            "rejected",
            "failed",
            "expired",
            "provisioning",
            "deleting",
        ],
        "Message": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef
):
    pass


_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef",
    {
        "AccepterVpcInfo": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef,
        "Status": ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsStatusTypeDef,
        "Tags": List[ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC peering connection.
      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.
        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.
    """


_ClientDescribeVpcPeeringConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcPeeringConnectionsResponseTypeDef",
    {
        "VpcPeeringConnections": List[
            ClientDescribeVpcPeeringConnectionsResponseVpcPeeringConnectionsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientDescribeVpcPeeringConnectionsResponseTypeDef(
    _ClientDescribeVpcPeeringConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcPeeringConnections** *(list) --*

        Information about the VPC peering connections.
        - *(dict) --*

          Describes a VPC peering connection.
          - **AccepterVpcInfo** *(dict) --*

            Information about the accepter VPC. CIDR block information is only returned when
            describing an active VPC peering connection.
            - **CidrBlock** *(string) --*

              The IPv4 CIDR block for the VPC.
    """


_ClientDescribeVpcsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpcsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpcsFiltersTypeDef(_ClientDescribeVpcsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef(
    _ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef
):
    pass


_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef(
    _ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef
):
    pass


_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef(
    _ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef
):
    pass


_ClientDescribeVpcsResponseVpcsTagsTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientDescribeVpcsResponseVpcsTagsTypeDef(_ClientDescribeVpcsResponseVpcsTagsTypeDef):
    pass


_ClientDescribeVpcsResponseVpcsTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseVpcsTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": Literal["pending", "available"],
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Ipv6CidrBlockAssociationSet": List[
            ClientDescribeVpcsResponseVpcsIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            ClientDescribeVpcsResponseVpcsCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[ClientDescribeVpcsResponseVpcsTagsTypeDef],
    },
    total=False,
)


class ClientDescribeVpcsResponseVpcsTypeDef(_ClientDescribeVpcsResponseVpcsTypeDef):
    """
    - *(dict) --*

      Describes a VPC.
      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.
    """


_ClientDescribeVpcsResponseTypeDef = TypedDict(
    "_ClientDescribeVpcsResponseTypeDef",
    {"Vpcs": List[ClientDescribeVpcsResponseVpcsTypeDef], "NextToken": str},
    total=False,
)


class ClientDescribeVpcsResponseTypeDef(_ClientDescribeVpcsResponseTypeDef):
    """
    - *(dict) --*

      - **Vpcs** *(list) --*

        Information about one or more VPCs.
        - *(dict) --*

          Describes a VPC.
          - **CidrBlock** *(string) --*

            The primary IPv4 CIDR block for the VPC.
    """


_ClientDescribeVpnConnectionsFiltersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpnConnectionsFiltersTypeDef(_ClientDescribeVpnConnectionsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": Literal["UP", "DOWN"],
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef
):
    pass


_ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientDescribeVpnConnectionsResponseVpnConnectionsOptionsTypeDef,
        "Routes": List[ClientDescribeVpnConnectionsResponseVpnConnectionsRoutesTypeDef],
        "Tags": List[ClientDescribeVpnConnectionsResponseVpnConnectionsTagsTypeDef],
        "VgwTelemetry": List[ClientDescribeVpnConnectionsResponseVpnConnectionsVgwTelemetryTypeDef],
    },
    total=False,
)


class ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef(
    _ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a VPN connection.
      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.
    """


_ClientDescribeVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientDescribeVpnConnectionsResponseTypeDef",
    {"VpnConnections": List[ClientDescribeVpnConnectionsResponseVpnConnectionsTypeDef]},
    total=False,
)


class ClientDescribeVpnConnectionsResponseTypeDef(_ClientDescribeVpnConnectionsResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeVpnConnections.
      - **VpnConnections** *(list) --*

        Information about one or more VPN connections.
        - *(dict) --*

          Describes a VPN connection.
          - **CustomerGatewayConfiguration** *(string) --*

            The configuration information for the VPN connection's customer gateway (in the native
            XML format). This element is always present in the  CreateVpnConnection response;
            however, it's present in the  DescribeVpnConnections response only if the VPN connection
            is in the ``pending`` or ``available`` state.
    """


_ClientDescribeVpnGatewaysFiltersTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ClientDescribeVpnGatewaysFiltersTypeDef(_ClientDescribeVpnGatewaysFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef
):
    pass


_ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef
):
    pass


_ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef",
    {
        "AvailabilityZone": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpcAttachments": List[ClientDescribeVpnGatewaysResponseVpnGatewaysVpcAttachmentsTypeDef],
        "VpnGatewayId": str,
        "AmazonSideAsn": int,
        "Tags": List[ClientDescribeVpnGatewaysResponseVpnGatewaysTagsTypeDef],
    },
    total=False,
)


class ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef(
    _ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a virtual private gateway.
      - **AvailabilityZone** *(string) --*

        The Availability Zone where the virtual private gateway was created, if applicable. This
        field may be empty or not returned.
    """


_ClientDescribeVpnGatewaysResponseTypeDef = TypedDict(
    "_ClientDescribeVpnGatewaysResponseTypeDef",
    {"VpnGateways": List[ClientDescribeVpnGatewaysResponseVpnGatewaysTypeDef]},
    total=False,
)


class ClientDescribeVpnGatewaysResponseTypeDef(_ClientDescribeVpnGatewaysResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeVpnGateways.
      - **VpnGateways** *(list) --*

        Information about one or more virtual private gateways.
        - *(dict) --*

          Describes a virtual private gateway.
          - **AvailabilityZone** *(string) --*

            The Availability Zone where the virtual private gateway was created, if applicable. This
            field may be empty or not returned.
    """


_ClientDetachClassicLinkVpcResponseTypeDef = TypedDict(
    "_ClientDetachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class ClientDetachClassicLinkVpcResponseTypeDef(_ClientDetachClassicLinkVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDetachVolumeResponseTypeDef = TypedDict(
    "_ClientDetachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class ClientDetachVolumeResponseTypeDef(_ClientDetachVolumeResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_ClientDisableEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientDisableEbsEncryptionByDefaultResponseTypeDef",
    {"EbsEncryptionByDefault": bool},
    total=False,
)


class ClientDisableEbsEncryptionByDefaultResponseTypeDef(
    _ClientDisableEbsEncryptionByDefaultResponseTypeDef
):
    """
    - *(dict) --*

      - **EbsEncryptionByDefault** *(boolean) --*

        The updated status of encryption by default.
    """


_ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef = TypedDict(
    "_ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": Literal["enabling", "optimizing", "enabled", "disabling", "disabled"],
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
    total=False,
)


class ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef(
    _ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef
):
    """
    - *(dict) --*

      Describes fast snapshot restores that were successfully disabled.
      - **SnapshotId** *(string) --*

        The ID of the snapshot.
    """


_ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef = TypedDict(
    "_ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef(
    _ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef
):
    pass


_ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef = TypedDict(
    "_ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef",
    {
        "AvailabilityZone": str,
        "Error": ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef,
    },
    total=False,
)


class ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef(
    _ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef
):
    pass


_ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef",
    {
        "SnapshotId": str,
        "FastSnapshotRestoreStateErrors": List[
            ClientDisableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef
        ],
    },
    total=False,
)


class ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef(
    _ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef
):
    pass


_ClientDisableFastSnapshotRestoresResponseTypeDef = TypedDict(
    "_ClientDisableFastSnapshotRestoresResponseTypeDef",
    {
        "Successful": List[ClientDisableFastSnapshotRestoresResponseSuccessfulTypeDef],
        "Unsuccessful": List[ClientDisableFastSnapshotRestoresResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientDisableFastSnapshotRestoresResponseTypeDef(
    _ClientDisableFastSnapshotRestoresResponseTypeDef
):
    """
    - *(dict) --*

      - **Successful** *(list) --*

        Information about the snapshots for which fast snapshot restores were successfully disabled.
        - *(dict) --*

          Describes fast snapshot restores that were successfully disabled.
          - **SnapshotId** *(string) --*

            The ID of the snapshot.
    """


_ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef = TypedDict(
    "_ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "TransitGatewayRouteTableId": str,
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef(
    _ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
):
    """
    - **Propagation** *(dict) --*

      Information about route propagation.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef = TypedDict(
    "_ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef",
    {"Propagation": ClientDisableTransitGatewayRouteTablePropagationResponsePropagationTypeDef},
    total=False,
)


class ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef(
    _ClientDisableTransitGatewayRouteTablePropagationResponseTypeDef
):
    """
    - *(dict) --*

      - **Propagation** *(dict) --*

        Information about route propagation.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientDisableVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientDisableVpcClassicLinkDnsSupportResponseTypeDef", {"Return": bool}, total=False
)


class ClientDisableVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientDisableVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDisableVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientDisableVpcClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class ClientDisableVpcClassicLinkResponseTypeDef(_ClientDisableVpcClassicLinkResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef = TypedDict(
    "_ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef",
    {
        "Code": Literal[
            "associating", "associated", "association-failed", "disassociating", "disassociated"
        ],
        "Message": str,
    },
    total=False,
)


class ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef(
    _ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef
):
    pass


_ClientDisassociateClientVpnTargetNetworkResponseTypeDef = TypedDict(
    "_ClientDisassociateClientVpnTargetNetworkResponseTypeDef",
    {"AssociationId": str, "Status": ClientDisassociateClientVpnTargetNetworkResponseStatusTypeDef},
    total=False,
)


class ClientDisassociateClientVpnTargetNetworkResponseTypeDef(
    _ClientDisassociateClientVpnTargetNetworkResponseTypeDef
):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        The ID of the target network association.
    """


_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    pass


_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef(
    _ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
):
    """
    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_ClientDisassociateIamInstanceProfileResponseTypeDef = TypedDict(
    "_ClientDisassociateIamInstanceProfileResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientDisassociateIamInstanceProfileResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientDisassociateIamInstanceProfileResponseTypeDef(
    _ClientDisassociateIamInstanceProfileResponseTypeDef
):
    """
    - *(dict) --*

      - **IamInstanceProfileAssociation** *(dict) --*

        Information about the IAM instance profile association.
        - **AssociationId** *(string) --*

          The ID of the association.
    """


_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    pass


_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.
      - **AssociationId** *(string) --*

        The association ID for the CIDR block.
    """


_ClientDisassociateSubnetCidrBlockResponseTypeDef = TypedDict(
    "_ClientDisassociateSubnetCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientDisassociateSubnetCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "SubnetId": str,
    },
    total=False,
)


class ClientDisassociateSubnetCidrBlockResponseTypeDef(
    _ClientDisassociateSubnetCidrBlockResponseTypeDef
):
    """
    - *(dict) --*

      - **Ipv6CidrBlockAssociation** *(dict) --*

        Information about the IPv6 CIDR block association.
        - **AssociationId** *(string) --*

          The association ID for the CIDR block.
    """


_ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef = TypedDict(
    "_ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef(
    _ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef
):
    """
    - **Association** *(dict) --*

      Information about the association.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_ClientDisassociateTransitGatewayRouteTableResponseTypeDef = TypedDict(
    "_ClientDisassociateTransitGatewayRouteTableResponseTypeDef",
    {"Association": ClientDisassociateTransitGatewayRouteTableResponseAssociationTypeDef},
    total=False,
)


class ClientDisassociateTransitGatewayRouteTableResponseTypeDef(
    _ClientDisassociateTransitGatewayRouteTableResponseTypeDef
):
    """
    - *(dict) --*

      - **Association** *(dict) --*

        Information about the association.
        - **TransitGatewayRouteTableId** *(string) --*

          The ID of the transit gateway route table.
    """


_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef(
    _ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef
):
    pass


_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationCidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef(
    _ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef
):
    pass


_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef(
    _ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef
):
    pass


_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef(
    _ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef
):
    """
    - **Ipv6CidrBlockAssociation** *(dict) --*

      Information about the IPv6 CIDR block association.
      - **AssociationId** *(string) --*

        The association ID for the IPv6 CIDR block.
    """


_ClientDisassociateVpcCidrBlockResponseTypeDef = TypedDict(
    "_ClientDisassociateVpcCidrBlockResponseTypeDef",
    {
        "Ipv6CidrBlockAssociation": ClientDisassociateVpcCidrBlockResponseIpv6CidrBlockAssociationTypeDef,
        "CidrBlockAssociation": ClientDisassociateVpcCidrBlockResponseCidrBlockAssociationTypeDef,
        "VpcId": str,
    },
    total=False,
)


class ClientDisassociateVpcCidrBlockResponseTypeDef(_ClientDisassociateVpcCidrBlockResponseTypeDef):
    """
    - *(dict) --*

      - **Ipv6CidrBlockAssociation** *(dict) --*

        Information about the IPv6 CIDR block association.
        - **AssociationId** *(string) --*

          The association ID for the IPv6 CIDR block.
    """


_ClientEnableEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientEnableEbsEncryptionByDefaultResponseTypeDef",
    {"EbsEncryptionByDefault": bool},
    total=False,
)


class ClientEnableEbsEncryptionByDefaultResponseTypeDef(
    _ClientEnableEbsEncryptionByDefaultResponseTypeDef
):
    """
    - *(dict) --*

      - **EbsEncryptionByDefault** *(boolean) --*

        The updated status of encryption by default.
    """


_ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef = TypedDict(
    "_ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": Literal["enabling", "optimizing", "enabled", "disabling", "disabled"],
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
    total=False,
)


class ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef(
    _ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef
):
    """
    - *(dict) --*

      Describes fast snapshot restores that were successfully enabled.
      - **SnapshotId** *(string) --*

        The ID of the snapshot.
    """


_ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef = TypedDict(
    "_ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef(
    _ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef
):
    pass


_ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef = TypedDict(
    "_ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef",
    {
        "AvailabilityZone": str,
        "Error": ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsErrorTypeDef,
    },
    total=False,
)


class ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef(
    _ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef
):
    pass


_ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef",
    {
        "SnapshotId": str,
        "FastSnapshotRestoreStateErrors": List[
            ClientEnableFastSnapshotRestoresResponseUnsuccessfulFastSnapshotRestoreStateErrorsTypeDef
        ],
    },
    total=False,
)


class ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef(
    _ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef
):
    pass


_ClientEnableFastSnapshotRestoresResponseTypeDef = TypedDict(
    "_ClientEnableFastSnapshotRestoresResponseTypeDef",
    {
        "Successful": List[ClientEnableFastSnapshotRestoresResponseSuccessfulTypeDef],
        "Unsuccessful": List[ClientEnableFastSnapshotRestoresResponseUnsuccessfulTypeDef],
    },
    total=False,
)


class ClientEnableFastSnapshotRestoresResponseTypeDef(
    _ClientEnableFastSnapshotRestoresResponseTypeDef
):
    """
    - *(dict) --*

      - **Successful** *(list) --*

        Information about the snapshots for which fast snapshot restores were successfully enabled.
        - *(dict) --*

          Describes fast snapshot restores that were successfully enabled.
          - **SnapshotId** *(string) --*

            The ID of the snapshot.
    """


_ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef = TypedDict(
    "_ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "TransitGatewayRouteTableId": str,
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef(
    _ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef
):
    """
    - **Propagation** *(dict) --*

      Information about route propagation.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef = TypedDict(
    "_ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef",
    {"Propagation": ClientEnableTransitGatewayRouteTablePropagationResponsePropagationTypeDef},
    total=False,
)


class ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef(
    _ClientEnableTransitGatewayRouteTablePropagationResponseTypeDef
):
    """
    - *(dict) --*

      - **Propagation** *(dict) --*

        Information about route propagation.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientEnableVpcClassicLinkDnsSupportResponseTypeDef = TypedDict(
    "_ClientEnableVpcClassicLinkDnsSupportResponseTypeDef", {"Return": bool}, total=False
)


class ClientEnableVpcClassicLinkDnsSupportResponseTypeDef(
    _ClientEnableVpcClassicLinkDnsSupportResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientEnableVpcClassicLinkResponseTypeDef = TypedDict(
    "_ClientEnableVpcClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class ClientEnableVpcClassicLinkResponseTypeDef(_ClientEnableVpcClassicLinkResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef = TypedDict(
    "_ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef",
    {"Code": Literal["pending", "active"], "Message": str},
    total=False,
)


class ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef(
    _ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef
):
    pass


_ClientExportClientVpnClientCertificateRevocationListResponseTypeDef = TypedDict(
    "_ClientExportClientVpnClientCertificateRevocationListResponseTypeDef",
    {
        "CertificateRevocationList": str,
        "Status": ClientExportClientVpnClientCertificateRevocationListResponseStatusTypeDef,
    },
    total=False,
)


class ClientExportClientVpnClientCertificateRevocationListResponseTypeDef(
    _ClientExportClientVpnClientCertificateRevocationListResponseTypeDef
):
    """
    - *(dict) --*

      - **CertificateRevocationList** *(string) --*

        Information about the client certificate revocation list.
    """


_ClientExportClientVpnClientConfigurationResponseTypeDef = TypedDict(
    "_ClientExportClientVpnClientConfigurationResponseTypeDef",
    {"ClientConfiguration": str},
    total=False,
)


class ClientExportClientVpnClientConfigurationResponseTypeDef(
    _ClientExportClientVpnClientConfigurationResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientConfiguration** *(string) --*

        The contents of the Client VPN endpoint configuration file.
    """


_ClientExportImageResponseS3ExportLocationTypeDef = TypedDict(
    "_ClientExportImageResponseS3ExportLocationTypeDef",
    {"S3Bucket": str, "S3Prefix": str},
    total=False,
)


class ClientExportImageResponseS3ExportLocationTypeDef(
    _ClientExportImageResponseS3ExportLocationTypeDef
):
    pass


_ClientExportImageResponseTypeDef = TypedDict(
    "_ClientExportImageResponseTypeDef",
    {
        "Description": str,
        "DiskImageFormat": Literal["VMDK", "RAW", "VHD"],
        "ExportImageTaskId": str,
        "ImageId": str,
        "RoleName": str,
        "Progress": str,
        "S3ExportLocation": ClientExportImageResponseS3ExportLocationTypeDef,
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class ClientExportImageResponseTypeDef(_ClientExportImageResponseTypeDef):
    """
    - *(dict) --*

      - **Description** *(string) --*

        A description of the image being exported.
    """


_RequiredClientExportImageS3ExportLocationTypeDef = TypedDict(
    "_RequiredClientExportImageS3ExportLocationTypeDef", {"S3Bucket": str}
)
_OptionalClientExportImageS3ExportLocationTypeDef = TypedDict(
    "_OptionalClientExportImageS3ExportLocationTypeDef", {"S3Prefix": str}, total=False
)


class ClientExportImageS3ExportLocationTypeDef(
    _RequiredClientExportImageS3ExportLocationTypeDef,
    _OptionalClientExportImageS3ExportLocationTypeDef,
):
    """
    Information about the destination S3 bucket. The bucket must exist and grant WRITE and READ_ACP
    permissions to the AWS account vm-import-export@amazon.com.
    - **S3Bucket** *(string) --***[REQUIRED]**

      The destination S3 bucket.
    """


_ClientExportTransitGatewayRoutesFiltersTypeDef = TypedDict(
    "_ClientExportTransitGatewayRoutesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientExportTransitGatewayRoutesFiltersTypeDef(
    _ClientExportTransitGatewayRoutesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientExportTransitGatewayRoutesResponseTypeDef = TypedDict(
    "_ClientExportTransitGatewayRoutesResponseTypeDef", {"S3Location": str}, total=False
)


class ClientExportTransitGatewayRoutesResponseTypeDef(
    _ClientExportTransitGatewayRoutesResponseTypeDef
):
    """
    - *(dict) --*

      - **S3Location** *(string) --*

        The URL of the exported file in Amazon S3. For example, s3://*bucket_name*
        /VPCTransitGateway/TransitGatewayRouteTables/*file_name* .
    """


_ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef = TypedDict(
    "_ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef",
    {"AccountId": str, "UsedInstanceCount": int},
    total=False,
)


class ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef(
    _ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef
):
    pass


_ClientGetCapacityReservationUsageResponseTypeDef = TypedDict(
    "_ClientGetCapacityReservationUsageResponseTypeDef",
    {
        "NextToken": str,
        "CapacityReservationId": str,
        "InstanceType": str,
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "State": Literal["active", "expired", "cancelled", "pending", "failed"],
        "InstanceUsages": List[ClientGetCapacityReservationUsageResponseInstanceUsagesTypeDef],
    },
    total=False,
)


class ClientGetCapacityReservationUsageResponseTypeDef(
    _ClientGetCapacityReservationUsageResponseTypeDef
):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_ClientGetConsoleOutputResponseTypeDef = TypedDict(
    "_ClientGetConsoleOutputResponseTypeDef",
    {"InstanceId": str, "Output": str, "Timestamp": datetime},
    total=False,
)


class ClientGetConsoleOutputResponseTypeDef(_ClientGetConsoleOutputResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientGetConsoleScreenshotResponseTypeDef = TypedDict(
    "_ClientGetConsoleScreenshotResponseTypeDef", {"ImageData": str, "InstanceId": str}, total=False
)


class ClientGetConsoleScreenshotResponseTypeDef(_ClientGetConsoleScreenshotResponseTypeDef):
    """
    - *(dict) --*

      - **ImageData** *(string) --*

        The data that comprises the image.
    """


_ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef = TypedDict(
    "_ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef",
    {"InstanceFamily": Literal["t2", "t3", "t3a"], "CpuCredits": str},
    total=False,
)


class ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef(
    _ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef
):
    """
    - **InstanceFamilyCreditSpecification** *(dict) --*

      The default credit option for CPU usage of the instance family.
      - **InstanceFamily** *(string) --*

        The instance family.
    """


_ClientGetDefaultCreditSpecificationResponseTypeDef = TypedDict(
    "_ClientGetDefaultCreditSpecificationResponseTypeDef",
    {
        "InstanceFamilyCreditSpecification": ClientGetDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef
    },
    total=False,
)


class ClientGetDefaultCreditSpecificationResponseTypeDef(
    _ClientGetDefaultCreditSpecificationResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceFamilyCreditSpecification** *(dict) --*

        The default credit option for CPU usage of the instance family.
        - **InstanceFamily** *(string) --*

          The instance family.
    """


_ClientGetEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientGetEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientGetEbsDefaultKmsKeyIdResponseTypeDef(_ClientGetEbsDefaultKmsKeyIdResponseTypeDef):
    """
    - *(dict) --*

      - **KmsKeyId** *(string) --*

        The Amazon Resource Name (ARN) of the default CMK for encryption by default.
    """


_ClientGetEbsEncryptionByDefaultResponseTypeDef = TypedDict(
    "_ClientGetEbsEncryptionByDefaultResponseTypeDef", {"EbsEncryptionByDefault": bool}, total=False
)


class ClientGetEbsEncryptionByDefaultResponseTypeDef(
    _ClientGetEbsEncryptionByDefaultResponseTypeDef
):
    """
    - *(dict) --*

      - **EbsEncryptionByDefault** *(boolean) --*

        Indicates whether encryption by default is enabled.
    """


_ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef = TypedDict(
    "_ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef(
    _ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef
):
    pass


_ClientGetHostReservationPurchasePreviewResponseTypeDef = TypedDict(
    "_ClientGetHostReservationPurchasePreviewResponseTypeDef",
    {
        "CurrencyCode": str,
        "Purchase": List[ClientGetHostReservationPurchasePreviewResponsePurchaseTypeDef],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
    },
    total=False,
)


class ClientGetHostReservationPurchasePreviewResponseTypeDef(
    _ClientGetHostReservationPurchasePreviewResponseTypeDef
):
    """
    - *(dict) --*

      - **CurrencyCode** *(string) --*

        The currency in which the ``totalUpfrontPrice`` and ``totalHourlyPrice`` amounts are
        specified. At this time, the only supported currency is ``USD`` .
    """


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientGetLaunchTemplateDataResponseLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": ClientGetLaunchTemplateDataResponseLaunchTemplateDataMonitoringTypeDef,
        "Placement": ClientGetLaunchTemplateDataResponseLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": ClientGetLaunchTemplateDataResponseLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            ClientGetLaunchTemplateDataResponseLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": ClientGetLaunchTemplateDataResponseLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef(
    _ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef
):
    """
    - **LaunchTemplateData** *(dict) --*

      The instance data.
      - **KernelId** *(string) --*

        The ID of the kernel, if applicable.
    """


_ClientGetLaunchTemplateDataResponseTypeDef = TypedDict(
    "_ClientGetLaunchTemplateDataResponseTypeDef",
    {"LaunchTemplateData": ClientGetLaunchTemplateDataResponseLaunchTemplateDataTypeDef},
    total=False,
)


class ClientGetLaunchTemplateDataResponseTypeDef(_ClientGetLaunchTemplateDataResponseTypeDef):
    """
    - *(dict) --*

      - **LaunchTemplateData** *(dict) --*

        The instance data.
        - **KernelId** *(string) --*

          The ID of the kernel, if applicable.
    """


_ClientGetPasswordDataResponseTypeDef = TypedDict(
    "_ClientGetPasswordDataResponseTypeDef",
    {"InstanceId": str, "PasswordData": str, "Timestamp": datetime},
    total=False,
)


class ClientGetPasswordDataResponseTypeDef(_ClientGetPasswordDataResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceId** *(string) --*

        The ID of the Windows instance.
    """


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef",
    {
        "ReservationValue": ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetReservationValueTypeDef,
        "ReservedInstanceId": str,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef",
    {"HourlyPrice": str, "RemainingTotalValue": str, "RemainingUpfrontValue": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef",
    {"InstanceCount": int, "OfferingId": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef",
    {
        "ReservationValue": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetReservationValueTypeDef,
        "TargetConfiguration": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTargetConfigurationTypeDef,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef
):
    pass


_ClientGetReservedInstancesExchangeQuoteResponseTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteResponseTypeDef",
    {
        "CurrencyCode": str,
        "IsValidExchange": bool,
        "OutputReservedInstancesWillExpireAt": datetime,
        "PaymentDue": str,
        "ReservedInstanceValueRollup": ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueRollupTypeDef,
        "ReservedInstanceValueSet": List[
            ClientGetReservedInstancesExchangeQuoteResponseReservedInstanceValueSetTypeDef
        ],
        "TargetConfigurationValueRollup": ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueRollupTypeDef,
        "TargetConfigurationValueSet": List[
            ClientGetReservedInstancesExchangeQuoteResponseTargetConfigurationValueSetTypeDef
        ],
        "ValidationFailureReason": str,
    },
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteResponseTypeDef(
    _ClientGetReservedInstancesExchangeQuoteResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of GetReservedInstancesExchangeQuote.
      - **CurrencyCode** *(string) --*

        The currency of the transaction.
    """


_ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef = TypedDict(
    "_ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef",
    {"InstanceCount": int, "OfferingId": str},
    total=False,
)


class ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef(
    _ClientGetReservedInstancesExchangeQuoteTargetConfigurationsTypeDef
):
    """
    - *(dict) --*

      Details about the target configuration.
      - **InstanceCount** *(integer) --*

        The number of instances the Covertible Reserved Instance offering can be applied to. This
        parameter is reserved and cannot be specified in a request
    """


_ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef
):
    """
    - *(dict) --*

      Describes a propagation route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the propagation route table.
    """


_ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef",
    {
        "TransitGatewayAttachmentPropagations": List[
            ClientGetTransitGatewayAttachmentPropagationsResponseTransitGatewayAttachmentPropagationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef(
    _ClientGetTransitGatewayAttachmentPropagationsResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayAttachmentPropagations** *(list) --*

        Information about the propagation route tables.
        - *(dict) --*

          Describes a propagation route table.
          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the propagation route table.
    """


_ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a route table and a resource attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef",
    {
        "Associations": List[
            ClientGetTransitGatewayRouteTableAssociationsResponseAssociationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef(
    _ClientGetTransitGatewayRouteTableAssociationsResponseTypeDef
):
    """
    - *(dict) --*

      - **Associations** *(list) --*

        Information about the associations.
        - *(dict) --*

          Describes an association between a route table and a resource attachment.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef
):
    """
    - *(dict) --*

      Describes a route table propagation.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef = TypedDict(
    "_ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef",
    {
        "TransitGatewayRouteTablePropagations": List[
            ClientGetTransitGatewayRouteTablePropagationsResponseTransitGatewayRouteTablePropagationsTypeDef
        ],
        "NextToken": str,
    },
    total=False,
)


class ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef(
    _ClientGetTransitGatewayRouteTablePropagationsResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTablePropagations** *(list) --*

        Information about the route table propagations.
        - *(dict) --*

          Describes a route table propagation.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_ClientImportClientVpnClientCertificateRevocationListResponseTypeDef = TypedDict(
    "_ClientImportClientVpnClientCertificateRevocationListResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientImportClientVpnClientCertificateRevocationListResponseTypeDef(
    _ClientImportClientVpnClientCertificateRevocationListResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientImportImageClientDataTypeDef = TypedDict(
    "_ClientImportImageClientDataTypeDef",
    {"Comment": str, "UploadEnd": datetime, "UploadSize": float, "UploadStart": datetime},
    total=False,
)


class ClientImportImageClientDataTypeDef(_ClientImportImageClientDataTypeDef):
    """
    The client-specific data.
    - **Comment** *(string) --*

      A user-defined comment about the disk upload.
    """


_ClientImportImageDiskContainersUserBucketTypeDef = TypedDict(
    "_ClientImportImageDiskContainersUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportImageDiskContainersUserBucketTypeDef(
    _ClientImportImageDiskContainersUserBucketTypeDef
):
    pass


_ClientImportImageDiskContainersTypeDef = TypedDict(
    "_ClientImportImageDiskContainersTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "Format": str,
        "SnapshotId": str,
        "Url": str,
        "UserBucket": ClientImportImageDiskContainersUserBucketTypeDef,
    },
    total=False,
)


class ClientImportImageDiskContainersTypeDef(_ClientImportImageDiskContainersTypeDef):
    """
    - *(dict) --*

      Describes the disk container object for an import image task.
      - **Description** *(string) --*

        The description of the disk image.
    """


_ClientImportImageLicenseSpecificationsTypeDef = TypedDict(
    "_ClientImportImageLicenseSpecificationsTypeDef", {"LicenseConfigurationArn": str}, total=False
)


class ClientImportImageLicenseSpecificationsTypeDef(_ClientImportImageLicenseSpecificationsTypeDef):
    """
    - *(dict) --*

      The request information of license configurations.
      - **LicenseConfigurationArn** *(string) --*

        The ARN of a license configuration.
    """


_ClientImportImageResponseLicenseSpecificationsTypeDef = TypedDict(
    "_ClientImportImageResponseLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientImportImageResponseLicenseSpecificationsTypeDef(
    _ClientImportImageResponseLicenseSpecificationsTypeDef
):
    pass


_ClientImportImageResponseSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_ClientImportImageResponseSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportImageResponseSnapshotDetailsUserBucketTypeDef(
    _ClientImportImageResponseSnapshotDetailsUserBucketTypeDef
):
    pass


_ClientImportImageResponseSnapshotDetailsTypeDef = TypedDict(
    "_ClientImportImageResponseSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientImportImageResponseSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class ClientImportImageResponseSnapshotDetailsTypeDef(
    _ClientImportImageResponseSnapshotDetailsTypeDef
):
    pass


_ClientImportImageResponseTypeDef = TypedDict(
    "_ClientImportImageResponseTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[ClientImportImageResponseSnapshotDetailsTypeDef],
        "Status": str,
        "StatusMessage": str,
        "LicenseSpecifications": List[ClientImportImageResponseLicenseSpecificationsTypeDef],
    },
    total=False,
)


class ClientImportImageResponseTypeDef(_ClientImportImageResponseTypeDef):
    """
    - *(dict) --*

      - **Architecture** *(string) --*

        The architecture of the virtual machine.
    """


_ClientImportInstanceDiskImagesImageTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesImageTypeDef",
    {"Bytes": int, "Format": Literal["VMDK", "RAW", "VHD"], "ImportManifestUrl": str},
    total=False,
)


class ClientImportInstanceDiskImagesImageTypeDef(_ClientImportInstanceDiskImagesImageTypeDef):
    pass


_ClientImportInstanceDiskImagesVolumeTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesVolumeTypeDef", {"Size": int}, total=False
)


class ClientImportInstanceDiskImagesVolumeTypeDef(_ClientImportInstanceDiskImagesVolumeTypeDef):
    pass


_ClientImportInstanceDiskImagesTypeDef = TypedDict(
    "_ClientImportInstanceDiskImagesTypeDef",
    {
        "Description": str,
        "Image": ClientImportInstanceDiskImagesImageTypeDef,
        "Volume": ClientImportInstanceDiskImagesVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceDiskImagesTypeDef(_ClientImportInstanceDiskImagesTypeDef):
    """
    - *(dict) --*

      Describes a disk image.
      - **Description** *(string) --*

        A description of the disk image.
    """


_ClientImportInstanceLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientImportInstanceLaunchSpecificationPlacementTypeDef(
    _ClientImportInstanceLaunchSpecificationPlacementTypeDef
):
    pass


_ClientImportInstanceLaunchSpecificationUserDataTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationUserDataTypeDef", {"Data": str}, total=False
)


class ClientImportInstanceLaunchSpecificationUserDataTypeDef(
    _ClientImportInstanceLaunchSpecificationUserDataTypeDef
):
    pass


_ClientImportInstanceLaunchSpecificationTypeDef = TypedDict(
    "_ClientImportInstanceLaunchSpecificationTypeDef",
    {
        "AdditionalInfo": str,
        "Architecture": Literal["i386", "x86_64", "arm64"],
        "GroupIds": List[str],
        "GroupNames": List[str],
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Monitoring": bool,
        "Placement": ClientImportInstanceLaunchSpecificationPlacementTypeDef,
        "PrivateIpAddress": str,
        "SubnetId": str,
        "UserData": ClientImportInstanceLaunchSpecificationUserDataTypeDef,
    },
    total=False,
)


class ClientImportInstanceLaunchSpecificationTypeDef(
    _ClientImportInstanceLaunchSpecificationTypeDef
):
    """
    The launch specification.
    - **AdditionalInfo** *(string) --*

      Reserved.
    """


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportInstanceResponseConversionTaskImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientImportInstanceResponseConversionTaskImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportInstanceTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[ClientImportInstanceResponseConversionTaskImportInstanceVolumesTypeDef],
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportInstanceTypeDef(
    _ClientImportInstanceResponseConversionTaskImportInstanceTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskImportVolumeTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportInstanceResponseConversionTaskImportVolumeImageTypeDef,
        "Volume": ClientImportInstanceResponseConversionTaskImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskImportVolumeTypeDef(
    _ClientImportInstanceResponseConversionTaskImportVolumeTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskTagsTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientImportInstanceResponseConversionTaskTagsTypeDef(
    _ClientImportInstanceResponseConversionTaskTagsTypeDef
):
    pass


_ClientImportInstanceResponseConversionTaskTypeDef = TypedDict(
    "_ClientImportInstanceResponseConversionTaskTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientImportInstanceResponseConversionTaskImportInstanceTypeDef,
        "ImportVolume": ClientImportInstanceResponseConversionTaskImportVolumeTypeDef,
        "State": Literal["active", "cancelling", "cancelled", "completed"],
        "StatusMessage": str,
        "Tags": List[ClientImportInstanceResponseConversionTaskTagsTypeDef],
    },
    total=False,
)


class ClientImportInstanceResponseConversionTaskTypeDef(
    _ClientImportInstanceResponseConversionTaskTypeDef
):
    """
    - **ConversionTask** *(dict) --*

      Information about the conversion task.
      - **ConversionTaskId** *(string) --*

        The ID of the conversion task.
    """


_ClientImportInstanceResponseTypeDef = TypedDict(
    "_ClientImportInstanceResponseTypeDef",
    {"ConversionTask": ClientImportInstanceResponseConversionTaskTypeDef},
    total=False,
)


class ClientImportInstanceResponseTypeDef(_ClientImportInstanceResponseTypeDef):
    """
    - *(dict) --*

      - **ConversionTask** *(dict) --*

        Information about the conversion task.
        - **ConversionTaskId** *(string) --*

          The ID of the conversion task.
    """


_ClientImportKeyPairResponseTypeDef = TypedDict(
    "_ClientImportKeyPairResponseTypeDef", {"KeyFingerprint": str, "KeyName": str}, total=False
)


class ClientImportKeyPairResponseTypeDef(_ClientImportKeyPairResponseTypeDef):
    """
    - *(dict) --*

      - **KeyFingerprint** *(string) --*

        The MD5 public key fingerprint as specified in section 4 of RFC 4716.
    """


_ClientImportSnapshotClientDataTypeDef = TypedDict(
    "_ClientImportSnapshotClientDataTypeDef",
    {"Comment": str, "UploadEnd": datetime, "UploadSize": float, "UploadStart": datetime},
    total=False,
)


class ClientImportSnapshotClientDataTypeDef(_ClientImportSnapshotClientDataTypeDef):
    """
    The client-specific data.
    - **Comment** *(string) --*

      A user-defined comment about the disk upload.
    """


_ClientImportSnapshotDiskContainerUserBucketTypeDef = TypedDict(
    "_ClientImportSnapshotDiskContainerUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportSnapshotDiskContainerUserBucketTypeDef(
    _ClientImportSnapshotDiskContainerUserBucketTypeDef
):
    pass


_ClientImportSnapshotDiskContainerTypeDef = TypedDict(
    "_ClientImportSnapshotDiskContainerTypeDef",
    {
        "Description": str,
        "Format": str,
        "Url": str,
        "UserBucket": ClientImportSnapshotDiskContainerUserBucketTypeDef,
    },
    total=False,
)


class ClientImportSnapshotDiskContainerTypeDef(_ClientImportSnapshotDiskContainerTypeDef):
    """
    Information about the disk container.
    - **Description** *(string) --*

      The description of the disk image being imported.
    """


_ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef(
    _ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef
):
    pass


_ClientImportSnapshotResponseSnapshotTaskDetailTypeDef = TypedDict(
    "_ClientImportSnapshotResponseSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": ClientImportSnapshotResponseSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class ClientImportSnapshotResponseSnapshotTaskDetailTypeDef(
    _ClientImportSnapshotResponseSnapshotTaskDetailTypeDef
):
    pass


_ClientImportSnapshotResponseTypeDef = TypedDict(
    "_ClientImportSnapshotResponseTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": ClientImportSnapshotResponseSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class ClientImportSnapshotResponseTypeDef(_ClientImportSnapshotResponseTypeDef):
    """
    - *(dict) --*

      - **Description** *(string) --*

        A description of the import snapshot task.
    """


_RequiredClientImportVolumeImageTypeDef = TypedDict(
    "_RequiredClientImportVolumeImageTypeDef", {"Bytes": int}
)
_OptionalClientImportVolumeImageTypeDef = TypedDict(
    "_OptionalClientImportVolumeImageTypeDef",
    {"Format": Literal["VMDK", "RAW", "VHD"], "ImportManifestUrl": str},
    total=False,
)


class ClientImportVolumeImageTypeDef(
    _RequiredClientImportVolumeImageTypeDef, _OptionalClientImportVolumeImageTypeDef
):
    """
    The disk image.
    - **Bytes** *(integer) --***[REQUIRED]**

      The size of the disk image, in GiB.
    """


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportVolumeResponseConversionTaskImportInstanceVolumesImageTypeDef,
        "Status": str,
        "StatusMessage": str,
        "Volume": ClientImportVolumeResponseConversionTaskImportInstanceVolumesVolumeTypeDef,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportInstanceTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportInstanceTypeDef",
    {
        "Description": str,
        "InstanceId": str,
        "Platform": str,
        "Volumes": List[ClientImportVolumeResponseConversionTaskImportInstanceVolumesTypeDef],
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportInstanceTypeDef(
    _ClientImportVolumeResponseConversionTaskImportInstanceTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef",
    {
        "Checksum": str,
        "Format": Literal["VMDK", "RAW", "VHD"],
        "ImportManifestUrl": str,
        "Size": int,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef",
    {"Id": str, "Size": int},
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskImportVolumeTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskImportVolumeTypeDef",
    {
        "AvailabilityZone": str,
        "BytesConverted": int,
        "Description": str,
        "Image": ClientImportVolumeResponseConversionTaskImportVolumeImageTypeDef,
        "Volume": ClientImportVolumeResponseConversionTaskImportVolumeVolumeTypeDef,
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskImportVolumeTypeDef(
    _ClientImportVolumeResponseConversionTaskImportVolumeTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskTagsTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientImportVolumeResponseConversionTaskTagsTypeDef(
    _ClientImportVolumeResponseConversionTaskTagsTypeDef
):
    pass


_ClientImportVolumeResponseConversionTaskTypeDef = TypedDict(
    "_ClientImportVolumeResponseConversionTaskTypeDef",
    {
        "ConversionTaskId": str,
        "ExpirationTime": str,
        "ImportInstance": ClientImportVolumeResponseConversionTaskImportInstanceTypeDef,
        "ImportVolume": ClientImportVolumeResponseConversionTaskImportVolumeTypeDef,
        "State": Literal["active", "cancelling", "cancelled", "completed"],
        "StatusMessage": str,
        "Tags": List[ClientImportVolumeResponseConversionTaskTagsTypeDef],
    },
    total=False,
)


class ClientImportVolumeResponseConversionTaskTypeDef(
    _ClientImportVolumeResponseConversionTaskTypeDef
):
    """
    - **ConversionTask** *(dict) --*

      Information about the conversion task.
      - **ConversionTaskId** *(string) --*

        The ID of the conversion task.
    """


_ClientImportVolumeResponseTypeDef = TypedDict(
    "_ClientImportVolumeResponseTypeDef",
    {"ConversionTask": ClientImportVolumeResponseConversionTaskTypeDef},
    total=False,
)


class ClientImportVolumeResponseTypeDef(_ClientImportVolumeResponseTypeDef):
    """
    - *(dict) --*

      - **ConversionTask** *(dict) --*

        Information about the conversion task.
        - **ConversionTaskId** *(string) --*

          The ID of the conversion task.
    """


_ClientImportVolumeVolumeTypeDef = TypedDict("_ClientImportVolumeVolumeTypeDef", {"Size": int})


class ClientImportVolumeVolumeTypeDef(_ClientImportVolumeVolumeTypeDef):
    """
    The volume size.
    - **Size** *(integer) --***[REQUIRED]**

      The size of the volume, in GiB.
    """


_ClientModifyCapacityReservationResponseTypeDef = TypedDict(
    "_ClientModifyCapacityReservationResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyCapacityReservationResponseTypeDef(
    _ClientModifyCapacityReservationResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef(
    _ClientModifyClientVpnEndpointConnectionLogOptionsTypeDef
):
    """
    Information about the client connection logging options.
    If you enable client connection logging, data about client connections is sent to a Cloudwatch
    Logs log stream. The following information is logged:
    * Client connection requests
    * Client connection results (successful and unsuccessful)
    * Reasons for unsuccessful client connection requests
    * Client connection termination time
    - **Enabled** *(boolean) --*

      Indicates whether connection logging is enabled.
    """


_ClientModifyClientVpnEndpointDnsServersTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointDnsServersTypeDef",
    {"CustomDnsServers": List[str], "Enabled": bool},
    total=False,
)


class ClientModifyClientVpnEndpointDnsServersTypeDef(
    _ClientModifyClientVpnEndpointDnsServersTypeDef
):
    """
    Information about the DNS servers to be used by Client VPN connections. A Client VPN endpoint
    can have up to two DNS servers.
    - **CustomDnsServers** *(list) --*

      The IPv4 address range, in CIDR notation, of the DNS servers to be used. You can specify up to
      two DNS servers. Ensure that the DNS servers can be reached by the clients. The specified
      values overwrite the existing values.
      - *(string) --*
    """


_ClientModifyClientVpnEndpointResponseTypeDef = TypedDict(
    "_ClientModifyClientVpnEndpointResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyClientVpnEndpointResponseTypeDef(_ClientModifyClientVpnEndpointResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef = TypedDict(
    "_ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef",
    {"InstanceFamily": Literal["t2", "t3", "t3a"], "CpuCredits": str},
    total=False,
)


class ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef(
    _ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef
):
    """
    - **InstanceFamilyCreditSpecification** *(dict) --*

      The default credit option for CPU usage of the instance family.
      - **InstanceFamily** *(string) --*

        The instance family.
    """


_ClientModifyDefaultCreditSpecificationResponseTypeDef = TypedDict(
    "_ClientModifyDefaultCreditSpecificationResponseTypeDef",
    {
        "InstanceFamilyCreditSpecification": ClientModifyDefaultCreditSpecificationResponseInstanceFamilyCreditSpecificationTypeDef
    },
    total=False,
)


class ClientModifyDefaultCreditSpecificationResponseTypeDef(
    _ClientModifyDefaultCreditSpecificationResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceFamilyCreditSpecification** *(dict) --*

        The default credit option for CPU usage of the instance family.
        - **InstanceFamily** *(string) --*

          The instance family.
    """


_ClientModifyEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientModifyEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientModifyEbsDefaultKmsKeyIdResponseTypeDef(_ClientModifyEbsDefaultKmsKeyIdResponseTypeDef):
    """
    - *(dict) --*

      - **KmsKeyId** *(string) --*

        The Amazon Resource Name (ARN) of the default CMK for encryption by default.
    """


_ClientModifyFleetResponseTypeDef = TypedDict(
    "_ClientModifyFleetResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyFleetResponseTypeDef(_ClientModifyFleetResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Is ``true`` if the request succeeds, and an error otherwise.
    """


_RequiredClientModifyFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_RequiredClientModifyFleetTargetCapacitySpecificationTypeDef", {"TotalTargetCapacity": int}
)
_OptionalClientModifyFleetTargetCapacitySpecificationTypeDef = TypedDict(
    "_OptionalClientModifyFleetTargetCapacitySpecificationTypeDef",
    {
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": Literal["spot", "on-demand"],
    },
    total=False,
)


class ClientModifyFleetTargetCapacitySpecificationTypeDef(
    _RequiredClientModifyFleetTargetCapacitySpecificationTypeDef,
    _OptionalClientModifyFleetTargetCapacitySpecificationTypeDef,
):
    """
    The size of the EC2 Fleet.
    - **TotalTargetCapacity** *(integer) --***[REQUIRED]**

      The number of units to request, filled using ``DefaultTargetCapacityType`` .
    """


_ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef
):
    """
    - *(dict) --*

      Describes a load permission.
      - **Group** *(string) --*

        The name of the group.
    """


_ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef
):
    pass


_ClientModifyFpgaImageAttributeLoadPermissionTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeLoadPermissionTypeDef",
    {
        "Add": List[ClientModifyFpgaImageAttributeLoadPermissionAddTypeDef],
        "Remove": List[ClientModifyFpgaImageAttributeLoadPermissionRemoveTypeDef],
    },
    total=False,
)


class ClientModifyFpgaImageAttributeLoadPermissionTypeDef(
    _ClientModifyFpgaImageAttributeLoadPermissionTypeDef
):
    """
    The load permission for the AFI.
    - **Add** *(list) --*

      The load permissions to add.
      - *(dict) --*

        Describes a load permission.
        - **Group** *(string) --*

          The name of the group.
    """


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef",
    {"UserId": str, "Group": str},
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
):
    pass


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
):
    pass


_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef",
    {
        "FpgaImageId": str,
        "Name": str,
        "Description": str,
        "LoadPermissions": List[
            ClientModifyFpgaImageAttributeResponseFpgaImageAttributeLoadPermissionsTypeDef
        ],
        "ProductCodes": List[
            ClientModifyFpgaImageAttributeResponseFpgaImageAttributeProductCodesTypeDef
        ],
    },
    total=False,
)


class ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef(
    _ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef
):
    """
    - **FpgaImageAttribute** *(dict) --*

      Information about the attribute.
      - **FpgaImageId** *(string) --*

        The ID of the AFI.
    """


_ClientModifyFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientModifyFpgaImageAttributeResponseTypeDef",
    {"FpgaImageAttribute": ClientModifyFpgaImageAttributeResponseFpgaImageAttributeTypeDef},
    total=False,
)


class ClientModifyFpgaImageAttributeResponseTypeDef(_ClientModifyFpgaImageAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **FpgaImageAttribute** *(dict) --*

        Information about the attribute.
        - **FpgaImageId** *(string) --*

          The ID of the AFI.
    """


_ClientModifyHostsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientModifyHostsResponseUnsuccessfulErrorTypeDef", {"Code": str, "Message": str}, total=False
)


class ClientModifyHostsResponseUnsuccessfulErrorTypeDef(
    _ClientModifyHostsResponseUnsuccessfulErrorTypeDef
):
    pass


_ClientModifyHostsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientModifyHostsResponseUnsuccessfulTypeDef",
    {"Error": ClientModifyHostsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientModifyHostsResponseUnsuccessfulTypeDef(_ClientModifyHostsResponseUnsuccessfulTypeDef):
    pass


_ClientModifyHostsResponseTypeDef = TypedDict(
    "_ClientModifyHostsResponseTypeDef",
    {"Successful": List[str], "Unsuccessful": List[ClientModifyHostsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientModifyHostsResponseTypeDef(_ClientModifyHostsResponseTypeDef):
    """
    - *(dict) --*

      - **Successful** *(list) --*

        The IDs of the Dedicated Hosts that were successfully modified.
        - *(string) --*
    """


_ClientModifyImageAttributeDescriptionTypeDef = TypedDict(
    "_ClientModifyImageAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class ClientModifyImageAttributeDescriptionTypeDef(_ClientModifyImageAttributeDescriptionTypeDef):
    """
    A new description for the AMI.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyImageAttributeLaunchPermissionAddTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionAddTypeDef(
    _ClientModifyImageAttributeLaunchPermissionAddTypeDef
):
    """
    - *(dict) --*

      Describes a launch permission.
      - **Group** *(string) --*

        The name of the group.
    """


_ClientModifyImageAttributeLaunchPermissionRemoveTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionRemoveTypeDef(
    _ClientModifyImageAttributeLaunchPermissionRemoveTypeDef
):
    pass


_ClientModifyImageAttributeLaunchPermissionTypeDef = TypedDict(
    "_ClientModifyImageAttributeLaunchPermissionTypeDef",
    {
        "Add": List[ClientModifyImageAttributeLaunchPermissionAddTypeDef],
        "Remove": List[ClientModifyImageAttributeLaunchPermissionRemoveTypeDef],
    },
    total=False,
)


class ClientModifyImageAttributeLaunchPermissionTypeDef(
    _ClientModifyImageAttributeLaunchPermissionTypeDef
):
    """
    A new launch permission for the AMI.
    - **Add** *(list) --*

      The AWS account ID to add to the list of launch permissions for the AMI.
      - *(dict) --*

        Describes a launch permission.
        - **Group** *(string) --*

          The name of the group.
    """


_ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef",
    {"DeleteOnTermination": bool, "VolumeId": str},
    total=False,
)


class ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef(
    _ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientModifyInstanceAttributeBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef(
    _ClientModifyInstanceAttributeBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping entry.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientModifyInstanceAttributeDisableApiTerminationTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeDisableApiTerminationTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeDisableApiTerminationTypeDef(
    _ClientModifyInstanceAttributeDisableApiTerminationTypeDef
):
    """
    If the value is ``true`` , you can't terminate the instance using the Amazon EC2 console, CLI,
    or API; otherwise, you can. You cannot use this parameter for Spot Instances.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeEbsOptimizedTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeEbsOptimizedTypeDef(
    _ClientModifyInstanceAttributeEbsOptimizedTypeDef
):
    """
    Specifies whether the instance is optimized for Amazon EBS I/O. This optimization provides
    dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS
    I/O performance. This optimization isn't available with all instance types. Additional usage
    charges apply when using an EBS Optimized instance.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeEnaSupportTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeEnaSupportTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeEnaSupportTypeDef(
    _ClientModifyInstanceAttributeEnaSupportTypeDef
):
    """
    Set to ``true`` to enable enhanced networking with ENA for the instance.
    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef(
    _ClientModifyInstanceAttributeInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Specifies whether an instance stops or terminates when you initiate shutdown from the instance
    (using the operating system command for system shutdown).
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeInstanceTypeTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeInstanceTypeTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeInstanceTypeTypeDef(
    _ClientModifyInstanceAttributeInstanceTypeTypeDef
):
    """
    Changes the instance type to the specified value. For more information, see `Instance Types
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ . If the instance
    type is not valid, the error returned is ``InvalidInstanceAttributeValue`` .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeKernelTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeKernelTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeKernelTypeDef(_ClientModifyInstanceAttributeKernelTypeDef):
    """
    Changes the instance's kernel to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeRamdiskTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeRamdiskTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeRamdiskTypeDef(_ClientModifyInstanceAttributeRamdiskTypeDef):
    """
    Changes the instance's RAM disk to the specified value. We recommend that you use PV-GRUB
    instead of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeSourceDestCheckTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class ClientModifyInstanceAttributeSourceDestCheckTypeDef(
    _ClientModifyInstanceAttributeSourceDestCheckTypeDef
):
    """
    Specifies whether source/destination checking is enabled. A value of ``true`` means that
    checking is enabled, and ``false`` means that checking is disabled. This value must be ``false``
    for a NAT instance to perform NAT.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyInstanceAttributeSriovNetSupportTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ClientModifyInstanceAttributeSriovNetSupportTypeDef(
    _ClientModifyInstanceAttributeSriovNetSupportTypeDef
):
    """
    Set to ``simple`` to enable enhanced networking with the Intel 82599 Virtual Function interface
    for the instance.
    There is no way to disable enhanced networking with the Intel 82599 Virtual Function interface
    at this time.
    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyInstanceAttributeUserDataTypeDef = TypedDict(
    "_ClientModifyInstanceAttributeUserDataTypeDef", {"Value": bytes}, total=False
)


class ClientModifyInstanceAttributeUserDataTypeDef(_ClientModifyInstanceAttributeUserDataTypeDef):
    """
    Changes the instance's user data to the specified value. If you are using an AWS SDK or command
    line tool, base64-encoding is performed for you, and you can load the text from a file.
    Otherwise, you must provide base64-encoded text.
    - **Value** *(bytes) --*
    """


_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesCapacityReservationSpecificationTypeDef
):
    """
    Information about the Capacity Reservation targeting option.
    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:
      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).
      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.
    """


_ClientModifyInstanceCapacityReservationAttributesResponseTypeDef = TypedDict(
    "_ClientModifyInstanceCapacityReservationAttributesResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientModifyInstanceCapacityReservationAttributesResponseTypeDef(
    _ClientModifyInstanceCapacityReservationAttributesResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationInstanceCreditSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes the credit option for CPU usage of a burstable performance instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str},
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes the burstable performance instance whose credit option for CPU usage was
      successfully modified.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef",
    {
        "Code": Literal[
            "InvalidInstanceID.Malformed",
            "InvalidInstanceID.NotFound",
            "IncorrectInstanceState",
            "InstanceCreditSpecification.NotSupported",
        ],
        "Message": str,
    },
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef
):
    pass


_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef",
    {
        "InstanceId": str,
        "Error": ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsErrorTypeDef,
    },
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef
):
    pass


_ClientModifyInstanceCreditSpecificationResponseTypeDef = TypedDict(
    "_ClientModifyInstanceCreditSpecificationResponseTypeDef",
    {
        "SuccessfulInstanceCreditSpecifications": List[
            ClientModifyInstanceCreditSpecificationResponseSuccessfulInstanceCreditSpecificationsTypeDef
        ],
        "UnsuccessfulInstanceCreditSpecifications": List[
            ClientModifyInstanceCreditSpecificationResponseUnsuccessfulInstanceCreditSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientModifyInstanceCreditSpecificationResponseTypeDef(
    _ClientModifyInstanceCreditSpecificationResponseTypeDef
):
    """
    - *(dict) --*

      - **SuccessfulInstanceCreditSpecifications** *(list) --*

        Information about the instances whose credit option for CPU usage was successfully modified.
        - *(dict) --*

          Describes the burstable performance instance whose credit option for CPU usage was
          successfully modified.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientModifyInstanceEventStartTimeResponseEventTypeDef = TypedDict(
    "_ClientModifyInstanceEventStartTimeResponseEventTypeDef",
    {
        "InstanceEventId": str,
        "Code": Literal[
            "instance-reboot",
            "system-reboot",
            "system-maintenance",
            "instance-retirement",
            "instance-stop",
        ],
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class ClientModifyInstanceEventStartTimeResponseEventTypeDef(
    _ClientModifyInstanceEventStartTimeResponseEventTypeDef
):
    """
    - **Event** *(dict) --*

      Describes a scheduled event for an instance.
      - **InstanceEventId** *(string) --*

        The ID of the event.
    """


_ClientModifyInstanceEventStartTimeResponseTypeDef = TypedDict(
    "_ClientModifyInstanceEventStartTimeResponseTypeDef",
    {"Event": ClientModifyInstanceEventStartTimeResponseEventTypeDef},
    total=False,
)


class ClientModifyInstanceEventStartTimeResponseTypeDef(
    _ClientModifyInstanceEventStartTimeResponseTypeDef
):
    """
    - *(dict) --*

      - **Event** *(dict) --*

        Describes a scheduled event for an instance.
        - **InstanceEventId** *(string) --*

          The ID of the event.
    """


_ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef = TypedDict(
    "_ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef",
    {
        "State": Literal["pending", "applied"],
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef(
    _ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef
):
    pass


_ClientModifyInstanceMetadataOptionsResponseTypeDef = TypedDict(
    "_ClientModifyInstanceMetadataOptionsResponseTypeDef",
    {
        "InstanceId": str,
        "InstanceMetadataOptions": ClientModifyInstanceMetadataOptionsResponseInstanceMetadataOptionsTypeDef,
    },
    total=False,
)


class ClientModifyInstanceMetadataOptionsResponseTypeDef(
    _ClientModifyInstanceMetadataOptionsResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientModifyInstancePlacementResponseTypeDef = TypedDict(
    "_ClientModifyInstancePlacementResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyInstancePlacementResponseTypeDef(_ClientModifyInstancePlacementResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef(
    _ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef
):
    pass


_ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[ClientModifyLaunchTemplateResponseLaunchTemplateTagsTypeDef],
    },
    total=False,
)


class ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef(
    _ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef
):
    """
    - **LaunchTemplate** *(dict) --*

      Information about the launch template.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_ClientModifyLaunchTemplateResponseTypeDef = TypedDict(
    "_ClientModifyLaunchTemplateResponseTypeDef",
    {"LaunchTemplate": ClientModifyLaunchTemplateResponseLaunchTemplateTypeDef},
    total=False,
)


class ClientModifyLaunchTemplateResponseTypeDef(_ClientModifyLaunchTemplateResponseTypeDef):
    """
    - *(dict) --*

      - **LaunchTemplate** *(dict) --*

        Information about the launch template.
        - **LaunchTemplateId** *(string) --*

          The ID of the launch template.
    """


_ClientModifyNetworkInterfaceAttributeAttachmentTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeAttachmentTypeDef",
    {"AttachmentId": str, "DeleteOnTermination": bool},
    total=False,
)


class ClientModifyNetworkInterfaceAttributeAttachmentTypeDef(
    _ClientModifyNetworkInterfaceAttributeAttachmentTypeDef
):
    """
    Information about the interface attachment. If modifying the 'delete on termination' attribute,
    you must specify the ID of the interface attachment.
    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.
    """


_ClientModifyNetworkInterfaceAttributeDescriptionTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class ClientModifyNetworkInterfaceAttributeDescriptionTypeDef(
    _ClientModifyNetworkInterfaceAttributeDescriptionTypeDef
):
    """
    A description for the network interface.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef = TypedDict(
    "_ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef(
    _ClientModifyNetworkInterfaceAttributeSourceDestCheckTypeDef
):
    """
    Indicates whether source/destination checking is enabled. A value of ``true`` means checking is
    enabled, and ``false`` means checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT. For more information, see `NAT Instances
    <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the *Amazon
    Virtual Private Cloud User Guide* .
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyReservedInstancesResponseTypeDef = TypedDict(
    "_ClientModifyReservedInstancesResponseTypeDef",
    {"ReservedInstancesModificationId": str},
    total=False,
)


class ClientModifyReservedInstancesResponseTypeDef(_ClientModifyReservedInstancesResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of ModifyReservedInstances.
      - **ReservedInstancesModificationId** *(string) --*

        The ID for the modification.
    """


_ClientModifyReservedInstancesTargetConfigurationsTypeDef = TypedDict(
    "_ClientModifyReservedInstancesTargetConfigurationsTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
        "Scope": Literal["Availability Zone", "Region"],
    },
    total=False,
)


class ClientModifyReservedInstancesTargetConfigurationsTypeDef(
    _ClientModifyReservedInstancesTargetConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes the configuration settings for the modified Reserved Instances.
      - **AvailabilityZone** *(string) --*

        The Availability Zone for the modified Reserved Instances.
    """


_ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef
):
    """
    - *(dict) --*

      Describes the user or group to be added or removed from the list of create volume permissions
      for a volume.
      - **Group** *(string) --*

        The group to be added or removed. The possible value is ``all`` .
    """


_ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef
):
    pass


_ClientModifySnapshotAttributeCreateVolumePermissionTypeDef = TypedDict(
    "_ClientModifySnapshotAttributeCreateVolumePermissionTypeDef",
    {
        "Add": List[ClientModifySnapshotAttributeCreateVolumePermissionAddTypeDef],
        "Remove": List[ClientModifySnapshotAttributeCreateVolumePermissionRemoveTypeDef],
    },
    total=False,
)


class ClientModifySnapshotAttributeCreateVolumePermissionTypeDef(
    _ClientModifySnapshotAttributeCreateVolumePermissionTypeDef
):
    """
    A JSON representation of the snapshot attribute modification.
    - **Add** *(list) --*

      Adds the specified AWS account ID or group to the list.
      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume
        permissions for a volume.
        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .
    """


_ClientModifySpotFleetRequestResponseTypeDef = TypedDict(
    "_ClientModifySpotFleetRequestResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifySpotFleetRequestResponseTypeDef(_ClientModifySpotFleetRequestResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of ModifySpotFleetRequest.
      - **Return** *(boolean) --*

        Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef = TypedDict(
    "_ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef", {"Value": bool}, total=False
)


class ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef(
    _ClientModifySubnetAttributeAssignIpv6AddressOnCreationTypeDef
):
    """
    Specify ``true`` to indicate that network interfaces created in the specified subnet should be
    assigned an IPv6 address. This includes a network interface that's created when launching an
    instance into the subnet (the instance therefore receives an IPv6 address).
    If you enable the IPv6 addressing feature for your subnet, your network interface or instance
    only receives an IPv6 address if it's created using version ``2016-11-15`` or later of the
    Amazon EC2 API.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef = TypedDict(
    "_ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef", {"Value": bool}, total=False
)


class ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef(
    _ClientModifySubnetAttributeMapPublicIpOnLaunchTypeDef
):
    """
    Specify ``true`` to indicate that ENIs attached to instances created in the specified subnet
    should be assigned a public IPv4 address.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[
            ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTagsTypeDef
        ],
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef
):
    """
    - **TrafficMirrorFilter** *(dict) --*

      The Traffic Mirror filter that the network service is associated with.
      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.
    """


_ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef",
    {
        "TrafficMirrorFilter": ClientModifyTrafficMirrorFilterNetworkServicesResponseTrafficMirrorFilterTypeDef
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef(
    _ClientModifyTrafficMirrorFilterNetworkServicesResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilter** *(dict) --*

        The Traffic Mirror filter that the network service is associated with.
        - **TrafficMirrorFilterId** *(string) --*

          The ID of the Traffic Mirror filter.
    """


_ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    """
    The destination ports that are associated with the Traffic Mirror rule.
    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    pass


_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleDestinationPortRangeTypeDef,
        "SourcePortRange": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
):
    """
    - **TrafficMirrorFilterRule** *(dict) --*

      Modifies a Traffic Mirror rule.
      - **TrafficMirrorFilterRuleId** *(string) --*

        The ID of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterRuleResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleResponseTypeDef",
    {
        "TrafficMirrorFilterRule": ClientModifyTrafficMirrorFilterRuleResponseTrafficMirrorFilterRuleTypeDef
    },
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleResponseTypeDef(
    _ClientModifyTrafficMirrorFilterRuleResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilterRule** *(dict) --*

        Modifies a Traffic Mirror rule.
        - **TrafficMirrorFilterRuleId** *(string) --*

          The ID of the Traffic Mirror rule.
    """


_ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef(
    _ClientModifyTrafficMirrorFilterRuleSourcePortRangeTypeDef
):
    """
    The port range to assign to the Traffic Mirror rule.
    - **FromPort** *(integer) --*

      The first port in the Traffic Mirror port range. This applies to the TCP and UDP protocols.
    """


_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef
):
    pass


_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTagsTypeDef],
    },
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef
):
    """
    - **TrafficMirrorSession** *(dict) --*

      Information about the Traffic Mirror session.
      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.
    """


_ClientModifyTrafficMirrorSessionResponseTypeDef = TypedDict(
    "_ClientModifyTrafficMirrorSessionResponseTypeDef",
    {"TrafficMirrorSession": ClientModifyTrafficMirrorSessionResponseTrafficMirrorSessionTypeDef},
    total=False,
)


class ClientModifyTrafficMirrorSessionResponseTypeDef(
    _ClientModifyTrafficMirrorSessionResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorSession** *(dict) --*

        Information about the Traffic Mirror session.
        - **TrafficMirrorSessionId** *(string) --*

          The ID for the Traffic Mirror session.
    """


_ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentOptionsTypeDef
):
    """
    The new VPC attachment options.
    - **DnsSupport** *(string) --*

      Enable or disable DNS support. The default is ``enable`` .
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    pass


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    pass


_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the modified attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientModifyTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientModifyTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientModifyTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientModifyTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientModifyTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachment** *(dict) --*

        Information about the modified attachment.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientModifyVolumeAttributeAutoEnableIOTypeDef = TypedDict(
    "_ClientModifyVolumeAttributeAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class ClientModifyVolumeAttributeAutoEnableIOTypeDef(
    _ClientModifyVolumeAttributeAutoEnableIOTypeDef
):
    """
    Indicates whether the volume should be auto-enabled for I/O operations.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVolumeResponseVolumeModificationTypeDef = TypedDict(
    "_ClientModifyVolumeResponseVolumeModificationTypeDef",
    {
        "VolumeId": str,
        "ModificationState": Literal["modifying", "optimizing", "completed", "failed"],
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class ClientModifyVolumeResponseVolumeModificationTypeDef(
    _ClientModifyVolumeResponseVolumeModificationTypeDef
):
    """
    - **VolumeModification** *(dict) --*

      Information about the volume modification.
      - **VolumeId** *(string) --*

        The ID of the volume.
    """


_ClientModifyVolumeResponseTypeDef = TypedDict(
    "_ClientModifyVolumeResponseTypeDef",
    {"VolumeModification": ClientModifyVolumeResponseVolumeModificationTypeDef},
    total=False,
)


class ClientModifyVolumeResponseTypeDef(_ClientModifyVolumeResponseTypeDef):
    """
    - *(dict) --*

      - **VolumeModification** *(dict) --*

        Information about the volume modification.
        - **VolumeId** *(string) --*

          The ID of the volume.
    """


_ClientModifyVpcAttributeEnableDnsHostnamesTypeDef = TypedDict(
    "_ClientModifyVpcAttributeEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class ClientModifyVpcAttributeEnableDnsHostnamesTypeDef(
    _ClientModifyVpcAttributeEnableDnsHostnamesTypeDef
):
    """
    Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in
    the VPC get DNS hostnames; otherwise, they do not.
    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS
    support.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVpcAttributeEnableDnsSupportTypeDef = TypedDict(
    "_ClientModifyVpcAttributeEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class ClientModifyVpcAttributeEnableDnsSupportTypeDef(
    _ClientModifyVpcAttributeEnableDnsSupportTypeDef
):
    """
    Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to the Amazon
    provided DNS server at the 169.254.169.253 IP address, or the reserved IP address at the base of
    the VPC network range "plus two" succeed. If disabled, the Amazon provided DNS service in the
    VPC that resolves public DNS hostnames to IP addresses is not enabled.
    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_ClientModifyVpcEndpointConnectionNotificationResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointConnectionNotificationResponseTypeDef",
    {"ReturnValue": bool},
    total=False,
)


class ClientModifyVpcEndpointConnectionNotificationResponseTypeDef(
    _ClientModifyVpcEndpointConnectionNotificationResponseTypeDef
):
    """
    - *(dict) --*

      - **ReturnValue** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyVpcEndpointResponseTypeDef(_ClientModifyVpcEndpointResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointServiceConfigurationResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointServiceConfigurationResponseTypeDef", {"Return": bool}, total=False
)


class ClientModifyVpcEndpointServiceConfigurationResponseTypeDef(
    _ClientModifyVpcEndpointServiceConfigurationResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcEndpointServicePermissionsResponseTypeDef = TypedDict(
    "_ClientModifyVpcEndpointServicePermissionsResponseTypeDef", {"ReturnValue": bool}, total=False
)


class ClientModifyVpcEndpointServicePermissionsResponseTypeDef(
    _ClientModifyVpcEndpointServicePermissionsResponseTypeDef
):
    """
    - *(dict) --*

      - **ReturnValue** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsAccepterPeeringConnectionOptionsTypeDef
):
    """
    The VPC peering connection options for the accepter VPC.
    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, enables a local VPC to resolve public DNS hostnames to private IP addresses when
      queried from instances in the peer VPC.
    """


_ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsRequesterPeeringConnectionOptionsTypeDef
):
    """
    The VPC peering connection options for the requester VPC.
    - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

      If true, enables a local VPC to resolve public DNS hostnames to private IP addresses when
      queried from instances in the peer VPC.
    """


_ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef
):
    """
    - **AccepterPeeringConnectionOptions** *(dict) --*

      Information about the VPC peering connection options for the accepter VPC.
      - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

        If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
        addresses when queried from instances in the peer VPC.
    """


_ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef
):
    pass


_ClientModifyVpcPeeringConnectionOptionsResponseTypeDef = TypedDict(
    "_ClientModifyVpcPeeringConnectionOptionsResponseTypeDef",
    {
        "AccepterPeeringConnectionOptions": ClientModifyVpcPeeringConnectionOptionsResponseAccepterPeeringConnectionOptionsTypeDef,
        "RequesterPeeringConnectionOptions": ClientModifyVpcPeeringConnectionOptionsResponseRequesterPeeringConnectionOptionsTypeDef,
    },
    total=False,
)


class ClientModifyVpcPeeringConnectionOptionsResponseTypeDef(
    _ClientModifyVpcPeeringConnectionOptionsResponseTypeDef
):
    """
    - *(dict) --*

      - **AccepterPeeringConnectionOptions** *(dict) --*

        Information about the VPC peering connection options for the accepter VPC.
        - **AllowDnsResolutionFromRemoteVpc** *(boolean) --*

          If true, the public DNS hostnames of instances in the specified VPC resolve to private IP
          addresses when queried from instances in the peer VPC.
    """


_ClientModifyVpcTenancyResponseTypeDef = TypedDict(
    "_ClientModifyVpcTenancyResponseTypeDef", {"ReturnValue": bool}, total=False
)


class ClientModifyVpcTenancyResponseTypeDef(_ClientModifyVpcTenancyResponseTypeDef):
    """
    - *(dict) --*

      - **ReturnValue** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnConnectionResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": Literal["UP", "DOWN"],
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef
):
    pass


_ClientModifyVpnConnectionResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnConnectionResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientModifyVpnConnectionResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientModifyVpnConnectionResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[ClientModifyVpnConnectionResponseVpnConnectionVgwTelemetryTypeDef],
    },
    total=False,
)


class ClientModifyVpnConnectionResponseVpnConnectionTypeDef(
    _ClientModifyVpnConnectionResponseVpnConnectionTypeDef
):
    """
    - **VpnConnection** *(dict) --*

      Describes a VPN connection.
      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.
    """


_ClientModifyVpnConnectionResponseTypeDef = TypedDict(
    "_ClientModifyVpnConnectionResponseTypeDef",
    {"VpnConnection": ClientModifyVpnConnectionResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnConnectionResponseTypeDef(_ClientModifyVpnConnectionResponseTypeDef):
    """
    - *(dict) --*

      - **VpnConnection** *(dict) --*

        Describes a VPN connection.
        - **CustomerGatewayConfiguration** *(string) --*

          The configuration information for the VPN connection's customer gateway (in the native XML
          format). This element is always present in the  CreateVpnConnection response; however,
          it's present in the  DescribeVpnConnections response only if the VPN connection is in the
          ``pending`` or ``available`` state.
    """


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": Literal["UP", "DOWN"],
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef
):
    pass


_ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnTunnelCertificateResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientModifyVpnTunnelCertificateResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientModifyVpnTunnelCertificateResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[
            ClientModifyVpnTunnelCertificateResponseVpnConnectionVgwTelemetryTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef(
    _ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef
):
    """
    - **VpnConnection** *(dict) --*

      Describes a VPN connection.
      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.
    """


_ClientModifyVpnTunnelCertificateResponseTypeDef = TypedDict(
    "_ClientModifyVpnTunnelCertificateResponseTypeDef",
    {"VpnConnection": ClientModifyVpnTunnelCertificateResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnTunnelCertificateResponseTypeDef(
    _ClientModifyVpnTunnelCertificateResponseTypeDef
):
    """
    - *(dict) --*

      - **VpnConnection** *(dict) --*

        Describes a VPN connection.
        - **CustomerGatewayConfiguration** *(string) --*

          The configuration information for the VPN connection's customer gateway (in the native XML
          format). This element is always present in the  CreateVpnConnection response; however,
          it's present in the  DescribeVpnConnections response only if the VPN connection is in the
          ``pending`` or ``available`` state.
    """


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef",
    {
        "OutsideIpAddress": str,
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DpdTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IkeVersions": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsIkeVersionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef",
    {
        "StaticRoutesOnly": bool,
        "TunnelOptions": List[
            ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTunnelOptionsTypeDef
        ],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "Source": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef",
    {
        "AcceptedRouteCount": int,
        "LastStatusChange": datetime,
        "OutsideIpAddress": str,
        "Status": Literal["UP", "DOWN"],
        "StatusMessage": str,
        "CertificateArn": str,
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef",
    {
        "CustomerGatewayConfiguration": str,
        "CustomerGatewayId": str,
        "Category": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "Type": str,
        "VpnConnectionId": str,
        "VpnGatewayId": str,
        "TransitGatewayId": str,
        "Options": ClientModifyVpnTunnelOptionsResponseVpnConnectionOptionsTypeDef,
        "Routes": List[ClientModifyVpnTunnelOptionsResponseVpnConnectionRoutesTypeDef],
        "Tags": List[ClientModifyVpnTunnelOptionsResponseVpnConnectionTagsTypeDef],
        "VgwTelemetry": List[ClientModifyVpnTunnelOptionsResponseVpnConnectionVgwTelemetryTypeDef],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef(
    _ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef
):
    """
    - **VpnConnection** *(dict) --*

      Describes a VPN connection.
      - **CustomerGatewayConfiguration** *(string) --*

        The configuration information for the VPN connection's customer gateway (in the native XML
        format). This element is always present in the  CreateVpnConnection response; however, it's
        present in the  DescribeVpnConnections response only if the VPN connection is in the
        ``pending`` or ``available`` state.
    """


_ClientModifyVpnTunnelOptionsResponseTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsResponseTypeDef",
    {"VpnConnection": ClientModifyVpnTunnelOptionsResponseVpnConnectionTypeDef},
    total=False,
)


class ClientModifyVpnTunnelOptionsResponseTypeDef(_ClientModifyVpnTunnelOptionsResponseTypeDef):
    """
    - *(dict) --*

      - **VpnConnection** *(dict) --*

        Describes a VPN connection.
        - **CustomerGatewayConfiguration** *(string) --*

          The configuration information for the VPN connection's customer gateway (in the native XML
          format). This element is always present in the  CreateVpnConnection response; however,
          it's present in the  DescribeVpnConnections response only if the VPN connection is in the
          ``pending`` or ``available`` state.
    """


_ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef", {"Value": str}, total=False
)


class ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef",
    {"Value": int},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef",
    {"Value": str},
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
):
    pass


_ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef = TypedDict(
    "_ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef",
    {
        "TunnelInsideCidr": str,
        "PreSharedKey": str,
        "Phase1LifetimeSeconds": int,
        "Phase2LifetimeSeconds": int,
        "RekeyMarginTimeSeconds": int,
        "RekeyFuzzPercentage": int,
        "ReplayWindowSize": int,
        "DPDTimeoutSeconds": int,
        "Phase1EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1EncryptionAlgorithmsTypeDef
        ],
        "Phase2EncryptionAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2EncryptionAlgorithmsTypeDef
        ],
        "Phase1IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1IntegrityAlgorithmsTypeDef
        ],
        "Phase2IntegrityAlgorithms": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2IntegrityAlgorithmsTypeDef
        ],
        "Phase1DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase1DHGroupNumbersTypeDef
        ],
        "Phase2DHGroupNumbers": List[
            ClientModifyVpnTunnelOptionsTunnelOptionsPhase2DHGroupNumbersTypeDef
        ],
        "IKEVersions": List[ClientModifyVpnTunnelOptionsTunnelOptionsIKEVersionsTypeDef],
    },
    total=False,
)


class ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef(
    _ClientModifyVpnTunnelOptionsTunnelOptionsTypeDef
):
    """
    The tunnel options to modify.
    - **TunnelInsideCidr** *(string) --*

      The range of inside IP addresses for the tunnel. Any specified CIDR blocks must be unique
      across all VPN connections that use the same virtual private gateway.
      Constraints: A size /30 CIDR block from the ``169.254.0.0/16`` range. The following CIDR
      blocks are reserved and cannot be used:
      * ``169.254.0.0/30``
      * ``169.254.1.0/30``
      * ``169.254.2.0/30``
      * ``169.254.3.0/30``
      * ``169.254.4.0/30``
      * ``169.254.5.0/30``
      * ``169.254.169.252/30``
    """


_ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef(
    _ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_ClientMonitorInstancesResponseInstanceMonitoringsTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": ClientMonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class ClientMonitorInstancesResponseInstanceMonitoringsTypeDef(
    _ClientMonitorInstancesResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientMonitorInstancesResponseTypeDef = TypedDict(
    "_ClientMonitorInstancesResponseTypeDef",
    {"InstanceMonitorings": List[ClientMonitorInstancesResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class ClientMonitorInstancesResponseTypeDef(_ClientMonitorInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientMoveAddressToVpcResponseTypeDef = TypedDict(
    "_ClientMoveAddressToVpcResponseTypeDef",
    {"AllocationId": str, "Status": Literal["MoveInProgress", "InVpc", "InClassic"]},
    total=False,
)


class ClientMoveAddressToVpcResponseTypeDef(_ClientMoveAddressToVpcResponseTypeDef):
    """
    - *(dict) --*

      - **AllocationId** *(string) --*

        The allocation ID for the Elastic IP address.
    """


_RequiredClientProvisionByoipCidrCidrAuthorizationContextTypeDef = TypedDict(
    "_RequiredClientProvisionByoipCidrCidrAuthorizationContextTypeDef", {"Message": str}
)
_OptionalClientProvisionByoipCidrCidrAuthorizationContextTypeDef = TypedDict(
    "_OptionalClientProvisionByoipCidrCidrAuthorizationContextTypeDef",
    {"Signature": str},
    total=False,
)


class ClientProvisionByoipCidrCidrAuthorizationContextTypeDef(
    _RequiredClientProvisionByoipCidrCidrAuthorizationContextTypeDef,
    _OptionalClientProvisionByoipCidrCidrAuthorizationContextTypeDef,
):
    """
    A signed document that proves that you are authorized to bring the specified IP address range to
    Amazon using BYOIP.
    - **Message** *(string) --***[REQUIRED]**

      The plain-text authorization message for the prefix and account.
    """


_ClientProvisionByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientProvisionByoipCidrResponseByoipCidrTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class ClientProvisionByoipCidrResponseByoipCidrTypeDef(
    _ClientProvisionByoipCidrResponseByoipCidrTypeDef
):
    """
    - **ByoipCidr** *(dict) --*

      Information about the address pool.
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_ClientProvisionByoipCidrResponseTypeDef = TypedDict(
    "_ClientProvisionByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientProvisionByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientProvisionByoipCidrResponseTypeDef(_ClientProvisionByoipCidrResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidr** *(dict) --*

        Information about the address pool.
        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.
    """


_ClientPurchaseHostReservationResponsePurchaseTypeDef = TypedDict(
    "_ClientPurchaseHostReservationResponsePurchaseTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "UpfrontPrice": str,
    },
    total=False,
)


class ClientPurchaseHostReservationResponsePurchaseTypeDef(
    _ClientPurchaseHostReservationResponsePurchaseTypeDef
):
    pass


_ClientPurchaseHostReservationResponseTypeDef = TypedDict(
    "_ClientPurchaseHostReservationResponseTypeDef",
    {
        "ClientToken": str,
        "CurrencyCode": str,
        "Purchase": List[ClientPurchaseHostReservationResponsePurchaseTypeDef],
        "TotalHourlyPrice": str,
        "TotalUpfrontPrice": str,
    },
    total=False,
)


class ClientPurchaseHostReservationResponseTypeDef(_ClientPurchaseHostReservationResponseTypeDef):
    """
    - *(dict) --*

      - **ClientToken** *(string) --*

        Unique, case-sensitive identifier that you provide to ensure the idempotency of the request.
        For more information, see `How to Ensure Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef = TypedDict(
    "_ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef",
    {"Amount": float, "CurrencyCode": str},
    total=False,
)


class ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef(
    _ClientPurchaseReservedInstancesOfferingLimitPriceTypeDef
):
    """
    Specified for Reserved Instance Marketplace offerings to limit the total order and ensure that
    the Reserved Instances are not purchased at unexpected prices.
    - **Amount** *(float) --*

      Used for Reserved Instance Marketplace offerings. Specifies the limit price on the total order
      (instanceCount * price).
    """


_ClientPurchaseReservedInstancesOfferingResponseTypeDef = TypedDict(
    "_ClientPurchaseReservedInstancesOfferingResponseTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class ClientPurchaseReservedInstancesOfferingResponseTypeDef(
    _ClientPurchaseReservedInstancesOfferingResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of PurchaseReservedInstancesOffering.
      - **ReservedInstancesId** *(string) --*

        The IDs of the purchased Reserved Instances.
    """


_RequiredClientPurchaseScheduledInstancesPurchaseRequestsTypeDef = TypedDict(
    "_RequiredClientPurchaseScheduledInstancesPurchaseRequestsTypeDef", {"InstanceCount": int}
)
_OptionalClientPurchaseScheduledInstancesPurchaseRequestsTypeDef = TypedDict(
    "_OptionalClientPurchaseScheduledInstancesPurchaseRequestsTypeDef",
    {"PurchaseToken": str},
    total=False,
)


class ClientPurchaseScheduledInstancesPurchaseRequestsTypeDef(
    _RequiredClientPurchaseScheduledInstancesPurchaseRequestsTypeDef,
    _OptionalClientPurchaseScheduledInstancesPurchaseRequestsTypeDef,
):
    """
    - *(dict) --*

      Describes a request to purchase Scheduled Instances.
      - **InstanceCount** *(integer) --***[REQUIRED]**

        The number of instances.
    """


_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef(
    _ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef
):
    pass


_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": ClientPurchaseScheduledInstancesResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef(
    _ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef
):
    """
    - *(dict) --*

      Describes a Scheduled Instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone.
    """


_ClientPurchaseScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientPurchaseScheduledInstancesResponseTypeDef",
    {
        "ScheduledInstanceSet": List[
            ClientPurchaseScheduledInstancesResponseScheduledInstanceSetTypeDef
        ]
    },
    total=False,
)


class ClientPurchaseScheduledInstancesResponseTypeDef(
    _ClientPurchaseScheduledInstancesResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of PurchaseScheduledInstances.
      - **ScheduledInstanceSet** *(list) --*

        Information about the Scheduled Instances.
        - *(dict) --*

          Describes a Scheduled Instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone.
    """


_ClientRegisterImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRegisterImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRegisterImageBlockDeviceMappingsEbsTypeDef(
    _ClientRegisterImageBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRegisterImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRegisterImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRegisterImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRegisterImageBlockDeviceMappingsTypeDef(_ClientRegisterImageBlockDeviceMappingsTypeDef):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientRegisterImageResponseTypeDef = TypedDict(
    "_ClientRegisterImageResponseTypeDef", {"ImageId": str}, total=False
)


class ClientRegisterImageResponseTypeDef(_ClientRegisterImageResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of RegisterImage.
      - **ImageId** *(string) --*

        The ID of the newly registered AMI.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef
):
    pass


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
):
    pass


_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentOptionsTypeDef,
        "Tags": List[
            ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTagsTypeDef
        ],
    },
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
):
    """
    - **TransitGatewayVpcAttachment** *(dict) --*

      Information about the attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_ClientRejectTransitGatewayVpcAttachmentResponseTypeDef = TypedDict(
    "_ClientRejectTransitGatewayVpcAttachmentResponseTypeDef",
    {
        "TransitGatewayVpcAttachment": ClientRejectTransitGatewayVpcAttachmentResponseTransitGatewayVpcAttachmentTypeDef
    },
    total=False,
)


class ClientRejectTransitGatewayVpcAttachmentResponseTypeDef(
    _ClientRejectTransitGatewayVpcAttachmentResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachment** *(dict) --*

        Information about the attachment.
        - **TransitGatewayAttachmentId** *(string) --*

          The ID of the attachment.
    """


_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef
):
    """
    - **Error** *(dict) --*

      Information about the error.
      - **Code** *(string) --*

        The error code.
    """


_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef",
    {
        "Error": ClientRejectVpcEndpointConnectionsResponseUnsuccessfulErrorTypeDef,
        "ResourceId": str,
    },
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef
):
    """
    - *(dict) --*

      Information about items that were not successfully processed in a batch call.
      - **Error** *(dict) --*

        Information about the error.
        - **Code** *(string) --*

          The error code.
    """


_ClientRejectVpcEndpointConnectionsResponseTypeDef = TypedDict(
    "_ClientRejectVpcEndpointConnectionsResponseTypeDef",
    {"Unsuccessful": List[ClientRejectVpcEndpointConnectionsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientRejectVpcEndpointConnectionsResponseTypeDef(
    _ClientRejectVpcEndpointConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **Unsuccessful** *(list) --*

        Information about the endpoints that were not rejected, if applicable.
        - *(dict) --*

          Information about items that were not successfully processed in a batch call.
          - **Error** *(dict) --*

            Information about the error.
            - **Code** *(string) --*

              The error code.
    """


_ClientRejectVpcPeeringConnectionResponseTypeDef = TypedDict(
    "_ClientRejectVpcPeeringConnectionResponseTypeDef", {"Return": bool}, total=False
)


class ClientRejectVpcPeeringConnectionResponseTypeDef(
    _ClientRejectVpcPeeringConnectionResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_ClientReleaseHostsResponseUnsuccessfulErrorTypeDef = TypedDict(
    "_ClientReleaseHostsResponseUnsuccessfulErrorTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientReleaseHostsResponseUnsuccessfulErrorTypeDef(
    _ClientReleaseHostsResponseUnsuccessfulErrorTypeDef
):
    pass


_ClientReleaseHostsResponseUnsuccessfulTypeDef = TypedDict(
    "_ClientReleaseHostsResponseUnsuccessfulTypeDef",
    {"Error": ClientReleaseHostsResponseUnsuccessfulErrorTypeDef, "ResourceId": str},
    total=False,
)


class ClientReleaseHostsResponseUnsuccessfulTypeDef(_ClientReleaseHostsResponseUnsuccessfulTypeDef):
    pass


_ClientReleaseHostsResponseTypeDef = TypedDict(
    "_ClientReleaseHostsResponseTypeDef",
    {"Successful": List[str], "Unsuccessful": List[ClientReleaseHostsResponseUnsuccessfulTypeDef]},
    total=False,
)


class ClientReleaseHostsResponseTypeDef(_ClientReleaseHostsResponseTypeDef):
    """
    - *(dict) --*

      - **Successful** *(list) --*

        The IDs of the Dedicated Hosts that were successfully released.
        - *(string) --*
    """


_ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientReplaceIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    """
    The IAM instance profile.
    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.
    """


_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef
):
    pass


_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationIamInstanceProfileTypeDef,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
        "Timestamp": datetime,
    },
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef
):
    """
    - **IamInstanceProfileAssociation** *(dict) --*

      Information about the IAM instance profile association.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_ClientReplaceIamInstanceProfileAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceIamInstanceProfileAssociationResponseTypeDef",
    {
        "IamInstanceProfileAssociation": ClientReplaceIamInstanceProfileAssociationResponseIamInstanceProfileAssociationTypeDef
    },
    total=False,
)


class ClientReplaceIamInstanceProfileAssociationResponseTypeDef(
    _ClientReplaceIamInstanceProfileAssociationResponseTypeDef
):
    """
    - *(dict) --*

      - **IamInstanceProfileAssociation** *(dict) --*

        Information about the IAM instance profile association.
        - **AssociationId** *(string) --*

          The ID of the association.
    """


_ClientReplaceNetworkAclAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceNetworkAclAssociationResponseTypeDef", {"NewAssociationId": str}, total=False
)


class ClientReplaceNetworkAclAssociationResponseTypeDef(
    _ClientReplaceNetworkAclAssociationResponseTypeDef
):
    """
    - *(dict) --*

      - **NewAssociationId** *(string) --*

        The ID of the new association.
    """


_ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef = TypedDict(
    "_ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef", {"Code": int, "Type": int}, total=False
)


class ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef(
    _ClientReplaceNetworkAclEntryIcmpTypeCodeTypeDef
):
    """
    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.
    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.
    """


_ClientReplaceNetworkAclEntryPortRangeTypeDef = TypedDict(
    "_ClientReplaceNetworkAclEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class ClientReplaceNetworkAclEntryPortRangeTypeDef(_ClientReplaceNetworkAclEntryPortRangeTypeDef):
    """
    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).
    - **From** *(integer) --*

      The first port in the range.
    """


_ClientReplaceRouteTableAssociationResponseTypeDef = TypedDict(
    "_ClientReplaceRouteTableAssociationResponseTypeDef", {"NewAssociationId": str}, total=False
)


class ClientReplaceRouteTableAssociationResponseTypeDef(
    _ClientReplaceRouteTableAssociationResponseTypeDef
):
    """
    - *(dict) --*

      - **NewAssociationId** *(string) --*

        The ID of the new association.
    """


_ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef",
    {
        "ResourceId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
    },
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef(
    _ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
):
    pass


_ClientReplaceTransitGatewayRouteResponseRouteTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseRouteTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientReplaceTransitGatewayRouteResponseRouteTransitGatewayAttachmentsTypeDef
        ],
        "Type": Literal["static", "propagated"],
        "State": Literal["pending", "active", "blackhole", "deleting", "deleted"],
    },
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseRouteTypeDef(
    _ClientReplaceTransitGatewayRouteResponseRouteTypeDef
):
    """
    - **Route** *(dict) --*

      Information about the modified route.
      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.
    """


_ClientReplaceTransitGatewayRouteResponseTypeDef = TypedDict(
    "_ClientReplaceTransitGatewayRouteResponseTypeDef",
    {"Route": ClientReplaceTransitGatewayRouteResponseRouteTypeDef},
    total=False,
)


class ClientReplaceTransitGatewayRouteResponseTypeDef(
    _ClientReplaceTransitGatewayRouteResponseTypeDef
):
    """
    - *(dict) --*

      - **Route** *(dict) --*

        Information about the modified route.
        - **DestinationCidrBlock** *(string) --*

          The CIDR block used for destination matches.
    """


_ClientRequestSpotFleetResponseTypeDef = TypedDict(
    "_ClientRequestSpotFleetResponseTypeDef", {"SpotFleetRequestId": str}, total=False
)


class ClientRequestSpotFleetResponseTypeDef(_ClientRequestSpotFleetResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of RequestSpotFleet.
      - **SpotFleetRequestId** *(string) --*

        The ID of the Spot Fleet request.
    """


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    pass


_ClientRequestSpotFleetSpotFleetRequestConfigTypeDef = TypedDict(
    "_ClientRequestSpotFleetSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": Literal["lowestPrice", "diversified", "capacityOptimized"],
        "OnDemandAllocationStrategy": Literal["lowestPrice", "prioritized"],
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": Literal["noTermination", "default"],
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            ClientRequestSpotFleetSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": Literal["request", "maintain", "instant"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "LoadBalancersConfig": ClientRequestSpotFleetSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class ClientRequestSpotFleetSpotFleetRequestConfigTypeDef(
    _ClientRequestSpotFleetSpotFleetRequestConfigTypeDef
):
    """
    The configuration for the Spot Fleet request.
    - **AllocationStrategy** *(string) --*

      Indicates how to allocate the target Spot Instance capacity across the Spot Instance pools
      specified by the Spot Fleet request.
      If the allocation strategy is ``lowestPrice`` , Spot Fleet launches instances from the Spot
      Instance pools with the lowest price. This is the default allocation strategy.
      If the allocation strategy is ``diversified`` , Spot Fleet launches instances from all the
      Spot Instance pools that you specify.
      If the allocation strategy is ``capacityOptimized`` , Spot Fleet launches instances from Spot
      Instance pools with optimal capacity for the number of instances that are launching.
    """


_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef
):
    pass


_ClientRequestSpotInstancesLaunchSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotInstancesLaunchSpecificationTypeDef",
    {
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotInstancesLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRequestSpotInstancesLaunchSpecificationMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRequestSpotInstancesLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotInstancesLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)


class ClientRequestSpotInstancesLaunchSpecificationTypeDef(
    _ClientRequestSpotInstancesLaunchSpecificationTypeDef
):
    """
    The launch specification.
    - **SecurityGroupIds** *(list) --*

      One or more security group IDs.
      - *(string) --*
    """


_ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef
):
    pass


_ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": ClientRequestSpotInstancesResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": ClientRequestSpotInstancesResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": Literal["open", "active", "closed", "cancelled", "failed"],
        "Status": ClientRequestSpotInstancesResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[ClientRequestSpotInstancesResponseSpotInstanceRequestsTagsTypeDef],
        "Type": Literal["one-time", "persistent"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef(
    _ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef
):
    """
    - *(dict) --*

      Describes a Spot Instance request.
      - **ActualBlockHourlyPrice** *(string) --*

        If you specified a duration and your Spot Instance request was fulfilled, this is the fixed
        hourly price in effect for the Spot Instance while it runs.
    """


_ClientRequestSpotInstancesResponseTypeDef = TypedDict(
    "_ClientRequestSpotInstancesResponseTypeDef",
    {"SpotInstanceRequests": List[ClientRequestSpotInstancesResponseSpotInstanceRequestsTypeDef]},
    total=False,
)


class ClientRequestSpotInstancesResponseTypeDef(_ClientRequestSpotInstancesResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of RequestSpotInstances.
      - **SpotInstanceRequests** *(list) --*

        One or more Spot Instance requests.
        - *(dict) --*

          Describes a Spot Instance request.
          - **ActualBlockHourlyPrice** *(string) --*

            If you specified a duration and your Spot Instance request was fulfilled, this is the
            fixed hourly price in effect for the Spot Instance while it runs.
    """


_ClientResetEbsDefaultKmsKeyIdResponseTypeDef = TypedDict(
    "_ClientResetEbsDefaultKmsKeyIdResponseTypeDef", {"KmsKeyId": str}, total=False
)


class ClientResetEbsDefaultKmsKeyIdResponseTypeDef(_ClientResetEbsDefaultKmsKeyIdResponseTypeDef):
    """
    - *(dict) --*

      - **KmsKeyId** *(string) --*

        The Amazon Resource Name (ARN) of the default CMK for EBS encryption by default.
    """


_ClientResetFpgaImageAttributeResponseTypeDef = TypedDict(
    "_ClientResetFpgaImageAttributeResponseTypeDef", {"Return": bool}, total=False
)


class ClientResetFpgaImageAttributeResponseTypeDef(_ClientResetFpgaImageAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Is ``true`` if the request succeeds, and an error otherwise.
    """


_ClientRestoreAddressToClassicResponseTypeDef = TypedDict(
    "_ClientRestoreAddressToClassicResponseTypeDef",
    {"PublicIp": str, "Status": Literal["MoveInProgress", "InVpc", "InClassic"]},
    total=False,
)


class ClientRestoreAddressToClassicResponseTypeDef(_ClientRestoreAddressToClassicResponseTypeDef):
    """
    - *(dict) --*

      - **PublicIp** *(string) --*

        The Elastic IP address.
    """


_ClientRevokeClientVpnIngressResponseStatusTypeDef = TypedDict(
    "_ClientRevokeClientVpnIngressResponseStatusTypeDef",
    {"Code": Literal["authorizing", "active", "failed", "revoking"], "Message": str},
    total=False,
)


class ClientRevokeClientVpnIngressResponseStatusTypeDef(
    _ClientRevokeClientVpnIngressResponseStatusTypeDef
):
    """
    - **Status** *(dict) --*

      The current state of the authorization rule.
      - **Code** *(string) --*

        The state of the authorization rule.
    """


_ClientRevokeClientVpnIngressResponseTypeDef = TypedDict(
    "_ClientRevokeClientVpnIngressResponseTypeDef",
    {"Status": ClientRevokeClientVpnIngressResponseStatusTypeDef},
    total=False,
)


class ClientRevokeClientVpnIngressResponseTypeDef(_ClientRevokeClientVpnIngressResponseTypeDef):
    """
    - *(dict) --*

      - **Status** *(dict) --*

        The current state of the authorization rule.
        - **Code** *(string) --*

          The state of the authorization rule.
    """


_ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef
):
    pass


_ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientRevokeSecurityGroupEgressIpPermissionsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientRevokeSecurityGroupEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[ClientRevokeSecurityGroupEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[ClientRevokeSecurityGroupEgressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientRevokeSecurityGroupEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientRevokeSecurityGroupEgressIpPermissionsTypeDef(
    _ClientRevokeSecurityGroupEgressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef
):
    pass


_ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientRevokeSecurityGroupIngressIpPermissionsTypeDef = TypedDict(
    "_ClientRevokeSecurityGroupIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[ClientRevokeSecurityGroupIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[ClientRevokeSecurityGroupIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[ClientRevokeSecurityGroupIngressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientRevokeSecurityGroupIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientRevokeSecurityGroupIngressIpPermissionsTypeDef(
    _ClientRevokeSecurityGroupIngressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientRunInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ClientRunInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientRunInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRunInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ClientRunInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ClientRunInstancesBlockDeviceMappingsTypeDef(_ClientRunInstancesBlockDeviceMappingsTypeDef):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientRunInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientRunInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientRunInstancesCapacityReservationSpecificationTypeDef(
    _ClientRunInstancesCapacityReservationSpecificationTypeDef
):
    """
    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables
    it to run in any open Capacity Reservation that has matching attributes (instance type,
    platform, Availability Zone).
    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:
      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).
      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.
    """


_ClientRunInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientRunInstancesCpuOptionsTypeDef", {"CoreCount": int, "ThreadsPerCore": int}, total=False
)


class ClientRunInstancesCpuOptionsTypeDef(_ClientRunInstancesCpuOptionsTypeDef):
    """
    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.
    """


_ClientRunInstancesCreditSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class ClientRunInstancesCreditSpecificationTypeDef(_ClientRunInstancesCreditSpecificationTypeDef):
    """
    The credit option for CPU usage of the burstable performance instance. Valid values are
    ``standard`` and ``unlimited`` . To change this attribute after launch, use
    `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .
    Default: ``standard`` (T2 instances) or ``unlimited`` (T3/T3a instances)
    - **CpuCredits** *(string) --***[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ClientRunInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class ClientRunInstancesElasticGpuSpecificationTypeDef(
    _ClientRunInstancesElasticGpuSpecificationTypeDef
):
    """
    - *(dict) --*

      A specification for an Elastic Graphics accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of Elastic Graphics accelerator.
    """


_ClientRunInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ClientRunInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class ClientRunInstancesElasticInferenceAcceleratorsTypeDef(
    _ClientRunInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    - *(dict) --*

      Describes an elastic inference accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
        ``eia1.medium`` , and ``eia1.large`` .
    """


_ClientRunInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientRunInstancesHibernationOptionsTypeDef", {"Configured": bool}, total=False
)


class ClientRunInstancesHibernationOptionsTypeDef(_ClientRunInstancesHibernationOptionsTypeDef):
    """
    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.
      Default: ``false``
    """


_ClientRunInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunInstancesIamInstanceProfileTypeDef", {"Arn": str, "Name": str}, total=False
)


class ClientRunInstancesIamInstanceProfileTypeDef(_ClientRunInstancesIamInstanceProfileTypeDef):
    """
    The IAM instance profile.
    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.
    """


_ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ClientRunInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_ClientRunInstancesInstanceMarketOptionsTypeDef",
    {"MarketType": str, "SpotOptions": ClientRunInstancesInstanceMarketOptionsSpotOptionsTypeDef},
    total=False,
)


class ClientRunInstancesInstanceMarketOptionsTypeDef(
    _ClientRunInstancesInstanceMarketOptionsTypeDef
):
    """
    The market (purchasing) option for the instances.
    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .
    - **MarketType** *(string) --*

      The market type.
    """


_ClientRunInstancesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ClientRunInstancesIpv6AddressesTypeDef(_ClientRunInstancesIpv6AddressesTypeDef):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_ClientRunInstancesLaunchTemplateTypeDef = TypedDict(
    "_ClientRunInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ClientRunInstancesLaunchTemplateTypeDef(_ClientRunInstancesLaunchTemplateTypeDef):
    """
    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the
    name or ID of a launch template, but not both.
    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.
    """


_ClientRunInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_ClientRunInstancesLicenseSpecificationsTypeDef", {"LicenseConfigurationArn": str}, total=False
)


class ClientRunInstancesLicenseSpecificationsTypeDef(
    _ClientRunInstancesLicenseSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes a license configuration.
      - **LicenseConfigurationArn** *(string) --*

        The Amazon Resource Name (ARN) of the license configuration.
    """


_ClientRunInstancesMetadataOptionsTypeDef = TypedDict(
    "_ClientRunInstancesMetadataOptionsTypeDef",
    {
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class ClientRunInstancesMetadataOptionsTypeDef(_ClientRunInstancesMetadataOptionsTypeDef):
    """
    The metadata options for the instance. For more information, see `Instance Metadata and User
    Data <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html>`__ .
    - **HttpTokens** *(string) --*

      The state of token usage for your instance metadata requests. If the parameter is not
      specified in the request, the default state is ``optional`` .
      If the state is ``optional`` , you can choose to retrieve instance metadata with or without a
      signed token header on your request. If you retrieve the IAM role credentials without a token,
      the version 1.0 role credentials are returned. If you retrieve the IAM role credentials using
      a valid signed token, the version 2.0 role credentials are returned.
      If the state is ``required`` , you must send a signed token header with any instance metadata
      retrieval requests. In this state, retrieving the IAM role credentials always returns the
      version 2.0 credentials; the version 1.0 credentials are not available.
    """


_ClientRunInstancesMonitoringTypeDef = TypedDict(
    "_ClientRunInstancesMonitoringTypeDef", {"Enabled": bool}
)


class ClientRunInstancesMonitoringTypeDef(_ClientRunInstancesMonitoringTypeDef):
    """
    Specifies whether detailed monitoring is enabled for the instance.
    - **Enabled** *(boolean) --***[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientRunInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[ClientRunInstancesNetworkInterfacesIpv6AddressesTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[ClientRunInstancesNetworkInterfacesPrivateIpAddressesTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRunInstancesNetworkInterfacesTypeDef(_ClientRunInstancesNetworkInterfacesTypeDef):
    """
    - *(dict) --*

      Describes a network interface.
      - **AssociatePublicIpAddress** *(boolean) --*

        Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
        public IP address can only be assigned to a network interface for eth0, and can only be
        assigned to a new network interface, not an existing one. You cannot specify more than one
        network interface in the request. If launching into a default subnet, the default value is
        ``true`` .
    """


_ClientRunInstancesPlacementTypeDef = TypedDict(
    "_ClientRunInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientRunInstancesPlacementTypeDef(_ClientRunInstancesPlacementTypeDef):
    """
    The placement for the instance.
    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.
      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.
    """


_ClientRunInstancesResponseGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseGroupsTypeDef", {"GroupName": str, "GroupId": str}, total=False
)


class ClientRunInstancesResponseGroupsTypeDef(_ClientRunInstancesResponseGroupsTypeDef):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
        "VolumeId": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef(
    _ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef",
    {"DeviceName": str, "Ebs": ClientRunInstancesResponseInstancesBlockDeviceMappingsEbsTypeDef},
    total=False,
)


class ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef(
    _ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ClientRunInstancesResponseInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef(
    _ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef
):
    pass


_ClientRunInstancesResponseInstancesCpuOptionsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ClientRunInstancesResponseInstancesCpuOptionsTypeDef(
    _ClientRunInstancesResponseInstancesCpuOptionsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef(
    _ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesHibernationOptionsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class ClientRunInstancesResponseInstancesHibernationOptionsTypeDef(
    _ClientRunInstancesResponseInstancesHibernationOptionsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef(
    _ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef
):
    pass


_ClientRunInstancesResponseInstancesLicensesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ClientRunInstancesResponseInstancesLicensesTypeDef(
    _ClientRunInstancesResponseInstancesLicensesTypeDef
):
    pass


_ClientRunInstancesResponseInstancesMetadataOptionsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesMetadataOptionsTypeDef",
    {
        "State": Literal["pending", "applied"],
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class ClientRunInstancesResponseInstancesMetadataOptionsTypeDef(
    _ClientRunInstancesResponseInstancesMetadataOptionsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesMonitoringTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class ClientRunInstancesResponseInstancesMonitoringTypeDef(
    _ClientRunInstancesResponseInstancesMonitoringTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef",
    {
        "Association": ClientRunInstancesResponseInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": ClientRunInstancesResponseInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[ClientRunInstancesResponseInstancesNetworkInterfacesGroupsTypeDef],
        "Ipv6Addresses": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ClientRunInstancesResponseInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef(
    _ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef
):
    pass


_ClientRunInstancesResponseInstancesPlacementTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesPlacementTypeDef(
    _ClientRunInstancesResponseInstancesPlacementTypeDef
):
    pass


_ClientRunInstancesResponseInstancesProductCodesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ClientRunInstancesResponseInstancesProductCodesTypeDef(
    _ClientRunInstancesResponseInstancesProductCodesTypeDef
):
    pass


_ClientRunInstancesResponseInstancesSecurityGroupsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class ClientRunInstancesResponseInstancesSecurityGroupsTypeDef(
    _ClientRunInstancesResponseInstancesSecurityGroupsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesStateReasonTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class ClientRunInstancesResponseInstancesStateReasonTypeDef(
    _ClientRunInstancesResponseInstancesStateReasonTypeDef
):
    pass


_ClientRunInstancesResponseInstancesStateTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientRunInstancesResponseInstancesStateTypeDef(
    _ClientRunInstancesResponseInstancesStateTypeDef
):
    pass


_ClientRunInstancesResponseInstancesTagsTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientRunInstancesResponseInstancesTagsTypeDef(
    _ClientRunInstancesResponseInstancesTagsTypeDef
):
    pass


_ClientRunInstancesResponseInstancesTypeDef = TypedDict(
    "_ClientRunInstancesResponseInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": ClientRunInstancesResponseInstancesMonitoringTypeDef,
        "Placement": ClientRunInstancesResponseInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[ClientRunInstancesResponseInstancesProductCodesTypeDef],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": ClientRunInstancesResponseInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": Literal["i386", "x86_64", "arm64"],
        "BlockDeviceMappings": List[ClientRunInstancesResponseInstancesBlockDeviceMappingsTypeDef],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": Literal["ovm", "xen"],
        "IamInstanceProfile": ClientRunInstancesResponseInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": Literal["spot", "scheduled"],
        "ElasticGpuAssociations": List[
            ClientRunInstancesResponseInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            ClientRunInstancesResponseInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[ClientRunInstancesResponseInstancesNetworkInterfacesTypeDef],
        "RootDeviceName": str,
        "RootDeviceType": Literal["ebs", "instance-store"],
        "SecurityGroups": List[ClientRunInstancesResponseInstancesSecurityGroupsTypeDef],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": ClientRunInstancesResponseInstancesStateReasonTypeDef,
        "Tags": List[ClientRunInstancesResponseInstancesTagsTypeDef],
        "VirtualizationType": Literal["hvm", "paravirtual"],
        "CpuOptions": ClientRunInstancesResponseInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": ClientRunInstancesResponseInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": ClientRunInstancesResponseInstancesHibernationOptionsTypeDef,
        "Licenses": List[ClientRunInstancesResponseInstancesLicensesTypeDef],
        "MetadataOptions": ClientRunInstancesResponseInstancesMetadataOptionsTypeDef,
    },
    total=False,
)


class ClientRunInstancesResponseInstancesTypeDef(_ClientRunInstancesResponseInstancesTypeDef):
    pass


_ClientRunInstancesResponseTypeDef = TypedDict(
    "_ClientRunInstancesResponseTypeDef",
    {
        "Groups": List[ClientRunInstancesResponseGroupsTypeDef],
        "Instances": List[ClientRunInstancesResponseInstancesTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class ClientRunInstancesResponseTypeDef(_ClientRunInstancesResponseTypeDef):
    """
    - *(dict) --*

      Describes a reservation.
      - **Groups** *(list) --*

        [EC2-Classic only] The security groups.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_ClientRunInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_ClientRunInstancesTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ClientRunInstancesTagSpecificationsTagsTypeDef(
    _ClientRunInstancesTagSpecificationsTagsTypeDef
):
    pass


_ClientRunInstancesTagSpecificationsTypeDef = TypedDict(
    "_ClientRunInstancesTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ClientRunInstancesTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ClientRunInstancesTagSpecificationsTypeDef(_ClientRunInstancesTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Encrypted": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping for a Scheduled Instance.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddressConfigs": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesPrivateIpAddressConfigsTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str},
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef
):
    pass


_ClientRunScheduledInstancesLaunchSpecificationTypeDef = TypedDict(
    "_ClientRunScheduledInstancesLaunchSpecificationTypeDef",
    {
        "BlockDeviceMappings": List[
            ClientRunScheduledInstancesLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": ClientRunScheduledInstancesLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": str,
        "KernelId": str,
        "KeyName": str,
        "Monitoring": ClientRunScheduledInstancesLaunchSpecificationMonitoringTypeDef,
        "NetworkInterfaces": List[
            ClientRunScheduledInstancesLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": ClientRunScheduledInstancesLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SecurityGroupIds": List[str],
        "SubnetId": str,
        "UserData": str,
    },
    total=False,
)


class ClientRunScheduledInstancesLaunchSpecificationTypeDef(
    _ClientRunScheduledInstancesLaunchSpecificationTypeDef
):
    """
    The launch specification. You must match the instance type, Availability Zone, network, and
    platform of the schedule that you purchased.
    - **BlockDeviceMappings** *(list) --*

      The block device mapping entries.
      - *(dict) --*

        Describes a block device mapping for a Scheduled Instance.
        - **DeviceName** *(string) --*

          The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ClientRunScheduledInstancesResponseTypeDef = TypedDict(
    "_ClientRunScheduledInstancesResponseTypeDef", {"InstanceIdSet": List[str]}, total=False
)


class ClientRunScheduledInstancesResponseTypeDef(_ClientRunScheduledInstancesResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of RunScheduledInstances.
      - **InstanceIdSet** *(list) --*

        The IDs of the newly launched instances.
        - *(string) --*
    """


_ClientSearchTransitGatewayRoutesFiltersTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class ClientSearchTransitGatewayRoutesFiltersTypeDef(
    _ClientSearchTransitGatewayRoutesFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef",
    {
        "ResourceId": str,
        "TransitGatewayAttachmentId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
    },
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef(
    _ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef
):
    pass


_ClientSearchTransitGatewayRoutesResponseRoutesTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "TransitGatewayAttachments": List[
            ClientSearchTransitGatewayRoutesResponseRoutesTransitGatewayAttachmentsTypeDef
        ],
        "Type": Literal["static", "propagated"],
        "State": Literal["pending", "active", "blackhole", "deleting", "deleted"],
    },
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseRoutesTypeDef(
    _ClientSearchTransitGatewayRoutesResponseRoutesTypeDef
):
    """
    - *(dict) --*

      Describes a route for a transit gateway route table.
      - **DestinationCidrBlock** *(string) --*

        The CIDR block used for destination matches.
    """


_ClientSearchTransitGatewayRoutesResponseTypeDef = TypedDict(
    "_ClientSearchTransitGatewayRoutesResponseTypeDef",
    {
        "Routes": List[ClientSearchTransitGatewayRoutesResponseRoutesTypeDef],
        "AdditionalRoutesAvailable": bool,
    },
    total=False,
)


class ClientSearchTransitGatewayRoutesResponseTypeDef(
    _ClientSearchTransitGatewayRoutesResponseTypeDef
):
    """
    - *(dict) --*

      - **Routes** *(list) --*

        Information about the routes.
        - *(dict) --*

          Describes a route for a transit gateway route table.
          - **DestinationCidrBlock** *(string) --*

            The CIDR block used for destination matches.
    """


_ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef(
    _ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef(
    _ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef
):
    pass


_ClientStartInstancesResponseStartingInstancesTypeDef = TypedDict(
    "_ClientStartInstancesResponseStartingInstancesTypeDef",
    {
        "CurrentState": ClientStartInstancesResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientStartInstancesResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientStartInstancesResponseStartingInstancesTypeDef(
    _ClientStartInstancesResponseStartingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_ClientStartInstancesResponseTypeDef = TypedDict(
    "_ClientStartInstancesResponseTypeDef",
    {"StartingInstances": List[ClientStartInstancesResponseStartingInstancesTypeDef]},
    total=False,
)


class ClientStartInstancesResponseTypeDef(_ClientStartInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **StartingInstances** *(list) --*

        Information about the started instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef(
    _ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef(
    _ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef
):
    pass


_ClientStopInstancesResponseStoppingInstancesTypeDef = TypedDict(
    "_ClientStopInstancesResponseStoppingInstancesTypeDef",
    {
        "CurrentState": ClientStopInstancesResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientStopInstancesResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientStopInstancesResponseStoppingInstancesTypeDef(
    _ClientStopInstancesResponseStoppingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_ClientStopInstancesResponseTypeDef = TypedDict(
    "_ClientStopInstancesResponseTypeDef",
    {"StoppingInstances": List[ClientStopInstancesResponseStoppingInstancesTypeDef]},
    total=False,
)


class ClientStopInstancesResponseTypeDef(_ClientStopInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **StoppingInstances** *(list) --*

        Information about the stopped instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef",
    {"Code": Literal["active", "failed-to-terminate", "terminating", "terminated"], "Message": str},
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef
):
    pass


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef",
    {"Code": Literal["active", "failed-to-terminate", "terminating", "terminated"], "Message": str},
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef
):
    pass


_ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef",
    {
        "ConnectionId": str,
        "PreviousStatus": ClientTerminateClientVpnConnectionsResponseConnectionStatusesPreviousStatusTypeDef,
        "CurrentStatus": ClientTerminateClientVpnConnectionsResponseConnectionStatusesCurrentStatusTypeDef,
    },
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef(
    _ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef
):
    pass


_ClientTerminateClientVpnConnectionsResponseTypeDef = TypedDict(
    "_ClientTerminateClientVpnConnectionsResponseTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Username": str,
        "ConnectionStatuses": List[
            ClientTerminateClientVpnConnectionsResponseConnectionStatusesTypeDef
        ],
    },
    total=False,
)


class ClientTerminateClientVpnConnectionsResponseTypeDef(
    _ClientTerminateClientVpnConnectionsResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint.
    """


_ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef
):
    pass


_ClientTerminateInstancesResponseTerminatingInstancesTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": ClientTerminateInstancesResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": ClientTerminateInstancesResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class ClientTerminateInstancesResponseTerminatingInstancesTypeDef(
    _ClientTerminateInstancesResponseTerminatingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_ClientTerminateInstancesResponseTypeDef = TypedDict(
    "_ClientTerminateInstancesResponseTypeDef",
    {"TerminatingInstances": List[ClientTerminateInstancesResponseTerminatingInstancesTypeDef]},
    total=False,
)


class ClientTerminateInstancesResponseTypeDef(_ClientTerminateInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **TerminatingInstances** *(list) --*

        Information about the terminated instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_ClientUnassignIpv6AddressesResponseTypeDef = TypedDict(
    "_ClientUnassignIpv6AddressesResponseTypeDef",
    {"NetworkInterfaceId": str, "UnassignedIpv6Addresses": List[str]},
    total=False,
)


class ClientUnassignIpv6AddressesResponseTypeDef(_ClientUnassignIpv6AddressesResponseTypeDef):
    """
    - *(dict) --*

      - **NetworkInterfaceId** *(string) --*

        The ID of the network interface.
    """


_ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef(
    _ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": ClientUnmonitorInstancesResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef(
    _ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_ClientUnmonitorInstancesResponseTypeDef = TypedDict(
    "_ClientUnmonitorInstancesResponseTypeDef",
    {"InstanceMonitorings": List[ClientUnmonitorInstancesResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class ClientUnmonitorInstancesResponseTypeDef(_ClientUnmonitorInstancesResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef", {"Return": bool}, total=False
)


class ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsEgressResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef = TypedDict(
    "_ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef",
    {"Return": bool},
    total=False,
)


class ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef(
    _ClientUpdateSecurityGroupRuleDescriptionsIngressResponseTypeDef
):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, returns an error.
    """


_ClientWithdrawByoipCidrResponseByoipCidrTypeDef = TypedDict(
    "_ClientWithdrawByoipCidrResponseByoipCidrTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class ClientWithdrawByoipCidrResponseByoipCidrTypeDef(
    _ClientWithdrawByoipCidrResponseByoipCidrTypeDef
):
    """
    - **ByoipCidr** *(dict) --*

      Information about the address pool.
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_ClientWithdrawByoipCidrResponseTypeDef = TypedDict(
    "_ClientWithdrawByoipCidrResponseTypeDef",
    {"ByoipCidr": ClientWithdrawByoipCidrResponseByoipCidrTypeDef},
    total=False,
)


class ClientWithdrawByoipCidrResponseTypeDef(_ClientWithdrawByoipCidrResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidr** *(dict) --*

        Information about the address pool.
        - **Cidr** *(string) --*

          The public IPv4 address range, in CIDR notation.
    """


_ConversionTaskCancelledWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskCancelledWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ConversionTaskCancelledWaitWaiterConfigTypeDef(
    _ConversionTaskCancelledWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ConversionTaskCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskCompletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class ConversionTaskCompletedWaitWaiterConfigTypeDef(
    _ConversionTaskCompletedWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ConversionTaskDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_ConversionTaskDeletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class ConversionTaskDeletedWaitWaiterConfigTypeDef(_ConversionTaskDeletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_CustomerGatewayAvailableWaitFiltersTypeDef = TypedDict(
    "_CustomerGatewayAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class CustomerGatewayAvailableWaitFiltersTypeDef(_CustomerGatewayAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_CustomerGatewayAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_CustomerGatewayAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class CustomerGatewayAvailableWaitWaiterConfigTypeDef(
    _CustomerGatewayAvailableWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_DescribeByoipCidrsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeByoipCidrsPaginatePaginationConfigTypeDef(
    _DescribeByoipCidrsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef",
    {
        "Cidr": str,
        "Description": str,
        "StatusMessage": str,
        "State": Literal[
            "advertised",
            "deprovisioned",
            "failed-deprovision",
            "failed-provision",
            "pending-deprovision",
            "pending-provision",
            "provisioned",
        ],
    },
    total=False,
)


class DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef(
    _DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef
):
    """
    - *(dict) --*

      Information about an address range that is provisioned for use with your AWS resources through
      bring your own IP addresses (BYOIP).
      - **Cidr** *(string) --*

        The public IPv4 address range, in CIDR notation.
    """


_DescribeByoipCidrsPaginateResponseTypeDef = TypedDict(
    "_DescribeByoipCidrsPaginateResponseTypeDef",
    {"ByoipCidrs": List[DescribeByoipCidrsPaginateResponseByoipCidrsTypeDef]},
    total=False,
)


class DescribeByoipCidrsPaginateResponseTypeDef(_DescribeByoipCidrsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **ByoipCidrs** *(list) --*

        Information about your address ranges.
        - *(dict) --*

          Information about an address range that is provisioned for use with your AWS resources
          through bring your own IP addresses (BYOIP).
          - **Cidr** *(string) --*

            The public IPv4 address range, in CIDR notation.
    """


_DescribeCapacityReservationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeCapacityReservationsPaginateFiltersTypeDef(
    _DescribeCapacityReservationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeCapacityReservationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeCapacityReservationsPaginatePaginationConfigTypeDef(
    _DescribeCapacityReservationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef(
    _DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef
):
    pass


_DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef",
    {
        "CapacityReservationId": str,
        "OwnerId": str,
        "CapacityReservationArn": str,
        "AvailabilityZoneId": str,
        "InstanceType": str,
        "InstancePlatform": Literal[
            "Linux/UNIX",
            "Red Hat Enterprise Linux",
            "SUSE Linux",
            "Windows",
            "Windows with SQL Server",
            "Windows with SQL Server Enterprise",
            "Windows with SQL Server Standard",
            "Windows with SQL Server Web",
            "Linux with SQL Server Standard",
            "Linux with SQL Server Web",
            "Linux with SQL Server Enterprise",
        ],
        "AvailabilityZone": str,
        "Tenancy": Literal["default", "dedicated"],
        "TotalInstanceCount": int,
        "AvailableInstanceCount": int,
        "EbsOptimized": bool,
        "EphemeralStorage": bool,
        "State": Literal["active", "expired", "cancelled", "pending", "failed"],
        "EndDate": datetime,
        "EndDateType": Literal["unlimited", "limited"],
        "InstanceMatchCriteria": Literal["open", "targeted"],
        "CreateDate": datetime,
        "Tags": List[DescribeCapacityReservationsPaginateResponseCapacityReservationsTagsTypeDef],
    },
    total=False,
)


class DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef(
    _DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef
):
    """
    - *(dict) --*

      Describes a Capacity Reservation.
      - **CapacityReservationId** *(string) --*

        The ID of the Capacity Reservation.
    """


_DescribeCapacityReservationsPaginateResponseTypeDef = TypedDict(
    "_DescribeCapacityReservationsPaginateResponseTypeDef",
    {
        "CapacityReservations": List[
            DescribeCapacityReservationsPaginateResponseCapacityReservationsTypeDef
        ]
    },
    total=False,
)


class DescribeCapacityReservationsPaginateResponseTypeDef(
    _DescribeCapacityReservationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **CapacityReservations** *(list) --*

        Information about the Capacity Reservations.
        - *(dict) --*

          Describes a Capacity Reservation.
          - **CapacityReservationId** *(string) --*

            The ID of the Capacity Reservation.
    """


_DescribeClassicLinkInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClassicLinkInstancesPaginateFiltersTypeDef(
    _DescribeClassicLinkInstancesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef(
    _DescribeClassicLinkInstancesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef
):
    pass


_DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef",
    {
        "Groups": List[DescribeClassicLinkInstancesPaginateResponseInstancesGroupsTypeDef],
        "InstanceId": str,
        "Tags": List[DescribeClassicLinkInstancesPaginateResponseInstancesTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a linked EC2-Classic instance.
      - **Groups** *(list) --*

        A list of security groups.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_DescribeClassicLinkInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeClassicLinkInstancesPaginateResponseTypeDef",
    {"Instances": List[DescribeClassicLinkInstancesPaginateResponseInstancesTypeDef]},
    total=False,
)


class DescribeClassicLinkInstancesPaginateResponseTypeDef(
    _DescribeClassicLinkInstancesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Instances** *(list) --*

        Information about one or more linked EC2-Classic instances.
        - *(dict) --*

          Describes a linked EC2-Classic instance.
          - **Groups** *(list) --*

            A list of security groups.
            - *(dict) --*

              Describes a security group.
              - **GroupName** *(string) --*

                The name of the security group.
    """


_DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef",
    {"Code": Literal["authorizing", "active", "failed", "revoking"], "Message": str},
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef
):
    pass


_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "GroupId": str,
        "AccessAll": bool,
        "DestinationCidr": str,
        "Status": DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesStatusTypeDef,
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef
):
    """
    - *(dict) --*

      Information about an authorization rule.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint with which the authorization rule is associated.
    """


_DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef",
    {
        "AuthorizationRules": List[
            DescribeClientVpnAuthorizationRulesPaginateResponseAuthorizationRulesTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef(
    _DescribeClientVpnAuthorizationRulesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **AuthorizationRules** *(list) --*

        Information about the authorization rules.
        - *(dict) --*

          Information about an authorization rule.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint with which the authorization rule is associated.
    """


_DescribeClientVpnConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnConnectionsPaginateFiltersTypeDef(
    _DescribeClientVpnConnectionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef(
    _DescribeClientVpnConnectionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef",
    {"Code": Literal["active", "failed-to-terminate", "terminating", "terminated"], "Message": str},
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef
):
    pass


_DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Timestamp": str,
        "ConnectionId": str,
        "Username": str,
        "ConnectionEstablishedTime": str,
        "IngressBytes": str,
        "EgressBytes": str,
        "IngressPackets": str,
        "EgressPackets": str,
        "ClientIp": str,
        "CommonName": str,
        "Status": DescribeClientVpnConnectionsPaginateResponseConnectionsStatusTypeDef,
        "ConnectionEndTime": str,
    },
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a client connection.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint to which the client is connected.
    """


_DescribeClientVpnConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnConnectionsPaginateResponseTypeDef",
    {"Connections": List[DescribeClientVpnConnectionsPaginateResponseConnectionsTypeDef]},
    total=False,
)


class DescribeClientVpnConnectionsPaginateResponseTypeDef(
    _DescribeClientVpnConnectionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Connections** *(list) --*

        Information about the active and terminated client connections.
        - *(dict) --*

          Describes a client connection.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint to which the client is connected.
    """


_DescribeClientVpnEndpointsPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnEndpointsPaginateFiltersTypeDef(
    _DescribeClientVpnEndpointsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef(
    _DescribeClientVpnEndpointsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef",
    {"NetworkId": str, "NetworkType": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef",
    {"DirectoryId": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef",
    {"ClientRootCertificateChain": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef",
    {
        "Type": Literal["certificate-authentication", "directory-service-authentication"],
        "ActiveDirectory": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsActiveDirectoryTypeDef,
        "MutualAuthentication": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsMutualAuthenticationTypeDef,
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef",
    {"Enabled": bool, "CloudwatchLogGroup": str, "CloudwatchLogStream": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef",
    {"Code": Literal["pending-associate", "available", "deleting", "deleted"], "Message": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef
):
    pass


_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef",
    {
        "ClientVpnEndpointId": str,
        "Description": str,
        "Status": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsStatusTypeDef,
        "CreationTime": str,
        "DeletionTime": str,
        "DnsName": str,
        "ClientCidrBlock": str,
        "DnsServers": List[str],
        "SplitTunnel": bool,
        "VpnProtocol": str,
        "TransportProtocol": Literal["tcp", "udp"],
        "AssociatedTargetNetworks": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAssociatedTargetNetworksTypeDef
        ],
        "ServerCertificateArn": str,
        "AuthenticationOptions": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsAuthenticationOptionsTypeDef
        ],
        "ConnectionLogOptions": DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsConnectionLogOptionsTypeDef,
        "Tags": List[DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTagsTypeDef],
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef
):
    """
    - *(dict) --*

      Describes a Client VPN endpoint.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint.
    """


_DescribeClientVpnEndpointsPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnEndpointsPaginateResponseTypeDef",
    {
        "ClientVpnEndpoints": List[
            DescribeClientVpnEndpointsPaginateResponseClientVpnEndpointsTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnEndpointsPaginateResponseTypeDef(
    _DescribeClientVpnEndpointsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientVpnEndpoints** *(list) --*

        Information about the Client VPN endpoints.
        - *(dict) --*

          Describes a Client VPN endpoint.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint.
    """


_DescribeClientVpnRoutesPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnRoutesPaginateFiltersTypeDef(_DescribeClientVpnRoutesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClientVpnRoutesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnRoutesPaginatePaginationConfigTypeDef(
    _DescribeClientVpnRoutesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef",
    {"Code": Literal["creating", "active", "failed", "deleting"], "Message": str},
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef(
    _DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef
):
    pass


_DescribeClientVpnRoutesPaginateResponseRoutesTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseRoutesTypeDef",
    {
        "ClientVpnEndpointId": str,
        "DestinationCidr": str,
        "TargetSubnet": str,
        "Type": str,
        "Origin": str,
        "Status": DescribeClientVpnRoutesPaginateResponseRoutesStatusTypeDef,
        "Description": str,
    },
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseRoutesTypeDef(
    _DescribeClientVpnRoutesPaginateResponseRoutesTypeDef
):
    """
    - *(dict) --*

      Information about a Client VPN endpoint route.
      - **ClientVpnEndpointId** *(string) --*

        The ID of the Client VPN endpoint with which the route is associated.
    """


_DescribeClientVpnRoutesPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnRoutesPaginateResponseTypeDef",
    {"Routes": List[DescribeClientVpnRoutesPaginateResponseRoutesTypeDef]},
    total=False,
)


class DescribeClientVpnRoutesPaginateResponseTypeDef(
    _DescribeClientVpnRoutesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Routes** *(list) --*

        Information about the Client VPN endpoint routes.
        - *(dict) --*

          Information about a Client VPN endpoint route.
          - **ClientVpnEndpointId** *(string) --*

            The ID of the Client VPN endpoint with which the route is associated.
    """


_DescribeClientVpnTargetNetworksPaginateFiltersTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateFiltersTypeDef(
    _DescribeClientVpnTargetNetworksPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef(
    _DescribeClientVpnTargetNetworksPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef",
    {
        "Code": Literal[
            "associating", "associated", "association-failed", "disassociating", "disassociated"
        ],
        "Message": str,
    },
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef
):
    pass


_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef",
    {
        "AssociationId": str,
        "VpcId": str,
        "TargetNetworkId": str,
        "ClientVpnEndpointId": str,
        "Status": DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksStatusTypeDef,
        "SecurityGroups": List[str],
    },
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef
):
    """
    - *(dict) --*

      Describes a target network associated with a Client VPN endpoint.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_DescribeClientVpnTargetNetworksPaginateResponseTypeDef = TypedDict(
    "_DescribeClientVpnTargetNetworksPaginateResponseTypeDef",
    {
        "ClientVpnTargetNetworks": List[
            DescribeClientVpnTargetNetworksPaginateResponseClientVpnTargetNetworksTypeDef
        ]
    },
    total=False,
)


class DescribeClientVpnTargetNetworksPaginateResponseTypeDef(
    _DescribeClientVpnTargetNetworksPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ClientVpnTargetNetworks** *(list) --*

        Information about the associated target networks.
        - *(dict) --*

          Describes a target network associated with a Client VPN endpoint.
          - **AssociationId** *(string) --*

            The ID of the association.
    """


_DescribeDhcpOptionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeDhcpOptionsPaginateFiltersTypeDef(_DescribeDhcpOptionsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeDhcpOptionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeDhcpOptionsPaginatePaginationConfigTypeDef(
    _DescribeDhcpOptionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef",
    {"Value": str},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
):
    pass


_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef",
    {
        "Key": str,
        "Values": List[
            DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsValuesTypeDef
        ],
    },
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes a DHCP configuration option.
      - **Key** *(string) --*

        The name of a DHCP option.
    """


_DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef
):
    pass


_DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef",
    {
        "DhcpConfigurations": List[
            DescribeDhcpOptionsPaginateResponseDhcpOptionsDhcpConfigurationsTypeDef
        ],
        "DhcpOptionsId": str,
        "OwnerId": str,
        "Tags": List[DescribeDhcpOptionsPaginateResponseDhcpOptionsTagsTypeDef],
    },
    total=False,
)


class DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef(
    _DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of DHCP options.
      - **DhcpConfigurations** *(list) --*

        One or more DHCP options in the set.
        - *(dict) --*

          Describes a DHCP configuration option.
          - **Key** *(string) --*

            The name of a DHCP option.
    """


_DescribeDhcpOptionsPaginateResponseTypeDef = TypedDict(
    "_DescribeDhcpOptionsPaginateResponseTypeDef",
    {"DhcpOptions": List[DescribeDhcpOptionsPaginateResponseDhcpOptionsTypeDef]},
    total=False,
)


class DescribeDhcpOptionsPaginateResponseTypeDef(_DescribeDhcpOptionsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **DhcpOptions** *(list) --*

        Information about one or more DHCP options sets.
        - *(dict) --*

          Describes a set of DHCP options.
          - **DhcpConfigurations** *(list) --*

            One or more DHCP options in the set.
            - *(dict) --*

              Describes a DHCP configuration option.
              - **Key** *(string) --*

                The name of a DHCP option.
    """


_DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes the attachment of a VPC to an internet gateway or an egress-only internet gateway.
      - **State** *(string) --*

        The current state of the attachment. For an internet gateway, the state is ``available``
        when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef",
    {
        "Attachments": List[
            DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysAttachmentsTypeDef
        ],
        "EgressOnlyInternetGatewayId": str,
    },
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes an egress-only internet gateway.
      - **Attachments** *(list) --*

        Information about the attachment of the egress-only internet gateway.
        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.
          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is ``available``
            when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef",
    {
        "EgressOnlyInternetGateways": List[
            DescribeEgressOnlyInternetGatewaysPaginateResponseEgressOnlyInternetGatewaysTypeDef
        ]
    },
    total=False,
)


class DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef(
    _DescribeEgressOnlyInternetGatewaysPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **EgressOnlyInternetGateways** *(list) --*

        Information about the egress-only internet gateways.
        - *(dict) --*

          Describes an egress-only internet gateway.
          - **Attachments** *(list) --*

            Information about the attachment of the egress-only internet gateway.
            - *(dict) --*

              Describes the attachment of a VPC to an internet gateway or an egress-only internet
              gateway.
              - **State** *(string) --*

                The current state of the attachment. For an internet gateway, the state is
                ``available`` when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeExportImageTasksPaginateFiltersTypeDef = TypedDict(
    "_DescribeExportImageTasksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeExportImageTasksPaginateFiltersTypeDef(
    _DescribeExportImageTasksPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeExportImageTasksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeExportImageTasksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeExportImageTasksPaginatePaginationConfigTypeDef(
    _DescribeExportImageTasksPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef = TypedDict(
    "_DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef",
    {"S3Bucket": str, "S3Prefix": str},
    total=False,
)


class DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef(
    _DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef
):
    pass


_DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef = TypedDict(
    "_DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef",
    {
        "Description": str,
        "ExportImageTaskId": str,
        "ImageId": str,
        "Progress": str,
        "S3ExportLocation": DescribeExportImageTasksPaginateResponseExportImageTasksS3ExportLocationTypeDef,
        "Status": str,
        "StatusMessage": str,
    },
    total=False,
)


class DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef(
    _DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef
):
    """
    - *(dict) --*

      Describes an export image task.
      - **Description** *(string) --*

        A description of the image being exported.
    """


_DescribeExportImageTasksPaginateResponseTypeDef = TypedDict(
    "_DescribeExportImageTasksPaginateResponseTypeDef",
    {"ExportImageTasks": List[DescribeExportImageTasksPaginateResponseExportImageTasksTypeDef]},
    total=False,
)


class DescribeExportImageTasksPaginateResponseTypeDef(
    _DescribeExportImageTasksPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ExportImageTasks** *(list) --*

        Information about the export image tasks.
        - *(dict) --*

          Describes an export image task.
          - **Description** *(string) --*

            A description of the image being exported.
    """


_DescribeFastSnapshotRestoresPaginateFiltersTypeDef = TypedDict(
    "_DescribeFastSnapshotRestoresPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeFastSnapshotRestoresPaginateFiltersTypeDef(
    _DescribeFastSnapshotRestoresPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeFastSnapshotRestoresPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFastSnapshotRestoresPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFastSnapshotRestoresPaginatePaginationConfigTypeDef(
    _DescribeFastSnapshotRestoresPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef = TypedDict(
    "_DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef",
    {
        "SnapshotId": str,
        "AvailabilityZone": str,
        "State": Literal["enabling", "optimizing", "enabled", "disabling", "disabled"],
        "StateTransitionReason": str,
        "OwnerId": str,
        "OwnerAlias": str,
        "EnablingTime": datetime,
        "OptimizingTime": datetime,
        "EnabledTime": datetime,
        "DisablingTime": datetime,
        "DisabledTime": datetime,
    },
    total=False,
)


class DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef(
    _DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef
):
    """
    - *(dict) --*

      Describes fast snapshot restores for a snapshot.
      - **SnapshotId** *(string) --*

        The ID of the snapshot.
    """


_DescribeFastSnapshotRestoresPaginateResponseTypeDef = TypedDict(
    "_DescribeFastSnapshotRestoresPaginateResponseTypeDef",
    {
        "FastSnapshotRestores": List[
            DescribeFastSnapshotRestoresPaginateResponseFastSnapshotRestoresTypeDef
        ]
    },
    total=False,
)


class DescribeFastSnapshotRestoresPaginateResponseTypeDef(
    _DescribeFastSnapshotRestoresPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **FastSnapshotRestores** *(list) --*

        Information about the state of fast snapshot restores.
        - *(dict) --*

          Describes fast snapshot restores for a snapshot.
          - **SnapshotId** *(string) --*

            The ID of the snapshot.
    """


_DescribeFleetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeFleetsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeFleetsPaginateFiltersTypeDef(_DescribeFleetsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeFleetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFleetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFleetsPaginatePaginationConfigTypeDef(_DescribeFleetsPaginatePaginationConfigTypeDef):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsErrorsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsErrorsTypeDef",
    {
        "LaunchTemplateAndOverrides": DescribeFleetsPaginateResponseFleetsErrorsLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "ErrorCode": str,
        "ErrorMessage": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsErrorsTypeDef(
    _DescribeFleetsPaginateResponseFleetsErrorsTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesLaunchTemplateSpecificationTypeDef,
        "Overrides": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesOverridesTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsInstancesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsInstancesTypeDef",
    {
        "LaunchTemplateAndOverrides": DescribeFleetsPaginateResponseFleetsInstancesLaunchTemplateAndOverridesTypeDef,
        "Lifecycle": Literal["spot", "on-demand"],
        "InstanceIds": List[str],
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsInstancesTypeDef(
    _DescribeFleetsPaginateResponseFleetsInstancesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef",
    {"GroupName": str},
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "MaxPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
        "Placement": DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesPlacementTypeDef,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef(
    _DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "prioritized"],
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef(
    _DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef",
    {
        "AllocationStrategy": Literal["lowest-price", "diversified", "capacity-optimized"],
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "InstancePoolsToUseCount": int,
        "SingleInstanceType": bool,
        "SingleAvailabilityZone": bool,
        "MinTargetCapacity": int,
        "MaxTotalPrice": str,
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef(
    _DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsTagsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DescribeFleetsPaginateResponseFleetsTagsTypeDef(
    _DescribeFleetsPaginateResponseFleetsTagsTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef",
    {
        "TotalTargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "SpotTargetCapacity": int,
        "DefaultTargetCapacityType": Literal["spot", "on-demand"],
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef(
    _DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef
):
    pass


_DescribeFleetsPaginateResponseFleetsTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseFleetsTypeDef",
    {
        "ActivityStatus": Literal[
            "error", "pending_fulfillment", "pending_termination", "fulfilled"
        ],
        "CreateTime": datetime,
        "FleetId": str,
        "FleetState": Literal[
            "submitted",
            "active",
            "deleted",
            "failed",
            "deleted_running",
            "deleted_terminating",
            "modifying",
        ],
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": Literal["no-termination", "termination"],
        "FulfilledCapacity": float,
        "FulfilledOnDemandCapacity": float,
        "LaunchTemplateConfigs": List[
            DescribeFleetsPaginateResponseFleetsLaunchTemplateConfigsTypeDef
        ],
        "TargetCapacitySpecification": DescribeFleetsPaginateResponseFleetsTargetCapacitySpecificationTypeDef,
        "TerminateInstancesWithExpiration": bool,
        "Type": Literal["request", "maintain", "instant"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "SpotOptions": DescribeFleetsPaginateResponseFleetsSpotOptionsTypeDef,
        "OnDemandOptions": DescribeFleetsPaginateResponseFleetsOnDemandOptionsTypeDef,
        "Tags": List[DescribeFleetsPaginateResponseFleetsTagsTypeDef],
        "Errors": List[DescribeFleetsPaginateResponseFleetsErrorsTypeDef],
        "Instances": List[DescribeFleetsPaginateResponseFleetsInstancesTypeDef],
    },
    total=False,
)


class DescribeFleetsPaginateResponseFleetsTypeDef(_DescribeFleetsPaginateResponseFleetsTypeDef):
    """
    - *(dict) --*

      Describes an EC2 Fleet.
      - **ActivityStatus** *(string) --*

        The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
        requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2 Fleet is
        equal to or greater than its target capacity, the status is ``fulfilled`` . If the size of
        the EC2 Fleet is decreased, the status is ``pending_termination`` while instances are
        terminating.
    """


_DescribeFleetsPaginateResponseTypeDef = TypedDict(
    "_DescribeFleetsPaginateResponseTypeDef",
    {"Fleets": List[DescribeFleetsPaginateResponseFleetsTypeDef]},
    total=False,
)


class DescribeFleetsPaginateResponseTypeDef(_DescribeFleetsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Fleets** *(list) --*

        Information about the EC2 Fleets.
        - *(dict) --*

          Describes an EC2 Fleet.
          - **ActivityStatus** *(string) --*

            The progress of the EC2 Fleet. If there is an error, the status is ``error`` . After all
            requests are placed, the status is ``pending_fulfillment`` . If the size of the EC2
            Fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If
            the size of the EC2 Fleet is decreased, the status is ``pending_termination`` while
            instances are terminating.
    """


_DescribeFlowLogsPaginateFiltersTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeFlowLogsPaginateFiltersTypeDef(_DescribeFlowLogsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeFlowLogsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFlowLogsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFlowLogsPaginatePaginationConfigTypeDef(
    _DescribeFlowLogsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeFlowLogsPaginateResponseFlowLogsTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateResponseFlowLogsTypeDef",
    {
        "CreationTime": datetime,
        "DeliverLogsErrorMessage": str,
        "DeliverLogsPermissionArn": str,
        "DeliverLogsStatus": str,
        "FlowLogId": str,
        "FlowLogStatus": str,
        "LogGroupName": str,
        "ResourceId": str,
        "TrafficType": Literal["ACCEPT", "REJECT", "ALL"],
        "LogDestinationType": Literal["cloud-watch-logs", "s3"],
        "LogDestination": str,
        "LogFormat": str,
    },
    total=False,
)


class DescribeFlowLogsPaginateResponseFlowLogsTypeDef(
    _DescribeFlowLogsPaginateResponseFlowLogsTypeDef
):
    """
    - *(dict) --*

      Describes a flow log.
      - **CreationTime** *(datetime) --*

        The date and time the flow log was created.
    """


_DescribeFlowLogsPaginateResponseTypeDef = TypedDict(
    "_DescribeFlowLogsPaginateResponseTypeDef",
    {"FlowLogs": List[DescribeFlowLogsPaginateResponseFlowLogsTypeDef]},
    total=False,
)


class DescribeFlowLogsPaginateResponseTypeDef(_DescribeFlowLogsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **FlowLogs** *(list) --*

        Information about the flow logs.
        - *(dict) --*

          Describes a flow log.
          - **CreationTime** *(datetime) --*

            The date and time the flow log was created.
    """


_DescribeFpgaImagesPaginateFiltersTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeFpgaImagesPaginateFiltersTypeDef(_DescribeFpgaImagesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeFpgaImagesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeFpgaImagesPaginatePaginationConfigTypeDef(
    _DescribeFpgaImagesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef",
    {"DeviceId": str, "VendorId": str, "SubsystemId": str, "SubsystemVendorId": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef
):
    pass


_DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef
):
    pass


_DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef",
    {"Code": Literal["pending", "failed", "available", "unavailable"], "Message": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef
):
    pass


_DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef
):
    pass


_DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef",
    {
        "FpgaImageId": str,
        "FpgaImageGlobalId": str,
        "Name": str,
        "Description": str,
        "ShellVersion": str,
        "PciId": DescribeFpgaImagesPaginateResponseFpgaImagesPciIdTypeDef,
        "State": DescribeFpgaImagesPaginateResponseFpgaImagesStateTypeDef,
        "CreateTime": datetime,
        "UpdateTime": datetime,
        "OwnerId": str,
        "OwnerAlias": str,
        "ProductCodes": List[DescribeFpgaImagesPaginateResponseFpgaImagesProductCodesTypeDef],
        "Tags": List[DescribeFpgaImagesPaginateResponseFpgaImagesTagsTypeDef],
        "Public": bool,
        "DataRetentionSupport": bool,
    },
    total=False,
)


class DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef(
    _DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef
):
    """
    - *(dict) --*

      Describes an Amazon FPGA image (AFI).
      - **FpgaImageId** *(string) --*

        The FPGA image identifier (AFI ID).
    """


_DescribeFpgaImagesPaginateResponseTypeDef = TypedDict(
    "_DescribeFpgaImagesPaginateResponseTypeDef",
    {"FpgaImages": List[DescribeFpgaImagesPaginateResponseFpgaImagesTypeDef]},
    total=False,
)


class DescribeFpgaImagesPaginateResponseTypeDef(_DescribeFpgaImagesPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **FpgaImages** *(list) --*

        Information about the FPGA images.
        - *(dict) --*

          Describes an Amazon FPGA image (AFI).
          - **FpgaImageId** *(string) --*

            The FPGA image identifier (AFI ID).
    """


_DescribeHostReservationOfferingsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeHostReservationOfferingsPaginateFiltersTypeDef(
    _DescribeHostReservationOfferingsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef(
    _DescribeHostReservationOfferingsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef",
    {
        "CurrencyCode": str,
        "Duration": int,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "UpfrontPrice": str,
    },
    total=False,
)


class DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef(
    _DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef
):
    """
    - *(dict) --*

      Details about the Dedicated Host Reservation offering.
      - **CurrencyCode** *(string) --*

        The currency of the offering.
    """


_DescribeHostReservationOfferingsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostReservationOfferingsPaginateResponseTypeDef",
    {"OfferingSet": List[DescribeHostReservationOfferingsPaginateResponseOfferingSetTypeDef]},
    total=False,
)


class DescribeHostReservationOfferingsPaginateResponseTypeDef(
    _DescribeHostReservationOfferingsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **OfferingSet** *(list) --*

        Information about the offerings.
        - *(dict) --*

          Details about the Dedicated Host Reservation offering.
          - **CurrencyCode** *(string) --*

            The currency of the offering.
    """


_DescribeHostReservationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeHostReservationsPaginateFiltersTypeDef(
    _DescribeHostReservationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeHostReservationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostReservationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostReservationsPaginatePaginationConfigTypeDef(
    _DescribeHostReservationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef(
    _DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef
):
    pass


_DescribeHostReservationsPaginateResponseHostReservationSetTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseHostReservationSetTypeDef",
    {
        "Count": int,
        "CurrencyCode": str,
        "Duration": int,
        "End": datetime,
        "HostIdSet": List[str],
        "HostReservationId": str,
        "HourlyPrice": str,
        "InstanceFamily": str,
        "OfferingId": str,
        "PaymentOption": Literal["AllUpfront", "PartialUpfront", "NoUpfront"],
        "Start": datetime,
        "State": Literal["payment-pending", "payment-failed", "active", "retired"],
        "UpfrontPrice": str,
        "Tags": List[DescribeHostReservationsPaginateResponseHostReservationSetTagsTypeDef],
    },
    total=False,
)


class DescribeHostReservationsPaginateResponseHostReservationSetTypeDef(
    _DescribeHostReservationsPaginateResponseHostReservationSetTypeDef
):
    """
    - *(dict) --*

      Details about the Dedicated Host Reservation and associated Dedicated Hosts.
      - **Count** *(integer) --*

        The number of Dedicated Hosts the reservation is associated with.
    """


_DescribeHostReservationsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostReservationsPaginateResponseTypeDef",
    {"HostReservationSet": List[DescribeHostReservationsPaginateResponseHostReservationSetTypeDef]},
    total=False,
)


class DescribeHostReservationsPaginateResponseTypeDef(
    _DescribeHostReservationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **HostReservationSet** *(list) --*

        Details about the reservation's configuration.
        - *(dict) --*

          Details about the Dedicated Host Reservation and associated Dedicated Hosts.
          - **Count** *(integer) --*

            The number of Dedicated Hosts the reservation is associated with.
    """


_DescribeHostsPaginateFiltersTypeDef = TypedDict(
    "_DescribeHostsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeHostsPaginateFiltersTypeDef(_DescribeHostsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeHostsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeHostsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeHostsPaginatePaginationConfigTypeDef(_DescribeHostsPaginatePaginationConfigTypeDef):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef",
    {"AvailableCapacity": int, "InstanceType": str, "TotalCapacity": int},
    total=False,
)


class DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef(
    _DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
):
    pass


_DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef",
    {
        "AvailableInstanceCapacity": List[
            DescribeHostsPaginateResponseHostsAvailableCapacityAvailableInstanceCapacityTypeDef
        ],
        "AvailableVCpus": int,
    },
    total=False,
)


class DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef(
    _DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef
):
    pass


_DescribeHostsPaginateResponseHostsHostPropertiesTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsHostPropertiesTypeDef",
    {"Cores": int, "InstanceType": str, "InstanceFamily": str, "Sockets": int, "TotalVCpus": int},
    total=False,
)


class DescribeHostsPaginateResponseHostsHostPropertiesTypeDef(
    _DescribeHostsPaginateResponseHostsHostPropertiesTypeDef
):
    pass


_DescribeHostsPaginateResponseHostsInstancesTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsInstancesTypeDef",
    {"InstanceId": str, "InstanceType": str, "OwnerId": str},
    total=False,
)


class DescribeHostsPaginateResponseHostsInstancesTypeDef(
    _DescribeHostsPaginateResponseHostsInstancesTypeDef
):
    pass


_DescribeHostsPaginateResponseHostsTagsTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DescribeHostsPaginateResponseHostsTagsTypeDef(_DescribeHostsPaginateResponseHostsTagsTypeDef):
    pass


_DescribeHostsPaginateResponseHostsTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseHostsTypeDef",
    {
        "AutoPlacement": Literal["on", "off"],
        "AvailabilityZone": str,
        "AvailableCapacity": DescribeHostsPaginateResponseHostsAvailableCapacityTypeDef,
        "ClientToken": str,
        "HostId": str,
        "HostProperties": DescribeHostsPaginateResponseHostsHostPropertiesTypeDef,
        "HostReservationId": str,
        "Instances": List[DescribeHostsPaginateResponseHostsInstancesTypeDef],
        "State": Literal[
            "available",
            "under-assessment",
            "permanent-failure",
            "released",
            "released-permanent-failure",
            "pending",
        ],
        "AllocationTime": datetime,
        "ReleaseTime": datetime,
        "Tags": List[DescribeHostsPaginateResponseHostsTagsTypeDef],
        "HostRecovery": Literal["on", "off"],
        "AllowsMultipleInstanceTypes": Literal["on", "off"],
        "OwnerId": str,
        "AvailabilityZoneId": str,
        "MemberOfServiceLinkedResourceGroup": bool,
    },
    total=False,
)


class DescribeHostsPaginateResponseHostsTypeDef(_DescribeHostsPaginateResponseHostsTypeDef):
    """
    - *(dict) --*

      Describes the properties of the Dedicated Host.
      - **AutoPlacement** *(string) --*

        Whether auto-placement is on or off.
    """


_DescribeHostsPaginateResponseTypeDef = TypedDict(
    "_DescribeHostsPaginateResponseTypeDef",
    {"Hosts": List[DescribeHostsPaginateResponseHostsTypeDef]},
    total=False,
)


class DescribeHostsPaginateResponseTypeDef(_DescribeHostsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Hosts** *(list) --*

        Information about the Dedicated Hosts.
        - *(dict) --*

          Describes the properties of the Dedicated Host.
          - **AutoPlacement** *(string) --*

            Whether auto-placement is on or off.
    """


_DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef
):
    pass


_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef",
    {
        "AssociationId": str,
        "InstanceId": str,
        "IamInstanceProfile": DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsIamInstanceProfileTypeDef,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
        "Timestamp": datetime,
    },
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between an IAM instance profile and an instance.
      - **AssociationId** *(string) --*

        The ID of the association.
    """


_DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef = TypedDict(
    "_DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef",
    {
        "IamInstanceProfileAssociations": List[
            DescribeIamInstanceProfileAssociationsPaginateResponseIamInstanceProfileAssociationsTypeDef
        ]
    },
    total=False,
)


class DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef(
    _DescribeIamInstanceProfileAssociationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **IamInstanceProfileAssociations** *(list) --*

        Information about the IAM instance profile associations.
        - *(dict) --*

          Describes an association between an IAM instance profile and an instance.
          - **AssociationId** *(string) --*

            The ID of the association.
    """


_DescribeImportImageTasksPaginateFiltersTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeImportImageTasksPaginateFiltersTypeDef(
    _DescribeImportImageTasksPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeImportImageTasksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeImportImageTasksPaginatePaginationConfigTypeDef(
    _DescribeImportImageTasksPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef
):
    pass


_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef
):
    pass


_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef",
    {
        "Description": str,
        "DeviceName": str,
        "DiskImageSize": float,
        "Format": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsUserBucketTypeDef,
    },
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef
):
    pass


_DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef",
    {
        "Architecture": str,
        "Description": str,
        "Encrypted": bool,
        "Hypervisor": str,
        "ImageId": str,
        "ImportTaskId": str,
        "KmsKeyId": str,
        "LicenseType": str,
        "Platform": str,
        "Progress": str,
        "SnapshotDetails": List[
            DescribeImportImageTasksPaginateResponseImportImageTasksSnapshotDetailsTypeDef
        ],
        "Status": str,
        "StatusMessage": str,
        "LicenseSpecifications": List[
            DescribeImportImageTasksPaginateResponseImportImageTasksLicenseSpecificationsTypeDef
        ],
    },
    total=False,
)


class DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef(
    _DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef
):
    """
    - *(dict) --*

      Describes an import image task.
      - **Architecture** *(string) --*

        The architecture of the virtual machine.
        Valid values: ``i386`` | ``x86_64`` | ``arm64``
    """


_DescribeImportImageTasksPaginateResponseTypeDef = TypedDict(
    "_DescribeImportImageTasksPaginateResponseTypeDef",
    {"ImportImageTasks": List[DescribeImportImageTasksPaginateResponseImportImageTasksTypeDef]},
    total=False,
)


class DescribeImportImageTasksPaginateResponseTypeDef(
    _DescribeImportImageTasksPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ImportImageTasks** *(list) --*

        A list of zero or more import image tasks that are currently active or were completed or
        canceled in the previous 7 days.
        - *(dict) --*

          Describes an import image task.
          - **Architecture** *(string) --*

            The architecture of the virtual machine.
            Valid values: ``i386`` | ``x86_64`` | ``arm64``
    """


_DescribeImportSnapshotTasksPaginateFiltersTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeImportSnapshotTasksPaginateFiltersTypeDef(
    _DescribeImportSnapshotTasksPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef(
    _DescribeImportSnapshotTasksPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef",
    {"S3Bucket": str, "S3Key": str},
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef
):
    pass


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef",
    {
        "Description": str,
        "DiskImageSize": float,
        "Encrypted": bool,
        "Format": str,
        "KmsKeyId": str,
        "Progress": str,
        "SnapshotId": str,
        "Status": str,
        "StatusMessage": str,
        "Url": str,
        "UserBucket": DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailUserBucketTypeDef,
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef
):
    pass


_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef",
    {
        "Description": str,
        "ImportTaskId": str,
        "SnapshotTaskDetail": DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksSnapshotTaskDetailTypeDef,
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef
):
    """
    - *(dict) --*

      Describes an import snapshot task.
      - **Description** *(string) --*

        A description of the import snapshot task.
    """


_DescribeImportSnapshotTasksPaginateResponseTypeDef = TypedDict(
    "_DescribeImportSnapshotTasksPaginateResponseTypeDef",
    {
        "ImportSnapshotTasks": List[
            DescribeImportSnapshotTasksPaginateResponseImportSnapshotTasksTypeDef
        ]
    },
    total=False,
)


class DescribeImportSnapshotTasksPaginateResponseTypeDef(
    _DescribeImportSnapshotTasksPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ImportSnapshotTasks** *(list) --*

        A list of zero or more import snapshot tasks that are currently active or were completed or
        canceled in the previous 7 days.
        - *(dict) --*

          Describes an import snapshot task.
          - **Description** *(string) --*

            A description of the import snapshot task.
    """


_DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef(
    _DescribeInstanceCreditSpecificationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef",
    {"InstanceId": str, "CpuCredits": str},
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes the credit option for CPU usage of a burstable performance instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_DescribeInstanceCreditSpecificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeInstanceCreditSpecificationsPaginateResponseTypeDef",
    {
        "InstanceCreditSpecifications": List[
            DescribeInstanceCreditSpecificationsPaginateResponseInstanceCreditSpecificationsTypeDef
        ]
    },
    total=False,
)


class DescribeInstanceCreditSpecificationsPaginateResponseTypeDef(
    _DescribeInstanceCreditSpecificationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **InstanceCreditSpecifications** *(list) --*

        Information about the credit option for CPU usage of an instance.
        - *(dict) --*

          Describes the credit option for CPU usage of a burstable performance instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_DescribeInstanceStatusPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeInstanceStatusPaginateFiltersTypeDef(_DescribeInstanceStatusPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeInstanceStatusPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstanceStatusPaginatePaginationConfigTypeDef(
    _DescribeInstanceStatusPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef",
    {
        "InstanceEventId": str,
        "Code": Literal[
            "instance-reboot",
            "system-reboot",
            "system-maintenance",
            "instance-retirement",
            "instance-stop",
        ],
        "Description": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
        "NotBeforeDeadline": datetime,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef",
    {
        "ImpairedSince": datetime,
        "Name": str,
        "Status": Literal["passed", "failed", "insufficient-data", "initializing"],
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef",
    {
        "Details": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusDetailsTypeDef
        ],
        "Status": Literal["ok", "impaired", "insufficient-data", "not-applicable", "initializing"],
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef",
    {
        "ImpairedSince": datetime,
        "Name": str,
        "Status": Literal["passed", "failed", "insufficient-data", "initializing"],
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef",
    {
        "Details": List[
            DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusDetailsTypeDef
        ],
        "Status": Literal["ok", "impaired", "insufficient-data", "not-applicable", "initializing"],
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef
):
    pass


_DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef",
    {
        "AvailabilityZone": str,
        "Events": List[DescribeInstanceStatusPaginateResponseInstanceStatusesEventsTypeDef],
        "InstanceId": str,
        "InstanceState": DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStateTypeDef,
        "InstanceStatus": DescribeInstanceStatusPaginateResponseInstanceStatusesInstanceStatusTypeDef,
        "SystemStatus": DescribeInstanceStatusPaginateResponseInstanceStatusesSystemStatusTypeDef,
    },
    total=False,
)


class DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef(
    _DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the status of an instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the instance.
    """


_DescribeInstanceStatusPaginateResponseTypeDef = TypedDict(
    "_DescribeInstanceStatusPaginateResponseTypeDef",
    {"InstanceStatuses": List[DescribeInstanceStatusPaginateResponseInstanceStatusesTypeDef]},
    total=False,
)


class DescribeInstanceStatusPaginateResponseTypeDef(_DescribeInstanceStatusPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceStatuses** *(list) --*

        Information about the status of the instances.
        - *(dict) --*

          Describes the status of an instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone of the instance.
    """


_DescribeInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeInstancesPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeInstancesPaginateFiltersTypeDef(_DescribeInstancesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInstancesPaginatePaginationConfigTypeDef(
    _DescribeInstancesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeInstancesPaginateResponseReservationsGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
        "VolumeId": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsEbsTypeDef,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef",
    {
        "ElasticGpuId": str,
        "ElasticGpuAssociationId": str,
        "ElasticGpuAssociationState": str,
        "ElasticGpuAssociationTime": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef",
    {
        "ElasticInferenceAcceleratorArn": str,
        "ElasticInferenceAcceleratorAssociationId": str,
        "ElasticInferenceAcceleratorAssociationState": str,
        "ElasticInferenceAcceleratorAssociationTime": datetime,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Id": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef",
    {
        "State": Literal["pending", "applied"],
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {"IpOwnerId": str, "PublicDnsName": str, "PublicIp": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef",
    {
        "Association": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAssociationTypeDef,
        "Attachment": DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesAttachmentTypeDef,
        "Description": str,
        "Groups": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesGroupsTypeDef
        ],
        "Ipv6Addresses": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "VpcId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsInstancesTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsInstancesTypeDef",
    {
        "AmiLaunchIndex": int,
        "ImageId": str,
        "InstanceId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "LaunchTime": datetime,
        "Monitoring": DescribeInstancesPaginateResponseReservationsInstancesMonitoringTypeDef,
        "Placement": DescribeInstancesPaginateResponseReservationsInstancesPlacementTypeDef,
        "Platform": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "ProductCodes": List[
            DescribeInstancesPaginateResponseReservationsInstancesProductCodesTypeDef
        ],
        "PublicDnsName": str,
        "PublicIpAddress": str,
        "RamdiskId": str,
        "State": DescribeInstancesPaginateResponseReservationsInstancesStateTypeDef,
        "StateTransitionReason": str,
        "SubnetId": str,
        "VpcId": str,
        "Architecture": Literal["i386", "x86_64", "arm64"],
        "BlockDeviceMappings": List[
            DescribeInstancesPaginateResponseReservationsInstancesBlockDeviceMappingsTypeDef
        ],
        "ClientToken": str,
        "EbsOptimized": bool,
        "EnaSupport": bool,
        "Hypervisor": Literal["ovm", "xen"],
        "IamInstanceProfile": DescribeInstancesPaginateResponseReservationsInstancesIamInstanceProfileTypeDef,
        "InstanceLifecycle": Literal["spot", "scheduled"],
        "ElasticGpuAssociations": List[
            DescribeInstancesPaginateResponseReservationsInstancesElasticGpuAssociationsTypeDef
        ],
        "ElasticInferenceAcceleratorAssociations": List[
            DescribeInstancesPaginateResponseReservationsInstancesElasticInferenceAcceleratorAssociationsTypeDef
        ],
        "NetworkInterfaces": List[
            DescribeInstancesPaginateResponseReservationsInstancesNetworkInterfacesTypeDef
        ],
        "RootDeviceName": str,
        "RootDeviceType": Literal["ebs", "instance-store"],
        "SecurityGroups": List[
            DescribeInstancesPaginateResponseReservationsInstancesSecurityGroupsTypeDef
        ],
        "SourceDestCheck": bool,
        "SpotInstanceRequestId": str,
        "SriovNetSupport": str,
        "StateReason": DescribeInstancesPaginateResponseReservationsInstancesStateReasonTypeDef,
        "Tags": List[DescribeInstancesPaginateResponseReservationsInstancesTagsTypeDef],
        "VirtualizationType": Literal["hvm", "paravirtual"],
        "CpuOptions": DescribeInstancesPaginateResponseReservationsInstancesCpuOptionsTypeDef,
        "CapacityReservationId": str,
        "CapacityReservationSpecification": DescribeInstancesPaginateResponseReservationsInstancesCapacityReservationSpecificationTypeDef,
        "HibernationOptions": DescribeInstancesPaginateResponseReservationsInstancesHibernationOptionsTypeDef,
        "Licenses": List[DescribeInstancesPaginateResponseReservationsInstancesLicensesTypeDef],
        "MetadataOptions": DescribeInstancesPaginateResponseReservationsInstancesMetadataOptionsTypeDef,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsInstancesTypeDef(
    _DescribeInstancesPaginateResponseReservationsInstancesTypeDef
):
    pass


_DescribeInstancesPaginateResponseReservationsTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseReservationsTypeDef",
    {
        "Groups": List[DescribeInstancesPaginateResponseReservationsGroupsTypeDef],
        "Instances": List[DescribeInstancesPaginateResponseReservationsInstancesTypeDef],
        "OwnerId": str,
        "RequesterId": str,
        "ReservationId": str,
    },
    total=False,
)


class DescribeInstancesPaginateResponseReservationsTypeDef(
    _DescribeInstancesPaginateResponseReservationsTypeDef
):
    """
    - *(dict) --*

      Describes a reservation.
      - **Groups** *(list) --*

        [EC2-Classic only] The security groups.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_DescribeInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeInstancesPaginateResponseTypeDef",
    {"Reservations": List[DescribeInstancesPaginateResponseReservationsTypeDef]},
    total=False,
)


class DescribeInstancesPaginateResponseTypeDef(_DescribeInstancesPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Reservations** *(list) --*

        Information about the reservations.
        - *(dict) --*

          Describes a reservation.
          - **Groups** *(list) --*

            [EC2-Classic only] The security groups.
            - *(dict) --*

              Describes a security group.
              - **GroupName** *(string) --*

                The name of the security group.
    """


_DescribeInternetGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeInternetGatewaysPaginateFiltersTypeDef(
    _DescribeInternetGatewaysPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeInternetGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeInternetGatewaysPaginatePaginationConfigTypeDef(
    _DescribeInternetGatewaysPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef",
    {"State": Literal["attaching", "attached", "detaching", "detached"], "VpcId": str},
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes the attachment of a VPC to an internet gateway or an egress-only internet gateway.
      - **State** *(string) --*

        The current state of the attachment. For an internet gateway, the state is ``available``
        when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef
):
    pass


_DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef",
    {
        "Attachments": List[
            DescribeInternetGatewaysPaginateResponseInternetGatewaysAttachmentsTypeDef
        ],
        "InternetGatewayId": str,
        "OwnerId": str,
        "Tags": List[DescribeInternetGatewaysPaginateResponseInternetGatewaysTagsTypeDef],
    },
    total=False,
)


class DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef(
    _DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes an internet gateway.
      - **Attachments** *(list) --*

        Any VPCs attached to the internet gateway.
        - *(dict) --*

          Describes the attachment of a VPC to an internet gateway or an egress-only internet
          gateway.
          - **State** *(string) --*

            The current state of the attachment. For an internet gateway, the state is ``available``
            when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeInternetGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeInternetGatewaysPaginateResponseTypeDef",
    {"InternetGateways": List[DescribeInternetGatewaysPaginateResponseInternetGatewaysTypeDef]},
    total=False,
)


class DescribeInternetGatewaysPaginateResponseTypeDef(
    _DescribeInternetGatewaysPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **InternetGateways** *(list) --*

        Information about one or more internet gateways.
        - *(dict) --*

          Describes an internet gateway.
          - **Attachments** *(list) --*

            Any VPCs attached to the internet gateway.
            - *(dict) --*

              Describes the attachment of a VPC to an internet gateway or an egress-only internet
              gateway.
              - **State** *(string) --*

                The current state of the attachment. For an internet gateway, the state is
                ``available`` when attached to a VPC; otherwise, this value is not returned.
    """


_DescribeLaunchTemplateVersionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateFiltersTypeDef(
    _DescribeLaunchTemplateVersionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef(
    _DescribeLaunchTemplateVersionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef",
    {
        "Encrypted": bool,
        "DeleteOnTermination": bool,
        "Iops": int,
        "KmsKeyId": str,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef",
    {"CpuCredits": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef",
    {"Type": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef",
    {"Type": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef",
    {"Configured": bool},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "InterfaceType": str,
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef",
    {
        "KernelId": str,
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataIamInstanceProfileTypeDef,
        "BlockDeviceMappings": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataBlockDeviceMappingsTypeDef
        ],
        "NetworkInterfaces": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataNetworkInterfacesTypeDef
        ],
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KeyName": str,
        "Monitoring": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataMonitoringTypeDef,
        "Placement": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataPlacementTypeDef,
        "RamDiskId": str,
        "DisableApiTermination": bool,
        "InstanceInitiatedShutdownBehavior": Literal["stop", "terminate"],
        "UserData": str,
        "TagSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTagSpecificationsTypeDef
        ],
        "ElasticGpuSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticGpuSpecificationsTypeDef
        ],
        "ElasticInferenceAccelerators": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataElasticInferenceAcceleratorsTypeDef
        ],
        "SecurityGroupIds": List[str],
        "SecurityGroups": List[str],
        "InstanceMarketOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataInstanceMarketOptionsTypeDef,
        "CreditSpecification": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCreditSpecificationTypeDef,
        "CpuOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCpuOptionsTypeDef,
        "CapacityReservationSpecification": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataCapacityReservationSpecificationTypeDef,
        "LicenseSpecifications": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataLicenseSpecificationsTypeDef
        ],
        "HibernationOptions": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataHibernationOptionsTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef
):
    pass


_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "VersionNumber": int,
        "VersionDescription": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersion": bool,
        "LaunchTemplateData": DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsLaunchTemplateDataTypeDef,
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef
):
    """
    - *(dict) --*

      Describes a launch template version.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_DescribeLaunchTemplateVersionsPaginateResponseTypeDef = TypedDict(
    "_DescribeLaunchTemplateVersionsPaginateResponseTypeDef",
    {
        "LaunchTemplateVersions": List[
            DescribeLaunchTemplateVersionsPaginateResponseLaunchTemplateVersionsTypeDef
        ]
    },
    total=False,
)


class DescribeLaunchTemplateVersionsPaginateResponseTypeDef(
    _DescribeLaunchTemplateVersionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **LaunchTemplateVersions** *(list) --*

        Information about the launch template versions.
        - *(dict) --*

          Describes a launch template version.
          - **LaunchTemplateId** *(string) --*

            The ID of the launch template.
    """


_DescribeLaunchTemplatesPaginateFiltersTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeLaunchTemplatesPaginateFiltersTypeDef(_DescribeLaunchTemplatesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeLaunchTemplatesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeLaunchTemplatesPaginatePaginationConfigTypeDef(
    _DescribeLaunchTemplatesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef(
    _DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef
):
    pass


_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef",
    {
        "LaunchTemplateId": str,
        "LaunchTemplateName": str,
        "CreateTime": datetime,
        "CreatedBy": str,
        "DefaultVersionNumber": int,
        "LatestVersionNumber": int,
        "Tags": List[DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTagsTypeDef],
    },
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef(
    _DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef
):
    """
    - *(dict) --*

      Describes a launch template.
      - **LaunchTemplateId** *(string) --*

        The ID of the launch template.
    """


_DescribeLaunchTemplatesPaginateResponseTypeDef = TypedDict(
    "_DescribeLaunchTemplatesPaginateResponseTypeDef",
    {"LaunchTemplates": List[DescribeLaunchTemplatesPaginateResponseLaunchTemplatesTypeDef]},
    total=False,
)


class DescribeLaunchTemplatesPaginateResponseTypeDef(
    _DescribeLaunchTemplatesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **LaunchTemplates** *(list) --*

        Information about the launch templates.
        - *(dict) --*

          Describes a launch template.
          - **LaunchTemplateId** *(string) --*

            The ID of the launch template.
    """


_DescribeMovingAddressesPaginateFiltersTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeMovingAddressesPaginateFiltersTypeDef(_DescribeMovingAddressesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeMovingAddressesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeMovingAddressesPaginatePaginationConfigTypeDef(
    _DescribeMovingAddressesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef",
    {"MoveStatus": Literal["movingToVpc", "restoringToClassic"], "PublicIp": str},
    total=False,
)


class DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef(
    _DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the status of a moving Elastic IP address.
      - **MoveStatus** *(string) --*

        The status of the Elastic IP address that's being moved to the EC2-VPC platform, or restored
        to the EC2-Classic platform.
    """


_DescribeMovingAddressesPaginateResponseTypeDef = TypedDict(
    "_DescribeMovingAddressesPaginateResponseTypeDef",
    {
        "MovingAddressStatuses": List[
            DescribeMovingAddressesPaginateResponseMovingAddressStatusesTypeDef
        ]
    },
    total=False,
)


class DescribeMovingAddressesPaginateResponseTypeDef(
    _DescribeMovingAddressesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **MovingAddressStatuses** *(list) --*

        The status for each Elastic IP address.
        - *(dict) --*

          Describes the status of a moving Elastic IP address.
          - **MoveStatus** *(string) --*

            The status of the Elastic IP address that's being moved to the EC2-VPC platform, or
            restored to the EC2-Classic platform.
    """


_DescribeNatGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeNatGatewaysPaginateFiltersTypeDef(_DescribeNatGatewaysPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeNatGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNatGatewaysPaginatePaginationConfigTypeDef(
    _DescribeNatGatewaysPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef",
    {"AllocationId": str, "NetworkInterfaceId": str, "PrivateIp": str, "PublicIp": str},
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef
):
    pass


_DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef",
    {
        "ProvisionTime": datetime,
        "Provisioned": str,
        "RequestTime": datetime,
        "Requested": str,
        "Status": str,
    },
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef
):
    pass


_DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef
):
    pass


_DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef",
    {
        "CreateTime": datetime,
        "DeleteTime": datetime,
        "FailureCode": str,
        "FailureMessage": str,
        "NatGatewayAddresses": List[
            DescribeNatGatewaysPaginateResponseNatGatewaysNatGatewayAddressesTypeDef
        ],
        "NatGatewayId": str,
        "ProvisionedBandwidth": DescribeNatGatewaysPaginateResponseNatGatewaysProvisionedBandwidthTypeDef,
        "State": Literal["pending", "failed", "available", "deleting", "deleted"],
        "SubnetId": str,
        "VpcId": str,
        "Tags": List[DescribeNatGatewaysPaginateResponseNatGatewaysTagsTypeDef],
    },
    total=False,
)


class DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef(
    _DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a NAT gateway.
      - **CreateTime** *(datetime) --*

        The date and time the NAT gateway was created.
    """


_DescribeNatGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeNatGatewaysPaginateResponseTypeDef",
    {"NatGateways": List[DescribeNatGatewaysPaginateResponseNatGatewaysTypeDef]},
    total=False,
)


class DescribeNatGatewaysPaginateResponseTypeDef(_DescribeNatGatewaysPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **NatGateways** *(list) --*

        Information about the NAT gateways.
        - *(dict) --*

          Describes a NAT gateway.
          - **CreateTime** *(datetime) --*

            The date and time the NAT gateway was created.
    """


_DescribeNetworkAclsPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeNetworkAclsPaginateFiltersTypeDef(_DescribeNetworkAclsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeNetworkAclsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkAclsPaginatePaginationConfigTypeDef(
    _DescribeNetworkAclsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef",
    {"NetworkAclAssociationId": str, "NetworkAclId": str, "SubnetId": str},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a network ACL and a subnet.
      - **NetworkAclAssociationId** *(string) --*

        The ID of the association between a network ACL and a subnet.
    """


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef",
    {"Code": int, "Type": int},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef
):
    pass


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef",
    {"From": int, "To": int},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef
):
    pass


_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef",
    {
        "CidrBlock": str,
        "Egress": bool,
        "IcmpTypeCode": DescribeNetworkAclsPaginateResponseNetworkAclsEntriesIcmpTypeCodeTypeDef,
        "Ipv6CidrBlock": str,
        "PortRange": DescribeNetworkAclsPaginateResponseNetworkAclsEntriesPortRangeTypeDef,
        "Protocol": str,
        "RuleAction": Literal["allow", "deny"],
        "RuleNumber": int,
    },
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef
):
    pass


_DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef
):
    pass


_DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef",
    {
        "Associations": List[DescribeNetworkAclsPaginateResponseNetworkAclsAssociationsTypeDef],
        "Entries": List[DescribeNetworkAclsPaginateResponseNetworkAclsEntriesTypeDef],
        "IsDefault": bool,
        "NetworkAclId": str,
        "Tags": List[DescribeNetworkAclsPaginateResponseNetworkAclsTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef(
    _DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef
):
    """
    - *(dict) --*

      Describes a network ACL.
      - **Associations** *(list) --*

        Any associations between the network ACL and one or more subnets
        - *(dict) --*

          Describes an association between a network ACL and a subnet.
          - **NetworkAclAssociationId** *(string) --*

            The ID of the association between a network ACL and a subnet.
    """


_DescribeNetworkAclsPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkAclsPaginateResponseTypeDef",
    {"NetworkAcls": List[DescribeNetworkAclsPaginateResponseNetworkAclsTypeDef]},
    total=False,
)


class DescribeNetworkAclsPaginateResponseTypeDef(_DescribeNetworkAclsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **NetworkAcls** *(list) --*

        Information about one or more network ACLs.
        - *(dict) --*

          Describes a network ACL.
          - **Associations** *(list) --*

            Any associations between the network ACL and one or more subnets
            - *(dict) --*

              Describes an association between a network ACL and a subnet.
              - **NetworkAclAssociationId** *(string) --*

                The ID of the association between a network ACL and a subnet.
    """


_DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef(
    _DescribeNetworkInterfacePermissionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef",
    {"State": Literal["pending", "granted", "revoking", "revoked"], "StatusMessage": str},
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef
):
    pass


_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef",
    {
        "NetworkInterfacePermissionId": str,
        "NetworkInterfaceId": str,
        "AwsAccountId": str,
        "AwsService": str,
        "Permission": Literal["INSTANCE-ATTACH", "EIP-ASSOCIATE"],
        "PermissionState": DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsPermissionStateTypeDef,
    },
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a permission for a network interface.
      - **NetworkInterfacePermissionId** *(string) --*

        The ID of the network interface permission.
    """


_DescribeNetworkInterfacePermissionsPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkInterfacePermissionsPaginateResponseTypeDef",
    {
        "NetworkInterfacePermissions": List[
            DescribeNetworkInterfacePermissionsPaginateResponseNetworkInterfacePermissionsTypeDef
        ]
    },
    total=False,
)


class DescribeNetworkInterfacePermissionsPaginateResponseTypeDef(
    _DescribeNetworkInterfacePermissionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output for DescribeNetworkInterfacePermissions.
      - **NetworkInterfacePermissions** *(list) --*

        The network interface permissions.
        - *(dict) --*

          Describes a permission for a network interface.
          - **NetworkInterfacePermissionId** *(string) --*

            The ID of the network interface permission.
    """


_DescribeNetworkInterfacesPaginateFiltersTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeNetworkInterfacesPaginateFiltersTypeDef(
    _DescribeNetworkInterfacesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeNetworkInterfacesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeNetworkInterfacesPaginatePaginationConfigTypeDef(
    _DescribeNetworkInterfacesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef
):
    """
    - **Association** *(dict) --*

      The association information for an Elastic IP address (IPv4) associated with the network
      interface.
      - **AllocationId** *(string) --*

        The allocation ID.
    """


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef",
    {
        "AllocationId": str,
        "AssociationId": str,
        "IpOwnerId": str,
        "PublicDnsName": str,
        "PublicIp": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef",
    {
        "Association": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesAssociationTypeDef,
        "Primary": bool,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef
):
    pass


_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef",
    {
        "Association": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAssociationTypeDef,
        "Attachment": DescribeNetworkInterfacesPaginateResponseNetworkInterfacesAttachmentTypeDef,
        "AvailabilityZone": str,
        "Description": str,
        "Groups": List[DescribeNetworkInterfacesPaginateResponseNetworkInterfacesGroupsTypeDef],
        "InterfaceType": Literal["interface", "natGateway", "efa"],
        "Ipv6Addresses": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesIpv6AddressesTypeDef
        ],
        "MacAddress": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PrivateDnsName": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeNetworkInterfacesPaginateResponseNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "RequesterId": str,
        "RequesterManaged": bool,
        "SourceDestCheck": bool,
        "Status": Literal["available", "associated", "attaching", "in-use", "detaching"],
        "SubnetId": str,
        "TagSet": List[DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTagSetTypeDef],
        "VpcId": str,
    },
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef(
    _DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef
):
    """
    - *(dict) --*

      Describes a network interface.
      - **Association** *(dict) --*

        The association information for an Elastic IP address (IPv4) associated with the network
        interface.
        - **AllocationId** *(string) --*

          The allocation ID.
    """


_DescribeNetworkInterfacesPaginateResponseTypeDef = TypedDict(
    "_DescribeNetworkInterfacesPaginateResponseTypeDef",
    {"NetworkInterfaces": List[DescribeNetworkInterfacesPaginateResponseNetworkInterfacesTypeDef]},
    total=False,
)


class DescribeNetworkInterfacesPaginateResponseTypeDef(
    _DescribeNetworkInterfacesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeNetworkInterfaces.
      - **NetworkInterfaces** *(list) --*

        Information about one or more network interfaces.
        - *(dict) --*

          Describes a network interface.
          - **Association** *(dict) --*

            The association information for an Elastic IP address (IPv4) associated with the network
            interface.
            - **AllocationId** *(string) --*

              The allocation ID.
    """


_DescribePrefixListsPaginateFiltersTypeDef = TypedDict(
    "_DescribePrefixListsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribePrefixListsPaginateFiltersTypeDef(_DescribePrefixListsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribePrefixListsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePrefixListsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePrefixListsPaginatePaginationConfigTypeDef(
    _DescribePrefixListsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribePrefixListsPaginateResponsePrefixListsTypeDef = TypedDict(
    "_DescribePrefixListsPaginateResponsePrefixListsTypeDef",
    {"Cidrs": List[str], "PrefixListId": str, "PrefixListName": str},
    total=False,
)


class DescribePrefixListsPaginateResponsePrefixListsTypeDef(
    _DescribePrefixListsPaginateResponsePrefixListsTypeDef
):
    """
    - *(dict) --*

      Describes prefixes for AWS services.
      - **Cidrs** *(list) --*

        The IP address range of the AWS service.
        - *(string) --*
    """


_DescribePrefixListsPaginateResponseTypeDef = TypedDict(
    "_DescribePrefixListsPaginateResponseTypeDef",
    {"PrefixLists": List[DescribePrefixListsPaginateResponsePrefixListsTypeDef]},
    total=False,
)


class DescribePrefixListsPaginateResponseTypeDef(_DescribePrefixListsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **PrefixLists** *(list) --*

        All available prefix lists.
        - *(dict) --*

          Describes prefixes for AWS services.
          - **Cidrs** *(list) --*

            The IP address range of the AWS service.
            - *(string) --*
    """


_DescribePrincipalIdFormatPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePrincipalIdFormatPaginatePaginationConfigTypeDef(
    _DescribePrincipalIdFormatPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef",
    {"Deadline": datetime, "Resource": str, "UseLongIds": bool},
    total=False,
)


class DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef(
    _DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef
):
    pass


_DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef",
    {
        "Arn": str,
        "Statuses": List[DescribePrincipalIdFormatPaginateResponsePrincipalsStatusesTypeDef],
    },
    total=False,
)


class DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef(
    _DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef
):
    """
    - *(dict) --*

      PrincipalIdFormat description
      - **Arn** *(string) --*

        PrincipalIdFormatARN description
    """


_DescribePrincipalIdFormatPaginateResponseTypeDef = TypedDict(
    "_DescribePrincipalIdFormatPaginateResponseTypeDef",
    {"Principals": List[DescribePrincipalIdFormatPaginateResponsePrincipalsTypeDef]},
    total=False,
)


class DescribePrincipalIdFormatPaginateResponseTypeDef(
    _DescribePrincipalIdFormatPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Principals** *(list) --*

        Information about the ID format settings for the ARN.
        - *(dict) --*

          PrincipalIdFormat description
          - **Arn** *(string) --*

            PrincipalIdFormatARN description
    """


_DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef(
    _DescribePublicIpv4PoolsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef",
    {"FirstAddress": str, "LastAddress": str, "AddressCount": int, "AvailableAddressCount": int},
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef(
    _DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef
):
    pass


_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef",
    {
        "PoolId": str,
        "Description": str,
        "PoolAddressRanges": List[
            DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsPoolAddressRangesTypeDef
        ],
        "TotalAddressCount": int,
        "TotalAvailableAddressCount": int,
    },
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef(
    _DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef
):
    """
    - *(dict) --*

      Describes an address pool.
      - **PoolId** *(string) --*

        The ID of the IPv4 address pool.
    """


_DescribePublicIpv4PoolsPaginateResponseTypeDef = TypedDict(
    "_DescribePublicIpv4PoolsPaginateResponseTypeDef",
    {"PublicIpv4Pools": List[DescribePublicIpv4PoolsPaginateResponsePublicIpv4PoolsTypeDef]},
    total=False,
)


class DescribePublicIpv4PoolsPaginateResponseTypeDef(
    _DescribePublicIpv4PoolsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **PublicIpv4Pools** *(list) --*

        Information about the address pools.
        - *(dict) --*

          Describes an address pool.
          - **PoolId** *(string) --*

            The ID of the IPv4 address pool.
    """


_DescribeReservedInstancesModificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeReservedInstancesModificationsPaginateFiltersTypeDef(
    _DescribeReservedInstancesModificationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "StartingToken": str},
    total=False,
)


class DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef(
    _DescribeReservedInstancesModificationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceCount": int,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "Platform": str,
        "Scope": Literal["Availability Zone", "Region"],
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef
):
    pass


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef",
    {
        "ReservedInstancesId": str,
        "TargetConfiguration": DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTargetConfigurationTypeDef,
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef
):
    pass


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef",
    {"ReservedInstancesId": str},
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
):
    pass


_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef",
    {
        "ClientToken": str,
        "CreateDate": datetime,
        "EffectiveDate": datetime,
        "ModificationResults": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsModificationResultsTypeDef
        ],
        "ReservedInstancesIds": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsReservedInstancesIdsTypeDef
        ],
        "ReservedInstancesModificationId": str,
        "Status": str,
        "StatusMessage": str,
        "UpdateDate": datetime,
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance modification.
      - **ClientToken** *(string) --*

        A unique, case-sensitive key supplied by the client to ensure that the request is
        idempotent. For more information, see `Ensuring Idempotency
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__ .
    """


_DescribeReservedInstancesModificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeReservedInstancesModificationsPaginateResponseTypeDef",
    {
        "ReservedInstancesModifications": List[
            DescribeReservedInstancesModificationsPaginateResponseReservedInstancesModificationsTypeDef
        ]
    },
    total=False,
)


class DescribeReservedInstancesModificationsPaginateResponseTypeDef(
    _DescribeReservedInstancesModificationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeReservedInstancesModifications.
      - **ReservedInstancesModifications** *(list) --*

        The Reserved Instance modification information.
        - *(dict) --*

          Describes a Reserved Instance modification.
          - **ClientToken** *(string) --*

            A unique, case-sensitive key supplied by the client to ensure that the request is
            idempotent. For more information, see `Ensuring Idempotency
            <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html>`__
            .
    """


_DescribeReservedInstancesOfferingsPaginateFiltersTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateFiltersTypeDef(
    _DescribeReservedInstancesOfferingsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef(
    _DescribeReservedInstancesOfferingsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef",
    {"Count": int, "Price": float},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef
):
    pass


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef",
    {"Amount": float, "Frequency": str},
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef
):
    pass


_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef",
    {
        "AvailabilityZone": str,
        "Duration": int,
        "FixedPrice": Any,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "ReservedInstancesOfferingId": str,
        "UsagePrice": Any,
        "CurrencyCode": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Marketplace": bool,
        "OfferingClass": Literal["standard", "convertible"],
        "OfferingType": Literal[
            "Heavy Utilization",
            "Medium Utilization",
            "Light Utilization",
            "No Upfront",
            "Partial Upfront",
            "All Upfront",
        ],
        "PricingDetails": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsPricingDetailsTypeDef
        ],
        "RecurringCharges": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsRecurringChargesTypeDef
        ],
        "Scope": Literal["Availability Zone", "Region"],
    },
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef
):
    """
    - *(dict) --*

      Describes a Reserved Instance offering.
      - **AvailabilityZone** *(string) --*

        The Availability Zone in which the Reserved Instance can be used.
    """


_DescribeReservedInstancesOfferingsPaginateResponseTypeDef = TypedDict(
    "_DescribeReservedInstancesOfferingsPaginateResponseTypeDef",
    {
        "ReservedInstancesOfferings": List[
            DescribeReservedInstancesOfferingsPaginateResponseReservedInstancesOfferingsTypeDef
        ]
    },
    total=False,
)


class DescribeReservedInstancesOfferingsPaginateResponseTypeDef(
    _DescribeReservedInstancesOfferingsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeReservedInstancesOfferings.
      - **ReservedInstancesOfferings** *(list) --*

        A list of Reserved Instances offerings.
        - *(dict) --*

          Describes a Reserved Instance offering.
          - **AvailabilityZone** *(string) --*

            The Availability Zone in which the Reserved Instance can be used.
    """


_DescribeRouteTablesPaginateFiltersTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeRouteTablesPaginateFiltersTypeDef(_DescribeRouteTablesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeRouteTablesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeRouteTablesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeRouteTablesPaginatePaginationConfigTypeDef(
    _DescribeRouteTablesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef",
    {"Main": bool, "RouteTableAssociationId": str, "RouteTableId": str, "SubnetId": str},
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a route table and a subnet.
      - **Main** *(boolean) --*

        Indicates whether this is the main route table.
    """


_DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef",
    {"GatewayId": str},
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef
):
    pass


_DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef",
    {
        "DestinationCidrBlock": str,
        "DestinationIpv6CidrBlock": str,
        "DestinationPrefixListId": str,
        "EgressOnlyInternetGatewayId": str,
        "GatewayId": str,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "NatGatewayId": str,
        "TransitGatewayId": str,
        "NetworkInterfaceId": str,
        "Origin": Literal["CreateRouteTable", "CreateRoute", "EnableVgwRoutePropagation"],
        "State": Literal["active", "blackhole"],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef
):
    pass


_DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef
):
    pass


_DescribeRouteTablesPaginateResponseRouteTablesTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseRouteTablesTypeDef",
    {
        "Associations": List[DescribeRouteTablesPaginateResponseRouteTablesAssociationsTypeDef],
        "PropagatingVgws": List[
            DescribeRouteTablesPaginateResponseRouteTablesPropagatingVgwsTypeDef
        ],
        "RouteTableId": str,
        "Routes": List[DescribeRouteTablesPaginateResponseRouteTablesRoutesTypeDef],
        "Tags": List[DescribeRouteTablesPaginateResponseRouteTablesTagsTypeDef],
        "VpcId": str,
        "OwnerId": str,
    },
    total=False,
)


class DescribeRouteTablesPaginateResponseRouteTablesTypeDef(
    _DescribeRouteTablesPaginateResponseRouteTablesTypeDef
):
    """
    - *(dict) --*

      Describes a route table.
      - **Associations** *(list) --*

        The associations between the route table and one or more subnets.
        - *(dict) --*

          Describes an association between a route table and a subnet.
          - **Main** *(boolean) --*

            Indicates whether this is the main route table.
    """


_DescribeRouteTablesPaginateResponseTypeDef = TypedDict(
    "_DescribeRouteTablesPaginateResponseTypeDef",
    {"RouteTables": List[DescribeRouteTablesPaginateResponseRouteTablesTypeDef]},
    total=False,
)


class DescribeRouteTablesPaginateResponseTypeDef(_DescribeRouteTablesPaginateResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeRouteTables.
      - **RouteTables** *(list) --*

        Information about one or more route tables.
        - *(dict) --*

          Describes a route table.
          - **Associations** *(list) --*

            The associations between the route table and one or more subnets.
            - *(dict) --*

              Describes an association between a route table and a subnet.
              - **Main** *(boolean) --*

                Indicates whether this is the main route table.
    """


_DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_RequiredDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_RequiredDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime},
)
_OptionalDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef = TypedDict(
    "_OptionalDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef",
    {"LatestTime": datetime},
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef(
    _RequiredDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef,
    _OptionalDescribeScheduledInstanceAvailabilityPaginateFirstSlotStartTimeRangeTypeDef,
):
    """
    The time period for the first schedule to start.
    - **EarliestTime** *(datetime) --***[REQUIRED]**

      The earliest date and time, in UTC, for the Scheduled Instance to start.
    """


_DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDays": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateRecurrenceTypeDef
):
    """
    The schedule recurrence.
    - **Frequency** *(string) --*

      The frequency (``Daily`` , ``Weekly`` , or ``Monthly`` ).
    """


_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef
):
    pass


_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef",
    {
        "AvailabilityZone": str,
        "AvailableInstanceCount": int,
        "FirstSlotStartTime": datetime,
        "HourlyPrice": str,
        "InstanceType": str,
        "MaxTermDurationInDays": int,
        "MinTermDurationInDays": int,
        "NetworkPlatform": str,
        "Platform": str,
        "PurchaseToken": str,
        "Recurrence": DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetRecurrenceTypeDef,
        "SlotDurationInHours": int,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef
):
    """
    - *(dict) --*

      Describes a schedule that is available for your Scheduled Instances.
      - **AvailabilityZone** *(string) --*

        The Availability Zone.
    """


_DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef = TypedDict(
    "_DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef",
    {
        "ScheduledInstanceAvailabilitySet": List[
            DescribeScheduledInstanceAvailabilityPaginateResponseScheduledInstanceAvailabilitySetTypeDef
        ]
    },
    total=False,
)


class DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef(
    _DescribeScheduledInstanceAvailabilityPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeScheduledInstanceAvailability.
      - **ScheduledInstanceAvailabilitySet** *(list) --*

        Information about the available Scheduled Instances.
        - *(dict) --*

          Describes a schedule that is available for your Scheduled Instances.
          - **AvailabilityZone** *(string) --*

            The Availability Zone.
    """


_DescribeScheduledInstancesPaginateFiltersTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeScheduledInstancesPaginateFiltersTypeDef(
    _DescribeScheduledInstancesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeScheduledInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeScheduledInstancesPaginatePaginationConfigTypeDef(
    _DescribeScheduledInstancesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef",
    {
        "Frequency": str,
        "Interval": int,
        "OccurrenceDaySet": List[int],
        "OccurrenceRelativeToEnd": bool,
        "OccurrenceUnit": str,
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef(
    _DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef
):
    pass


_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef",
    {
        "AvailabilityZone": str,
        "CreateDate": datetime,
        "HourlyPrice": str,
        "InstanceCount": int,
        "InstanceType": str,
        "NetworkPlatform": str,
        "NextSlotStartTime": datetime,
        "Platform": str,
        "PreviousSlotEndTime": datetime,
        "Recurrence": DescribeScheduledInstancesPaginateResponseScheduledInstanceSetRecurrenceTypeDef,
        "ScheduledInstanceId": str,
        "SlotDurationInHours": int,
        "TermEndDate": datetime,
        "TermStartDate": datetime,
        "TotalScheduledInstanceHours": int,
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef(
    _DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef
):
    """
    - *(dict) --*

      Describes a Scheduled Instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone.
    """


_DescribeScheduledInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateResponseTypeDef",
    {
        "ScheduledInstanceSet": List[
            DescribeScheduledInstancesPaginateResponseScheduledInstanceSetTypeDef
        ]
    },
    total=False,
)


class DescribeScheduledInstancesPaginateResponseTypeDef(
    _DescribeScheduledInstancesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeScheduledInstances.
      - **ScheduledInstanceSet** *(list) --*

        Information about the Scheduled Instances.
        - *(dict) --*

          Describes a Scheduled Instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone.
    """


_DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef = TypedDict(
    "_DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef",
    {"EarliestTime": datetime, "LatestTime": datetime},
    total=False,
)


class DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef(
    _DescribeScheduledInstancesPaginateSlotStartTimeRangeTypeDef
):
    """
    The time period for the first schedule to start.
    - **EarliestTime** *(datetime) --*

      The earliest date and time, in UTC, for the Scheduled Instance to start.
    """


_DescribeSecurityGroupsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeSecurityGroupsPaginateFiltersTypeDef(_DescribeSecurityGroupsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeSecurityGroupsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSecurityGroupsPaginatePaginationConfigTypeDef(
    _DescribeSecurityGroupsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpRangesTypeDef
        ],
        "Ipv6Ranges": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsIpv6RangesTypeDef
        ],
        "PrefixListIds": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsPrefixListIdsTypeDef
        ],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef
):
    pass


_DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef",
    {
        "Description": str,
        "GroupName": str,
        "IpPermissions": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsTypeDef
        ],
        "OwnerId": str,
        "GroupId": str,
        "IpPermissionsEgress": List[
            DescribeSecurityGroupsPaginateResponseSecurityGroupsIpPermissionsEgressTypeDef
        ],
        "Tags": List[DescribeSecurityGroupsPaginateResponseSecurityGroupsTagsTypeDef],
        "VpcId": str,
    },
    total=False,
)


class DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef(
    _DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group
      - **Description** *(string) --*

        A description of the security group.
    """


_DescribeSecurityGroupsPaginateResponseTypeDef = TypedDict(
    "_DescribeSecurityGroupsPaginateResponseTypeDef",
    {"SecurityGroups": List[DescribeSecurityGroupsPaginateResponseSecurityGroupsTypeDef]},
    total=False,
)


class DescribeSecurityGroupsPaginateResponseTypeDef(_DescribeSecurityGroupsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **SecurityGroups** *(list) --*

        Information about the security groups.
        - *(dict) --*

          Describes a security group
          - **Description** *(string) --*

            A description of the security group.
    """


_DescribeSnapshotsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeSnapshotsPaginateFiltersTypeDef(_DescribeSnapshotsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeSnapshotsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSnapshotsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSnapshotsPaginatePaginationConfigTypeDef(
    _DescribeSnapshotsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef(
    _DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef
):
    pass


_DescribeSnapshotsPaginateResponseSnapshotsTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseSnapshotsTypeDef",
    {
        "DataEncryptionKeyId": str,
        "Description": str,
        "Encrypted": bool,
        "KmsKeyId": str,
        "OwnerId": str,
        "Progress": str,
        "SnapshotId": str,
        "StartTime": datetime,
        "State": Literal["pending", "completed", "error"],
        "StateMessage": str,
        "VolumeId": str,
        "VolumeSize": int,
        "OwnerAlias": str,
        "Tags": List[DescribeSnapshotsPaginateResponseSnapshotsTagsTypeDef],
    },
    total=False,
)


class DescribeSnapshotsPaginateResponseSnapshotsTypeDef(
    _DescribeSnapshotsPaginateResponseSnapshotsTypeDef
):
    """
    - *(dict) --*

      Describes a snapshot.
      - **DataEncryptionKeyId** *(string) --*

        The data encryption key identifier for the snapshot. This value is a unique identifier that
        corresponds to the data encryption key that was used to encrypt the original volume or
        snapshot copy. Because data encryption keys are inherited by volumes created from snapshots,
        and vice versa, if snapshots share the same data encryption key identifier, then they belong
        to the same volume/snapshot lineage. This parameter is only returned by  DescribeSnapshots .
    """


_DescribeSnapshotsPaginateResponseTypeDef = TypedDict(
    "_DescribeSnapshotsPaginateResponseTypeDef",
    {"Snapshots": List[DescribeSnapshotsPaginateResponseSnapshotsTypeDef]},
    total=False,
)


class DescribeSnapshotsPaginateResponseTypeDef(_DescribeSnapshotsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Snapshots** *(list) --*

        Information about the snapshots.
        - *(dict) --*

          Describes a snapshot.
          - **DataEncryptionKeyId** *(string) --*

            The data encryption key identifier for the snapshot. This value is a unique identifier
            that corresponds to the data encryption key that was used to encrypt the original volume
            or snapshot copy. Because data encryption keys are inherited by volumes created from
            snapshots, and vice versa, if snapshots share the same data encryption key identifier,
            then they belong to the same volume/snapshot lineage. This parameter is only returned by
            DescribeSnapshots .
    """


_DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef(
    _DescribeSpotFleetInstancesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef",
    {
        "InstanceId": str,
        "InstanceType": str,
        "SpotInstanceRequestId": str,
        "InstanceHealth": Literal["healthy", "unhealthy"],
    },
    total=False,
)


class DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef(
    _DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef
):
    """
    - *(dict) --*

      Describes a running instance in a Spot Fleet.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_DescribeSpotFleetInstancesPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotFleetInstancesPaginateResponseTypeDef",
    {
        "ActiveInstances": List[DescribeSpotFleetInstancesPaginateResponseActiveInstancesTypeDef],
        "SpotFleetRequestId": str,
    },
    total=False,
)


class DescribeSpotFleetInstancesPaginateResponseTypeDef(
    _DescribeSpotFleetInstancesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotFleetInstances.
      - **ActiveInstances** *(list) --*

        The running instances. This list is refreshed periodically and might be out of date.
        - *(dict) --*

          Describes a running instance in a Spot Fleet.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef(
    _DescribeSpotFleetRequestsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef",
    {
        "SecurityGroups": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "Monitoring": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsMonitoringTypeDef,
        "NetworkInterfaces": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsNetworkInterfacesTypeDef
        ],
        "Placement": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsPlacementTypeDef,
        "RamdiskId": str,
        "SpotPrice": str,
        "SubnetId": str,
        "UserData": str,
        "WeightedCapacity": float,
        "TagSpecifications": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTagSpecificationsTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef",
    {
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "SpotPrice": str,
        "SubnetId": str,
        "AvailabilityZone": str,
        "WeightedCapacity": float,
        "Priority": float,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef",
    {
        "LaunchTemplateSpecification": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsLaunchTemplateSpecificationTypeDef,
        "Overrides": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsOverridesTypeDef
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef",
    {"Name": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancers": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigClassicLoadBalancersTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef",
    {"Arn": str},
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef",
    {
        "TargetGroups": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTargetGroupsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef",
    {
        "ClassicLoadBalancersConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigClassicLoadBalancersConfigTypeDef,
        "TargetGroupsConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTargetGroupsConfigTypeDef,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef",
    {
        "AllocationStrategy": Literal["lowestPrice", "diversified", "capacityOptimized"],
        "OnDemandAllocationStrategy": Literal["lowestPrice", "prioritized"],
        "ClientToken": str,
        "ExcessCapacityTerminationPolicy": Literal["noTermination", "default"],
        "FulfilledCapacity": float,
        "OnDemandFulfilledCapacity": float,
        "IamFleetRole": str,
        "LaunchSpecifications": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchSpecificationsTypeDef
        ],
        "LaunchTemplateConfigs": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLaunchTemplateConfigsTypeDef
        ],
        "SpotPrice": str,
        "TargetCapacity": int,
        "OnDemandTargetCapacity": int,
        "OnDemandMaxTotalPrice": str,
        "SpotMaxTotalPrice": str,
        "TerminateInstancesWithExpiration": bool,
        "Type": Literal["request", "maintain", "instant"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "ReplaceUnhealthyInstances": bool,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
        "LoadBalancersConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigLoadBalancersConfigTypeDef,
        "InstancePoolsToUseCount": int,
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef
):
    pass


_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef",
    {
        "ActivityStatus": Literal[
            "error", "pending_fulfillment", "pending_termination", "fulfilled"
        ],
        "CreateTime": datetime,
        "SpotFleetRequestConfig": DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsSpotFleetRequestConfigTypeDef,
        "SpotFleetRequestId": str,
        "SpotFleetRequestState": Literal[
            "submitted",
            "active",
            "cancelled",
            "failed",
            "cancelled_running",
            "cancelled_terminating",
            "modifying",
        ],
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef
):
    """
    - *(dict) --*

      Describes a Spot Fleet request.
      - **ActivityStatus** *(string) --*

        The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
        After all requests are placed, the status is ``pending_fulfillment`` . If the size of the
        fleet is equal to or greater than its target capacity, the status is ``fulfilled`` . If the
        size of the fleet is decreased, the status is ``pending_termination`` while Spot Instances
        are terminating.
    """


_DescribeSpotFleetRequestsPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotFleetRequestsPaginateResponseTypeDef",
    {
        "SpotFleetRequestConfigs": List[
            DescribeSpotFleetRequestsPaginateResponseSpotFleetRequestConfigsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotFleetRequestsPaginateResponseTypeDef(
    _DescribeSpotFleetRequestsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotFleetRequests.
      - **SpotFleetRequestConfigs** *(list) --*

        Information about the configuration of your Spot Fleet.
        - *(dict) --*

          Describes a Spot Fleet request.
          - **ActivityStatus** *(string) --*

            The progress of the Spot Fleet request. If there is an error, the status is ``error`` .
            After all requests are placed, the status is ``pending_fulfillment`` . If the size of
            the fleet is equal to or greater than its target capacity, the status is ``fulfilled`` .
            If the size of the fleet is decreased, the status is ``pending_termination`` while Spot
            Instances are terminating.
    """


_DescribeSpotInstanceRequestsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateFiltersTypeDef(
    _DescribeSpotInstanceRequestsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef(
    _DescribeSpotInstanceRequestsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef",
    {"Code": str, "Message": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef",
    {"Enabled": bool},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesIpv6AddressesTypeDef
        ],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef",
    {"AvailabilityZone": str, "GroupName": str, "Tenancy": Literal["default", "dedicated", "host"]},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef",
    {
        "UserData": str,
        "SecurityGroups": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationSecurityGroupsTypeDef
        ],
        "AddressingType": str,
        "BlockDeviceMappings": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationBlockDeviceMappingsTypeDef
        ],
        "EbsOptimized": bool,
        "IamInstanceProfile": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationIamInstanceProfileTypeDef,
        "ImageId": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "KernelId": str,
        "KeyName": str,
        "NetworkInterfaces": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationNetworkInterfacesTypeDef
        ],
        "Placement": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationPlacementTypeDef,
        "RamdiskId": str,
        "SubnetId": str,
        "Monitoring": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationMonitoringTypeDef,
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef",
    {"Code": str, "Message": str, "UpdateTime": datetime},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef
):
    pass


_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef",
    {
        "ActualBlockHourlyPrice": str,
        "AvailabilityZoneGroup": str,
        "BlockDurationMinutes": int,
        "CreateTime": datetime,
        "Fault": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsFaultTypeDef,
        "InstanceId": str,
        "LaunchGroup": str,
        "LaunchSpecification": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsLaunchSpecificationTypeDef,
        "LaunchedAvailabilityZone": str,
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "SpotInstanceRequestId": str,
        "SpotPrice": str,
        "State": Literal["open", "active", "closed", "cancelled", "failed"],
        "Status": DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsStatusTypeDef,
        "Tags": List[DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTagsTypeDef],
        "Type": Literal["one-time", "persistent"],
        "ValidFrom": datetime,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef
):
    """
    - *(dict) --*

      Describes a Spot Instance request.
      - **ActualBlockHourlyPrice** *(string) --*

        If you specified a duration and your Spot Instance request was fulfilled, this is the fixed
        hourly price in effect for the Spot Instance while it runs.
    """


_DescribeSpotInstanceRequestsPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotInstanceRequestsPaginateResponseTypeDef",
    {
        "SpotInstanceRequests": List[
            DescribeSpotInstanceRequestsPaginateResponseSpotInstanceRequestsTypeDef
        ]
    },
    total=False,
)


class DescribeSpotInstanceRequestsPaginateResponseTypeDef(
    _DescribeSpotInstanceRequestsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotInstanceRequests.
      - **SpotInstanceRequests** *(list) --*

        One or more Spot Instance requests.
        - *(dict) --*

          Describes a Spot Instance request.
          - **ActualBlockHourlyPrice** *(string) --*

            If you specified a duration and your Spot Instance request was fulfilled, this is the
            fixed hourly price in effect for the Spot Instance while it runs.
    """


_DescribeSpotPriceHistoryPaginateFiltersTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeSpotPriceHistoryPaginateFiltersTypeDef(
    _DescribeSpotPriceHistoryPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef(
    _DescribeSpotPriceHistoryPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef",
    {
        "AvailabilityZone": str,
        "InstanceType": Literal[
            "t1.micro",
            "t2.nano",
            "t2.micro",
            "t2.small",
            "t2.medium",
            "t2.large",
            "t2.xlarge",
            "t2.2xlarge",
            "t3.nano",
            "t3.micro",
            "t3.small",
            "t3.medium",
            "t3.large",
            "t3.xlarge",
            "t3.2xlarge",
            "t3a.nano",
            "t3a.micro",
            "t3a.small",
            "t3a.medium",
            "t3a.large",
            "t3a.xlarge",
            "t3a.2xlarge",
            "m1.small",
            "m1.medium",
            "m1.large",
            "m1.xlarge",
            "m3.medium",
            "m3.large",
            "m3.xlarge",
            "m3.2xlarge",
            "m4.large",
            "m4.xlarge",
            "m4.2xlarge",
            "m4.4xlarge",
            "m4.10xlarge",
            "m4.16xlarge",
            "m2.xlarge",
            "m2.2xlarge",
            "m2.4xlarge",
            "cr1.8xlarge",
            "r3.large",
            "r3.xlarge",
            "r3.2xlarge",
            "r3.4xlarge",
            "r3.8xlarge",
            "r4.large",
            "r4.xlarge",
            "r4.2xlarge",
            "r4.4xlarge",
            "r4.8xlarge",
            "r4.16xlarge",
            "r5.large",
            "r5.xlarge",
            "r5.2xlarge",
            "r5.4xlarge",
            "r5.8xlarge",
            "r5.12xlarge",
            "r5.16xlarge",
            "r5.24xlarge",
            "r5.metal",
            "r5a.large",
            "r5a.xlarge",
            "r5a.2xlarge",
            "r5a.4xlarge",
            "r5a.8xlarge",
            "r5a.12xlarge",
            "r5a.16xlarge",
            "r5a.24xlarge",
            "r5d.large",
            "r5d.xlarge",
            "r5d.2xlarge",
            "r5d.4xlarge",
            "r5d.8xlarge",
            "r5d.12xlarge",
            "r5d.16xlarge",
            "r5d.24xlarge",
            "r5d.metal",
            "r5ad.large",
            "r5ad.xlarge",
            "r5ad.2xlarge",
            "r5ad.4xlarge",
            "r5ad.8xlarge",
            "r5ad.12xlarge",
            "r5ad.16xlarge",
            "r5ad.24xlarge",
            "x1.16xlarge",
            "x1.32xlarge",
            "x1e.xlarge",
            "x1e.2xlarge",
            "x1e.4xlarge",
            "x1e.8xlarge",
            "x1e.16xlarge",
            "x1e.32xlarge",
            "i2.xlarge",
            "i2.2xlarge",
            "i2.4xlarge",
            "i2.8xlarge",
            "i3.large",
            "i3.xlarge",
            "i3.2xlarge",
            "i3.4xlarge",
            "i3.8xlarge",
            "i3.16xlarge",
            "i3.metal",
            "i3en.large",
            "i3en.xlarge",
            "i3en.2xlarge",
            "i3en.3xlarge",
            "i3en.6xlarge",
            "i3en.12xlarge",
            "i3en.24xlarge",
            "i3en.metal",
            "hi1.4xlarge",
            "hs1.8xlarge",
            "c1.medium",
            "c1.xlarge",
            "c3.large",
            "c3.xlarge",
            "c3.2xlarge",
            "c3.4xlarge",
            "c3.8xlarge",
            "c4.large",
            "c4.xlarge",
            "c4.2xlarge",
            "c4.4xlarge",
            "c4.8xlarge",
            "c5.large",
            "c5.xlarge",
            "c5.2xlarge",
            "c5.4xlarge",
            "c5.9xlarge",
            "c5.12xlarge",
            "c5.18xlarge",
            "c5.24xlarge",
            "c5.metal",
            "c5d.large",
            "c5d.xlarge",
            "c5d.2xlarge",
            "c5d.4xlarge",
            "c5d.9xlarge",
            "c5d.12xlarge",
            "c5d.18xlarge",
            "c5d.24xlarge",
            "c5d.metal",
            "c5n.large",
            "c5n.xlarge",
            "c5n.2xlarge",
            "c5n.4xlarge",
            "c5n.9xlarge",
            "c5n.18xlarge",
            "cc1.4xlarge",
            "cc2.8xlarge",
            "g2.2xlarge",
            "g2.8xlarge",
            "g3.4xlarge",
            "g3.8xlarge",
            "g3.16xlarge",
            "g3s.xlarge",
            "g4dn.xlarge",
            "g4dn.2xlarge",
            "g4dn.4xlarge",
            "g4dn.8xlarge",
            "g4dn.12xlarge",
            "g4dn.16xlarge",
            "cg1.4xlarge",
            "p2.xlarge",
            "p2.8xlarge",
            "p2.16xlarge",
            "p3.2xlarge",
            "p3.8xlarge",
            "p3.16xlarge",
            "p3dn.24xlarge",
            "d2.xlarge",
            "d2.2xlarge",
            "d2.4xlarge",
            "d2.8xlarge",
            "f1.2xlarge",
            "f1.4xlarge",
            "f1.16xlarge",
            "m5.large",
            "m5.xlarge",
            "m5.2xlarge",
            "m5.4xlarge",
            "m5.8xlarge",
            "m5.12xlarge",
            "m5.16xlarge",
            "m5.24xlarge",
            "m5.metal",
            "m5a.large",
            "m5a.xlarge",
            "m5a.2xlarge",
            "m5a.4xlarge",
            "m5a.8xlarge",
            "m5a.12xlarge",
            "m5a.16xlarge",
            "m5a.24xlarge",
            "m5d.large",
            "m5d.xlarge",
            "m5d.2xlarge",
            "m5d.4xlarge",
            "m5d.8xlarge",
            "m5d.12xlarge",
            "m5d.16xlarge",
            "m5d.24xlarge",
            "m5d.metal",
            "m5ad.large",
            "m5ad.xlarge",
            "m5ad.2xlarge",
            "m5ad.4xlarge",
            "m5ad.8xlarge",
            "m5ad.12xlarge",
            "m5ad.16xlarge",
            "m5ad.24xlarge",
            "h1.2xlarge",
            "h1.4xlarge",
            "h1.8xlarge",
            "h1.16xlarge",
            "z1d.large",
            "z1d.xlarge",
            "z1d.2xlarge",
            "z1d.3xlarge",
            "z1d.6xlarge",
            "z1d.12xlarge",
            "z1d.metal",
            "u-6tb1.metal",
            "u-9tb1.metal",
            "u-12tb1.metal",
            "u-18tb1.metal",
            "u-24tb1.metal",
            "a1.medium",
            "a1.large",
            "a1.xlarge",
            "a1.2xlarge",
            "a1.4xlarge",
            "a1.metal",
            "m5dn.large",
            "m5dn.xlarge",
            "m5dn.2xlarge",
            "m5dn.4xlarge",
            "m5dn.8xlarge",
            "m5dn.12xlarge",
            "m5dn.16xlarge",
            "m5dn.24xlarge",
            "m5n.large",
            "m5n.xlarge",
            "m5n.2xlarge",
            "m5n.4xlarge",
            "m5n.8xlarge",
            "m5n.12xlarge",
            "m5n.16xlarge",
            "m5n.24xlarge",
            "r5dn.large",
            "r5dn.xlarge",
            "r5dn.2xlarge",
            "r5dn.4xlarge",
            "r5dn.8xlarge",
            "r5dn.12xlarge",
            "r5dn.16xlarge",
            "r5dn.24xlarge",
            "r5n.large",
            "r5n.xlarge",
            "r5n.2xlarge",
            "r5n.4xlarge",
            "r5n.8xlarge",
            "r5n.12xlarge",
            "r5n.16xlarge",
            "r5n.24xlarge",
        ],
        "ProductDescription": Literal[
            "Linux/UNIX", "Linux/UNIX (Amazon VPC)", "Windows", "Windows (Amazon VPC)"
        ],
        "SpotPrice": str,
        "Timestamp": datetime,
    },
    total=False,
)


class DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef(
    _DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef
):
    """
    - *(dict) --*

      Describes the maximum price per hour that you are willing to pay for a Spot Instance.
      - **AvailabilityZone** *(string) --*

        The Availability Zone.
    """


_DescribeSpotPriceHistoryPaginateResponseTypeDef = TypedDict(
    "_DescribeSpotPriceHistoryPaginateResponseTypeDef",
    {"SpotPriceHistory": List[DescribeSpotPriceHistoryPaginateResponseSpotPriceHistoryTypeDef]},
    total=False,
)


class DescribeSpotPriceHistoryPaginateResponseTypeDef(
    _DescribeSpotPriceHistoryPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeSpotPriceHistory.
      - **SpotPriceHistory** *(list) --*

        The historical Spot prices.
        - *(dict) --*

          Describes the maximum price per hour that you are willing to pay for a Spot Instance.
          - **AvailabilityZone** *(string) --*

            The Availability Zone.
    """


_DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef(
    _DescribeStaleSecurityGroupsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
):
    pass


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
):
    pass


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[str],
        "PrefixListIds": List[str],
        "ToPort": int,
        "UserIdGroupPairs": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsUserIdGroupPairsTypeDef
        ],
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
):
    pass


_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "StaleIpPermissions": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsTypeDef
        ],
        "StaleIpPermissionsEgress": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetStaleIpPermissionsEgressTypeDef
        ],
        "VpcId": str,
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef
):
    """
    - *(dict) --*

      Describes a stale security group (a security group that contains stale rules).
      - **Description** *(string) --*

        The description of the security group.
    """


_DescribeStaleSecurityGroupsPaginateResponseTypeDef = TypedDict(
    "_DescribeStaleSecurityGroupsPaginateResponseTypeDef",
    {
        "StaleSecurityGroupSet": List[
            DescribeStaleSecurityGroupsPaginateResponseStaleSecurityGroupSetTypeDef
        ]
    },
    total=False,
)


class DescribeStaleSecurityGroupsPaginateResponseTypeDef(
    _DescribeStaleSecurityGroupsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **StaleSecurityGroupSet** *(list) --*

        Information about the stale security groups.
        - *(dict) --*

          Describes a stale security group (a security group that contains stale rules).
          - **Description** *(string) --*

            The description of the security group.
    """


_DescribeSubnetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeSubnetsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeSubnetsPaginateFiltersTypeDef(_DescribeSubnetsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeSubnetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeSubnetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeSubnetsPaginatePaginationConfigTypeDef(
    _DescribeSubnetsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
):
    pass


_DescribeSubnetsPaginateResponseSubnetsTagsTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DescribeSubnetsPaginateResponseSubnetsTagsTypeDef(
    _DescribeSubnetsPaginateResponseSubnetsTagsTypeDef
):
    pass


_DescribeSubnetsPaginateResponseSubnetsTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseSubnetsTypeDef",
    {
        "AvailabilityZone": str,
        "AvailabilityZoneId": str,
        "AvailableIpAddressCount": int,
        "CidrBlock": str,
        "DefaultForAz": bool,
        "MapPublicIpOnLaunch": bool,
        "State": Literal["pending", "available"],
        "SubnetId": str,
        "VpcId": str,
        "OwnerId": str,
        "AssignIpv6AddressOnCreation": bool,
        "Ipv6CidrBlockAssociationSet": List[
            DescribeSubnetsPaginateResponseSubnetsIpv6CidrBlockAssociationSetTypeDef
        ],
        "Tags": List[DescribeSubnetsPaginateResponseSubnetsTagsTypeDef],
        "SubnetArn": str,
    },
    total=False,
)


class DescribeSubnetsPaginateResponseSubnetsTypeDef(_DescribeSubnetsPaginateResponseSubnetsTypeDef):
    """
    - *(dict) --*

      Describes a subnet.
      - **AvailabilityZone** *(string) --*

        The Availability Zone of the subnet.
    """


_DescribeSubnetsPaginateResponseTypeDef = TypedDict(
    "_DescribeSubnetsPaginateResponseTypeDef",
    {"Subnets": List[DescribeSubnetsPaginateResponseSubnetsTypeDef]},
    total=False,
)


class DescribeSubnetsPaginateResponseTypeDef(_DescribeSubnetsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Subnets** *(list) --*

        Information about one or more subnets.
        - *(dict) --*

          Describes a subnet.
          - **AvailabilityZone** *(string) --*

            The Availability Zone of the subnet.
    """


_DescribeTagsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTagsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeTagsPaginateFiltersTypeDef(_DescribeTagsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTagsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTagsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTagsPaginatePaginationConfigTypeDef(_DescribeTagsPaginatePaginationConfigTypeDef):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTagsPaginateResponseTagsTypeDef = TypedDict(
    "_DescribeTagsPaginateResponseTagsTypeDef",
    {
        "Key": str,
        "ResourceId": str,
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Value": str,
    },
    total=False,
)


class DescribeTagsPaginateResponseTagsTypeDef(_DescribeTagsPaginateResponseTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The tag key.
    """


_DescribeTagsPaginateResponseTypeDef = TypedDict(
    "_DescribeTagsPaginateResponseTypeDef",
    {"Tags": List[DescribeTagsPaginateResponseTagsTypeDef]},
    total=False,
)


class DescribeTagsPaginateResponseTypeDef(_DescribeTagsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Tags** *(list) --*

        The tags.
        - *(dict) --*

          Describes a tag.
          - **Key** *(string) --*

            The tag key.
    """


_DescribeTrafficMirrorFiltersPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateFiltersTypeDef(
    _DescribeTrafficMirrorFiltersPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorFiltersPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef",
    {"FromPort": int, "ToPort": int},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef",
    {
        "TrafficMirrorFilterRuleId": str,
        "TrafficMirrorFilterId": str,
        "TrafficDirection": Literal["ingress", "egress"],
        "RuleNumber": int,
        "RuleAction": Literal["accept", "reject"],
        "Protocol": int,
        "DestinationPortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesDestinationPortRangeTypeDef,
        "SourcePortRange": DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesSourcePortRangeTypeDef,
        "DestinationCidrBlock": str,
        "SourceCidrBlock": str,
        "Description": str,
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef
):
    pass


_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef",
    {
        "TrafficMirrorFilterId": str,
        "IngressFilterRules": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersIngressFilterRulesTypeDef
        ],
        "EgressFilterRules": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersEgressFilterRulesTypeDef
        ],
        "NetworkServices": List[str],
        "Description": str,
        "Tags": List[DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTagsTypeDef],
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef
):
    """
    - *(dict) --*

      Describes the Traffic Mirror filter.
      - **TrafficMirrorFilterId** *(string) --*

        The ID of the Traffic Mirror filter.
    """


_DescribeTrafficMirrorFiltersPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorFiltersPaginateResponseTypeDef",
    {
        "TrafficMirrorFilters": List[
            DescribeTrafficMirrorFiltersPaginateResponseTrafficMirrorFiltersTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorFiltersPaginateResponseTypeDef(
    _DescribeTrafficMirrorFiltersPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorFilters** *(list) --*

        Information about one or more Traffic Mirror filters.
        - *(dict) --*

          Describes the Traffic Mirror filter.
          - **TrafficMirrorFilterId** *(string) --*

            The ID of the Traffic Mirror filter.
    """


_DescribeTrafficMirrorSessionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateFiltersTypeDef(
    _DescribeTrafficMirrorSessionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorSessionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef
):
    pass


_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef",
    {
        "TrafficMirrorSessionId": str,
        "TrafficMirrorTargetId": str,
        "TrafficMirrorFilterId": str,
        "NetworkInterfaceId": str,
        "OwnerId": str,
        "PacketLength": int,
        "SessionNumber": int,
        "VirtualNetworkId": int,
        "Description": str,
        "Tags": List[DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTagsTypeDef],
    },
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef
):
    """
    - *(dict) --*

      Describes a Traffic Mirror session.
      - **TrafficMirrorSessionId** *(string) --*

        The ID for the Traffic Mirror session.
    """


_DescribeTrafficMirrorSessionsPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorSessionsPaginateResponseTypeDef",
    {
        "TrafficMirrorSessions": List[
            DescribeTrafficMirrorSessionsPaginateResponseTrafficMirrorSessionsTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorSessionsPaginateResponseTypeDef(
    _DescribeTrafficMirrorSessionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorSessions** *(list) --*

        Describes one or more Traffic Mirror sessions. By default, all Traffic Mirror sessions are
        described. Alternatively, you can filter the results.
        - *(dict) --*

          Describes a Traffic Mirror session.
          - **TrafficMirrorSessionId** *(string) --*

            The ID for the Traffic Mirror session.
    """


_DescribeTrafficMirrorTargetsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateFiltersTypeDef(
    _DescribeTrafficMirrorTargetsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef(
    _DescribeTrafficMirrorTargetsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef
):
    pass


_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef",
    {
        "TrafficMirrorTargetId": str,
        "NetworkInterfaceId": str,
        "NetworkLoadBalancerArn": str,
        "Type": Literal["network-interface", "network-load-balancer"],
        "Description": str,
        "OwnerId": str,
        "Tags": List[DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTagsTypeDef],
    },
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef
):
    """
    - *(dict) --*

      Describes a Traffic Mirror target.
      - **TrafficMirrorTargetId** *(string) --*

        The ID of the Traffic Mirror target.
    """


_DescribeTrafficMirrorTargetsPaginateResponseTypeDef = TypedDict(
    "_DescribeTrafficMirrorTargetsPaginateResponseTypeDef",
    {
        "TrafficMirrorTargets": List[
            DescribeTrafficMirrorTargetsPaginateResponseTrafficMirrorTargetsTypeDef
        ]
    },
    total=False,
)


class DescribeTrafficMirrorTargetsPaginateResponseTypeDef(
    _DescribeTrafficMirrorTargetsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TrafficMirrorTargets** *(list) --*

        Information about one or more Traffic Mirror targets.
        - *(dict) --*

          Describes a Traffic Mirror target.
          - **TrafficMirrorTargetId** *(string) --*

            The ID of the Traffic Mirror target.
    """


_DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayAttachmentsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef
):
    pass


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef
):
    pass


_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "TransitGatewayOwnerId": str,
        "ResourceOwnerId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "ResourceId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "Association": DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsAssociationTypeDef,
        "CreationTime": datetime,
        "Tags": List[
            DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes an attachment between a resource and a transit gateway.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_DescribeTransitGatewayAttachmentsPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayAttachmentsPaginateResponseTypeDef",
    {
        "TransitGatewayAttachments": List[
            DescribeTransitGatewayAttachmentsPaginateResponseTransitGatewayAttachmentsTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayAttachmentsPaginateResponseTypeDef(
    _DescribeTransitGatewayAttachmentsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayAttachments** *(list) --*

        Information about the attachments.
        - *(dict) --*

          Describes an attachment between a resource and a transit gateway.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayRouteTablesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef
):
    pass


_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "TransitGatewayId": str,
        "State": Literal["pending", "available", "deleting", "deleted"],
        "DefaultAssociationRouteTable": bool,
        "DefaultPropagationRouteTable": bool,
        "CreationTime": datetime,
        "Tags": List[
            DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef
):
    """
    - *(dict) --*

      Describes a transit gateway route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the transit gateway route table.
    """


_DescribeTransitGatewayRouteTablesPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayRouteTablesPaginateResponseTypeDef",
    {
        "TransitGatewayRouteTables": List[
            DescribeTransitGatewayRouteTablesPaginateResponseTransitGatewayRouteTablesTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayRouteTablesPaginateResponseTypeDef(
    _DescribeTransitGatewayRouteTablesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTables** *(list) --*

        Information about the transit gateway route tables.
        - *(dict) --*

          Describes a transit gateway route table.
          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the transit gateway route table.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef",
    {"DnsSupport": Literal["enable", "disable"], "Ipv6Support": Literal["enable", "disable"]},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef
):
    pass


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef
):
    pass


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "TransitGatewayId": str,
        "VpcId": str,
        "VpcOwnerId": str,
        "State": Literal[
            "pendingAcceptance",
            "rollingBack",
            "pending",
            "available",
            "modifying",
            "deleting",
            "deleted",
            "failed",
            "rejected",
            "rejecting",
            "failing",
        ],
        "SubnetIds": List[str],
        "CreationTime": datetime,
        "Options": DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsOptionsTypeDef,
        "Tags": List[
            DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef",
    {
        "TransitGatewayVpcAttachments": List[
            DescribeTransitGatewayVpcAttachmentsPaginateResponseTransitGatewayVpcAttachmentsTypeDef
        ]
    },
    total=False,
)


class DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef(
    _DescribeTransitGatewayVpcAttachmentsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayVpcAttachments** *(list) --*

        Information about the VPC attachments.
        - *(dict) --*

          Describes a VPC attachment.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_DescribeTransitGatewaysPaginateFiltersTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeTransitGatewaysPaginateFiltersTypeDef(_DescribeTransitGatewaysPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeTransitGatewaysPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeTransitGatewaysPaginatePaginationConfigTypeDef(
    _DescribeTransitGatewaysPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef",
    {
        "AmazonSideAsn": int,
        "AutoAcceptSharedAttachments": Literal["enable", "disable"],
        "DefaultRouteTableAssociation": Literal["enable", "disable"],
        "AssociationDefaultRouteTableId": str,
        "DefaultRouteTablePropagation": Literal["enable", "disable"],
        "PropagationDefaultRouteTableId": str,
        "VpnEcmpSupport": Literal["enable", "disable"],
        "DnsSupport": Literal["enable", "disable"],
    },
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef
):
    pass


_DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef
):
    pass


_DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef",
    {
        "TransitGatewayId": str,
        "TransitGatewayArn": str,
        "State": Literal["pending", "available", "modifying", "deleting", "deleted"],
        "OwnerId": str,
        "Description": str,
        "CreationTime": datetime,
        "Options": DescribeTransitGatewaysPaginateResponseTransitGatewaysOptionsTypeDef,
        "Tags": List[DescribeTransitGatewaysPaginateResponseTransitGatewaysTagsTypeDef],
    },
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef(
    _DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef
):
    """
    - *(dict) --*

      Describes a transit gateway.
      - **TransitGatewayId** *(string) --*

        The ID of the transit gateway.
    """


_DescribeTransitGatewaysPaginateResponseTypeDef = TypedDict(
    "_DescribeTransitGatewaysPaginateResponseTypeDef",
    {"TransitGateways": List[DescribeTransitGatewaysPaginateResponseTransitGatewaysTypeDef]},
    total=False,
)


class DescribeTransitGatewaysPaginateResponseTypeDef(
    _DescribeTransitGatewaysPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGateways** *(list) --*

        Information about the transit gateways.
        - *(dict) --*

          Describes a transit gateway.
          - **TransitGatewayId** *(string) --*

            The ID of the transit gateway.
    """


_DescribeVolumeStatusPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeVolumeStatusPaginateFiltersTypeDef(_DescribeVolumeStatusPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVolumeStatusPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumeStatusPaginatePaginationConfigTypeDef(
    _DescribeVolumeStatusPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef
):
    """
    - *(dict) --*

      Describes a volume status operation code.
      - **Code** *(string) --*

        The code identifying the operation, for example, ``enable-volume-io`` .
    """


_DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef
):
    pass


_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": Literal["io-enabled", "io-performance"], "Status": str},
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    pass


_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[
            DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusDetailsTypeDef
        ],
        "Status": Literal["ok", "impaired", "insufficient-data"],
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef
):
    pass


_DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef",
    {
        "Actions": List[DescribeVolumeStatusPaginateResponseVolumeStatusesActionsTypeDef],
        "AvailabilityZone": str,
        "Events": List[DescribeVolumeStatusPaginateResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": DescribeVolumeStatusPaginateResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef(
    _DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef
):
    """
    - *(dict) --*

      Describes the volume status.
      - **Actions** *(list) --*

        The details of the operation.
        - *(dict) --*

          Describes a volume status operation code.
          - **Code** *(string) --*

            The code identifying the operation, for example, ``enable-volume-io`` .
    """


_DescribeVolumeStatusPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumeStatusPaginateResponseTypeDef",
    {"VolumeStatuses": List[DescribeVolumeStatusPaginateResponseVolumeStatusesTypeDef]},
    total=False,
)


class DescribeVolumeStatusPaginateResponseTypeDef(_DescribeVolumeStatusPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **VolumeStatuses** *(list) --*

        Information about the status of the volumes.
        - *(dict) --*

          Describes the volume status.
          - **Actions** *(list) --*

            The details of the operation.
            - *(dict) --*

              Describes a volume status operation code.
              - **Code** *(string) --*

                The code identifying the operation, for example, ``enable-volume-io`` .
    """


_DescribeVolumesModificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVolumesModificationsPaginateFiltersTypeDef(
    _DescribeVolumesModificationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVolumesModificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumesModificationsPaginatePaginationConfigTypeDef(
    _DescribeVolumesModificationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef",
    {
        "VolumeId": str,
        "ModificationState": Literal["modifying", "optimizing", "completed", "failed"],
        "StatusMessage": str,
        "TargetSize": int,
        "TargetIops": int,
        "TargetVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "OriginalSize": int,
        "OriginalIops": int,
        "OriginalVolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Progress": int,
        "StartTime": datetime,
        "EndTime": datetime,
    },
    total=False,
)


class DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef(
    _DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef
):
    """
    - *(dict) --*

      Describes the modification status of an EBS volume.
      If the volume has never been modified, some element values will be null.
      - **VolumeId** *(string) --*

        The ID of the volume.
    """


_DescribeVolumesModificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumesModificationsPaginateResponseTypeDef",
    {
        "VolumesModifications": List[
            DescribeVolumesModificationsPaginateResponseVolumesModificationsTypeDef
        ]
    },
    total=False,
)


class DescribeVolumesModificationsPaginateResponseTypeDef(
    _DescribeVolumesModificationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **VolumesModifications** *(list) --*

        Information about the volume modifications.
        - *(dict) --*

          Describes the modification status of an EBS volume.
          If the volume has never been modified, some element values will be null.
          - **VolumeId** *(string) --*

            The ID of the volume.
    """


_DescribeVolumesPaginateFiltersTypeDef = TypedDict(
    "_DescribeVolumesPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeVolumesPaginateFiltersTypeDef(_DescribeVolumesPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVolumesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVolumesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVolumesPaginatePaginationConfigTypeDef(
    _DescribeVolumesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef(
    _DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef
):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_DescribeVolumesPaginateResponseVolumesTagsTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DescribeVolumesPaginateResponseVolumesTagsTypeDef(
    _DescribeVolumesPaginateResponseVolumesTagsTypeDef
):
    pass


_DescribeVolumesPaginateResponseVolumesTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseVolumesTypeDef",
    {
        "Attachments": List[DescribeVolumesPaginateResponseVolumesAttachmentsTypeDef],
        "AvailabilityZone": str,
        "CreateTime": datetime,
        "Encrypted": bool,
        "KmsKeyId": str,
        "Size": int,
        "SnapshotId": str,
        "State": Literal["creating", "available", "in-use", "deleting", "deleted", "error"],
        "VolumeId": str,
        "Iops": int,
        "Tags": List[DescribeVolumesPaginateResponseVolumesTagsTypeDef],
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "FastRestored": bool,
    },
    total=False,
)


class DescribeVolumesPaginateResponseVolumesTypeDef(_DescribeVolumesPaginateResponseVolumesTypeDef):
    """
    - *(dict) --*

      Describes a volume.
      - **Attachments** *(list) --*

        Information about the volume attachments.
        - *(dict) --*

          Describes volume attachment details.
          - **AttachTime** *(datetime) --*

            The time stamp when the attachment initiated.
    """


_DescribeVolumesPaginateResponseTypeDef = TypedDict(
    "_DescribeVolumesPaginateResponseTypeDef",
    {"Volumes": List[DescribeVolumesPaginateResponseVolumesTypeDef]},
    total=False,
)


class DescribeVolumesPaginateResponseTypeDef(_DescribeVolumesPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Volumes** *(list) --*

        Information about the volumes.
        - *(dict) --*

          Describes a volume.
          - **Attachments** *(list) --*

            Information about the volume attachments.
            - *(dict) --*

              Describes volume attachment details.
              - **AttachTime** *(datetime) --*

                The time stamp when the attachment initiated.
    """


_DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef",
    {"ClassicLinkDnsSupported": bool, "VpcId": str},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef
):
    """
    - *(dict) --*

      Describes the ClassicLink DNS support status of a VPC.
      - **ClassicLinkDnsSupported** *(boolean) --*

        Indicates whether ClassicLink DNS support is enabled for the VPC.
    """


_DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef",
    {"Vpcs": List[DescribeVpcClassicLinkDnsSupportPaginateResponseVpcsTypeDef]},
    total=False,
)


class DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef(
    _DescribeVpcClassicLinkDnsSupportPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Vpcs** *(list) --*

        Information about the ClassicLink DNS support status of the VPCs.
        - *(dict) --*

          Describes the ClassicLink DNS support status of a VPC.
          - **ClassicLinkDnsSupported** *(boolean) --*

            Indicates whether ClassicLink DNS support is enabled for the VPC.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef",
    {
        "ConnectionNotificationId": str,
        "ServiceId": str,
        "VpcEndpointId": str,
        "ConnectionNotificationType": str,
        "ConnectionNotificationArn": str,
        "ConnectionEvents": List[str],
        "ConnectionNotificationState": Literal["Enabled", "Disabled"],
    },
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef
):
    """
    - *(dict) --*

      Describes a connection notification for a VPC endpoint or VPC endpoint service.
      - **ConnectionNotificationId** *(string) --*

        The ID of the notification.
    """


_DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef",
    {
        "ConnectionNotificationSet": List[
            DescribeVpcEndpointConnectionNotificationsPaginateResponseConnectionNotificationSetTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef(
    _DescribeVpcEndpointConnectionNotificationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ConnectionNotificationSet** *(list) --*

        One or more notifications.
        - *(dict) --*

          Describes a connection notification for a VPC endpoint or VPC endpoint service.
          - **ConnectionNotificationId** *(string) --*

            The ID of the notification.
    """


_DescribeVpcEndpointConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateFiltersTypeDef(
    _DescribeVpcEndpointConnectionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointConnectionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef
):
    pass


_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef",
    {
        "ServiceId": str,
        "VpcEndpointId": str,
        "VpcEndpointOwner": str,
        "VpcEndpointState": Literal[
            "PendingAcceptance",
            "Pending",
            "Available",
            "Deleting",
            "Deleted",
            "Rejected",
            "Failed",
            "Expired",
        ],
        "CreationTimestamp": datetime,
        "DnsEntries": List[
            DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsDnsEntriesTypeDef
        ],
        "NetworkLoadBalancerArns": List[str],
    },
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC endpoint connection to a service.
      - **ServiceId** *(string) --*

        The ID of the service to which the endpoint is connected.
    """


_DescribeVpcEndpointConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointConnectionsPaginateResponseTypeDef",
    {
        "VpcEndpointConnections": List[
            DescribeVpcEndpointConnectionsPaginateResponseVpcEndpointConnectionsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointConnectionsPaginateResponseTypeDef(
    _DescribeVpcEndpointConnectionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcEndpointConnections** *(list) --*

        Information about one or more VPC endpoint connections.
        - *(dict) --*

          Describes a VPC endpoint connection to a service.
          - **ServiceId** *(string) --*

            The ID of the service to which the endpoint is connected.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef",
    {"ServiceType": Literal["Interface", "Gateway"]},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef
):
    """
    - *(dict) --*

      Describes the type of service for a VPC endpoint.
      - **ServiceType** *(string) --*

        The type of service.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef
):
    pass


_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef",
    {
        "ServiceType": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsServiceTypeTypeDef
        ],
        "ServiceId": str,
        "ServiceName": str,
        "ServiceState": Literal["Pending", "Available", "Deleting", "Deleted", "Failed"],
        "AvailabilityZones": List[str],
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "NetworkLoadBalancerArns": List[str],
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "Tags": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTagsTypeDef
        ],
    },
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef
):
    """
    - *(dict) --*

      Describes a service configuration for a VPC endpoint service.
      - **ServiceType** *(list) --*

        The type of service.
        - *(dict) --*

          Describes the type of service for a VPC endpoint.
          - **ServiceType** *(string) --*

            The type of service.
    """


_DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef",
    {
        "ServiceConfigurations": List[
            DescribeVpcEndpointServiceConfigurationsPaginateResponseServiceConfigurationsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef(
    _DescribeVpcEndpointServiceConfigurationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **ServiceConfigurations** *(list) --*

        Information about one or more services.
        - *(dict) --*

          Describes a service configuration for a VPC endpoint service.
          - **ServiceType** *(list) --*

            The type of service.
            - *(dict) --*

              Describes the type of service for a VPC endpoint.
              - **ServiceType** *(string) --*

                The type of service.
    """


_DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef",
    {
        "PrincipalType": Literal["All", "Service", "OrganizationUnit", "Account", "User", "Role"],
        "Principal": str,
    },
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef
):
    """
    - *(dict) --*

      Describes a principal.
      - **PrincipalType** *(string) --*

        The type of principal.
    """


_DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef",
    {
        "AllowedPrincipals": List[
            DescribeVpcEndpointServicePermissionsPaginateResponseAllowedPrincipalsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef(
    _DescribeVpcEndpointServicePermissionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **AllowedPrincipals** *(list) --*

        Information about one or more allowed principals.
        - *(dict) --*

          Describes a principal.
          - **PrincipalType** *(string) --*

            The type of principal.
    """


_DescribeVpcEndpointServicesPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcEndpointServicesPaginateFiltersTypeDef(
    _DescribeVpcEndpointServicesPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointServicesPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef",
    {"ServiceType": Literal["Interface", "Gateway"]},
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef
):
    pass


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef
):
    pass


_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef",
    {
        "ServiceName": str,
        "ServiceId": str,
        "ServiceType": List[
            DescribeVpcEndpointServicesPaginateResponseServiceDetailsServiceTypeTypeDef
        ],
        "AvailabilityZones": List[str],
        "Owner": str,
        "BaseEndpointDnsNames": List[str],
        "PrivateDnsName": str,
        "VpcEndpointPolicySupported": bool,
        "AcceptanceRequired": bool,
        "ManagesVpcEndpoints": bool,
        "Tags": List[DescribeVpcEndpointServicesPaginateResponseServiceDetailsTagsTypeDef],
    },
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef
):
    pass


_DescribeVpcEndpointServicesPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointServicesPaginateResponseTypeDef",
    {
        "ServiceNames": List[str],
        "ServiceDetails": List[DescribeVpcEndpointServicesPaginateResponseServiceDetailsTypeDef],
    },
    total=False,
)


class DescribeVpcEndpointServicesPaginateResponseTypeDef(
    _DescribeVpcEndpointServicesPaginateResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeVpcEndpointServices.
      - **ServiceNames** *(list) --*

        A list of supported services.
        - *(string) --*
    """


_DescribeVpcEndpointsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeVpcEndpointsPaginateFiltersTypeDef(_DescribeVpcEndpointsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcEndpointsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcEndpointsPaginatePaginationConfigTypeDef(
    _DescribeVpcEndpointsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef",
    {"DnsName": str, "HostedZoneId": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef
):
    pass


_DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef",
    {"GroupId": str, "GroupName": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef
):
    pass


_DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef
):
    pass


_DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef",
    {
        "VpcEndpointId": str,
        "VpcEndpointType": Literal["Interface", "Gateway"],
        "VpcId": str,
        "ServiceName": str,
        "State": Literal[
            "PendingAcceptance",
            "Pending",
            "Available",
            "Deleting",
            "Deleted",
            "Rejected",
            "Failed",
            "Expired",
        ],
        "PolicyDocument": str,
        "RouteTableIds": List[str],
        "SubnetIds": List[str],
        "Groups": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsGroupsTypeDef],
        "PrivateDnsEnabled": bool,
        "RequesterManaged": bool,
        "NetworkInterfaceIds": List[str],
        "DnsEntries": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsDnsEntriesTypeDef],
        "CreationTimestamp": datetime,
        "Tags": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsTagsTypeDef],
        "OwnerId": str,
    },
    total=False,
)


class DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef(
    _DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC endpoint.
      - **VpcEndpointId** *(string) --*

        The ID of the VPC endpoint.
    """


_DescribeVpcEndpointsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcEndpointsPaginateResponseTypeDef",
    {"VpcEndpoints": List[DescribeVpcEndpointsPaginateResponseVpcEndpointsTypeDef]},
    total=False,
)


class DescribeVpcEndpointsPaginateResponseTypeDef(_DescribeVpcEndpointsPaginateResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of DescribeVpcEndpoints.
      - **VpcEndpoints** *(list) --*

        Information about the endpoints.
        - *(dict) --*

          Describes a VPC endpoint.
          - **VpcEndpointId** *(string) --*

            The ID of the VPC endpoint.
    """


_DescribeVpcPeeringConnectionsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateFiltersTypeDef(
    _DescribeVpcPeeringConnectionsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef(
    _DescribeVpcPeeringConnectionsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef
):
    """
    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing an
      active VPC peering connection.
      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.
    """


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef",
    {
        "Code": Literal[
            "initiating-request",
            "pending-acceptance",
            "active",
            "deleted",
            "rejected",
            "failed",
            "expired",
            "provisioning",
            "deleting",
        ],
        "Message": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef
):
    pass


_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef",
    {
        "AccepterVpcInfo": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsRequesterVpcInfoTypeDef,
        "Status": DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsStatusTypeDef,
        "Tags": List[DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef
):
    """
    - *(dict) --*

      Describes a VPC peering connection.
      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.
        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.
    """


_DescribeVpcPeeringConnectionsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcPeeringConnectionsPaginateResponseTypeDef",
    {
        "VpcPeeringConnections": List[
            DescribeVpcPeeringConnectionsPaginateResponseVpcPeeringConnectionsTypeDef
        ]
    },
    total=False,
)


class DescribeVpcPeeringConnectionsPaginateResponseTypeDef(
    _DescribeVpcPeeringConnectionsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **VpcPeeringConnections** *(list) --*

        Information about the VPC peering connections.
        - *(dict) --*

          Describes a VPC peering connection.
          - **AccepterVpcInfo** *(dict) --*

            Information about the accepter VPC. CIDR block information is only returned when
            describing an active VPC peering connection.
            - **CidrBlock** *(string) --*

              The IPv4 CIDR block for the VPC.
    """


_DescribeVpcsPaginateFiltersTypeDef = TypedDict(
    "_DescribeVpcsPaginateFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DescribeVpcsPaginateFiltersTypeDef(_DescribeVpcsPaginateFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_DescribeVpcsPaginatePaginationConfigTypeDef = TypedDict(
    "_DescribeVpcsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class DescribeVpcsPaginatePaginationConfigTypeDef(_DescribeVpcsPaginatePaginationConfigTypeDef):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef(
    _DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef
):
    pass


_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "CidrBlock": str,
        "CidrBlockState": DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetCidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef(
    _DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef
):
    pass


_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef",
    {
        "State": Literal[
            "associating", "associated", "disassociating", "disassociated", "failing", "failed"
        ],
        "StatusMessage": str,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef(
    _DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef
):
    pass


_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef",
    {
        "AssociationId": str,
        "Ipv6CidrBlock": str,
        "Ipv6CidrBlockState": DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetIpv6CidrBlockStateTypeDef,
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef(
    _DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef
):
    pass


_DescribeVpcsPaginateResponseVpcsTagsTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DescribeVpcsPaginateResponseVpcsTagsTypeDef(_DescribeVpcsPaginateResponseVpcsTagsTypeDef):
    pass


_DescribeVpcsPaginateResponseVpcsTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseVpcsTypeDef",
    {
        "CidrBlock": str,
        "DhcpOptionsId": str,
        "State": Literal["pending", "available"],
        "VpcId": str,
        "OwnerId": str,
        "InstanceTenancy": Literal["default", "dedicated", "host"],
        "Ipv6CidrBlockAssociationSet": List[
            DescribeVpcsPaginateResponseVpcsIpv6CidrBlockAssociationSetTypeDef
        ],
        "CidrBlockAssociationSet": List[
            DescribeVpcsPaginateResponseVpcsCidrBlockAssociationSetTypeDef
        ],
        "IsDefault": bool,
        "Tags": List[DescribeVpcsPaginateResponseVpcsTagsTypeDef],
    },
    total=False,
)


class DescribeVpcsPaginateResponseVpcsTypeDef(_DescribeVpcsPaginateResponseVpcsTypeDef):
    """
    - *(dict) --*

      Describes a VPC.
      - **CidrBlock** *(string) --*

        The primary IPv4 CIDR block for the VPC.
    """


_DescribeVpcsPaginateResponseTypeDef = TypedDict(
    "_DescribeVpcsPaginateResponseTypeDef",
    {"Vpcs": List[DescribeVpcsPaginateResponseVpcsTypeDef]},
    total=False,
)


class DescribeVpcsPaginateResponseTypeDef(_DescribeVpcsPaginateResponseTypeDef):
    """
    - *(dict) --*

      - **Vpcs** *(list) --*

        Information about one or more VPCs.
        - *(dict) --*

          Describes a VPC.
          - **CidrBlock** *(string) --*

            The primary IPv4 CIDR block for the VPC.
    """


_DhcpOptionsCreateTagsTagsTypeDef = TypedDict(
    "_DhcpOptionsCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class DhcpOptionsCreateTagsTagsTypeDef(_DhcpOptionsCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_DhcpOptionsSetsFilterFiltersTypeDef = TypedDict(
    "_DhcpOptionsSetsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class DhcpOptionsSetsFilterFiltersTypeDef(_DhcpOptionsSetsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ExportTaskCancelledWaitWaiterConfigTypeDef = TypedDict(
    "_ExportTaskCancelledWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class ExportTaskCancelledWaitWaiterConfigTypeDef(_ExportTaskCancelledWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ExportTaskCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_ExportTaskCompletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class ExportTaskCompletedWaitWaiterConfigTypeDef(_ExportTaskCompletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef",
    {
        "TransitGatewayRouteTableId": str,
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef
):
    """
    - *(dict) --*

      Describes a propagation route table.
      - **TransitGatewayRouteTableId** *(string) --*

        The ID of the propagation route table.
    """


_GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef",
    {
        "TransitGatewayAttachmentPropagations": List[
            GetTransitGatewayAttachmentPropagationsPaginateResponseTransitGatewayAttachmentPropagationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef(
    _GetTransitGatewayAttachmentPropagationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayAttachmentPropagations** *(list) --*

        Information about the propagation route tables.
        - *(dict) --*

          Describes a propagation route table.
          - **TransitGatewayRouteTableId** *(string) --*

            The ID of the propagation route table.
    """


_GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["associating", "associated", "disassociating", "disassociated"],
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef
):
    """
    - *(dict) --*

      Describes an association between a route table and a resource attachment.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef",
    {
        "Associations": List[
            GetTransitGatewayRouteTableAssociationsPaginateResponseAssociationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef(
    _GetTransitGatewayRouteTableAssociationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **Associations** *(list) --*

        Information about the associations.
        - *(dict) --*

          Describes an association between a route table and a resource attachment.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef",
    {"MaxItems": int, "PageSize": int, "StartingToken": str},
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginatePaginationConfigTypeDef
):
    """
    A dictionary that provides parameters to control pagination.
    - **MaxItems** *(integer) --*

      The total number of items to return. If the total number of items available is more than the
      value specified in max-items then a ``NextToken`` will be provided in the output that you can
      use to resume pagination.
    """


_GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef",
    {
        "TransitGatewayAttachmentId": str,
        "ResourceId": str,
        "ResourceType": Literal["vpc", "vpn", "direct-connect-gateway"],
        "State": Literal["enabling", "enabled", "disabling", "disabled"],
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef
):
    """
    - *(dict) --*

      Describes a route table propagation.
      - **TransitGatewayAttachmentId** *(string) --*

        The ID of the attachment.
    """


_GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef = TypedDict(
    "_GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef",
    {
        "TransitGatewayRouteTablePropagations": List[
            GetTransitGatewayRouteTablePropagationsPaginateResponseTransitGatewayRouteTablePropagationsTypeDef
        ]
    },
    total=False,
)


class GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef(
    _GetTransitGatewayRouteTablePropagationsPaginateResponseTypeDef
):
    """
    - *(dict) --*

      - **TransitGatewayRouteTablePropagations** *(list) --*

        Information about the route table propagations.
        - *(dict) --*

          Describes a route table propagation.
          - **TransitGatewayAttachmentId** *(string) --*

            The ID of the attachment.
    """


_ImageAvailableWaitFiltersTypeDef = TypedDict(
    "_ImageAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImageAvailableWaitFiltersTypeDef(_ImageAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ImageAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_ImageAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class ImageAvailableWaitWaiterConfigTypeDef(_ImageAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ImageCreateTagsTagsTypeDef = TypedDict(
    "_ImageCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class ImageCreateTagsTagsTypeDef(_ImageCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    pass


_ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ImageDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef(
    _ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ImageDescribeAttributeResponseDescriptionTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseDescriptionTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseDescriptionTypeDef(
    _ImageDescribeAttributeResponseDescriptionTypeDef
):
    pass


_ImageDescribeAttributeResponseKernelIdTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseKernelIdTypeDef(_ImageDescribeAttributeResponseKernelIdTypeDef):
    pass


_ImageDescribeAttributeResponseLaunchPermissionsTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseLaunchPermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class ImageDescribeAttributeResponseLaunchPermissionsTypeDef(
    _ImageDescribeAttributeResponseLaunchPermissionsTypeDef
):
    pass


_ImageDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class ImageDescribeAttributeResponseProductCodesTypeDef(
    _ImageDescribeAttributeResponseProductCodesTypeDef
):
    pass


_ImageDescribeAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseRamdiskIdTypeDef(
    _ImageDescribeAttributeResponseRamdiskIdTypeDef
):
    pass


_ImageDescribeAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseSriovNetSupportTypeDef", {"Value": str}, total=False
)


class ImageDescribeAttributeResponseSriovNetSupportTypeDef(
    _ImageDescribeAttributeResponseSriovNetSupportTypeDef
):
    pass


_ImageDescribeAttributeResponseTypeDef = TypedDict(
    "_ImageDescribeAttributeResponseTypeDef",
    {
        "BlockDeviceMappings": List[ImageDescribeAttributeResponseBlockDeviceMappingsTypeDef],
        "ImageId": str,
        "LaunchPermissions": List[ImageDescribeAttributeResponseLaunchPermissionsTypeDef],
        "ProductCodes": List[ImageDescribeAttributeResponseProductCodesTypeDef],
        "Description": ImageDescribeAttributeResponseDescriptionTypeDef,
        "KernelId": ImageDescribeAttributeResponseKernelIdTypeDef,
        "RamdiskId": ImageDescribeAttributeResponseRamdiskIdTypeDef,
        "SriovNetSupport": ImageDescribeAttributeResponseSriovNetSupportTypeDef,
    },
    total=False,
)


class ImageDescribeAttributeResponseTypeDef(_ImageDescribeAttributeResponseTypeDef):
    """
    - *(dict) --*

      Describes an image attribute.
      - **BlockDeviceMappings** *(list) --*

        The block device mapping entries.
        - *(dict) --*

          Describes a block device mapping.
          - **DeviceName** *(string) --*

            The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ImageExistsWaitFiltersTypeDef = TypedDict(
    "_ImageExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImageExistsWaitFiltersTypeDef(_ImageExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ImageExistsWaitWaiterConfigTypeDef = TypedDict(
    "_ImageExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class ImageExistsWaitWaiterConfigTypeDef(_ImageExistsWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_ImageModifyAttributeDescriptionTypeDef = TypedDict(
    "_ImageModifyAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class ImageModifyAttributeDescriptionTypeDef(_ImageModifyAttributeDescriptionTypeDef):
    """
    A new description for the AMI.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_ImageModifyAttributeLaunchPermissionAddTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionAddTypeDef", {"Group": str, "UserId": str}, total=False
)


class ImageModifyAttributeLaunchPermissionAddTypeDef(
    _ImageModifyAttributeLaunchPermissionAddTypeDef
):
    """
    - *(dict) --*

      Describes a launch permission.
      - **Group** *(string) --*

        The name of the group.
    """


_ImageModifyAttributeLaunchPermissionRemoveTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionRemoveTypeDef", {"Group": str, "UserId": str}, total=False
)


class ImageModifyAttributeLaunchPermissionRemoveTypeDef(
    _ImageModifyAttributeLaunchPermissionRemoveTypeDef
):
    pass


_ImageModifyAttributeLaunchPermissionTypeDef = TypedDict(
    "_ImageModifyAttributeLaunchPermissionTypeDef",
    {
        "Add": List[ImageModifyAttributeLaunchPermissionAddTypeDef],
        "Remove": List[ImageModifyAttributeLaunchPermissionRemoveTypeDef],
    },
    total=False,
)


class ImageModifyAttributeLaunchPermissionTypeDef(_ImageModifyAttributeLaunchPermissionTypeDef):
    """
    A new launch permission for the AMI.
    - **Add** *(list) --*

      The AWS account ID to add to the list of launch permissions for the AMI.
      - *(dict) --*

        Describes a launch permission.
        - **Group** *(string) --*

          The name of the group.
    """


_ImageWaitUntilExistsFiltersTypeDef = TypedDict(
    "_ImageWaitUntilExistsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImageWaitUntilExistsFiltersTypeDef(_ImageWaitUntilExistsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ImagesFilterFiltersTypeDef = TypedDict(
    "_ImagesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class ImagesFilterFiltersTypeDef(_ImagesFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceAttachClassicLinkVpcResponseTypeDef = TypedDict(
    "_InstanceAttachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class InstanceAttachClassicLinkVpcResponseTypeDef(_InstanceAttachClassicLinkVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_InstanceAttachVolumeResponseTypeDef = TypedDict(
    "_InstanceAttachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class InstanceAttachVolumeResponseTypeDef(_InstanceAttachVolumeResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_InstanceConsoleOutputResponseTypeDef = TypedDict(
    "_InstanceConsoleOutputResponseTypeDef",
    {"InstanceId": str, "Output": str, "Timestamp": datetime},
    total=False,
)


class InstanceConsoleOutputResponseTypeDef(_InstanceConsoleOutputResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_InstanceCreateImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceCreateImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class InstanceCreateImageBlockDeviceMappingsEbsTypeDef(
    _InstanceCreateImageBlockDeviceMappingsEbsTypeDef
):
    pass


_InstanceCreateImageBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceCreateImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": InstanceCreateImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class InstanceCreateImageBlockDeviceMappingsTypeDef(_InstanceCreateImageBlockDeviceMappingsTypeDef):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_InstanceCreateTagsTagsTypeDef = TypedDict(
    "_InstanceCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstanceCreateTagsTagsTypeDef(_InstanceCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_InstanceDeleteTagsTagsTypeDef = TypedDict(
    "_InstanceDeleteTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstanceDeleteTagsTagsTypeDef(_InstanceDeleteTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef",
    {
        "AttachTime": datetime,
        "DeleteOnTermination": bool,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
        "VolumeId": str,
    },
    total=False,
)


class InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef(
    _InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef
):
    pass


_InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef",
    {"DeviceName": str, "Ebs": InstanceDescribeAttributeResponseBlockDeviceMappingsEbsTypeDef},
    total=False,
)


class InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef(
    _InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef
):
    pass


_InstanceDescribeAttributeResponseDisableApiTerminationTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseDisableApiTerminationTypeDef", {"Value": bool}, total=False
)


class InstanceDescribeAttributeResponseDisableApiTerminationTypeDef(
    _InstanceDescribeAttributeResponseDisableApiTerminationTypeDef
):
    pass


_InstanceDescribeAttributeResponseEbsOptimizedTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class InstanceDescribeAttributeResponseEbsOptimizedTypeDef(
    _InstanceDescribeAttributeResponseEbsOptimizedTypeDef
):
    pass


_InstanceDescribeAttributeResponseEnaSupportTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseEnaSupportTypeDef", {"Value": bool}, total=False
)


class InstanceDescribeAttributeResponseEnaSupportTypeDef(
    _InstanceDescribeAttributeResponseEnaSupportTypeDef
):
    pass


_InstanceDescribeAttributeResponseGroupsTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class InstanceDescribeAttributeResponseGroupsTypeDef(
    _InstanceDescribeAttributeResponseGroupsTypeDef
):
    """
    - *(dict) --*

      Describes a security group.
      - **GroupName** *(string) --*

        The name of the security group.
    """


_InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef",
    {"Value": str},
    total=False,
)


class InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef(
    _InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef
):
    pass


_InstanceDescribeAttributeResponseInstanceTypeTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseInstanceTypeTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseInstanceTypeTypeDef(
    _InstanceDescribeAttributeResponseInstanceTypeTypeDef
):
    pass


_InstanceDescribeAttributeResponseKernelIdTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseKernelIdTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseKernelIdTypeDef(
    _InstanceDescribeAttributeResponseKernelIdTypeDef
):
    pass


_InstanceDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class InstanceDescribeAttributeResponseProductCodesTypeDef(
    _InstanceDescribeAttributeResponseProductCodesTypeDef
):
    pass


_InstanceDescribeAttributeResponseRamdiskIdTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseRamdiskIdTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseRamdiskIdTypeDef(
    _InstanceDescribeAttributeResponseRamdiskIdTypeDef
):
    pass


_InstanceDescribeAttributeResponseRootDeviceNameTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseRootDeviceNameTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseRootDeviceNameTypeDef(
    _InstanceDescribeAttributeResponseRootDeviceNameTypeDef
):
    pass


_InstanceDescribeAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class InstanceDescribeAttributeResponseSourceDestCheckTypeDef(
    _InstanceDescribeAttributeResponseSourceDestCheckTypeDef
):
    pass


_InstanceDescribeAttributeResponseSriovNetSupportTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseSriovNetSupportTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseSriovNetSupportTypeDef(
    _InstanceDescribeAttributeResponseSriovNetSupportTypeDef
):
    pass


_InstanceDescribeAttributeResponseUserDataTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseUserDataTypeDef", {"Value": str}, total=False
)


class InstanceDescribeAttributeResponseUserDataTypeDef(
    _InstanceDescribeAttributeResponseUserDataTypeDef
):
    pass


_InstanceDescribeAttributeResponseTypeDef = TypedDict(
    "_InstanceDescribeAttributeResponseTypeDef",
    {
        "Groups": List[InstanceDescribeAttributeResponseGroupsTypeDef],
        "BlockDeviceMappings": List[InstanceDescribeAttributeResponseBlockDeviceMappingsTypeDef],
        "DisableApiTermination": InstanceDescribeAttributeResponseDisableApiTerminationTypeDef,
        "EnaSupport": InstanceDescribeAttributeResponseEnaSupportTypeDef,
        "EbsOptimized": InstanceDescribeAttributeResponseEbsOptimizedTypeDef,
        "InstanceId": str,
        "InstanceInitiatedShutdownBehavior": InstanceDescribeAttributeResponseInstanceInitiatedShutdownBehaviorTypeDef,
        "InstanceType": InstanceDescribeAttributeResponseInstanceTypeTypeDef,
        "KernelId": InstanceDescribeAttributeResponseKernelIdTypeDef,
        "ProductCodes": List[InstanceDescribeAttributeResponseProductCodesTypeDef],
        "RamdiskId": InstanceDescribeAttributeResponseRamdiskIdTypeDef,
        "RootDeviceName": InstanceDescribeAttributeResponseRootDeviceNameTypeDef,
        "SourceDestCheck": InstanceDescribeAttributeResponseSourceDestCheckTypeDef,
        "SriovNetSupport": InstanceDescribeAttributeResponseSriovNetSupportTypeDef,
        "UserData": InstanceDescribeAttributeResponseUserDataTypeDef,
    },
    total=False,
)


class InstanceDescribeAttributeResponseTypeDef(_InstanceDescribeAttributeResponseTypeDef):
    """
    - *(dict) --*

      Describes an instance attribute.
      - **Groups** *(list) --*

        The security groups associated with the instance.
        - *(dict) --*

          Describes a security group.
          - **GroupName** *(string) --*

            The name of the security group.
    """


_InstanceDetachClassicLinkVpcResponseTypeDef = TypedDict(
    "_InstanceDetachClassicLinkVpcResponseTypeDef", {"Return": bool}, total=False
)


class InstanceDetachClassicLinkVpcResponseTypeDef(_InstanceDetachClassicLinkVpcResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_InstanceDetachVolumeResponseTypeDef = TypedDict(
    "_InstanceDetachVolumeResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class InstanceDetachVolumeResponseTypeDef(_InstanceDetachVolumeResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_InstanceExistsWaitFiltersTypeDef = TypedDict(
    "_InstanceExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceExistsWaitFiltersTypeDef(_InstanceExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceExistsWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InstanceExistsWaitWaiterConfigTypeDef(_InstanceExistsWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 5
    """


_InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef",
    {"DeleteOnTermination": bool, "VolumeId": str},
    total=False,
)


class InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef(
    _InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef
):
    pass


_InstanceModifyAttributeBlockDeviceMappingsTypeDef = TypedDict(
    "_InstanceModifyAttributeBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "Ebs": InstanceModifyAttributeBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
        "VirtualName": str,
    },
    total=False,
)


class InstanceModifyAttributeBlockDeviceMappingsTypeDef(
    _InstanceModifyAttributeBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping entry.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_InstanceModifyAttributeDisableApiTerminationTypeDef = TypedDict(
    "_InstanceModifyAttributeDisableApiTerminationTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeDisableApiTerminationTypeDef(
    _InstanceModifyAttributeDisableApiTerminationTypeDef
):
    """
    If the value is ``true`` , you can't terminate the instance using the Amazon EC2 console, CLI,
    or API; otherwise, you can. You cannot use this parameter for Spot Instances.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeEbsOptimizedTypeDef = TypedDict(
    "_InstanceModifyAttributeEbsOptimizedTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeEbsOptimizedTypeDef(_InstanceModifyAttributeEbsOptimizedTypeDef):
    """
    Specifies whether the instance is optimized for Amazon EBS I/O. This optimization provides
    dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal EBS
    I/O performance. This optimization isn't available with all instance types. Additional usage
    charges apply when using an EBS Optimized instance.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeEnaSupportTypeDef = TypedDict(
    "_InstanceModifyAttributeEnaSupportTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeEnaSupportTypeDef(_InstanceModifyAttributeEnaSupportTypeDef):
    """
    Set to ``true`` to enable enhanced networking with ENA for the instance.
    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef = TypedDict(
    "_InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef(
    _InstanceModifyAttributeInstanceInitiatedShutdownBehaviorTypeDef
):
    """
    Specifies whether an instance stops or terminates when you initiate shutdown from the instance
    (using the operating system command for system shutdown).
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeInstanceTypeTypeDef = TypedDict(
    "_InstanceModifyAttributeInstanceTypeTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeInstanceTypeTypeDef(_InstanceModifyAttributeInstanceTypeTypeDef):
    """
    Changes the instance type to the specified value. For more information, see `Instance Types
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html>`__ . If the instance
    type is not valid, the error returned is ``InvalidInstanceAttributeValue`` .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeKernelTypeDef = TypedDict(
    "_InstanceModifyAttributeKernelTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeKernelTypeDef(_InstanceModifyAttributeKernelTypeDef):
    """
    Changes the instance's kernel to the specified value. We recommend that you use PV-GRUB instead
    of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeRamdiskTypeDef = TypedDict(
    "_InstanceModifyAttributeRamdiskTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeRamdiskTypeDef(_InstanceModifyAttributeRamdiskTypeDef):
    """
    Changes the instance's RAM disk to the specified value. We recommend that you use PV-GRUB
    instead of kernels and RAM disks. For more information, see `PV-GRUB
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/UserProvidedKernels.html>`__ .
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeSourceDestCheckTypeDef = TypedDict(
    "_InstanceModifyAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class InstanceModifyAttributeSourceDestCheckTypeDef(_InstanceModifyAttributeSourceDestCheckTypeDef):
    """
    Specifies whether source/destination checking is enabled. A value of ``true`` means that
    checking is enabled, and ``false`` means that checking is disabled. This value must be ``false``
    for a NAT instance to perform NAT.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_InstanceModifyAttributeSriovNetSupportTypeDef = TypedDict(
    "_InstanceModifyAttributeSriovNetSupportTypeDef", {"Value": str}, total=False
)


class InstanceModifyAttributeSriovNetSupportTypeDef(_InstanceModifyAttributeSriovNetSupportTypeDef):
    """
    Set to ``simple`` to enable enhanced networking with the Intel 82599 Virtual Function interface
    for the instance.
    There is no way to disable enhanced networking with the Intel 82599 Virtual Function interface
    at this time.
    This option is supported only for HVM instances. Specifying this option with a PV instance can
    make it unreachable.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_InstanceModifyAttributeUserDataTypeDef = TypedDict(
    "_InstanceModifyAttributeUserDataTypeDef", {"Value": bytes}, total=False
)


class InstanceModifyAttributeUserDataTypeDef(_InstanceModifyAttributeUserDataTypeDef):
    """
    Changes the instance's user data to the specified value. If you are using an AWS SDK or command
    line tool, base64-encoding is performed for you, and you can load the text from a file.
    Otherwise, you must provide base64-encoded text.
    - **Value** *(bytes) --*
    """


_InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_InstanceMonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstanceMonitorResponseInstanceMonitoringsTypeDef",
    {"InstanceId": str, "Monitoring": InstanceMonitorResponseInstanceMonitoringsMonitoringTypeDef},
    total=False,
)


class InstanceMonitorResponseInstanceMonitoringsTypeDef(
    _InstanceMonitorResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_InstanceMonitorResponseTypeDef = TypedDict(
    "_InstanceMonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstanceMonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstanceMonitorResponseTypeDef(_InstanceMonitorResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_InstancePasswordDataResponseTypeDef = TypedDict(
    "_InstancePasswordDataResponseTypeDef",
    {"InstanceId": str, "PasswordData": str, "Timestamp": datetime},
    total=False,
)


class InstancePasswordDataResponseTypeDef(_InstancePasswordDataResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceId** *(string) --*

        The ID of the Windows instance.
    """


_InstanceRunningWaitFiltersTypeDef = TypedDict(
    "_InstanceRunningWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceRunningWaitFiltersTypeDef(_InstanceRunningWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceRunningWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceRunningWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InstanceRunningWaitWaiterConfigTypeDef(_InstanceRunningWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_InstanceStartResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceStartResponseStartingInstancesCurrentStateTypeDef(
    _InstanceStartResponseStartingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstanceStartResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceStartResponseStartingInstancesPreviousStateTypeDef(
    _InstanceStartResponseStartingInstancesPreviousStateTypeDef
):
    pass


_InstanceStartResponseStartingInstancesTypeDef = TypedDict(
    "_InstanceStartResponseStartingInstancesTypeDef",
    {
        "CurrentState": InstanceStartResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceStartResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceStartResponseStartingInstancesTypeDef(_InstanceStartResponseStartingInstancesTypeDef):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstanceStartResponseTypeDef = TypedDict(
    "_InstanceStartResponseTypeDef",
    {"StartingInstances": List[InstanceStartResponseStartingInstancesTypeDef]},
    total=False,
)


class InstanceStartResponseTypeDef(_InstanceStartResponseTypeDef):
    """
    - *(dict) --*

      - **StartingInstances** *(list) --*

        Information about the started instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstanceStatusOkWaitFiltersTypeDef = TypedDict(
    "_InstanceStatusOkWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceStatusOkWaitFiltersTypeDef(_InstanceStatusOkWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceStatusOkWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceStatusOkWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InstanceStatusOkWaitWaiterConfigTypeDef(_InstanceStatusOkWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_InstanceStopResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceStopResponseStoppingInstancesCurrentStateTypeDef(
    _InstanceStopResponseStoppingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstanceStopResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceStopResponseStoppingInstancesPreviousStateTypeDef(
    _InstanceStopResponseStoppingInstancesPreviousStateTypeDef
):
    pass


_InstanceStopResponseStoppingInstancesTypeDef = TypedDict(
    "_InstanceStopResponseStoppingInstancesTypeDef",
    {
        "CurrentState": InstanceStopResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceStopResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceStopResponseStoppingInstancesTypeDef(_InstanceStopResponseStoppingInstancesTypeDef):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstanceStopResponseTypeDef = TypedDict(
    "_InstanceStopResponseTypeDef",
    {"StoppingInstances": List[InstanceStopResponseStoppingInstancesTypeDef]},
    total=False,
)


class InstanceStopResponseTypeDef(_InstanceStopResponseTypeDef):
    """
    - *(dict) --*

      - **StoppingInstances** *(list) --*

        Information about the stopped instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstanceStoppedWaitFiltersTypeDef = TypedDict(
    "_InstanceStoppedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceStoppedWaitFiltersTypeDef(_InstanceStoppedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceStoppedWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceStoppedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InstanceStoppedWaitWaiterConfigTypeDef(_InstanceStoppedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef(
    _InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef(
    _InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef
):
    pass


_InstanceTerminateResponseTerminatingInstancesTypeDef = TypedDict(
    "_InstanceTerminateResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": InstanceTerminateResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstanceTerminateResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstanceTerminateResponseTerminatingInstancesTypeDef(
    _InstanceTerminateResponseTerminatingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstanceTerminateResponseTypeDef = TypedDict(
    "_InstanceTerminateResponseTypeDef",
    {"TerminatingInstances": List[InstanceTerminateResponseTerminatingInstancesTypeDef]},
    total=False,
)


class InstanceTerminateResponseTypeDef(_InstanceTerminateResponseTypeDef):
    """
    - *(dict) --*

      - **TerminatingInstances** *(list) --*

        Information about the terminated instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstanceTerminatedWaitFiltersTypeDef = TypedDict(
    "_InstanceTerminatedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceTerminatedWaitFiltersTypeDef(_InstanceTerminatedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceTerminatedWaitWaiterConfigTypeDef = TypedDict(
    "_InstanceTerminatedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class InstanceTerminatedWaitWaiterConfigTypeDef(_InstanceTerminatedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_InstanceUnmonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstanceUnmonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstanceUnmonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstanceUnmonitorResponseInstanceMonitoringsTypeDef(
    _InstanceUnmonitorResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_InstanceUnmonitorResponseTypeDef = TypedDict(
    "_InstanceUnmonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstanceUnmonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstanceUnmonitorResponseTypeDef(_InstanceUnmonitorResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_InstanceWaitUntilExistsFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilExistsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceWaitUntilExistsFiltersTypeDef(_InstanceWaitUntilExistsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceWaitUntilRunningFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilRunningFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceWaitUntilRunningFiltersTypeDef(_InstanceWaitUntilRunningFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceWaitUntilStoppedFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilStoppedFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceWaitUntilStoppedFiltersTypeDef(_InstanceWaitUntilStoppedFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstanceWaitUntilTerminatedFiltersTypeDef = TypedDict(
    "_InstanceWaitUntilTerminatedFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstanceWaitUntilTerminatedFiltersTypeDef(_InstanceWaitUntilTerminatedFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstancesCreateTagsTagsTypeDef = TypedDict(
    "_InstancesCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InstancesCreateTagsTagsTypeDef(_InstancesCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_InstancesFilterFiltersTypeDef = TypedDict(
    "_InstancesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InstancesFilterFiltersTypeDef(_InstancesFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_InstancesMonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstancesMonitorResponseInstanceMonitoringsTypeDef",
    {"InstanceId": str, "Monitoring": InstancesMonitorResponseInstanceMonitoringsMonitoringTypeDef},
    total=False,
)


class InstancesMonitorResponseInstanceMonitoringsTypeDef(
    _InstancesMonitorResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_InstancesMonitorResponseTypeDef = TypedDict(
    "_InstancesMonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstancesMonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstancesMonitorResponseTypeDef(_InstancesMonitorResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_InstancesStartResponseStartingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesStartResponseStartingInstancesCurrentStateTypeDef(
    _InstancesStartResponseStartingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstancesStartResponseStartingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesStartResponseStartingInstancesPreviousStateTypeDef(
    _InstancesStartResponseStartingInstancesPreviousStateTypeDef
):
    pass


_InstancesStartResponseStartingInstancesTypeDef = TypedDict(
    "_InstancesStartResponseStartingInstancesTypeDef",
    {
        "CurrentState": InstancesStartResponseStartingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesStartResponseStartingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesStartResponseStartingInstancesTypeDef(
    _InstancesStartResponseStartingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstancesStartResponseTypeDef = TypedDict(
    "_InstancesStartResponseTypeDef",
    {"StartingInstances": List[InstancesStartResponseStartingInstancesTypeDef]},
    total=False,
)


class InstancesStartResponseTypeDef(_InstancesStartResponseTypeDef):
    """
    - *(dict) --*

      - **StartingInstances** *(list) --*

        Information about the started instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstancesStopResponseStoppingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesStopResponseStoppingInstancesCurrentStateTypeDef(
    _InstancesStopResponseStoppingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstancesStopResponseStoppingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesStopResponseStoppingInstancesPreviousStateTypeDef(
    _InstancesStopResponseStoppingInstancesPreviousStateTypeDef
):
    pass


_InstancesStopResponseStoppingInstancesTypeDef = TypedDict(
    "_InstancesStopResponseStoppingInstancesTypeDef",
    {
        "CurrentState": InstancesStopResponseStoppingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesStopResponseStoppingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesStopResponseStoppingInstancesTypeDef(_InstancesStopResponseStoppingInstancesTypeDef):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstancesStopResponseTypeDef = TypedDict(
    "_InstancesStopResponseTypeDef",
    {"StoppingInstances": List[InstancesStopResponseStoppingInstancesTypeDef]},
    total=False,
)


class InstancesStopResponseTypeDef(_InstancesStopResponseTypeDef):
    """
    - *(dict) --*

      - **StoppingInstances** *(list) --*

        Information about the stopped instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef(
    _InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef
):
    """
    - **CurrentState** *(dict) --*

      The current state of the instance.
      - **Code** *(integer) --*

        The state of the instance as a 16-bit unsigned integer.
        The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
        between 256 and 65,535. These numerical values are used for internal purposes and should be
        ignored.
        The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values between
        0 and 255.
        The valid values for instance-state-code will all be in the range of the low byte and they
        are:
        * ``0`` : ``pending``
        * ``16`` : ``running``
        * ``32`` : ``shutting-down``
        * ``48`` : ``terminated``
        * ``64`` : ``stopping``
        * ``80`` : ``stopped``
        You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
        decimal.
    """


_InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef",
    {
        "Code": int,
        "Name": Literal["pending", "running", "shutting-down", "terminated", "stopping", "stopped"],
    },
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef(
    _InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef
):
    pass


_InstancesTerminateResponseTerminatingInstancesTypeDef = TypedDict(
    "_InstancesTerminateResponseTerminatingInstancesTypeDef",
    {
        "CurrentState": InstancesTerminateResponseTerminatingInstancesCurrentStateTypeDef,
        "InstanceId": str,
        "PreviousState": InstancesTerminateResponseTerminatingInstancesPreviousStateTypeDef,
    },
    total=False,
)


class InstancesTerminateResponseTerminatingInstancesTypeDef(
    _InstancesTerminateResponseTerminatingInstancesTypeDef
):
    """
    - *(dict) --*

      Describes an instance state change.
      - **CurrentState** *(dict) --*

        The current state of the instance.
        - **Code** *(integer) --*

          The state of the instance as a 16-bit unsigned integer.
          The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
          between 256 and 65,535. These numerical values are used for internal purposes and should
          be ignored.
          The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
          between 0 and 255.
          The valid values for instance-state-code will all be in the range of the low byte and they
          are:
          * ``0`` : ``pending``
          * ``16`` : ``running``
          * ``32`` : ``shutting-down``
          * ``48`` : ``terminated``
          * ``64`` : ``stopping``
          * ``80`` : ``stopped``
          You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
          decimal.
    """


_InstancesTerminateResponseTypeDef = TypedDict(
    "_InstancesTerminateResponseTypeDef",
    {"TerminatingInstances": List[InstancesTerminateResponseTerminatingInstancesTypeDef]},
    total=False,
)


class InstancesTerminateResponseTypeDef(_InstancesTerminateResponseTypeDef):
    """
    - *(dict) --*

      - **TerminatingInstances** *(list) --*

        Information about the terminated instances.
        - *(dict) --*

          Describes an instance state change.
          - **CurrentState** *(dict) --*

            The current state of the instance.
            - **Code** *(integer) --*

              The state of the instance as a 16-bit unsigned integer.
              The high byte is all of the bits between 2^8 and (2^16)-1, which equals decimal values
              between 256 and 65,535. These numerical values are used for internal purposes and
              should be ignored.
              The low byte is all of the bits between 2^0 and (2^8)-1, which equals decimal values
              between 0 and 255.
              The valid values for instance-state-code will all be in the range of the low byte and
              they are:
              * ``0`` : ``pending``
              * ``16`` : ``running``
              * ``32`` : ``shutting-down``
              * ``48`` : ``terminated``
              * ``64`` : ``stopping``
              * ``80`` : ``stopped``
              You can ignore the high byte value by zeroing out all of the bits above 2^8 or 256 in
              decimal.
    """


_InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef = TypedDict(
    "_InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef",
    {"State": Literal["disabled", "disabling", "enabled", "pending"]},
    total=False,
)


class InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef(
    _InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef
):
    pass


_InstancesUnmonitorResponseInstanceMonitoringsTypeDef = TypedDict(
    "_InstancesUnmonitorResponseInstanceMonitoringsTypeDef",
    {
        "InstanceId": str,
        "Monitoring": InstancesUnmonitorResponseInstanceMonitoringsMonitoringTypeDef,
    },
    total=False,
)


class InstancesUnmonitorResponseInstanceMonitoringsTypeDef(
    _InstancesUnmonitorResponseInstanceMonitoringsTypeDef
):
    """
    - *(dict) --*

      Describes the monitoring of an instance.
      - **InstanceId** *(string) --*

        The ID of the instance.
    """


_InstancesUnmonitorResponseTypeDef = TypedDict(
    "_InstancesUnmonitorResponseTypeDef",
    {"InstanceMonitorings": List[InstancesUnmonitorResponseInstanceMonitoringsTypeDef]},
    total=False,
)


class InstancesUnmonitorResponseTypeDef(_InstancesUnmonitorResponseTypeDef):
    """
    - *(dict) --*

      - **InstanceMonitorings** *(list) --*

        The monitoring information.
        - *(dict) --*

          Describes the monitoring of an instance.
          - **InstanceId** *(string) --*

            The ID of the instance.
    """


_InternetGatewayCreateTagsTagsTypeDef = TypedDict(
    "_InternetGatewayCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class InternetGatewayCreateTagsTagsTypeDef(_InternetGatewayCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_InternetGatewaysFilterFiltersTypeDef = TypedDict(
    "_InternetGatewaysFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class InternetGatewaysFilterFiltersTypeDef(_InternetGatewaysFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_KeyPairExistsWaitFiltersTypeDef = TypedDict(
    "_KeyPairExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class KeyPairExistsWaitFiltersTypeDef(_KeyPairExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_KeyPairExistsWaitWaiterConfigTypeDef = TypedDict(
    "_KeyPairExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class KeyPairExistsWaitWaiterConfigTypeDef(_KeyPairExistsWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 5
    """


_KeyPairsFilterFiltersTypeDef = TypedDict(
    "_KeyPairsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class KeyPairsFilterFiltersTypeDef(_KeyPairsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_NatGatewayAvailableWaitFiltersTypeDef = TypedDict(
    "_NatGatewayAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class NatGatewayAvailableWaitFiltersTypeDef(_NatGatewayAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_NatGatewayAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_NatGatewayAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class NatGatewayAvailableWaitWaiterConfigTypeDef(_NatGatewayAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_NetworkAclCreateEntryIcmpTypeCodeTypeDef = TypedDict(
    "_NetworkAclCreateEntryIcmpTypeCodeTypeDef", {"Code": int, "Type": int}, total=False
)


class NetworkAclCreateEntryIcmpTypeCodeTypeDef(_NetworkAclCreateEntryIcmpTypeCodeTypeDef):
    """
    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.
    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.
    """


_NetworkAclCreateEntryPortRangeTypeDef = TypedDict(
    "_NetworkAclCreateEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class NetworkAclCreateEntryPortRangeTypeDef(_NetworkAclCreateEntryPortRangeTypeDef):
    """
    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).
    - **From** *(integer) --*

      The first port in the range.
    """


_NetworkAclCreateTagsTagsTypeDef = TypedDict(
    "_NetworkAclCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class NetworkAclCreateTagsTagsTypeDef(_NetworkAclCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_NetworkAclReplaceAssociationResponseTypeDef = TypedDict(
    "_NetworkAclReplaceAssociationResponseTypeDef", {"NewAssociationId": str}, total=False
)


class NetworkAclReplaceAssociationResponseTypeDef(_NetworkAclReplaceAssociationResponseTypeDef):
    """
    - *(dict) --*

      - **NewAssociationId** *(string) --*

        The ID of the new association.
    """


_NetworkAclReplaceEntryIcmpTypeCodeTypeDef = TypedDict(
    "_NetworkAclReplaceEntryIcmpTypeCodeTypeDef", {"Code": int, "Type": int}, total=False
)


class NetworkAclReplaceEntryIcmpTypeCodeTypeDef(_NetworkAclReplaceEntryIcmpTypeCodeTypeDef):
    """
    ICMP protocol: The ICMP or ICMPv6 type and code. Required if specifying protocol 1 (ICMP) or
    protocol 58 (ICMPv6) with an IPv6 CIDR block.
    - **Code** *(integer) --*

      The ICMP code. A value of -1 means all codes for the specified ICMP type.
    """


_NetworkAclReplaceEntryPortRangeTypeDef = TypedDict(
    "_NetworkAclReplaceEntryPortRangeTypeDef", {"From": int, "To": int}, total=False
)


class NetworkAclReplaceEntryPortRangeTypeDef(_NetworkAclReplaceEntryPortRangeTypeDef):
    """
    TCP or UDP protocols: The range of ports the rule applies to. Required if specifying protocol 6
    (TCP) or 17 (UDP).
    - **From** *(integer) --*

      The first port in the range.
    """


_NetworkAclsFilterFiltersTypeDef = TypedDict(
    "_NetworkAclsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class NetworkAclsFilterFiltersTypeDef(_NetworkAclsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef = TypedDict(
    "_NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef",
    {"PrivateIpAddress": str},
    total=False,
)


class NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef(
    _NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
):
    pass


_NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef = TypedDict(
    "_NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef",
    {
        "NetworkInterfaceId": str,
        "AssignedPrivateIpAddresses": List[
            NetworkInterfaceAssignPrivateIpAddressesResponseAssignedPrivateIpAddressesTypeDef
        ],
    },
    total=False,
)


class NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef(
    _NetworkInterfaceAssignPrivateIpAddressesResponseTypeDef
):
    """
    - *(dict) --*

      - **NetworkInterfaceId** *(string) --*

        The ID of the network interface.
    """


_NetworkInterfaceAttachResponseTypeDef = TypedDict(
    "_NetworkInterfaceAttachResponseTypeDef", {"AttachmentId": str}, total=False
)


class NetworkInterfaceAttachResponseTypeDef(_NetworkInterfaceAttachResponseTypeDef):
    """
    - *(dict) --*

      Contains the output of AttachNetworkInterface.
      - **AttachmentId** *(string) --*

        The ID of the network interface attachment.
    """


_NetworkInterfaceAvailableWaitFiltersTypeDef = TypedDict(
    "_NetworkInterfaceAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class NetworkInterfaceAvailableWaitFiltersTypeDef(_NetworkInterfaceAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_NetworkInterfaceAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_NetworkInterfaceAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class NetworkInterfaceAvailableWaitWaiterConfigTypeDef(
    _NetworkInterfaceAvailableWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 20
    """


_NetworkInterfaceCreateTagsTagsTypeDef = TypedDict(
    "_NetworkInterfaceCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class NetworkInterfaceCreateTagsTagsTypeDef(_NetworkInterfaceCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef",
    {
        "AttachTime": datetime,
        "AttachmentId": str,
        "DeleteOnTermination": bool,
        "DeviceIndex": int,
        "InstanceId": str,
        "InstanceOwnerId": str,
        "Status": Literal["attaching", "attached", "detaching", "detached"],
    },
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef(
    _NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef
):
    """
    - **Attachment** *(dict) --*

      The attachment (if any) of the network interface.
      - **AttachTime** *(datetime) --*

        The timestamp indicating when the attachment initiated.
    """


_NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef", {"Value": str}, total=False
)


class NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef(
    _NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef
):
    pass


_NetworkInterfaceDescribeAttributeResponseGroupsTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseGroupsTypeDef",
    {"GroupName": str, "GroupId": str},
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseGroupsTypeDef(
    _NetworkInterfaceDescribeAttributeResponseGroupsTypeDef
):
    pass


_NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef(
    _NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef
):
    pass


_NetworkInterfaceDescribeAttributeResponseTypeDef = TypedDict(
    "_NetworkInterfaceDescribeAttributeResponseTypeDef",
    {
        "Attachment": NetworkInterfaceDescribeAttributeResponseAttachmentTypeDef,
        "Description": NetworkInterfaceDescribeAttributeResponseDescriptionTypeDef,
        "Groups": List[NetworkInterfaceDescribeAttributeResponseGroupsTypeDef],
        "NetworkInterfaceId": str,
        "SourceDestCheck": NetworkInterfaceDescribeAttributeResponseSourceDestCheckTypeDef,
    },
    total=False,
)


class NetworkInterfaceDescribeAttributeResponseTypeDef(
    _NetworkInterfaceDescribeAttributeResponseTypeDef
):
    """
    - *(dict) --*

      Contains the output of DescribeNetworkInterfaceAttribute.
      - **Attachment** *(dict) --*

        The attachment (if any) of the network interface.
        - **AttachTime** *(datetime) --*

          The timestamp indicating when the attachment initiated.
    """


_NetworkInterfaceModifyAttributeAttachmentTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeAttachmentTypeDef",
    {"AttachmentId": str, "DeleteOnTermination": bool},
    total=False,
)


class NetworkInterfaceModifyAttributeAttachmentTypeDef(
    _NetworkInterfaceModifyAttributeAttachmentTypeDef
):
    """
    Information about the interface attachment. If modifying the 'delete on termination' attribute,
    you must specify the ID of the interface attachment.
    - **AttachmentId** *(string) --*

      The ID of the network interface attachment.
    """


_NetworkInterfaceModifyAttributeDescriptionTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeDescriptionTypeDef", {"Value": str}, total=False
)


class NetworkInterfaceModifyAttributeDescriptionTypeDef(
    _NetworkInterfaceModifyAttributeDescriptionTypeDef
):
    """
    A description for the network interface.
    - **Value** *(string) --*

      The attribute value. The value is case-sensitive.
    """


_NetworkInterfaceModifyAttributeSourceDestCheckTypeDef = TypedDict(
    "_NetworkInterfaceModifyAttributeSourceDestCheckTypeDef", {"Value": bool}, total=False
)


class NetworkInterfaceModifyAttributeSourceDestCheckTypeDef(
    _NetworkInterfaceModifyAttributeSourceDestCheckTypeDef
):
    """
    Indicates whether source/destination checking is enabled. A value of ``true`` means checking is
    enabled, and ``false`` means checking is disabled. This value must be ``false`` for a NAT
    instance to perform NAT. For more information, see `NAT Instances
    <https://docs.aws.amazon.com/AmazonVPC/latest/UserGuide/VPC_NAT_Instance.html>`__ in the *Amazon
    Virtual Private Cloud User Guide* .
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_NetworkInterfacesFilterFiltersTypeDef = TypedDict(
    "_NetworkInterfacesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class NetworkInterfacesFilterFiltersTypeDef(_NetworkInterfacesFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_PasswordDataAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_PasswordDataAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class PasswordDataAvailableWaitWaiterConfigTypeDef(_PasswordDataAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_PlacementGroupsFilterFiltersTypeDef = TypedDict(
    "_PlacementGroupsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class PlacementGroupsFilterFiltersTypeDef(_PlacementGroupsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_RouteTableCreateTagsTagsTypeDef = TypedDict(
    "_RouteTableCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class RouteTableCreateTagsTagsTypeDef(_RouteTableCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_RouteTablesFilterFiltersTypeDef = TypedDict(
    "_RouteTablesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class RouteTablesFilterFiltersTypeDef(_RouteTablesFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef
):
    pass


_SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef
):
    pass


_SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef
):
    pass


_SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_SecurityGroupAuthorizeEgressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupAuthorizeEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupAuthorizeEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[SecurityGroupAuthorizeEgressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[SecurityGroupAuthorizeEgressIpPermissionsUserIdGroupPairsTypeDef],
    },
    total=False,
)


class SecurityGroupAuthorizeEgressIpPermissionsTypeDef(
    _SecurityGroupAuthorizeEgressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef
):
    pass


_SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef
):
    pass


_SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef
):
    pass


_SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_SecurityGroupAuthorizeIngressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupAuthorizeIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupAuthorizeIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupAuthorizeIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[SecurityGroupAuthorizeIngressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[SecurityGroupAuthorizeIngressIpPermissionsUserIdGroupPairsTypeDef],
    },
    total=False,
)


class SecurityGroupAuthorizeIngressIpPermissionsTypeDef(
    _SecurityGroupAuthorizeIngressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_SecurityGroupCreateTagsTagsTypeDef = TypedDict(
    "_SecurityGroupCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SecurityGroupCreateTagsTagsTypeDef(_SecurityGroupCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_SecurityGroupExistsWaitFiltersTypeDef = TypedDict(
    "_SecurityGroupExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SecurityGroupExistsWaitFiltersTypeDef(_SecurityGroupExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SecurityGroupExistsWaitWaiterConfigTypeDef = TypedDict(
    "_SecurityGroupExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class SecurityGroupExistsWaitWaiterConfigTypeDef(_SecurityGroupExistsWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 5
    """


_SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef
):
    pass


_SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef
):
    pass


_SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef
):
    pass


_SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_SecurityGroupRevokeEgressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupRevokeEgressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupRevokeEgressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupRevokeEgressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[SecurityGroupRevokeEgressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[SecurityGroupRevokeEgressIpPermissionsUserIdGroupPairsTypeDef],
    },
    total=False,
)


class SecurityGroupRevokeEgressIpPermissionsTypeDef(_SecurityGroupRevokeEgressIpPermissionsTypeDef):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef",
    {"CidrIp": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef
):
    pass


_SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef",
    {"CidrIpv6": str, "Description": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef
):
    pass


_SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef",
    {"Description": str, "PrefixListId": str},
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef
):
    pass


_SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef",
    {
        "Description": str,
        "GroupId": str,
        "GroupName": str,
        "PeeringStatus": str,
        "UserId": str,
        "VpcId": str,
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef
):
    pass


_SecurityGroupRevokeIngressIpPermissionsTypeDef = TypedDict(
    "_SecurityGroupRevokeIngressIpPermissionsTypeDef",
    {
        "FromPort": int,
        "IpProtocol": str,
        "IpRanges": List[SecurityGroupRevokeIngressIpPermissionsIpRangesTypeDef],
        "Ipv6Ranges": List[SecurityGroupRevokeIngressIpPermissionsIpv6RangesTypeDef],
        "PrefixListIds": List[SecurityGroupRevokeIngressIpPermissionsPrefixListIdsTypeDef],
        "ToPort": int,
        "UserIdGroupPairs": List[SecurityGroupRevokeIngressIpPermissionsUserIdGroupPairsTypeDef],
    },
    total=False,
)


class SecurityGroupRevokeIngressIpPermissionsTypeDef(
    _SecurityGroupRevokeIngressIpPermissionsTypeDef
):
    """
    - *(dict) --*

      Describes a set of permissions for a security group rule.
      - **FromPort** *(integer) --*

        The start of port range for the TCP and UDP protocols, or an ICMP/ICMPv6 type number. A
        value of ``-1`` indicates all ICMP/ICMPv6 types. If you specify all ICMP/ICMPv6 types, you
        must specify all codes.
    """


_SecurityGroupsFilterFiltersTypeDef = TypedDict(
    "_SecurityGroupsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SecurityGroupsFilterFiltersTypeDef(_SecurityGroupsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef = TypedDict(
    "_ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef",
    {"Key": str, "Values": List[str]},
    total=False,
)


class ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef(
    _ServiceResourceCreateDhcpOptionsDhcpConfigurationsTypeDef
):
    """
    - *(dict) --*

      - **Key** *(string) --*
      - **Values** *(list) --*

        - *(string) --*
    """


_ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef(
    _ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ServiceResourceCreateInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef(
    _ServiceResourceCreateInstancesBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": ServiceResourceCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef(
    _ServiceResourceCreateInstancesCapacityReservationSpecificationTypeDef
):
    """
    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables
    it to run in any open Capacity Reservation that has matching attributes (instance type,
    platform, Availability Zone).
    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:
      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).
      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.
    """


_ServiceResourceCreateInstancesCpuOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class ServiceResourceCreateInstancesCpuOptionsTypeDef(
    _ServiceResourceCreateInstancesCpuOptionsTypeDef
):
    """
    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.
    """


_ServiceResourceCreateInstancesCreditSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class ServiceResourceCreateInstancesCreditSpecificationTypeDef(
    _ServiceResourceCreateInstancesCreditSpecificationTypeDef
):
    """
    The credit option for CPU usage of the burstable performance instance. Valid values are
    ``standard`` and ``unlimited`` . To change this attribute after launch, use
    `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .
    Default: ``standard`` (T2 instances) or ``unlimited`` (T3/T3a instances)
    - **CpuCredits** *(string) --***[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef(
    _ServiceResourceCreateInstancesElasticGpuSpecificationTypeDef
):
    """
    - *(dict) --*

      A specification for an Elastic Graphics accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of Elastic Graphics accelerator.
    """


_ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef(
    _ServiceResourceCreateInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    - *(dict) --*

      Describes an elastic inference accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
        ``eia1.medium`` , and ``eia1.large`` .
    """


_ServiceResourceCreateInstancesHibernationOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesHibernationOptionsTypeDef", {"Configured": bool}, total=False
)


class ServiceResourceCreateInstancesHibernationOptionsTypeDef(
    _ServiceResourceCreateInstancesHibernationOptionsTypeDef
):
    """
    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.
      Default: ``false``
    """


_ServiceResourceCreateInstancesIamInstanceProfileTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesIamInstanceProfileTypeDef",
    {"Arn": str, "Name": str},
    total=False,
)


class ServiceResourceCreateInstancesIamInstanceProfileTypeDef(
    _ServiceResourceCreateInstancesIamInstanceProfileTypeDef
):
    """
    The IAM instance profile.
    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.
    """


_ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": ServiceResourceCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef(
    _ServiceResourceCreateInstancesInstanceMarketOptionsTypeDef
):
    """
    The market (purchasing) option for the instances.
    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .
    - **MarketType** *(string) --*

      The market type.
    """


_ServiceResourceCreateInstancesIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ServiceResourceCreateInstancesIpv6AddressesTypeDef(
    _ServiceResourceCreateInstancesIpv6AddressesTypeDef
):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_ServiceResourceCreateInstancesLaunchTemplateTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class ServiceResourceCreateInstancesLaunchTemplateTypeDef(
    _ServiceResourceCreateInstancesLaunchTemplateTypeDef
):
    """
    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the
    name or ID of a launch template, but not both.
    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.
    """


_ServiceResourceCreateInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class ServiceResourceCreateInstancesLicenseSpecificationsTypeDef(
    _ServiceResourceCreateInstancesLicenseSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes a license configuration.
      - **LicenseConfigurationArn** *(string) --*

        The Amazon Resource Name (ARN) of the license configuration.
    """


_ServiceResourceCreateInstancesMetadataOptionsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesMetadataOptionsTypeDef",
    {
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class ServiceResourceCreateInstancesMetadataOptionsTypeDef(
    _ServiceResourceCreateInstancesMetadataOptionsTypeDef
):
    """
    The metadata options for the instance. For more information, see `Instance Metadata and User
    Data <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html>`__ .
    - **HttpTokens** *(string) --*

      The state of token usage for your instance metadata requests. If the parameter is not
      specified in the request, the default state is ``optional`` .
      If the state is ``optional`` , you can choose to retrieve instance metadata with or without a
      signed token header on your request. If you retrieve the IAM role credentials without a token,
      the version 1.0 role credentials are returned. If you retrieve the IAM role credentials using
      a valid signed token, the version 2.0 role credentials are returned.
      If the state is ``required`` , you must send a signed token header with any instance metadata
      retrieval requests. In this state, retrieving the IAM role credentials always returns the
      version 2.0 credentials; the version 1.0 credentials are not available.
    """


_ServiceResourceCreateInstancesMonitoringTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesMonitoringTypeDef", {"Enabled": bool}
)


class ServiceResourceCreateInstancesMonitoringTypeDef(
    _ServiceResourceCreateInstancesMonitoringTypeDef
):
    """
    Specifies whether detailed monitoring is enabled for the instance.
    - **Enabled** *(boolean) --***[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef",
    {"Ipv6Address": str},
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_ServiceResourceCreateInstancesNetworkInterfacesTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[ServiceResourceCreateInstancesNetworkInterfacesIpv6AddressesTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[
            ServiceResourceCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
        ],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesNetworkInterfacesTypeDef(
    _ServiceResourceCreateInstancesNetworkInterfacesTypeDef
):
    """
    - *(dict) --*

      Describes a network interface.
      - **AssociatePublicIpAddress** *(boolean) --*

        Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
        public IP address can only be assigned to a network interface for eth0, and can only be
        assigned to a new network interface, not an existing one. You cannot specify more than one
        network interface in the request. If launching into a default subnet, the default value is
        ``true`` .
    """


_ServiceResourceCreateInstancesPlacementTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class ServiceResourceCreateInstancesPlacementTypeDef(
    _ServiceResourceCreateInstancesPlacementTypeDef
):
    """
    The placement for the instance.
    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.
      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.
    """


_ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef
):
    pass


_ServiceResourceCreateInstancesTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateInstancesTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ServiceResourceCreateInstancesTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateInstancesTagSpecificationsTypeDef(
    _ServiceResourceCreateInstancesTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef(
    _ServiceResourceCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _ServiceResourceCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    - *(dict) --*

      Describes a secondary private IPv4 address for a network interface.
      - **Primary** *(boolean) --*

        Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
        IPv4 address can be designated as primary.
    """


_ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef
):
    pass


_ServiceResourceCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ServiceResourceCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateSnapshotTagSpecificationsTypeDef(
    _ServiceResourceCreateSnapshotTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef = TypedDict(
    "_ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef(
    _ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef
):
    pass


_ServiceResourceCreateVolumeTagSpecificationsTypeDef = TypedDict(
    "_ServiceResourceCreateVolumeTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[ServiceResourceCreateVolumeTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class ServiceResourceCreateVolumeTagSpecificationsTypeDef(
    _ServiceResourceCreateVolumeTagSpecificationsTypeDef
):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef(
    _ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef
):
    pass


_ServiceResourceRegisterImageBlockDeviceMappingsTypeDef = TypedDict(
    "_ServiceResourceRegisterImageBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": ServiceResourceRegisterImageBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class ServiceResourceRegisterImageBlockDeviceMappingsTypeDef(
    _ServiceResourceRegisterImageBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_SnapshotCompletedWaitFiltersTypeDef = TypedDict(
    "_SnapshotCompletedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SnapshotCompletedWaitFiltersTypeDef(_SnapshotCompletedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SnapshotCompletedWaitWaiterConfigTypeDef = TypedDict(
    "_SnapshotCompletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class SnapshotCompletedWaitWaiterConfigTypeDef(_SnapshotCompletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_SnapshotCopyResponseTagsTypeDef = TypedDict(
    "_SnapshotCopyResponseTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCopyResponseTagsTypeDef(_SnapshotCopyResponseTagsTypeDef):
    pass


_SnapshotCopyResponseTypeDef = TypedDict(
    "_SnapshotCopyResponseTypeDef",
    {"SnapshotId": str, "Tags": List[SnapshotCopyResponseTagsTypeDef]},
    total=False,
)


class SnapshotCopyResponseTypeDef(_SnapshotCopyResponseTypeDef):
    """
    - *(dict) --*

      - **SnapshotId** *(string) --*

        The ID of the new snapshot.
    """


_SnapshotCopyTagSpecificationsTagsTypeDef = TypedDict(
    "_SnapshotCopyTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCopyTagSpecificationsTagsTypeDef(_SnapshotCopyTagSpecificationsTagsTypeDef):
    pass


_SnapshotCopyTagSpecificationsTypeDef = TypedDict(
    "_SnapshotCopyTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[SnapshotCopyTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class SnapshotCopyTagSpecificationsTypeDef(_SnapshotCopyTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_SnapshotCreateTagsTagsTypeDef = TypedDict(
    "_SnapshotCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SnapshotCreateTagsTagsTypeDef(_SnapshotCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef(
    _SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef
):
    """
    - *(dict) --*

      Describes the user or group to be added or removed from the list of create volume permissions
      for a volume.
      - **Group** *(string) --*

        The group to be added or removed. The possible value is ``all`` .
    """


_SnapshotDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class SnapshotDescribeAttributeResponseProductCodesTypeDef(
    _SnapshotDescribeAttributeResponseProductCodesTypeDef
):
    pass


_SnapshotDescribeAttributeResponseTypeDef = TypedDict(
    "_SnapshotDescribeAttributeResponseTypeDef",
    {
        "CreateVolumePermissions": List[
            SnapshotDescribeAttributeResponseCreateVolumePermissionsTypeDef
        ],
        "ProductCodes": List[SnapshotDescribeAttributeResponseProductCodesTypeDef],
        "SnapshotId": str,
    },
    total=False,
)


class SnapshotDescribeAttributeResponseTypeDef(_SnapshotDescribeAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **CreateVolumePermissions** *(list) --*

        The users and groups that have the permissions for creating volumes from the snapshot.
        - *(dict) --*

          Describes the user or group to be added or removed from the list of create volume
          permissions for a volume.
          - **Group** *(string) --*

            The group to be added or removed. The possible value is ``all`` .
    """


_SnapshotModifyAttributeCreateVolumePermissionAddTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionAddTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionAddTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionAddTypeDef
):
    """
    - *(dict) --*

      Describes the user or group to be added or removed from the list of create volume permissions
      for a volume.
      - **Group** *(string) --*

        The group to be added or removed. The possible value is ``all`` .
    """


_SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef",
    {"Group": str, "UserId": str},
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef
):
    pass


_SnapshotModifyAttributeCreateVolumePermissionTypeDef = TypedDict(
    "_SnapshotModifyAttributeCreateVolumePermissionTypeDef",
    {
        "Add": List[SnapshotModifyAttributeCreateVolumePermissionAddTypeDef],
        "Remove": List[SnapshotModifyAttributeCreateVolumePermissionRemoveTypeDef],
    },
    total=False,
)


class SnapshotModifyAttributeCreateVolumePermissionTypeDef(
    _SnapshotModifyAttributeCreateVolumePermissionTypeDef
):
    """
    A JSON representation of the snapshot attribute modification.
    - **Add** *(list) --*

      Adds the specified AWS account ID or group to the list.
      - *(dict) --*

        Describes the user or group to be added or removed from the list of create volume
        permissions for a volume.
        - **Group** *(string) --*

          The group to be added or removed. The possible value is ``all`` .
    """


_SnapshotWaitUntilCompletedFiltersTypeDef = TypedDict(
    "_SnapshotWaitUntilCompletedFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SnapshotWaitUntilCompletedFiltersTypeDef(_SnapshotWaitUntilCompletedFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SnapshotsFilterFiltersTypeDef = TypedDict(
    "_SnapshotsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SnapshotsFilterFiltersTypeDef(_SnapshotsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SpotInstanceRequestFulfilledWaitFiltersTypeDef = TypedDict(
    "_SpotInstanceRequestFulfilledWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class SpotInstanceRequestFulfilledWaitFiltersTypeDef(
    _SpotInstanceRequestFulfilledWaitFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef = TypedDict(
    "_SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef(
    _SpotInstanceRequestFulfilledWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_SubnetAvailableWaitFiltersTypeDef = TypedDict(
    "_SubnetAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SubnetAvailableWaitFiltersTypeDef(_SubnetAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SubnetAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_SubnetAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class SubnetAvailableWaitWaiterConfigTypeDef(_SubnetAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef = TypedDict(
    "_SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef",
    {
        "DeleteOnTermination": bool,
        "Iops": int,
        "SnapshotId": str,
        "VolumeSize": int,
        "VolumeType": Literal["standard", "io1", "gp2", "sc1", "st1"],
        "Encrypted": bool,
        "KmsKeyId": str,
    },
    total=False,
)


class SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef(
    _SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef
):
    pass


_SubnetCreateInstancesBlockDeviceMappingsTypeDef = TypedDict(
    "_SubnetCreateInstancesBlockDeviceMappingsTypeDef",
    {
        "DeviceName": str,
        "VirtualName": str,
        "Ebs": SubnetCreateInstancesBlockDeviceMappingsEbsTypeDef,
        "NoDevice": str,
    },
    total=False,
)


class SubnetCreateInstancesBlockDeviceMappingsTypeDef(
    _SubnetCreateInstancesBlockDeviceMappingsTypeDef
):
    """
    - *(dict) --*

      Describes a block device mapping.
      - **DeviceName** *(string) --*

        The device name (for example, ``/dev/sdh`` or ``xvdh`` ).
    """


_SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef = TypedDict(
    "_SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef",
    {"CapacityReservationId": str},
    total=False,
)


class SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef(
    _SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef
):
    pass


_SubnetCreateInstancesCapacityReservationSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesCapacityReservationSpecificationTypeDef",
    {
        "CapacityReservationPreference": Literal["open", "none"],
        "CapacityReservationTarget": SubnetCreateInstancesCapacityReservationSpecificationCapacityReservationTargetTypeDef,
    },
    total=False,
)


class SubnetCreateInstancesCapacityReservationSpecificationTypeDef(
    _SubnetCreateInstancesCapacityReservationSpecificationTypeDef
):
    """
    Information about the Capacity Reservation targeting option. If you do not specify this
    parameter, the instance's Capacity Reservation preference defaults to ``open`` , which enables
    it to run in any open Capacity Reservation that has matching attributes (instance type,
    platform, Availability Zone).
    - **CapacityReservationPreference** *(string) --*

      Indicates the instance's Capacity Reservation preferences. Possible preferences include:
      * ``open`` - The instance can run in any ``open`` Capacity Reservation that has matching
      attributes (instance type, platform, Availability Zone).
      * ``none`` - The instance avoids running in a Capacity Reservation even if one is available.
      The instance runs as an On-Demand Instance.
    """


_SubnetCreateInstancesCpuOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesCpuOptionsTypeDef",
    {"CoreCount": int, "ThreadsPerCore": int},
    total=False,
)


class SubnetCreateInstancesCpuOptionsTypeDef(_SubnetCreateInstancesCpuOptionsTypeDef):
    """
    The CPU options for the instance. For more information, see `Optimizing CPU Options
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-optimize-cpu.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **CoreCount** *(integer) --*

      The number of CPU cores for the instance.
    """


_SubnetCreateInstancesCreditSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesCreditSpecificationTypeDef", {"CpuCredits": str}
)


class SubnetCreateInstancesCreditSpecificationTypeDef(
    _SubnetCreateInstancesCreditSpecificationTypeDef
):
    """
    The credit option for CPU usage of the burstable performance instance. Valid values are
    ``standard`` and ``unlimited`` . To change this attribute after launch, use
    `ModifyInstanceCreditSpecification
    <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_ModifyInstanceCreditSpecification.html>`__
    . For more information, see `Burstable Performance Instances
    <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/burstable-performance-instances.html>`__ in
    the *Amazon Elastic Compute Cloud User Guide* .
    Default: ``standard`` (T2 instances) or ``unlimited`` (T3/T3a instances)
    - **CpuCredits** *(string) --***[REQUIRED]**

      The credit option for CPU usage of a T2 or T3 instance. Valid values are ``standard`` and
      ``unlimited`` .
    """


_SubnetCreateInstancesElasticGpuSpecificationTypeDef = TypedDict(
    "_SubnetCreateInstancesElasticGpuSpecificationTypeDef", {"Type": str}
)


class SubnetCreateInstancesElasticGpuSpecificationTypeDef(
    _SubnetCreateInstancesElasticGpuSpecificationTypeDef
):
    """
    - *(dict) --*

      A specification for an Elastic Graphics accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of Elastic Graphics accelerator.
    """


_SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef = TypedDict(
    "_SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef", {"Type": str}
)


class SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef(
    _SubnetCreateInstancesElasticInferenceAcceleratorsTypeDef
):
    """
    - *(dict) --*

      Describes an elastic inference accelerator.
      - **Type** *(string) --***[REQUIRED]**

        The type of elastic inference accelerator. The possible values are ``eia1.small`` ,
        ``eia1.medium`` , and ``eia1.large`` .
    """


_SubnetCreateInstancesHibernationOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesHibernationOptionsTypeDef", {"Configured": bool}, total=False
)


class SubnetCreateInstancesHibernationOptionsTypeDef(
    _SubnetCreateInstancesHibernationOptionsTypeDef
):
    """
    Indicates whether an instance is enabled for hibernation. For more information, see `Hibernate
    Your Instance <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Hibernate.html>`__ in the
    *Amazon Elastic Compute Cloud User Guide* .
    - **Configured** *(boolean) --*

      If you set this parameter to ``true`` , your instance is enabled for hibernation.
      Default: ``false``
    """


_SubnetCreateInstancesIamInstanceProfileTypeDef = TypedDict(
    "_SubnetCreateInstancesIamInstanceProfileTypeDef", {"Arn": str, "Name": str}, total=False
)


class SubnetCreateInstancesIamInstanceProfileTypeDef(
    _SubnetCreateInstancesIamInstanceProfileTypeDef
):
    """
    The IAM instance profile.
    - **Arn** *(string) --*

      The Amazon Resource Name (ARN) of the instance profile.
    """


_SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef",
    {
        "MaxPrice": str,
        "SpotInstanceType": Literal["one-time", "persistent"],
        "BlockDurationMinutes": int,
        "ValidUntil": datetime,
        "InstanceInterruptionBehavior": Literal["hibernate", "stop", "terminate"],
    },
    total=False,
)


class SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef(
    _SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef
):
    pass


_SubnetCreateInstancesInstanceMarketOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesInstanceMarketOptionsTypeDef",
    {
        "MarketType": str,
        "SpotOptions": SubnetCreateInstancesInstanceMarketOptionsSpotOptionsTypeDef,
    },
    total=False,
)


class SubnetCreateInstancesInstanceMarketOptionsTypeDef(
    _SubnetCreateInstancesInstanceMarketOptionsTypeDef
):
    """
    The market (purchasing) option for the instances.
    For  RunInstances , persistent Spot Instance requests are only supported when
    **InstanceInterruptionBehavior** is set to either ``hibernate`` or ``stop`` .
    - **MarketType** *(string) --*

      The market type.
    """


_SubnetCreateInstancesIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class SubnetCreateInstancesIpv6AddressesTypeDef(_SubnetCreateInstancesIpv6AddressesTypeDef):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_SubnetCreateInstancesLaunchTemplateTypeDef = TypedDict(
    "_SubnetCreateInstancesLaunchTemplateTypeDef",
    {"LaunchTemplateId": str, "LaunchTemplateName": str, "Version": str},
    total=False,
)


class SubnetCreateInstancesLaunchTemplateTypeDef(_SubnetCreateInstancesLaunchTemplateTypeDef):
    """
    The launch template to use to launch the instances. Any parameters that you specify in
    RunInstances override the same parameters in the launch template. You can specify either the
    name or ID of a launch template, but not both.
    - **LaunchTemplateId** *(string) --*

      The ID of the launch template.
    """


_SubnetCreateInstancesLicenseSpecificationsTypeDef = TypedDict(
    "_SubnetCreateInstancesLicenseSpecificationsTypeDef",
    {"LicenseConfigurationArn": str},
    total=False,
)


class SubnetCreateInstancesLicenseSpecificationsTypeDef(
    _SubnetCreateInstancesLicenseSpecificationsTypeDef
):
    """
    - *(dict) --*

      Describes a license configuration.
      - **LicenseConfigurationArn** *(string) --*

        The Amazon Resource Name (ARN) of the license configuration.
    """


_SubnetCreateInstancesMetadataOptionsTypeDef = TypedDict(
    "_SubnetCreateInstancesMetadataOptionsTypeDef",
    {
        "HttpTokens": Literal["optional", "required"],
        "HttpPutResponseHopLimit": int,
        "HttpEndpoint": Literal["disabled", "enabled"],
    },
    total=False,
)


class SubnetCreateInstancesMetadataOptionsTypeDef(_SubnetCreateInstancesMetadataOptionsTypeDef):
    """
    The metadata options for the instance. For more information, see `Instance Metadata and User
    Data <https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html>`__ .
    - **HttpTokens** *(string) --*

      The state of token usage for your instance metadata requests. If the parameter is not
      specified in the request, the default state is ``optional`` .
      If the state is ``optional`` , you can choose to retrieve instance metadata with or without a
      signed token header on your request. If you retrieve the IAM role credentials without a token,
      the version 1.0 role credentials are returned. If you retrieve the IAM role credentials using
      a valid signed token, the version 2.0 role credentials are returned.
      If the state is ``required`` , you must send a signed token header with any instance metadata
      retrieval requests. In this state, retrieving the IAM role credentials always returns the
      version 2.0 credentials; the version 1.0 credentials are not available.
    """


_SubnetCreateInstancesMonitoringTypeDef = TypedDict(
    "_SubnetCreateInstancesMonitoringTypeDef", {"Enabled": bool}
)


class SubnetCreateInstancesMonitoringTypeDef(_SubnetCreateInstancesMonitoringTypeDef):
    """
    Specifies whether detailed monitoring is enabled for the instance.
    - **Enabled** *(boolean) --***[REQUIRED]**

      Indicates whether detailed monitoring is enabled. Otherwise, basic monitoring is enabled.
    """


_SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef(
    _SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef
):
    pass


_SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef(
    _SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef
):
    pass


_SubnetCreateInstancesNetworkInterfacesTypeDef = TypedDict(
    "_SubnetCreateInstancesNetworkInterfacesTypeDef",
    {
        "AssociatePublicIpAddress": bool,
        "DeleteOnTermination": bool,
        "Description": str,
        "DeviceIndex": int,
        "Groups": List[str],
        "Ipv6AddressCount": int,
        "Ipv6Addresses": List[SubnetCreateInstancesNetworkInterfacesIpv6AddressesTypeDef],
        "NetworkInterfaceId": str,
        "PrivateIpAddress": str,
        "PrivateIpAddresses": List[SubnetCreateInstancesNetworkInterfacesPrivateIpAddressesTypeDef],
        "SecondaryPrivateIpAddressCount": int,
        "SubnetId": str,
        "InterfaceType": str,
    },
    total=False,
)


class SubnetCreateInstancesNetworkInterfacesTypeDef(_SubnetCreateInstancesNetworkInterfacesTypeDef):
    """
    - *(dict) --*

      Describes a network interface.
      - **AssociatePublicIpAddress** *(boolean) --*

        Indicates whether to assign a public IPv4 address to an instance you launch in a VPC. The
        public IP address can only be assigned to a network interface for eth0, and can only be
        assigned to a new network interface, not an existing one. You cannot specify more than one
        network interface in the request. If launching into a default subnet, the default value is
        ``true`` .
    """


_SubnetCreateInstancesPlacementTypeDef = TypedDict(
    "_SubnetCreateInstancesPlacementTypeDef",
    {
        "AvailabilityZone": str,
        "Affinity": str,
        "GroupName": str,
        "PartitionNumber": int,
        "HostId": str,
        "Tenancy": Literal["default", "dedicated", "host"],
        "SpreadDomain": str,
        "HostResourceGroupArn": str,
    },
    total=False,
)


class SubnetCreateInstancesPlacementTypeDef(_SubnetCreateInstancesPlacementTypeDef):
    """
    The placement for the instance.
    - **AvailabilityZone** *(string) --*

      The Availability Zone of the instance.
      If not specified, an Availability Zone will be automatically chosen for you based on the load
      balancing criteria for the Region.
    """


_SubnetCreateInstancesTagSpecificationsTagsTypeDef = TypedDict(
    "_SubnetCreateInstancesTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SubnetCreateInstancesTagSpecificationsTagsTypeDef(
    _SubnetCreateInstancesTagSpecificationsTagsTypeDef
):
    pass


_SubnetCreateInstancesTagSpecificationsTypeDef = TypedDict(
    "_SubnetCreateInstancesTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[SubnetCreateInstancesTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class SubnetCreateInstancesTagSpecificationsTypeDef(_SubnetCreateInstancesTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_SubnetCreateNetworkInterfaceIpv6AddressesTypeDef = TypedDict(
    "_SubnetCreateNetworkInterfaceIpv6AddressesTypeDef", {"Ipv6Address": str}, total=False
)


class SubnetCreateNetworkInterfaceIpv6AddressesTypeDef(
    _SubnetCreateNetworkInterfaceIpv6AddressesTypeDef
):
    """
    - *(dict) --*

      Describes an IPv6 address.
      - **Ipv6Address** *(string) --*

        The IPv6 address.
    """


_SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef = TypedDict(
    "_SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef",
    {"Primary": bool, "PrivateIpAddress": str},
    total=False,
)


class SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef(
    _SubnetCreateNetworkInterfacePrivateIpAddressesTypeDef
):
    """
    - *(dict) --*

      Describes a secondary private IPv4 address for a network interface.
      - **Primary** *(boolean) --*

        Indicates whether the private IPv4 address is the primary private IPv4 address. Only one
        IPv4 address can be designated as primary.
    """


_SubnetCreateTagsTagsTypeDef = TypedDict(
    "_SubnetCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class SubnetCreateTagsTagsTypeDef(_SubnetCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_SubnetsFilterFiltersTypeDef = TypedDict(
    "_SubnetsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SubnetsFilterFiltersTypeDef(_SubnetsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SystemStatusOkWaitFiltersTypeDef = TypedDict(
    "_SystemStatusOkWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class SystemStatusOkWaitFiltersTypeDef(_SystemStatusOkWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_SystemStatusOkWaitWaiterConfigTypeDef = TypedDict(
    "_SystemStatusOkWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class SystemStatusOkWaitWaiterConfigTypeDef(_SystemStatusOkWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VolumeAttachToInstanceResponseTypeDef = TypedDict(
    "_VolumeAttachToInstanceResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class VolumeAttachToInstanceResponseTypeDef(_VolumeAttachToInstanceResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_VolumeAvailableWaitFiltersTypeDef = TypedDict(
    "_VolumeAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeAvailableWaitFiltersTypeDef(_VolumeAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VolumeAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VolumeAvailableWaitWaiterConfigTypeDef(_VolumeAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VolumeCreateSnapshotTagSpecificationsTagsTypeDef = TypedDict(
    "_VolumeCreateSnapshotTagSpecificationsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class VolumeCreateSnapshotTagSpecificationsTagsTypeDef(
    _VolumeCreateSnapshotTagSpecificationsTagsTypeDef
):
    pass


_VolumeCreateSnapshotTagSpecificationsTypeDef = TypedDict(
    "_VolumeCreateSnapshotTagSpecificationsTypeDef",
    {
        "ResourceType": Literal[
            "client-vpn-endpoint",
            "customer-gateway",
            "dedicated-host",
            "dhcp-options",
            "elastic-ip",
            "fleet",
            "fpga-image",
            "host-reservation",
            "image",
            "instance",
            "internet-gateway",
            "launch-template",
            "natgateway",
            "network-acl",
            "network-interface",
            "reserved-instances",
            "route-table",
            "security-group",
            "snapshot",
            "spot-fleet-request",
            "spot-instances-request",
            "subnet",
            "traffic-mirror-filter",
            "traffic-mirror-session",
            "traffic-mirror-target",
            "transit-gateway",
            "transit-gateway-attachment",
            "transit-gateway-route-table",
            "volume",
            "vpc",
            "vpc-peering-connection",
            "vpn-connection",
            "vpn-gateway",
        ],
        "Tags": List[VolumeCreateSnapshotTagSpecificationsTagsTypeDef],
    },
    total=False,
)


class VolumeCreateSnapshotTagSpecificationsTypeDef(_VolumeCreateSnapshotTagSpecificationsTypeDef):
    """
    - *(dict) --*

      The tags to apply to a resource when the resource is being created.
      - **ResourceType** *(string) --*

        The type of resource to tag. Currently, the resource types that support tagging on creation
        are: ``capacity-reservation`` | ``client-vpn-endpoint`` | ``dedicated-host``
        | ``fleet`` |
        ``fpga-image`` | ``instance`` | ``launch-template`` | ``snapshot`` |
        ``traffic-mirror-filter`` | ``traffic-mirror-session`` | ``traffic-mirror-target`` |
        ``transit-gateway`` | ``transit-gateway-attachment`` | ``transit-gateway-route-table`` |
        ``volume`` .
        To tag a resource after it has been created, see `CreateTags
        <https://docs.aws.amazon.com/AWSEC2/latest/APIReference/API_CreateTags.html>`__ .
    """


_VolumeCreateTagsTagsTypeDef = TypedDict(
    "_VolumeCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class VolumeCreateTagsTagsTypeDef(_VolumeCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_VolumeDeletedWaitFiltersTypeDef = TypedDict(
    "_VolumeDeletedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeDeletedWaitFiltersTypeDef(_VolumeDeletedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VolumeDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeDeletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VolumeDeletedWaitWaiterConfigTypeDef(_VolumeDeletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VolumeDescribeAttributeResponseAutoEnableIOTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class VolumeDescribeAttributeResponseAutoEnableIOTypeDef(
    _VolumeDescribeAttributeResponseAutoEnableIOTypeDef
):
    """
    - **AutoEnableIO** *(dict) --*

      The state of ``autoEnableIO`` attribute.
      - **Value** *(boolean) --*

        The attribute value. The valid values are ``true`` or ``false`` .
    """


_VolumeDescribeAttributeResponseProductCodesTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseProductCodesTypeDef",
    {"ProductCodeId": str, "ProductCodeType": Literal["devpay", "marketplace"]},
    total=False,
)


class VolumeDescribeAttributeResponseProductCodesTypeDef(
    _VolumeDescribeAttributeResponseProductCodesTypeDef
):
    pass


_VolumeDescribeAttributeResponseTypeDef = TypedDict(
    "_VolumeDescribeAttributeResponseTypeDef",
    {
        "AutoEnableIO": VolumeDescribeAttributeResponseAutoEnableIOTypeDef,
        "ProductCodes": List[VolumeDescribeAttributeResponseProductCodesTypeDef],
        "VolumeId": str,
    },
    total=False,
)


class VolumeDescribeAttributeResponseTypeDef(_VolumeDescribeAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **AutoEnableIO** *(dict) --*

        The state of ``autoEnableIO`` attribute.
        - **Value** *(boolean) --*

          The attribute value. The valid values are ``true`` or ``false`` .
    """


_VolumeDescribeStatusFiltersTypeDef = TypedDict(
    "_VolumeDescribeStatusFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeDescribeStatusFiltersTypeDef(_VolumeDescribeStatusFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef",
    {"Code": str, "Description": str, "EventId": str, "EventType": str},
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef
):
    pass


_VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef",
    {
        "Description": str,
        "EventId": str,
        "EventType": str,
        "NotAfter": datetime,
        "NotBefore": datetime,
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef
):
    pass


_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef",
    {"Name": Literal["io-enabled", "io-performance"], "Status": str},
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef
):
    pass


_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef",
    {
        "Details": List[VolumeDescribeStatusResponseVolumeStatusesVolumeStatusDetailsTypeDef],
        "Status": Literal["ok", "impaired", "insufficient-data"],
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef
):
    pass


_VolumeDescribeStatusResponseVolumeStatusesTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseVolumeStatusesTypeDef",
    {
        "Actions": List[VolumeDescribeStatusResponseVolumeStatusesActionsTypeDef],
        "AvailabilityZone": str,
        "Events": List[VolumeDescribeStatusResponseVolumeStatusesEventsTypeDef],
        "VolumeId": str,
        "VolumeStatus": VolumeDescribeStatusResponseVolumeStatusesVolumeStatusTypeDef,
    },
    total=False,
)


class VolumeDescribeStatusResponseVolumeStatusesTypeDef(
    _VolumeDescribeStatusResponseVolumeStatusesTypeDef
):
    pass


_VolumeDescribeStatusResponseTypeDef = TypedDict(
    "_VolumeDescribeStatusResponseTypeDef",
    {"NextToken": str, "VolumeStatuses": List[VolumeDescribeStatusResponseVolumeStatusesTypeDef]},
    total=False,
)


class VolumeDescribeStatusResponseTypeDef(_VolumeDescribeStatusResponseTypeDef):
    """
    - *(dict) --*

      - **NextToken** *(string) --*

        The token to use to retrieve the next page of results. This value is ``null`` when there are
        no more results to return.
    """


_VolumeDetachFromInstanceResponseTypeDef = TypedDict(
    "_VolumeDetachFromInstanceResponseTypeDef",
    {
        "AttachTime": datetime,
        "Device": str,
        "InstanceId": str,
        "State": Literal["attaching", "attached", "detaching", "detached", "busy"],
        "VolumeId": str,
        "DeleteOnTermination": bool,
    },
    total=False,
)


class VolumeDetachFromInstanceResponseTypeDef(_VolumeDetachFromInstanceResponseTypeDef):
    """
    - *(dict) --*

      Describes volume attachment details.
      - **AttachTime** *(datetime) --*

        The time stamp when the attachment initiated.
    """


_VolumeInUseWaitFiltersTypeDef = TypedDict(
    "_VolumeInUseWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumeInUseWaitFiltersTypeDef(_VolumeInUseWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VolumeInUseWaitWaiterConfigTypeDef = TypedDict(
    "_VolumeInUseWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VolumeInUseWaitWaiterConfigTypeDef(_VolumeInUseWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VolumeModifyAttributeAutoEnableIOTypeDef = TypedDict(
    "_VolumeModifyAttributeAutoEnableIOTypeDef", {"Value": bool}, total=False
)


class VolumeModifyAttributeAutoEnableIOTypeDef(_VolumeModifyAttributeAutoEnableIOTypeDef):
    """
    Indicates whether the volume should be auto-enabled for I/O operations.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VolumesFilterFiltersTypeDef = TypedDict(
    "_VolumesFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VolumesFilterFiltersTypeDef(_VolumesFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcAddressAssociateResponseTypeDef = TypedDict(
    "_VpcAddressAssociateResponseTypeDef", {"AssociationId": str}, total=False
)


class VpcAddressAssociateResponseTypeDef(_VpcAddressAssociateResponseTypeDef):
    """
    - *(dict) --*

      - **AssociationId** *(string) --*

        [EC2-VPC] The ID that represents the association of the Elastic IP address with an instance.
    """


_VpcAttachClassicLinkInstanceResponseTypeDef = TypedDict(
    "_VpcAttachClassicLinkInstanceResponseTypeDef", {"Return": bool}, total=False
)


class VpcAttachClassicLinkInstanceResponseTypeDef(_VpcAttachClassicLinkInstanceResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcAvailableWaitFiltersTypeDef = TypedDict(
    "_VpcAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcAvailableWaitFiltersTypeDef(_VpcAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VpcAvailableWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VpcAvailableWaitWaiterConfigTypeDef(_VpcAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VpcCreateTagsTagsTypeDef = TypedDict(
    "_VpcCreateTagsTagsTypeDef", {"Key": str, "Value": str}, total=False
)


class VpcCreateTagsTagsTypeDef(_VpcCreateTagsTagsTypeDef):
    """
    - *(dict) --*

      Describes a tag.
      - **Key** *(string) --*

        The key of the tag.
        Constraints: Tag keys are case-sensitive and accept a maximum of 127 Unicode characters. May
        not begin with ``aws:`` .
    """


_VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef(
    _VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef
):
    pass


_VpcDescribeAttributeResponseEnableDnsSupportTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class VpcDescribeAttributeResponseEnableDnsSupportTypeDef(
    _VpcDescribeAttributeResponseEnableDnsSupportTypeDef
):
    pass


_VpcDescribeAttributeResponseTypeDef = TypedDict(
    "_VpcDescribeAttributeResponseTypeDef",
    {
        "VpcId": str,
        "EnableDnsHostnames": VpcDescribeAttributeResponseEnableDnsHostnamesTypeDef,
        "EnableDnsSupport": VpcDescribeAttributeResponseEnableDnsSupportTypeDef,
    },
    total=False,
)


class VpcDescribeAttributeResponseTypeDef(_VpcDescribeAttributeResponseTypeDef):
    """
    - *(dict) --*

      - **VpcId** *(string) --*

        The ID of the VPC.
    """


_VpcDetachClassicLinkInstanceResponseTypeDef = TypedDict(
    "_VpcDetachClassicLinkInstanceResponseTypeDef", {"Return": bool}, total=False
)


class VpcDetachClassicLinkInstanceResponseTypeDef(_VpcDetachClassicLinkInstanceResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcDisableClassicLinkResponseTypeDef = TypedDict(
    "_VpcDisableClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class VpcDisableClassicLinkResponseTypeDef(_VpcDisableClassicLinkResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcEnableClassicLinkResponseTypeDef = TypedDict(
    "_VpcEnableClassicLinkResponseTypeDef", {"Return": bool}, total=False
)


class VpcEnableClassicLinkResponseTypeDef(_VpcEnableClassicLinkResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcExistsWaitFiltersTypeDef = TypedDict(
    "_VpcExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcExistsWaitFiltersTypeDef(_VpcExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcExistsWaitWaiterConfigTypeDef = TypedDict(
    "_VpcExistsWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VpcExistsWaitWaiterConfigTypeDef(_VpcExistsWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 1
    """


_VpcModifyAttributeEnableDnsHostnamesTypeDef = TypedDict(
    "_VpcModifyAttributeEnableDnsHostnamesTypeDef", {"Value": bool}, total=False
)


class VpcModifyAttributeEnableDnsHostnamesTypeDef(_VpcModifyAttributeEnableDnsHostnamesTypeDef):
    """
    Indicates whether the instances launched in the VPC get DNS hostnames. If enabled, instances in
    the VPC get DNS hostnames; otherwise, they do not.
    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute. You can only enable DNS hostnames if you've enabled DNS
    support.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcModifyAttributeEnableDnsSupportTypeDef = TypedDict(
    "_VpcModifyAttributeEnableDnsSupportTypeDef", {"Value": bool}, total=False
)


class VpcModifyAttributeEnableDnsSupportTypeDef(_VpcModifyAttributeEnableDnsSupportTypeDef):
    """
    Indicates whether the DNS resolution is supported for the VPC. If enabled, queries to the Amazon
    provided DNS server at the 169.254.169.253 IP address, or the reserved IP address at the base of
    the VPC network range "plus two" succeed. If disabled, the Amazon provided DNS service in the
    VPC that resolves public DNS hostnames to IP addresses is not enabled.
    You cannot modify the DNS resolution and DNS hostnames attributes in the same request. Use
    separate requests for each attribute.
    - **Value** *(boolean) --*

      The attribute value. The valid values are ``true`` or ``false`` .
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef
):
    """
    - **AccepterVpcInfo** *(dict) --*

      Information about the accepter VPC. CIDR block information is only returned when describing an
      active VPC peering connection.
      - **CidrBlock** *(string) --*

        The IPv4 CIDR block for the VPC.
    """


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef",
    {"CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef",
    {"Ipv6CidrBlock": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef",
    {
        "AllowDnsResolutionFromRemoteVpc": bool,
        "AllowEgressFromLocalClassicLinkToRemoteVpc": bool,
        "AllowEgressFromLocalVpcToRemoteClassicLink": bool,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef",
    {
        "CidrBlock": str,
        "Ipv6CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoIpv6CidrBlockSetTypeDef
        ],
        "CidrBlockSet": List[
            VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoCidrBlockSetTypeDef
        ],
        "OwnerId": str,
        "PeeringOptions": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoPeeringOptionsTypeDef,
        "VpcId": str,
        "Region": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef",
    {
        "Code": Literal[
            "initiating-request",
            "pending-acceptance",
            "active",
            "deleted",
            "rejected",
            "failed",
            "expired",
            "provisioning",
            "deleting",
        ],
        "Message": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef",
    {"Key": str, "Value": str},
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef
):
    pass


_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef",
    {
        "AccepterVpcInfo": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionAccepterVpcInfoTypeDef,
        "ExpirationTime": datetime,
        "RequesterVpcInfo": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionRequesterVpcInfoTypeDef,
        "Status": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionStatusTypeDef,
        "Tags": List[VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTagsTypeDef],
        "VpcPeeringConnectionId": str,
    },
    total=False,
)


class VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef(
    _VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef
):
    """
    - **VpcPeeringConnection** *(dict) --*

      Information about the VPC peering connection.
      - **AccepterVpcInfo** *(dict) --*

        Information about the accepter VPC. CIDR block information is only returned when describing
        an active VPC peering connection.
        - **CidrBlock** *(string) --*

          The IPv4 CIDR block for the VPC.
    """


_VpcPeeringConnectionAcceptResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionAcceptResponseTypeDef",
    {"VpcPeeringConnection": VpcPeeringConnectionAcceptResponseVpcPeeringConnectionTypeDef},
    total=False,
)


class VpcPeeringConnectionAcceptResponseTypeDef(_VpcPeeringConnectionAcceptResponseTypeDef):
    """
    - *(dict) --*

      - **VpcPeeringConnection** *(dict) --*

        Information about the VPC peering connection.
        - **AccepterVpcInfo** *(dict) --*

          Information about the accepter VPC. CIDR block information is only returned when
          describing an active VPC peering connection.
          - **CidrBlock** *(string) --*

            The IPv4 CIDR block for the VPC.
    """


_VpcPeeringConnectionDeleteResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionDeleteResponseTypeDef", {"Return": bool}, total=False
)


class VpcPeeringConnectionDeleteResponseTypeDef(_VpcPeeringConnectionDeleteResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcPeeringConnectionDeletedWaitFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionDeletedWaitFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionDeletedWaitFiltersTypeDef(_VpcPeeringConnectionDeletedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef(
    _VpcPeeringConnectionDeletedWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VpcPeeringConnectionExistsWaitFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionExistsWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcPeeringConnectionExistsWaitFiltersTypeDef(_VpcPeeringConnectionExistsWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcPeeringConnectionExistsWaitWaiterConfigTypeDef = TypedDict(
    "_VpcPeeringConnectionExistsWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpcPeeringConnectionExistsWaitWaiterConfigTypeDef(
    _VpcPeeringConnectionExistsWaitWaiterConfigTypeDef
):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VpcPeeringConnectionRejectResponseTypeDef = TypedDict(
    "_VpcPeeringConnectionRejectResponseTypeDef", {"Return": bool}, total=False
)


class VpcPeeringConnectionRejectResponseTypeDef(_VpcPeeringConnectionRejectResponseTypeDef):
    """
    - *(dict) --*

      - **Return** *(boolean) --*

        Returns ``true`` if the request succeeds; otherwise, it returns an error.
    """


_VpcPeeringConnectionWaitUntilExistsFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionWaitUntilExistsFiltersTypeDef",
    {"Name": str, "Values": List[str]},
    total=False,
)


class VpcPeeringConnectionWaitUntilExistsFiltersTypeDef(
    _VpcPeeringConnectionWaitUntilExistsFiltersTypeDef
):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcPeeringConnectionsFilterFiltersTypeDef = TypedDict(
    "_VpcPeeringConnectionsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcPeeringConnectionsFilterFiltersTypeDef(_VpcPeeringConnectionsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcWaitUntilAvailableFiltersTypeDef = TypedDict(
    "_VpcWaitUntilAvailableFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcWaitUntilAvailableFiltersTypeDef(_VpcWaitUntilAvailableFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcWaitUntilExistsFiltersTypeDef = TypedDict(
    "_VpcWaitUntilExistsFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcWaitUntilExistsFiltersTypeDef(_VpcWaitUntilExistsFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpcsFilterFiltersTypeDef = TypedDict(
    "_VpcsFilterFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpcsFilterFiltersTypeDef(_VpcsFilterFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpnConnectionAvailableWaitFiltersTypeDef = TypedDict(
    "_VpnConnectionAvailableWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpnConnectionAvailableWaitFiltersTypeDef(_VpnConnectionAvailableWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpnConnectionAvailableWaitWaiterConfigTypeDef = TypedDict(
    "_VpnConnectionAvailableWaitWaiterConfigTypeDef",
    {"Delay": int, "MaxAttempts": int},
    total=False,
)


class VpnConnectionAvailableWaitWaiterConfigTypeDef(_VpnConnectionAvailableWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """


_VpnConnectionDeletedWaitFiltersTypeDef = TypedDict(
    "_VpnConnectionDeletedWaitFiltersTypeDef", {"Name": str, "Values": List[str]}, total=False
)


class VpnConnectionDeletedWaitFiltersTypeDef(_VpnConnectionDeletedWaitFiltersTypeDef):
    """
    - *(dict) --*

      A filter name and value pair that is used to return a more specific list of results from a
      describe operation. Filters can be used to match a set of resources by specific criteria, such
      as tags, attributes, or IDs. The filters supported by a describe operation are documented with
      the describe operation. For example:
      *  DescribeAvailabilityZones
      *  DescribeImages
      *  DescribeInstances
      *  DescribeKeyPairs
      *  DescribeSecurityGroups
      *  DescribeSnapshots
      *  DescribeSubnets
      *  DescribeTags
      *  DescribeVolumes
      *  DescribeVpcs
      - **Name** *(string) --*

        The name of the filter. Filter names are case-sensitive.
    """


_VpnConnectionDeletedWaitWaiterConfigTypeDef = TypedDict(
    "_VpnConnectionDeletedWaitWaiterConfigTypeDef", {"Delay": int, "MaxAttempts": int}, total=False
)


class VpnConnectionDeletedWaitWaiterConfigTypeDef(_VpnConnectionDeletedWaitWaiterConfigTypeDef):
    """
    A dictionary that provides parameters to control waiting behavior.
    - **Delay** *(integer) --*

      The amount of time in seconds to wait between attempts. Default: 15
    """
